<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (function_exists("ini_set")) @set_time_limit(0);
if ($nsProduct->VERSION!=$TrackerVersion) exit;

require_once SELF. '/lib/cron/cron.func.php';
require_once SELF. '/lib/email.func.php';
if (!isset($Settings)) $Settings=GetSettings();

if (!defined("NO_CRON_COMMENTS")) define("NO_CRON_COMMENTS",true);

$SetSleepMessageFunc="EmailSleepMessage";
if (!NO_CRON_COMMENTS) echo "Scheduled emails... \n";

function RunAllEmail() {
    global $Db;

    $Query = "
        SELECT C.ID, CO.TIMEZONE
        FROM ?_client C
        INNER JOIN ?_config CO ON CO.COMPANY_ID=C.ID AND CO.SITE_ID=0
        ORDER BY C.ID
    ";
    $Sql = new Query($Query);
    $ClientArr=array();
    while ($Row=$Sql->Row()) $ClientArr[$Row->ID]=$Row;

    $Emails = array();
    $utc_str = gmdate("M d Y H:i:s", time());
    $Now = strtotime($utc_str);
    $Query = "SELECT *, UNIX_TIMESTAMP(SEND_AT) AS STAMP FROM ?_email_schedule WHERE ENABLED = '1' ORDER BY SEND_AT ASC";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        if ($Row->STAMP > $Now) continue;
        $Row->Params = unserialize($Row->PARAMETERS);
        $Emails[]=$Row;
    }

    foreach ($Emails as $Row) {
        CheckCpuLoad($Row->COMPANY_ID,NO_CRON_COMMENTS);
        if (IsCronTaskFinished()) return false;
        $Params = $Row->Params;
        if (!NO_CRON_COMMENTS) echo "-> {$Row->SUBJECT}\n";

        if (!@$Params['Log']) {
            SendReport(explode("\n", $Row->RECEPIENTS),
                    PrepareReportForEmail($Params['CacheId'], $Row->COMPANY_ID, $Params['Additional'], $Row->ATTACH_TYPE,
                                                              array('SplitId'=>$Params['SplitId'], 'Subject'=>$Row->SUBJECT)),
                    array('Subject'=>$Row->SUBJECT, 'Body'=>$Row->BODY, 'SendAs'=>$Row->ATTACH_TYPE, 'SplitId'=>$Params['SplitId'],
                              'Schedule'=>$Row->SCHEDULE));
        } else {
            SendReport(explode("\n", $Row->RECEPIENTS),
                    PrepareLogForEmail($Params['Log'], $Row->COMPANY_ID, $Params['Additional'], $Row->ATTACH_TYPE,
                                                         array('NoLimit'=>$Params['NoRowsLimit'])),
                    array('Subject'=>$Row->SUBJECT, 'Body'=>$Row->BODY, 'SendAs'=>$Row->ATTACH_TYPE, 'Schedule'=>$Row->SCHEDULE));
        }

        if ($Row->SCHEDULE) {
            $SendAt = EmailGetNextDate($Row->SCHEDULE, $Now);
            $Query = "UPDATE ?_email_schedule SET SEND_AT = ?, LAST_SENT = ? WHERE ID=?";
            $Db->Query($Query, $SendAt, gmdate('Y-m-d H:i:s'), $Row->ID);
        }
        else {
            $Db->Query("DELETE FROM ?_email_schedule WHERE ID=?", $Row->ID);
        }
        UpdateCronEmailLog($Row->SUBJECT);
    }
}

RunAllEmail();


function UpdateCronEmailLog($Subj='') {
    if (!defined("CRON_MODE")) return false;
    global $Db, $Logs, $CurrentTaskId;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Err=GetErrText();
    if (!$Err) $Err= null;
    $Query = "INSERT INTO ?_cron_email_log (TASK_PROCESS_ID, STAMP, SUBJECT, ERRORS)
                                                                            VALUES (?,?,?,?)";
    $Db->Query($Query, $CurrentTaskId, $Stamp, $Subj, $Err);
    DisplayErrors();
    $_SESSION['__Errors']=array();
}

function EmailSleepMessage()
{
    return false;
}


?>