<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

require_once SELF."/lib/reports/misc.func.php";
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/customreport.class.php";

$nsLang->TplInc("inc/menu");
$nsLang->TplInc("admin.reports");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->IncFile("inc/cache.php");

extract(VPack(array('SiteId','RobotId','ViewDate','StartDate','EndDate','GroupBy', 'DynamicPeriod'),
                          array('DynamicPeriod'=>'-1', 'GroupBy'=>'Month')));

if($DynamicPeriod=='0-a-0') $DynamicPeriod="-1";

$PageTitle=$Lang['Title'];
$ProgPath[0]['Name']=$Lang['MReports'];
$ProgPath[0]['Url']=getUrl("reports", "CpId=$CpId&SiteId=$SiteId", "admin");
$ProgPath[1]['Name']=$Lang['OtherReports'];
$ProgPath[1]['Url']=getUrl("reports", "Tab=Custom&CpId=$CpId&SiteId=$SiteId", "admin");
$ProgPath[2]['Name']=$Lang['BotStat'];
$ProgPath[2]['Url']=getUrl("bot_stat", "CpId=$CpId&SiteId=$SiteId", "report");

$nsLang->TplInc("constructor/periods");
//    
$FormPeriodsArr=array();
$Query = "SELECT * FROM ?_periods WHERE COMPANY_ID IN (0, $CpId) AND DELETED != '1' ORDER BY TEMPLATE";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
    $FormPeriodsArr[$Row->TEMPLATE]=$Row;
}
$PArr=array_keys($FormPeriodsArr);
usort($PArr,"SortPeriods");
$FormPeriodsArr=SyncKeysWValues($FormPeriodsArr,$PArr);    

$MenuSection="logs";

$SitesArr=array();
$BotArr=array();

$Query = "SELECT * FROM ?_site WHERE COMPANY_ID=?";
$Sql = new Query($Query,false,$CpId);
while ($Row=$Sql->Row()) $SitesArr[]=$Row;

$Query = "SELECT * FROM ?_visitor_agent_robot";
$Sql = new Query($Query,false,$CpId);
while ($Row=$Sql->Row()) $BotArr[]=$Row;


$Templs=array('Date'=>'%Y-%m-%d','Month'=>'%Y-%m','Week'=>'%w','Year'=>'%Y','Time'=>'%H');
$DateTempl=$Templs[$GroupBy];

$WhereStr="";
$WhereArr=$Args=array();

if ($SiteId) {$WhereArr[]="B_LOG.SITE_ID=?siteid"; $Args['siteid']=$SiteId; }

$StartDay=$EndDay=false;
$DynamicDate="";
if ($DynamicPeriod!="-1" && $DynamicPeriod!==""  && $DynamicPeriod!=="0-a-0") {
    $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
    $StartDay=$DynamicDate['StartDate'];
    $EndDay=$DynamicDate['EndDate'];
} else {
    if ($StartDate) $StartDay=$StartDate." 00:00:00";
    if ($EndDate) $EndDay=$EndDate." 00:00:00";
}
if ($StartDay&&!$EndDay) $WhereArr[]="B_LOG.STAMP >= DATE_ADD('$StartDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
if (!$StartDay&&$EndDay) $WhereArr[]="B_LOG.STAMP <= DATE_ADD('$EndDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
if ($StartDay&&$EndDay) $WhereArr[]="B_LOG.STAMP BETWEEN DATE_ADD('$StartDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) AND DATE_ADD('$EndDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";


if (!empty($WhereArr)) $WhereStr=" WHERE ".implode(" AND ",$WhereArr);

$StatArr=array();
$RobotArr=array();
$TemplArr=array();
$Query = "

    SELECT
    VAR.ID,
    DATE_FORMAT(DATE_ADD(B_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE), '$DateTempl') AS NAME,
    UNIX_TIMESTAMP(DATE_ADD(B_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS USTAMP,
    VAR.NAME AS BOT_NAME,
    COUNT(B_LOG.ID) AS CNT

    FROM ?_{$CpId}_bot_log B_LOG

    INNER JOIN ?_visitor_agent VA
        ON VA.ID=B_LOG.UA_ID
    INNER JOIN ?_visitor_agent_robot VAR
        ON VAR.ID=VA.ROBOT_ID 

    $WhereStr
    GROUP BY VAR.ID, 2
    ORDER BY 2 DESC, CNT DESC
";

$Cache=new CustomReport($CpId);
$Cache->CustomId=3;
$Cache->CacheJob(array('Bots'=>$Query),1,array('Bots'=> $Args));
$CustomReportId=3;

if (!empty($Cache->Data['Bots'])) {
    if (!is_array($Cache->Data['Bots']) && is_object($Cache->Data['Bots'])) {
        $tmp = array($Cache->Data['Bots']);
        $Cache->Data['Bots'] = $tmp; 
    }
    foreach ($Cache->Data['Bots'] as $Row) {
    $RobotArr[$Row->ID]=$Row->BOT_NAME;
    $AddDates[$Row->NAME]=array('Name'=>$Row->NAME,'Obj'=>$Row);
    $StatArr[$Row->ID][$Row->NAME]=$Row;
}}

if (!empty($StatArr)) {
    $Constructor = new Constructor($CpId);
    $Constructor->StatArr=&$AddDates;
    $Constructor->StartDate=$StartDate;
    $Constructor->EndDate=$EndDate;
    $Constructor->GroupBy=$GroupBy;
    $Constructor->OrderBy='NAME';
    $Constructor->OrderTo=$OrderTo='ASC';
    $Constructor->FillDates();
    
    foreach ($AddDates as $Row) $TemplArr[]=$Row['Obj'];
}

include $nsTemplate->Inc();

?>