<?

require_once SELF."/class/cache_v2.class.php";

$StaticMode=false;

class ReportParent extends nsQueryCache 
{

    function ReportParent($CpId=false) 
    {
        $this->nsQueryCache($CpId);
        $this->CpId=$CpId;
        $this->StatArr=array(); //  
        $this->FilterOnFly=false; //     ,      
        $this->ExplainArr=array(); //    

        $this->NonRealTime=false;  // , ,     ,   
        $this->ReportId=false; //  ID   ( )  
        $this->GroupBy=false;
    }
    
    
    //  
    function CacheJob()
    {
        if ($this->CacheJobLaunched) return false;
        $this->CacheJobLaunched=true;        
        global $Logs, $nsUser, $Db;
        $this->GetSettings();
        $Return=false;

        //   ,      
        if (empty($this->QueryParams)) $this->CollectCacheParams();

        // ,        
        if (isset($this->QueryParams['Filter'])&&$this->QueryParams['Filter']&&$this->FindCacheWithoutLimit()) {
            $this->QueryParams['Filter']="";
            $this->FilterOnFly=true;
        }

        //     
        $this->QueryParams=$this->RemoveExcess($this->QueryParams);

        $this->GetQuerySetId();
        // ,     
        if ($this->CacheEnable&&$this->CacheSmart) $this->CacheNeed=$this->CheckCacheNeed();


        //     
        //   ,  smart  
        if ( ($this->CacheEnable && $this->CacheNeed) || ($this->CacheEnable && !$this->CacheSmart)) {
            $Return=true;
            $this->GetCacheId();
            if ($this->CacheId && $this->CacheAgeLimitExceed) return $this->NoCache(); 
            if (!$this->CacheId) $this->CreateCacheRecord();
            if ($this->CacheId) {
                if ($this->HasData()) {
                    $this->StatArr=$this->GetData();
                    $this->TakenFromCache=true;
                    if (isset($nsUser->CacheArr[$this->CacheId])) {
                        unset($nsUser->CacheArr[$this->CacheId]);
                        $nsUser->REPORTS_DONE--;
                        $Query = "UPDATE ?_user_cache SET DONE=2 WHERE CACHE_ID=? AND DONE=1";
                        $Db->Query($Query, $this->CacheId);
                    }
                }
                else {
                    if (!$this->ToCache && $this->CacheUpdateMode==1) $this->AddToCache();
                    $this->NonRealTime=true;
                }
            }
        }

        return $Return;
    }    
    
    //       
    function GetCacheExplain()
    {
        $this->Calculate("EXPLAIN");
        return $this->ExplainArr;
    }

    function GetQueryExplain($Query, $Type)
    {
        $Sql = new Query("EXPLAIN ".$Query);
        $this->ExplainArr[$Type]=array();
        while ($Row=$Sql->Row()) $this->ExplainArr[$Type][]=$Row;
    }    
    
    //      
    //     
    function CollectCacheParams()
    {
        global $GroupBy, $ViewDate, $StartDate, $EndDate, $DynamicPeriod;
        global $TrafficMode, $Filter, $CpId, $SiteId, $nsUser, $NewVsRet, $CountType;
        $ReportSiteId=($SiteId)?$SiteId:"-1";
        $CacheParams['GroupBy']=(string) $GroupBy;
        $CacheParams['ViewDate']=(string) $ViewDate or $this->ViewDate;
        $CacheParams['StartDate']=(string) $StartDate or $this->StartDate;
        $CacheParams['EndDate']=(string) $EndDate or $this->EndDate;
        $CacheParams['DynamicPeriod']=(string) $DynamicPeriod;
        $CacheParams['TrafficMode']=(string) $TrafficMode;
        $CacheParams['Filter']=(string) $Filter;
        $CacheParams['SiteId']=(string) $ReportSiteId;
        //if ($CountType != 'COUNT') $CacheParams['CountType']=$CountType;
        //if (!empty($NewVsRet) && $NewVsRet) $CacheParams['NewVsRet']=(string) $NewVsRet;
        $this->QueryParams=$CacheParams;
        global $WhereArr;
        $this->QueryParams['WhereArr']=$WhereArr;
    }
    
    //    ,      
    //    ,     
    //  ,      
    function FindCacheWithoutLimit()
    {
        global $Logs;
        $CacheParams=$this->QueryParams;
        $CacheParams['Filter']="";
        $Cache = new nsQueryCache($this->CpId);        
        $Cache->QueryParams=$Cache->SortArrKeys($this->RemoveExcess($CacheParams));
        $Cache->QueryHashSet=serialize($this->RemoveSorting($Cache->QueryParams));
        $Cache->Mode=$this->Mode;
        $Cache->GetCacheId();
        return $Cache->HasData();
    }
    
    function UserCache()
    {
        global $Db, $nsUser, $nsProduct;
        if (!in_array($nsProduct->Action, array("natural_constructor", "paid_constructor", "split_test"))) return;
        $Stamp=gmdate("Y-m-d H:i:s", time());
        $ReportId=(isset($this->ReportId)&&$this->ReportId)?$this->ReportId:0;
        $Query = "INSERT INTO ?_user_cache (CACHE_ID, USER_ID, STAMP, REPORT_ID, COMPANY_ID) 
                            VALUES (?,?,?,?,?)";
        $Db->Query($Query, $this->CacheId, $nsUser->UserId(), $Stamp, $ReportId, $this->CpId);
        $Query = "DELETE FROM ?_user_cache WHERE STAMP <= DATE_ADD('$Stamp', INTERVAL -1 MONTH)";
        $Db->Query($Query);
    }
    
    
    
    
    //  
    ////////////////////////////////////////////////////
        
    function RemoveExcess($Arr)
    {
        if (!isset($Arr['WhereArr'])) return $Arr;
        foreach($Arr['WhereArr'] as $i=>$Row) {
            unset($Arr['WhereArr'][$i]['Name']);
            unset($Arr['WhereArr'][$i]['Name2']);
            unset($Arr['WhereArr'][$i]['Url']);
            unset($Arr['WhereArr'][$i]['Url2']);
            unset($Arr['WhereArr'][$i]['OrderBy']);
            unset($Arr['WhereArr'][$i]['OrderTo']);            
        }
        return $Arr;
    }

    function RemoveSorting($Arr)
    {
        if (!isset($Arr['WhereArr'])) return $Arr;
        foreach($Arr['WhereArr'] as $i=>$Row) {
            unset($Arr['WhereArr'][$i]['OrderBy']);
            unset($Arr['WhereArr'][$i]['OrderTo']);
        }
        return $Arr;
    }
    
    
    
    
    //     
    ////////////////////////////////////////////////////
    
    function GetSiteIds($CpId)
    {
        $Arr=array();
        $Sql=new Query("SELECT ID FROM ?_site WHERE COMPANY_ID = ?", false, $CpId);
        while ($Row=$Sql->Row()) $Arr[]=$Row->ID;
        if (empty($Arr)) return '';
        return implode(",",$Arr);
    }

    //   
    function GetRatio($UniVisit=false, $UniSome=false)
    {
        if (!$UniVisit||!$UniSome) return 0;
        return round((100/$UniVisit)*$UniSome, 2);
    }
    //    
    //     
    function GetMicrotime() 
    { 
        list($usec, $sec) = explode(" ", microtime()); 
        return ((float)$usec + (float)$sec); 
    } 

    function OneOf($Current=false, $Total=false)
    {
        if ($Total<=0) return "0/0";
        if ($Current<=0) return "0/$Total";
        return "1/".ceil($Total/$Current);
    }

    function GetROI($Cost=false, $Income=false)
    {
        if (!$Cost||!$Income) return 0;
        return round(($Income/$Cost)*100, 2);
    }

    function GoodROI($Roi)
    {
        if ($Roi>100) return true;
        else return false;
    }

    function EnableAll()
    {   
        $this->_GetVisits=true;
        $this->_GetSales=true;
        $this->_GetActions=true;
        $this->_GetCost=true;
        $this->_GetActionConv=true;
        $this->_GetSaleConv=true;
        $this->NewVsRet=true;
        $this->SessVisits=true;
    }

    function DisableAll()
    {
        $this->_GetVisits=false;
        $this->_GetSales=false;
        $this->_GetActions=false;
        $this->_GetCost=false;
        $this->_GetActionConv=false;
        $this->_GetSaleConv=false;
        $this->NewVsRet=false;
        $this->SessVisits=false;        
    }

    function SetAll($Params = array())
    {
        $this->_GetVisits= @$Params['_GetVisits']? true : false;
        $this->_GetSales= @$Params['_GetSales']? true : false;
        $this->_GetActions= @$Params['_GetActions']? true : false;
        $this->_GetCost= @$Params['_GetCost']? true : false;
        $this->_GetActionConv= @$Params['_GetActionConv']? true : false;
        $this->_GetSaleConv= @$Params['_GetSaleConv']? true : false;
    }

}
?>