
INSERT INTO `{PREF}_system_product` (`ID`, `NAME`, `FOLDER`, `DEFAULT_LANG`, `STRT_INT`, `DEFAULT_SKIN`, `VERSION`) VALUES 
(1, '{PRODUCT_NAME}', '{FOLDER}', '{C_LANG}', '{START_TIME}', 'default', '{P_VERSION}');

INSERT INTO `{PREF}_system_user` (`ID`, `LOGIN`, `PWD`, `NAME`, `EMAIL`) VALUES 
(1, '{REG_LOGIN}', '{REG_PASS}', '{REG_NAME}', '{REG_EMAIL}');

INSERT INTO `{PREF}_system_user2lang` (`ID`, `UID`, `PROD_ID`, `LANG`) VALUES 
(1, 1, 1, '{C_LANG}');

INSERT INTO `{PREF}_system_user2skin` (`ID`, `UID`, `PROD_ID`, `SKIN`) VALUES 
(1, 1, 1, 'default');

INSERT INTO `{PREF}_tracker_admin` (`ID`, `USER_ID`, `SUPER_ADMIN`, `MODIFIED`, `DEMO`) VALUES 
(1, 1, '1', NOW(), '0');

INSERT INTO `{PREF}_tracker_client` (`ID`, `NAME`, `DESCRIPTION`, `MODIFIED`, `HIDDEN`) VALUES 
(1, '{CLIENT_NAME}', '{CLIENT_DESCR}', NOW(), '0');


INSERT INTO `{PREF}_tracker_config` 
(`ID`, `COMPANY_ID`, `SITE_ID`, 
`KEEP_VISITOR_PATH`, `KEEP_NO_REF`, 
`STOP_DBL_PAGE_LOAD`, `STOP_DBL_ADV_CLICK`, `STOP_DBL_EVENT`, `STOP_DBL_SALE`) 

VALUES 

(1, 0, 0, '1', '1', '0', '0', '0', '0'),
(2, 1, 0, '2', '2', '2', '2', '2', '2'),
(3, 1, 1, '2', '2', '2', '2', '2', '2');


UPDATE `{PREF}_tracker_config` SET `ONLINE_PERIOD`='30', `CACHE_AUTO_ENABLE` = '1'  WHERE `COMPANY_ID`=0 AND `SITE_ID`=0;
UPDATE `{PREF}_tracker_config` SET `CACHE_UPDATE_TIME`='1-60|2-100|5-300|10-600', `CACHE_DYNAMIC_ENABLE`='0', `CACHE_ROWS_CNT`='20', `CACHE_SMART_KEEP_DAYS`='7' WHERE `COMPANY_ID`=0 AND `SITE_ID`=0;
UPDATE `{PREF}_tracker_config` SET `DELETE_FUNCS`='Ref|Key|Vis|Addr|SItem|AItem', `DELETE_SUB_FUNCS`='', `DELETE_RUN_PERIOD`='2|w|n|4', `DELETE_KEEP_PERIOD`='1-m' WHERE `COMPANY_ID`=0 AND `SITE_ID`=0;
UPDATE `{PREF}_tracker_config` SET `DELETE_ENABLE`=3  WHERE `COMPANY_ID`!=0 AND `SITE_ID`=0;
UPDATE `{PREF}_tracker_config` SET `FORMAT_DATE`='d.m.Y',  `FORMAT_TIME`='H:i', `SESSION_BREAK_TIME`='90'  WHERE `COMPANY_ID`=0 AND `SITE_ID`=0;

#{LICENSE}

INSERT INTO `{PREF}_tracker_site` (`ID`, `COMPANY_ID`, `HOST`, `SHOW_PAGE_TITLES`) VALUES 
(1, 1, '{SITE_DOMAIN}', '0');

INSERT INTO `{PREF}_tracker_site_host` (`HOST`, `SITE_ID`) VALUES ('{SITE_DOMAIN}', 1);

INSERT INTO `{PREF}_tracker_site_page` (`ID`, `SITE_ID`, `NAME`, `PATH`) VALUES 
(1, 1, '', '/');

INSERT INTO `{PREF}_tracker_user_column` (`ID`, `USER_ID`, `HITS`, `SALES`, `ACTIONS`, `CLICKS`, `ROI`, `CONVERSIONS`, `GRAPHS`) 
VALUES 
(1, 1, '1', '1', '1', '1', '1', '1', '1');

INSERT INTO `{PREF}_tracker_user_settings` (`ID`, `USER_ID`, `HELP_MODE`) VALUES 
(1, 1, '2');

INSERT INTO `{PREF}_system_config` 
	(`ID`, `PRODUCT_ID`, `PLUGIN_ID`, `NAME`, `CALLNAME`, `DATATYPE`, `INTVAL`, `STRVAL`, `MEMO`) 
	VALUES 
	(1, 1, 0, 'Privacy Policy', 'P3P', 'STRVAL', NULL, 'CUR ADM OUR NOR STA NID', NULL),
	(2, 1, 0, '', 'P3P_REF', 'STRVAL', NULL, '', NULL);
        
INSERT INTO `{PREF}_tracker_periods` (NAME, TEMPLATE, COMPANY_ID, DELETED, SYSTEM_TEMPLATE) VALUES 
    ('', '0-a-0', 0, '0', '1'),
    ('', '0-d-0', 0, '0', '1'),
    ('', '1-d-0', 0, '0', '1'),
    ('', '0-w-0', 0, '0', '1'),
    ('', '1-w-0', 0, '0', '1'),
    ('', '0-m-0', 0, '0', '1'),
    ('', '1-m-0', 0, '0', '1'),
    ('', '0-y-0', 0, '0', '1'),
    ('', '1-y-0', 0, '0', '1');

INSERT INTO `{PREF}_tracker_visit_length` (`ID`, `LEN1`, `LEN2`)VALUES 
(1,0,5),
(2,6,15),
(3,16,30),
(4,31,60),
(5,60,300),
(6,300,600),
(7,600,1800),
(8,1800,1000000000);    

INSERT INTO {PREF}_tracker_static_report_group (COMPANY_ID, NAME) 
VALUES 
(0, 'x-groupTraffic'), (0, 'x-groupActivity'), (0, 'x-groupVisitors'), (0, 'x-groupCustom');   