<?
if(!defined("NS_TRACKER_INDEX")) exit;

require SYS."/system/lib/validate.func.php";

$RegLogin = V($_REQUEST['RegLogin'], V($vStore['RegLogin']));
$RegPass = V($_REQUEST['RegPass'], V($vStore['RegPass']));
$RegPass2 = V($_REQUEST['RegPass2'], V($vStore['RegPass2']));
$RegName = V($_REQUEST['RegName'], V($vStore['RegName']));
$RegEmail = V($_REQUEST['RegEmail'], V($vStore['RegEmail']));

$SaveVars=array("RegLogin", "RegPass", "RegPass2", "RegName", "RegEmail");


function CheckReg() {
	global $RegLogin, $RegPass, $RegPass2, $RegName, $RegEmail;
	global $Logs, $Lang;

	$RegLogin=ToLower($RegLogin);
	if (CheckSymb_($RegLogin)) return $Logs->Err($Lang['SymbErr']);
	if (CheckSymb_($RegPass)) return $Logs->Err($Lang['SymbErr']);

	if (!$RegLogin) return $Logs->Err($Lang['MustFillLogin']);
	if (!$RegPass) return $Logs->Err($Lang['MustFillPass']);
	if (!$RegName) return $Logs->Err($Lang['MustFillName']);
	if (!$RegEmail) return $Logs->Err($Lang['MustFillEmail']);

	if ($RegPass!=$RegPass2) return $Logs->Err($Lang['PassNotPass2']);
	if (strlen($RegLogin)<3) return $Logs->Err($Lang['LoginTooShort']);
	if (strlen($RegLogin)>64) return $Logs->Err($Lang['LoginTooLong']);
	if (strlen($RegPass)<3) return $Logs->Err($Lang['PassTooShort']);
	if (strlen($RegPass)>64) return $Logs->Err($Lang['PassTooLong']);
	if (!ValidMail($RegEmail)) return $Logs->Err($Lang['MustFillCorrEmail']);

    return true;
}


?>