/* 'filters' 
 * 
 * (c) stuffed guys
 * written by johann kuindji
 * jQuery required
 */

var sgFilters=[]
function createFilter(wrapperID, options) {
    var f = new stFilter(wrapperID, options)
    f.inx = sgFilters.push(f)
    return f
}

function stFilter(wrapperID, options) {
    if (!options) options={};
    if (!wrapperID) return alert('wrapperID needed!');
    this.currentElem=false; //   
    this.wrapperID=wrapperID;

    this.wrapperElem=$('#'+wrapperID); //   
    this.submitElem=$('.SubmitElement',this.wrapperElem); //     
    this.panelElem=$('.Filter',this.wrapperElem); //   
    this.optionsElem=$('ul',this.wrapperElem); //    
    //   
    this.adjustCallback=options.adjustCallback?options.adjustCallback:false;
    this.openTime=options.openTime?options.openTime:'150'; //  
    this.firstOpenTime=options.firstOpenTime?options.firstOpenTime:'100'; //  
    this.closeTime=options.closeTime?options.closeTime:'400'; //  

    this.doNotHideFilter=false; //   
    this.filterOpenTimeout=false; //  
    this.filterCloseTimeout=false; //  
    this.slideInProgress=false; //   

    this.moreHidden=true; //   
    this.moreExists=false; //   
    this.stopAnimation=false; //    (   )
    this.allIsShowed=false; //   

    //      (   )
    this.storeMenuItems = {}; 
    this.delayedEvent = false; //    
    
    //        
    //           
    //           
    //   
    this.childCloseCallbacks = {};

    stFilterExtend(this);
}

function stFilterExtend(o) {

    //   
    o.skipFilterOpening = function() {
        if (o.filterOpenTimeout) window.clearTimeout(o.filterOpenTimeout);
        o.filterOpenTimeout=false;
    }

    //    
    o._runDelayed = function() {
        if (!o.delayedEvent) return false;
        var elem=o.delayedEvent;
        o.delayedEvent=false;
        o._preOpenCode(elem);
    }

    //    
    o._openFilterElement = function(elem) {
        if (o.slideInProgress) return false;
        o.slideInProgress=true;
        o.filterOpenTimeout=false;
        o.currentElem=elem;
        $('li[@name='+elem+']').css('background','#f0f0f0');
        if (!$.browser.msie) o.panelElem.css('width',($(o.wrapperElem).width()-2)+'px');
        else o.panelElem.css('width','100%');
        o.panelElem.css('display','block').css('position','absolute');
        $('#'+elem).fadeIn('normal',function(){ o.slideInProgress=false; o._runDelayed();});
    }

    //    
    //    ,     
    o._preOpenCode = function(elem) {
        o.slideInProgress=false;
        if (o.currentElem && o.currentElem != elem) {
            $('#'+o.currentElem).css('display','none');
            $('li[@name='+o.currentElem+']').css('background','transparent');
        }
        o._openFilterElement(elem);        
    }

    //   
    //    ,   
    //   ,   
    o.showFilterElement = function(ev) {
        if (typeof(jQuery)=='undefined') return false
        var evData=jQuery.eventData(ev,'li');
        var elem = $(evData.target).attr('name');
        if(elem=='undefined')elem=false;
        o.doNotHideFilter=true;
        if (o.filterCloseTimeout) window.clearTimeout(o.filterCloseTimeout);
        if (!elem || o.currentElem == elem || o.stopAnimation) return false;
        if (!$('#'+elem)) return false;
        if (o.slideInProgress) return o.delayedEvent=elem;
        if (o.filterOpenTimeout) o.filterOpenTimeout=window.clearTimeout(o.filterOpenTimeout);
        if (evData.ev.type=='click') o._preOpenCode(elem);
        else o.filterOpenTimeout=window.setTimeout( function() {o._preOpenCode(elem);}, 
                                     (o.currentElem?o.openTime:o.firstOpenTime));
    }

    //  
    o.closeFilterElements = function() {
        if (!o.currentElem) return false;
        o.slideInProgress=true;
        if (o.childCloseCallbacks[o.currentElem]) {
            if (!o.childCloseCallbacks[o.currentElem].length)
                o.childCloseCallbacks[o.currentElem]()
            else for (var i in o.childCloseCallbacks[o.currentElem]) 
                o.childCloseCallbacks[o.currentElem][i]()
        }
        $('#'+o.currentElem).fadeOut('normal', function () {
            $('li[@name='+o.currentElem+']').css('background','transparent');
            o.panelElem.css('position','').css('display','none');
            if (!$.browser.msie) o.panelElem.css('width','');
            o.currentElem=false;    
            o.doNotHideFilter=false;
            o.filterCloseTimeout=false;
            o.slideInProgress=false;
        });
    }

    o._showMore = function() {
        $('li',o.optionsElem).show('normal');
        $($('li[@name=more]',o.optionsElem).find('span')[1]).show();
        $($('li[@name=more]',o.optionsElem).find('span')[0]).hide();
        o.moreHidden=false;
    }

    o._hideMore = function() {
        $('li[@show=more]:not(span)',o.optionsElem).hide();
        $('li[@show=more-even]',o.optionsElem).hide();
        $($('li[@name=more]',o.optionsElem).find('span')[0]).show();
        $($('li[@name=more]',o.optionsElem).find('span')[1]).hide();
        o.moreHidden=true;
    }

    //     
    o.more = function() {
        if (!o.moreExists||o.allIsShowed) return false;
        if (o.moreHidden) o._showMore();
        else o._hideMore();
    }

    //      
    o.showAll = function () {
        if (o.allIsShowed) return false;
        if (o.currentElem) o.closeFilterElements();
        o.allIsShowed=true;
        o.stopAnimation=true;
        $('li',o.optionsElem).css('display','block').css('width','99%');
        $('li',o.optionsElem).each(function(i) {
            if ($(this).attr('show')=='manual') return false;
            var name=$(this).attr('name');
            o.storeMenuItems[name]=$(this).html();
            $(this).css('cursor','default');
            $('span',this).css('display','none');
            $(this).html('<div style="width:200px;float:left;">'+($(this).html())+'</div>');
            $(this).append('<div>'+($('#'+name).html())+'</div>');
        });
        o.submitElem.css('display','block');
    }

    //        
    o.values = function(mode) {
        if (!mode) mode=='object';
        if (mode != 'object' && mode != 'string') mode='object';
        if (mode=='object') var values ={};
        else var values = '';
        $('input, select, textarea', o.wrapperElem).each(function() {
            var f = $(this);
            if (!f.attr('name')) return true;
            if (mode == 'object') values[f.attr('name')] = f.val();
            else values += '&'+f.attr('name')+'='+f.val();
        });
        return values;
    }

    $(document).ready(function() { 
        if (o.adjustCallback) o.adjustCallback(o);

        $(document.body).mouseover( function() {
            if (o.doNotHideFilter) { 
                o.doNotHideFilter=false; 
                o.filterCloseTimeout=false; 
                return false;
            }
            if (!o.filterCloseTimeout && o.currentElem) {
                o.filterCloseTimeout=window.setTimeout(o.closeFilterElements,o.closeTime);
            }
    })});

    //      ,   'more'
    if ( $('li[@name=more]',o.optionsElem).length>0 &&
        ($('li[@show=more]:not(span)',o.optionsElem).length>0 ||
         $('li[@show=more-even]',o.optionsElem).length>0 )) {
         $($('li[@name=more]',o.optionsElem).find('span')[1]).css('display','none');
         $('li[@name=more]',o.optionsElem).css('display','block');
         o.moreExists=true;
    }

    //       
    //       css li[show=more]
    //       
    $('li[@show=always]',o.optionsElem).css('display','block');
    $('li[@show=manual]',o.optionsElem).css('display','block');
    $('li[@show=more]:has(span)',o.optionsElem).css('display','block');
    if ($.browser.msie) {
        $('li[@show=manual]',o.optionsElem).find('span').css({
            margin:'0px',fontSize:'11px', fontWeight:'normal'})
        $('li[@show=manual]',o.optionsElem).css({float:'right', marginRight: '10px', marginLeft:'5px', 
            fontSize:'11px', fontWeight:'normal'})
    }

    //     '  '
    if ($('li[@name=all]',o.optionsElem).length>0) {
        $($('li[@name=all]',o.optionsElem).find('span')[1]).css('display','none');
        $('li[@name=all]',o.optionsElem).css('display','block');
        $('li[@name=all]',o.optionsElem).click(o.showAll);
    }

    //     ,    
    //    ,  more-even
    $('li[@show=more]:has(span)',o.optionsElem).css('display','block');

    $('li:not([@show=manual])',o.optionsElem).mouseover(o.showFilterElement);
    $('li:not([@show=manual])',o.optionsElem).click(o.showFilterElement);
    $('li:not([@show=manual])',o.optionsElem).mouseout(o.skipFilterOpening);
    if (o.moreExists) $('li[@name=more]',o.optionsElem).click(o.more);

    o.wrapperElem.mouseover(function () {
        o.doNotHideFilter=true
        if (o.filterCloseTimeout) window.clearTimeout(o.filterCloseTimeout);
        o.filterCloseTimeout=false
    });
}