<?

$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->ShowNoRecords = true;
$RData->Id = 'lref';

$RData->ColumnOrder = array('Stamp','Path','Visitor','Source','Keyword');
$RData->AddColumn('Stamp', $Lang['Time'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Path', $Lang['Page'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Visitor', $Lang['Visitor'], false, false, array('NoFormat'=>true));;
$RData->AddColumn('Source', $Lang['Source'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Keyword', $Lang['Keyword'], false, false, array('NoFormat'=>true));

$RData->TopCaption = $Lang['LastRefs'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('LastRefs', '".getURL('client_page','Mode=lastref&ax=1')."', '{$RData->Id}')";
$RData->CloseLink = 'javascript:;';
$RData->CloseJs = "$('#Report_{$RData->Id}').hide(); $('#SpacerLarge', '#Caption_{$RData->Id}').hide(); $('#close{$RData->Id}, #goto{$RData->Id}').hide(); ";
$RData->GotoLink =getURL('logs','Mode=Ref&CpId='.$CpId,'report');


$Now = gmdate("Y-m-d H:i:s", time());
$Query = "SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL -7 DAY), '%Y-%m-%d %H:%i:%s')";
$FromStamp = $Db->ReturnValue($Query);

$Query = "
    SELECT
    S_LOG.ID,
    UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP,
    (TO_DAYS(DATE_ADD(?now, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) - 
        TO_DAYS(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE))) AS NOT_TODAY,
    
    S_LOG.VISITOR_ID, I.IP, CV.NAME AS VISITOR_NAME,
    RS.NATURAL_KEY, K.KEYWORD,
    H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME,
    SH.HOST,
    R.REFERER,
    SP.PATH, Q.QUERY_STRING, SH.HOST

    FROM ?_{$CpId}_stat_log S_LOG

    INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
    INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
    INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID
    INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
    INNER JOIN ?_host H ON H.ID=RS.HOST_ID
    INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID

    INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID
    LEFT JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID

    LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
    LEFT JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY
    LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=S_LOG.VISITOR_ID AND CV.COMPANY_ID=?cp
    
    WHERE S_LOG.STAMP > ?stamp
    ORDER BY S_LOG.STAMP DESC
    LIMIT 10
";
$Sql = new Query($Query,false,array('cp'=>$CpId,'now'=>$Now,'stamp'=>$FromStamp));

while ($Row=$Sql->Row()) {
    $Row->VISITOR_NAME=htmlspecialchars(stripslashes($Row->VISITOR_NAME));
    if ($Row->NOT_TODAY == 0) $Arr['Stamp'] = _date($Row->STAMP,'time');
    if ($Row->NOT_TODAY == 1) $Arr['Stamp'] = $Lang['Yesterday'].', '._date($Row->STAMP,'time');
    if ($Row->NOT_TODAY > 1) $Arr['Stamp'] = _date($Row->STAMP,'datetime');
    $Arr['Visitor']= $Row->VISITOR_NAME? $Row->VISITOR_NAME : $Row->IP;
    $Arr['Keyword'] = $Row->KEYWORD;
    $Arr['Source'] = $Row->HOST_GRP_NAME ? $Row->HOST_GRP_NAME : $Row->SOURCE_HOST;
    $Arr['Path'] = 'http://'.$Row->HOST.$Row->PATH;
    if ($Row->QUERY_STRING) $Arr['Path'].='?'.$Row->QUERY_STRING;
    $Arr['Link_Path']=$Arr['Path'];
    $Arr['Path'] = RefCut($Arr['Path']);    
    $Arr['Link_Source'] = $Row->REFERER;
    $Arr['Link_Visitor'] = getURL('visitor_path', "CpId=$CpId&VisId={$Row->VISITOR_ID}&ViewDate=".date("Y-m-d",$Row->STAMP), 'report');

    $RData->AddRow($Arr);
}

$RData->CheckExport();
$RData->HtmlDump();
exit;
?>