<?
if ($nsProduct->LICENSE==4) exit;
$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->ShowNoRecords = true;
$RData->Id = 'lsale';

$RData->ColumnOrder = array('Stamp','Host','Visitor','Source','SourceHost','Keyword','Product','Value');
$RData->AddColumn('Stamp', $Lang['Time'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Host', $Lang['SiteHost'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Visitor', $Lang['Visitor'], false, false, array('NoFormat'=>true));;
$RData->AddColumn('Source', $Lang['Source'], false, false, array('NoFormat'=>true));
$RData->AddColumn('SourceHost', $Lang['SourceHost'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Keyword', $Lang['Keyword'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Product', $Lang['Products'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Value', $Lang['Value'], false, false, array('NoFormat'=>true));


$RData->TopCaption = $Lang['LastSales'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('LastSales', '".getURL('client_page','Mode=lastsale&ax=1')."', '{$RData->Id}')";
$RData->CloseLink = 'javascript:;';
$RData->CloseJs = "$('#Report_{$RData->Id}').hide(); $('#SpacerLarge', '#Caption_{$RData->Id}').hide(); $('#close{$RData->Id}, #goto{$RData->Id}').hide(); ";
$RData->GotoLink =getURL('logs','Mode=Ref&CpId='.$CpId,'report');


$Now = gmdate("Y-m-d H:i:s", time());
$Query = "SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL -7 DAY), '%Y-%m-%d %H:%i:%s')";
$FromStamp = $Db->ReturnValue($Query);

$Query = "
    SELECT
    S_LOG.ID, S_SALE.ID AS SALE_ID,
    UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP,
    (TO_DAYS(DATE_ADD(?now, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) - 
        TO_DAYS(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE))) AS NOT_TODAY,
    
    S_LOG.VISITOR_ID, I.IP, CV.NAME AS VISITOR_NAME,
    SH.HOST,
    S_SALE.COST,
    H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME, K.KEYWORD,
    CP.NAME AS CAMP_NAME, K2.KEYWORD AS CAMP_KEY, H2.HOST AS CAMP_SOURCE, 
    HG2.NAME AS CAMP_SOURCE_GRP,
    CP2.NAME AS SPLIT_NAME,
    R.REFERER

    FROM ?_{$CpId}_stat_sale S_SALE
    INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.ID=S_SALE.LOG_ID

    INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
    INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
    INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID

    LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=S_LOG.VISITOR_ID AND CV.COMPANY_ID=?cp

    LEFT JOIN ?_{$CpId}_stat_log S_PARENT ON S_PARENT.ID=S_LOG.COOKIE_LOG

    LEFT JOIN ?_referer_set RS ON RS.ID=S_PARENT.REFERER_SET
    LEFT JOIN ?_host H ON H.ID=RS.HOST_ID
    LEFT JOIN ?_referer R ON R.ID=RS.REFERER_ID
    LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
    LEFT JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY

    LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_PARENT.ID
    LEFT JOIN ?_camp_piece CP ON CP.ID = S_CLICK.CAMP_ID
    LEFT JOIN ?_keyword K2 ON K2.ID=S_CLICK.KEYWORD_ID
    LEFT JOIN ?_host H2 ON H2.ID = S_CLICK.SOURCE_HOST_ID
    LEFT JOIN ?_host_grp HG2 ON HG2.ID=H2.GRP_ID

    LEFT JOIN ?_{$CpId}_stat_split S_SPLIT ON S_SPLIT.LOG_ID=S_PARENT.ID
    LEFT JOIN ?_camp_piece CP2 ON CP2.ID=S_SPLIT.SPLIT_ID

    WHERE S_LOG.STAMP > ?stamp
    ORDER BY S_LOG.STAMP DESC
    LIMIT 10
";
$Sql = new Query($Query,false,array('cp'=>$CpId,'now'=>$Now,'stamp'=>$FromStamp));
while ($Row=$Sql->Row()) {
    $Row->Items = array();
    $Query = "
        SELECT SI.ID, SI.NAME
        FROM ?_sale_set SS
            INNER JOIN ?_sale_item SI ON SI.ID=SS.ITEM_ID AND SI.COMPANY_ID=?cp
        WHERE SS.SALE_ID=?sale AND SS.COMPANY_ID=?cp
    ";
    $SubSql = new Query($Query, false, array('sale'=>$Row->SALE_ID, 'cp'=>$CpId));
    while ($SubRow=$SubSql->Row()) {
        $Row->Items[]=$SubRow->NAME;
    }

    $Row->VISITOR_NAME=htmlspecialchars(stripslashes($Row->VISITOR_NAME));
    if ($Row->NOT_TODAY == 0) $Arr['Stamp'] = _date($Row->STAMP,'time');
    if ($Row->NOT_TODAY == 1) $Arr['Stamp'] = 'Yesterday, '._date($Row->STAMP,'time');
    if ($Row->NOT_TODAY > 1) $Arr['Stamp'] = _date($Row->STAMP,'datetime');
    $Arr['Visitor']= $Row->VISITOR_NAME? $Row->VISITOR_NAME : $Row->IP;
    $Arr['Keyword'] = $Row->CAMP_KEY? $Row->CAMP_KEY: $Row->KEYWORD;
    $Arr['SourceHost'] = '';
    if ($Row->CAMP_SOURCE) {
        $Arr['SourceHost'] = $Row->CAMP_SOURCE_GRP? $Row->CAMP_SOURCE_GRP: $Row->CAMP_SOURCE;
    }
    else $Arr['SourceHost'] = $Row->HOST_GRP_NAME ? $Row->HOST_GRP_NAME : $Row->SOURCE_HOST;
    $Arr['Source'] = '';
    if ($Row->SOURCE_HOST) $Arr['Source'] = $Lang['Referer'];
    if ($Row->SPLIT_NAME) $Arr['Source'] = $Row->SPLIT_NAME;
    if ($Row->CAMP_NAME) $Arr['Source'] = $Row->CAMP_NAME;

    $Arr['Value']=ShowCost($Row->COST);
    $Arr['Product'] = !empty($Row->Items) ? implode(', ',$Row->Items) : ''; 

    $Arr['Link_SourceHost'] = $Row->REFERER;
    $Arr['Link_Visitor'] = getURL('visitor_path', "CpId=$CpId&VisId={$Row->VISITOR_ID}&ViewDate=".date("Y-m-d",$Row->STAMP), 'report');
    $Arr['Host'] = $Row->HOST;

    $RData->AddRow($Arr);
}

$RData->CheckExport();
$RData->HtmlDump();
exit;
?>