<?
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/map.class.php";
require_once SELF."/lib/reports/misc.func.php";

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("constructor/report_description");
$nsLang->TplInc("inc/cache");

UserColumns();
define('NO_SESSION_DATES', true);

$GroupBy=$_REQUEST['GroupBy']='PageAddr';
$_REQUEST['DynamicPeriod']='7-d-1';
$_REQUEST['OrderBy']='UNI';
$_REQUEST['OrderTo']='DESC';
$_REQUEST['WhereArr'] = array(0=>array('Mode'=>'PageAddr','Id'=>''));
$SaveMode = 'NATURAL';

require_once SELF."/lib/reports/const_groups.arr.php";
require_once SELF."/lib/reports/prepare_vars.inc.php";

$Report = new Constructor($CpId,'NATURAL');
$Report->GroupBy=$GroupBy;
$Report->NewVsRet=false;
$Report->MakeSum=false;

$DynamicDate=GetDateFromPeriod('7-d-1',true);
$Report->StartDate=$DynamicDate['StartDate'];
$Report->EndDate=$DynamicDate['EndDate'];
$Report->ViewDate="";

require_once SELF."/lib/reports/const_where.inc.php";
require_once SELF."/lib/reports/prepare_groups.inc.php";
require_once SELF."/lib/reports/const_groupby.inc.php";

$Report->PageLimit=10;
$Report->OrderBy=$OrderBy;
$Report->OrderTo=$OrderTo;
$Report->SessVisits=false;
$Report->DisableDatesFill=true;
$Report->_GetSales = false;
$Report->_GetActions = false;
$Report->_GetCosts = false;
$Report->CacheType = 2;
$Report->CountIfNoCache = true;
$Report->NoCacheUpdate = true;


$Report->Calculate();
$Report->SetCacheType(2);
$Report->SetUpdateInterval(180);
if ($Report->CacheTZ=='' && !$Report->TakenFromCache) $Report->AddToCache();

if (isset($Report->StatArr['__total'])) unset($Report->StatArr['__total']);

$z=0;
if (!$Report->TakenFromCache) foreach ($Report->StatArr as $i=>$Row) {
    $Row['Name'] = 'http://'.$Row['Obj']->SITE_HOST.$Row['Name'];
    $Row['Link_Name']=$Row['Name'];
    $Row['Name']=RefCut($Row['Name']);
    include SELF."/lib/reports/prepare_names.inc.php";
    $Row['Position']=$z;
    $Row['ActionConvOneOf']=$Report->OneOf(V($Row['UniAction'],0),V($Row['UniClick'],0));
    $Row['SaleConvOneOf']=$Report->OneOf(V($Row['UniSale'],0),V($Row['UniClick'],0));
    $Report->StatArr[$i]=$Row;     
    $z++;
}

$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->CssIncluded = true;
$RData->ShowNoRecords = true;
$RData->AddColumn("Name",$Lang['Page']);
$RData->AddColumn("CntClick",$Lang['Hits']);
$RData->AddColumn("UniClick",$Lang['Visitors']);
$RData->Id = 'lpages';

$RData->TopCaption = $Lang['PopPages'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('LastPages', '".getURL('client_page','Mode=pages&ax=1')."', '{$RData->Id}')";

$RData->CloseLink = 'javascript:;';
$RData->CloseJs = "$('#Report_{$RData->Id}').hide(); $('#SpacerLarge', '#Caption_{$RData->Id}').hide(); $('#close{$RData->Id}, #goto{$RData->Id}').hide(); ";
$RData->GotoLink =getURL('natural_constructor','GroupBy=PageAddr&CpId='.$CpId,'report');


if ($Report->TakenFromCache) {
    $RData->BottomCaption = $Lang['CacheUpdated']._date($Report->CacheStamp,'datetime');
    if (@$Report->CacheTZ)  $RData->BottomCaption .= " ".str_replace("{TZ}", ($Report->CacheTZ>0?"+":"").$Report->CacheTZ, $Lang['CacheTimezone']);
}

if (!empty($Report->StatArr)) $RData->Rows =& $Report->StatArr;
$RData->CheckExport();
$RData->HtmlDump();


?>