<?

require_once SELF."/lib/reports/hidden_reports.func.php";

$MyVersion=$Db->Version;
$MyVersion=ToFloat($MyVersion)*10;


function DeleteSiteStat($CpId, $SiteId, $StartTime=false, $EndTime=false)
{
	global $Db, $MyVersion, $Logs;
	$Db->LastError=false;
	$Where="";
		if ($StartTime&&$EndTime) $Where=" AND S_LOG.STAMP BETWEEN '$StartTime' AND '$EndTime'";
	$V40Syn="?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_click, ?{PFX}_tracker_{$CpId}_stat_action, ?{PFX}_tracker_{$CpId}_stat_sale, ?{PFX}_tracker_{$CpId}_stat_split";
	$V41Syn="S_LOG, S_ACTION, S_CLICK, S_SPLIT, S_SALE";
	$Str=($MyVersion>40)?$V41Syn:$V40Syn;

	$Query = "
		DELETE $Str
		FROM ?_{$CpId}_stat_log S_LOG
		LEFT JOIN ?_{$CpId}_stat_action S_ACTION
			ON S_ACTION.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_click S_CLICK
			ON S_CLICK.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_split S_SPLIT
			ON S_SPLIT.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_sale S_SALE
			ON S_SALE.LOG_ID=S_LOG.ID

		WHERE S_LOG.SITE_ID=?
			$Where
	";
	$Db->Query($Query, $SiteId);
    $Query = "DELETE FROM ?_{$CpId}_stat_undef WHERE SITE_ID=?";
    $Db->Query($Query, $SiteId);
	if ($Db->LastError) {
		$Query = "DELETE FROM ?_{$CpId}_stat_log WHERE SITE_ID=? ".str_replace("S_LOG.", "", $Where);
		$Db->Query($Query, $SiteId);
	}
	return $Db->LastAffected;
}

function DeleteSiteHostStat($CpId, $SiteId, $HostId, $StartTime=false, $EndTime=false)
{
	global $Db, $MyVersion, $Logs;
	$Db->LastError=false;

	$Where="";
		if ($StartTime&&$EndTime) $Where=" AND S_LOG.STAMP BETWEEN '$StartTime' AND '$EndTime'";
	$V40Syn="?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_click, ?{PFX}_tracker_{$CpId}_stat_action, ?{PFX}_tracker_{$CpId}_stat_sale, ?{PFX}_tracker_{$CpId}_stat_split";
	$V41Syn="S_LOG, S_ACTION, S_CLICK, S_SPLIT, S_SALE";
	$Str=($MyVersion>40)?$V41Syn:$V40Syn;

	$Query = "
		DELETE $Str
		FROM ?_{$CpId}_stat_log S_LOG

		LEFT JOIN ?_{$CpId}_stat_action S_ACTION
			ON S_ACTION.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_click S_CLICK
			ON S_CLICK.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_split S_SPLIT
			ON S_SPLIT.LOG_ID=S_LOG.ID
		LEFT JOIN ?_{$CpId}_stat_sale S_SALE
			ON S_SALE.LOG_ID=S_LOG.ID

		WHERE S_LOG.SITE_ID=? AND S_LOG.SITE_HOST_ID=?
			$Where
	";
	$Db->Query($Query, $SiteId, $HostId);
	if ($Db->LastError) {
		$Query = "DELETE FROM ?_{$CpId}_stat_log WHERE SITE_ID=? AND SITE_HOST_ID=$HostId ".str_replace("S_LOG.", "", $Where);
		$Db->Query($Query, $SiteId);
	}
	return $Db->LastAffected;
}


function DeleteCampStat($CpId, $CampId, $StartTime=false, $EndTime=false)
{
	global $Db, $MyVersion, $Logs;
	$Db->LastError=false;

	$Where="";
	if ($StartTime&&$EndTime) $Where=" AND S_LOG.STAMP BETWEEN '$StartTime' AND '$EndTime'";

	$V40Syn= "?{PFX}_tracker_{$CpId}_stat_click, ?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_action";
	$V41Syn="S_LOG, S_ACTION, S_CLICK";
	$Str=($MyVersion>40)?$V41Syn:$V40Syn;

	$Query = "
		DELETE $Str
		FROM ?_{$CpId}_stat_click S_CLICK
		INNER JOIN ?_{$CpId}_stat_log S_LOG
		ON S_LOG.ID=S_CLICK.LOG_ID
		LEFT JOIN ?_{$CpId}_stat_action S_ACTION
		ON S_ACTION.LOG_ID=S_LOG.ID
		WHERE S_CLICK.CAMP_ID=?
				$Where
	";
	$Db->Query($Query, $CampId);
	if ($Db->LastError) {

		if ($StartTime&&$EndTime) {
			$Query = "
				SELECT 
					S_CLICK.ID AS CLICK_ID,
					S_LOG.ID AS LOG_ID
					FROM ?_{$CpId}_stat_click S_CLICK 
						INNER JOIN ?_{$CpId}_stat_log S_LOG
							ON S_LOG.ID=S_CLICK.LOG_ID
					WHERE S_CLICK.CAMP_ID=? $Where
			";
			$Sql = new Query($Query,false,$CampId);
			while ($Row=$Sql->Row()) {
				$Query="DELETE FROM ?_{$CpId}_stat_log WHERE ID = ?";
				$Db->Query($Query, $Row->LOG_ID);
				$Query="DELETE FROM ?_{$CpId}_stat_click WHERE ID = ?";
				$Db->Query($Query, $Row->CLICK_ID);
			}
		}
		else {
			$Query = "DELETE FROM ?_{$CpId}_stat_click WHERE CAMP_ID=?";
			$Db->Query($Query,$CampId);
		}
	}
	return $Db->LastAffected;
}

function DeleteSplitStat($CpId, $SubId, $StartTime=false, $EndTime=false)
{
	global $Db, $MyVersion, $Logs;
	$Db->LastError=false;

	$Where="";
	if ($StartTime&&$EndTime) $Where=" AND S_LOG.STAMP BETWEEN '$StartTime' AND '$EndTime'";

	$V40Syn= "?{PFX}_tracker_{$CpId}_stat_split, ?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_action";
	$V41Syn="S_LOG, S_ACTION, S_SPLIT";
	$Str=($MyVersion>40)?$V41Syn:$V40Syn;

	$Query = "
		DELETE $Str
		FROM ?_{$CpId}_stat_split S_SPLIT
		INNER JOIN ?_{$CpId}_stat_log S_LOG
		ON S_LOG.ID=S_SPLIT.LOG_ID
		LEFT JOIN ?_{$CpId}_stat_action S_ACTION
		ON S_ACTION.LOG_ID=S_LOG.ID
		WHERE S_SPLIT.SPLIT_ID=?
				$Where
	";
	$Db->Query($Query, $SubId);
	if ($Db->LastError) {

		if ($StartTime&&$EndTime) {
			$Query = "
				SELECT 
					S_SPLIT.ID AS SPLIT_ID,
					S_LOG.ID AS LOG_ID
					FROM ?_{$CpId}_stat_split S_SPLIT
						INNER JOIN ?_{$CpId}_stat_log S_LOG
							ON S_LOG.ID=S_SPLIT.LOG_ID
					WHERE S_SPLIT.SPLIT_ID=? $Where
			";
			$Sql = new Query($Query, false, $SubId);
			while ($Row=$Sql->Row()) {
				$Query="DELETE FROM ?_{$CpId}_stat_log WHERE ID = ?";
				$Db->Query($Query,$Row->LOG_ID);
				$Query="DELETE FROM ?_{$CpId}_stat_split WHERE ID = ?";
				$Db->Query($Query,$Row->SPLIT_ID);
			}
		}
		else {
			$Query = "DELETE FROM ?_{$CpId}_stat_split WHERE SPLIT_ID=?";
			$Db->Query($Query,$SubId);
		}
	}
	return $Db->LastAffected;
}

function DeleteActionStat($CpId, $ActionId) {
	global $Db, $MyVersion, $Logs;
	$Db->LastError=false;

	$V40Syn= "?{PFX}_tracker_action_item, ?{PFX}_tracker_action_set, ?{PFX}_tracker_{$CpId}_stat_action";
	$V41Syn="AI, ASE, S_ACTION";
	$Str=($MyVersion>40)?$V41Syn:$V40Syn;

	$Query = "
		DELETE $Str
			FROM ?_{$CpId}_stat_action S_ACTION
			LEFT JOIN ?_action_set ASE
				ON ASE.STAT_ACTION_ID=S_ACTION.ACTION_ID
			LEFT JOIN ?_action_item AI
				ON AI.ID=ASE.ACTION_ITEM_ID
		WHERE S_ACTION.ACTION_ID=?
	";
	$Db->Query($Query, $ActionId);
	if ($Db->LastError) {
		$Query = "DELETE FROM ?_{$CpId}_stat_action WHERE ACTION_ID=?";
		$Db->Query($Query,$ActionId);
	}
	return $Db->LastAffected;
}



function DeleteSubCampaign($CpId, $Id, $NoRedir=false)
{
	global $Db, $Logs, $nsProduct, $Lang, $GrpId;
	$Query = "DELETE FROM ?_camp_piece WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_sub_campaign WHERE SUB_ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_camp_cost WHERE SUB_CAMPAIGN = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_watch WHERE SUB_ID = ?";
	$Db->Query($Query,$Id);
	DeleteCampStat($CpId, $Id);

    $Cache = new nsQueryCache($CpId);
    $Cache->Mode="PAID";
    $Cache->QueryParams=SubCampQueryParams($Id);
    $Cache->DropCacheRecord();

	if (!$NoRedir&&$GrpId>0) $nsProduct->Redir("incampaign", "CampId=$GrpId&RDlt=1");
	if (!$NoRedir&&$GrpId==0) $nsProduct->Redir("campaign", "RDlt=1");
}

function DeleteSplit($CpId, $Id, $NoRedir=false)
{
	global $Db, $Logs, $nsProduct, $Lang, $CompId, $GrpId;
	$SplitId=$Db->ReturnValue("SELECT ID FROM ?_split_test WHERE SUB_ID=?",$Id);
	$Query = "DELETE FROM ?_camp_piece WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_split_test WHERE SUB_ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_split_page WHERE SPLIT_ID = ?";
	$Db->Query($Query,$SplitId);

	DeleteSplitStat($CpId, $Id);

    $Cache = new nsQueryCache($CpId);
    $Cache->Mode="SPLIT";
    $Cache->QueryParams=SplitQueryParams($SplitId);
    $Cache->DropCacheRecord();

	if (!$NoRedir&&!$GrpId) $nsProduct->Redir("split_list", "CompId=$CompId&RDlt=1");
	if (!$NoRedir&&ValidId($GrpId)&&$GrpId>0) $nsProduct->Redir("incampaign", "CampId=$GrpId&RDlt=1");
}


function DeleteCampaign($CpId, $Id, $NoRedir=false) 
{
	global $Db, $Logs, $Lang, $nsProduct;

	$Query = "
		SELECT 
			TCP.ID,
			TSC.ID AS SUB_CAMP,
			TST.ID AS SPLIT_TEST
			FROM ?_camp_piece TCP
				LEFT JOIN ?_sub_campaign TSC
					ON TSC.SUB_ID=TCP.ID
				LEFT JOIN ?_split_test TST
					ON TST.SUB_ID=TCP.ID
			WHERE CAMPAIGN_ID=? 
			ORDER BY TCP.NAME
	";
	$Sql = new Query($Query, false, $Id);
	while ($Row=$Sql->Row()) {
		if ($Row->SUB_CAMP) DeleteSubCampaign($CpId, $Row->ID, true);
		if ($Row->SPLIT_TEST) DeleteSplit($CpId, $Row->ID, true);
	}

	$Query = "DELETE FROM ?_campaign WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_watch WHERE GRP_ID = ?";
	$Db->Query($Query,$Id);


    $Cache = new nsQueryCache($CpId);
    $Cache->Mode="PAID";
    $Cache->QueryParams=CampQueryParams($Id);
    $Cache->DropCacheRecord();

	if (!$NoRedir) $nsProduct->Redir("campaign", "RDlt=1");
}



function DeleteCompany($Id, $NoRedir=false) {
	global $Db, $nsProduct, $Logs, $Lang;

	//  
	$Users=array();
	$Query = "SELECT USER_ID FROM ?_user WHERE COMPANY_ID=?";
	$Sql = new Query($Query,false,$Id);
	while ($Row=$Sql->Row()) $Users[]=$Row->USER_ID;
	foreach ($Users as $uid) {
		$Query="DELETE FROM ?{PFX}_system_user WHERE ID = ?";
		$Db->Query($Query,$uid);
		$Query="DELETE FROM ?_user WHERE USER_ID = ?";
		$Db->Query($Query,$uid);
		$Query="DELETE FROM ?_user_column WHERE USER_ID = ?";
		$Db->Query($Query,$uid);
		$Query="DELETE FROM ?_user_settings WHERE USER_ID = ?";
		$Db->Query($Query,$uid);
        $Query="DELETE FROM ?_user_cache WHERE USER_ID = ?";
        $Db->Query($Query,$uid);
	}


	//   
	$Query = "SELECT ID FROM ?_site WHERE COMPANY_ID=?";
	$Sql = new Query($Query,false,$Id);
	while ($Row=$Sql->Row()) DeleteHost($Id, $Row->ID, false, true);


	//   
	DeleteCompanyActions($Id);
	//  
	DeleteCompanySaleItems($Id);

	//    
	$Query = "SELECT ID FROM ?_campaign WHERE COMPANY_ID=?";
	$Sql = new Query($Query,false,$Id);
	while ($Row=$Sql->Row()) DeleteCampaign($Id, $Row->ID,true);

    //    
    $Query = "
        SELECT 
            TCP.ID,
            TSC.ID AS SUB_CAMP,
            TST.ID AS SPLIT_TEST
            FROM ?_camp_piece TCP
                LEFT JOIN ?_sub_campaign TSC
                    ON TSC.SUB_ID=TCP.ID
                LEFT JOIN ?_split_test TST
                    ON TST.SUB_ID=TCP.ID
            WHERE TCP.COMPANY_ID=? 
    ";
    $Sql = new Query($Query,false,$Id);
    while ($Row=$Sql->Row()) {
        if ($Row->SUB_CAMP) DeleteSubCampaign($Id, $Row->ID, true);
        if ($Row->SPLIT_TEST) DeleteSplit($Id, $Row->ID, true);
    }
    
	//  
	$Query = "DELETE FROM ?_config WHERE COMPANY_ID=?";
	$Db->Query($Query,$Id);
	//     
	$Query = "DELETE FROM ?_const_group WHERE COMPANY_ID=?";
	$Db->Query($Query,$Id);
    //    
    $Query = "DELETE FROM ?_user_cache WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);    
	//      
	$Query = "DELETE FROM ?_watch WHERE COMPANY_ID=?";
	$Db->Query($Query,$Id);
    //  
    $Query = "DELETE FROM ?_periods WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);    
    //   
    $Query = "SELECT ID FROM ?_static_report WHERE COMPANY_ID=?";
    $Sql = new Query($Query,false,$Id);
    while ($Row=$Sql->Row()) {
        $Query = "DELETE FROM ?_watch WHERE REPORT_ID=?";
        $Db->Query($Query,$Row->ID);
    }
    $Query = "DELETE FROM ?_static_report WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);       
    //   
    $Query = "DELETE FROM ?_static_report_group WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);             
    //  
    $Query = "DELETE FROM ?_archive WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    //   
    $Query = "DELETE FROM ?_sale_tag_rel WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_visitor_tag_rel WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    //   
    $Query = "DELETE FROM ?_client_visitor WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    //  
    $Query = "DELETE FROM ?_cron_archive_log WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    //    
    $Query = "DELETE FROM ?_ip_ignore WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);
    //     
    $Query = "DELETE FROM ?_report_time_stat WHERE COMPANY_ID=?";
    $Db->Query($Query,$Id);

	DropStatTables($Id);
	//   
	$Query = "DELETE FROM ?_client WHERE ID = ?";
	$Db->Query($Query,$Id);
	if (!$NoRedir)$nsProduct->Redir("company", "RDlt=1");
}

function DeleteCompanyActions($CpId)
{
	global $Db;
	$Query = "DELETE FROM ?_action_item WHERE COMPANY_ID=?";
	$Db->Query($Query,$CpId);
	$Query = "DELETE FROM ?_action_set WHERE COMPANY_ID=?";
	$Db->Query($Query,$CpId);
    $Query = "DELETE FROM ?_visitor_action_group WHERE COMPANY_ID=?";
    $Db->Query($Query,$CpId);    
}


function DeleteCompanySaleItems($CpId)
{
	global $Db;
	$Query = "DELETE FROM ?_sale_item WHERE COMPANY_ID=?";
	$Db->Query($Query,$CpId);
	$Query = "DELETE FROM ?_sale_set WHERE COMPANY_ID=?";
	$Db->Query($Query,$CpId);
}



function DeleteHost($CpId, $Id, $NoDelStat=false, $NoRedir=false)
{
	global $Db, $nsUser, $nsProduct;
	if (!$NoDelStat) DeleteSiteStat($CpId, $Id);
	$Query = "DELETE FROM ?_site WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_site_host WHERE SITE_ID=?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_site_page WHERE SITE_ID=?";
	$Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_page_query WHERE SITE_ID=?";
    $Db->Query($Query,$Id);    
	$Query = "DELETE FROM ?_visitor_action WHERE SITE_ID=?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_watch WHERE SITE_ID=?";
	$Db->Query($Query,$Id);

    $Cache= new nsQueryCache($CpId);
    $Cache->Mode="NATURAL";
    $Cache->QueryParams=array("SiteId"=>$Id, "DynamicPeriod"=>"0-d-0");
    $Cache->DropCacheRecord();
    $Cache= new nsQueryCache($CpId);
    $Cache->Mode="PAID";
    $Cache->QueryParams=array("SiteId"=>$Id, "DynamicPeriod"=>"0-d-0");
    $Cache->DropCacheRecord();   
    
	if (!$NoRedir) $nsProduct->Redir("company", "EditId=$CpId&RDlt=1", "admin");
}


function DeleteOneSale($CpId, $Id, $NoMsg=false)
{
	global $Db, $Logs, $Lang;
	$Query = "DELETE FROM ?_{$CpId}_stat_sale WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_sale_set WHERE SALE_ID = ?";
	$Db->Query($Query,$Id);
	if (!$NoMsg) $Logs->Msg($Lang['RecordDeleted']);
}

function DeleteMultiSale($CpId, $Arr)
{
    global $Db, $Logs, $Lang;
    foreach ($Arr as $Id) DeleteOneSale($CpId,$Id,true);
    $Logs->Msg($Lang['RecordDeleted']);
}


function DeleteOneAction($CpId, $Id, $NoMsg=false) {
	global $Db, $Logs, $Lang;
	$Query = "DELETE FROM ?_{$CpId}_stat_action WHERE ID = ?";
	$Db->Query($Query,$Id);
	$Query = "DELETE FROM ?_action_set WHERE STAT_ACTION_ID = ?";
	$Db->Query($Query,$Id);
	if (!$NoMsg) $Logs->Msg($Lang['RecordDeleted']);
}

function DeleteMultiAction($CpId, $Arr)
{
    global $Db, $Logs, $Lang;
    foreach ($Arr as $Id) DeleteOneAction($CpId,$Id,true);
    $Logs->Msg($Lang['RecordDeleted']);
}


function DeleteOneClick($CpId, $Id, $NoMsg=false) 
{
	global $Db, $Logs, $Lang;
	$Query = "DELETE FROM ?_{$CpId}_stat_click WHERE ID = ?";
	$Db->Query($Query,$Id);
	if (!$NoMsg) $Logs->Msg($Lang['RecordDeleted']);
}

function DeleteMultiClick($CpId, $Arr)
{
    global $Db, $Logs, $Lang;
    foreach ($Arr as $Id) DeleteOneClick($CpId,$Id,true);
    $Logs->Msg($Lang['RecordDeleted']);
}

function DeleteOneSplit($CpId, $Id, $NoMsg=false) 
{
	global $Db, $Logs, $Lang;
	$Query = "DELETE FROM ?_{$CpId}_stat_split WHERE ID = ?";
	$Db->Query($Query,$Id);
	if (!$NoMsg) $Logs->Msg($Lang['RecordDeleted']);
}

function DeleteMultiSplit($CpId, $Arr)
{
    global $Db, $Logs, $Lang;
    foreach ($Arr as $Id) DeleteOneSplit($CpId,$Id,true);
    $Logs->Msg($Lang['RecordDeleted']);
}


?>