<?

$ReplaceReportId=array();

require_once SELF."/class/cache_v2.class.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/delete/period.func.php";

/*
 * 
 * EditArr[Name]
 * EditArr[Mode]
 * EditArr[GroupId]
 * EditArr[Descr]
 * EditArr[UpdateInterval]
 * 
 * WhereArr -  
 * 
 * SaveReport[GroupBy]
 * 
 */
 
 
function CreateAllSystemReports($CpId=0)
{
    global $nsConsole;
    $nsConsole->Stop=true;
    $WhereArr=array();
    $WhereArr[0]['Id']="";

    // TRAFFIC EFFECTIVENESS

    $WhereArr[0]['Mode']="Grp";
    //  
    CreateSystemReport("EffCampGrp", 
        array("Mode"=>"PAID", "Name"=>"x-reportEffCampGrp", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffCampGrp"), 
        $WhereArr, array("GroupBy"=>"Grp"), $CpId);

    // 
    $WhereArr[0]['Mode']="Camp";
    CreateSystemReport("EffCamp", 
        array("Mode"=>"PAID", "Name"=>"x-reportEffCamp", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffCamp"), 
        $WhereArr, array("GroupBy"=>"Camp"), $CpId);

    //  
    $WhereArr[0]['Mode']="SeachEngine";
    CreateSystemReport("SearchEngine", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportEffSearchEngine", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffSearchEngine"), 
        $WhereArr, array("GroupBy"=>"SearchEngine", "TrafficMode"=>"0"), $CpId);

    // 
    $WhereArr[0]['Mode']="Source";
    CreateSystemReport("EffRef", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportEffRef", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffRef"), 
        $WhereArr, array("GroupBy"=>"Source", "TrafficMode"=>"0"), $CpId);  

    //  
    $WhereArr[0]['Mode']="CampSource";
    CreateSystemReport("EffCampRef", 
        array("Mode"=>"PAID", "Name"=>"x-reportEffCampRef", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffCampRef"), 
        $WhereArr, array("GroupBy"=>"CampSource"), $CpId);              

    //  
    $WhereArr[0]['Mode']="Key";
    CreateSystemReport("EffKeyNarural", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportEffKeyNarural", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffKeyNarural"), 
        $WhereArr, array("GroupBy"=>"Key", "TrafficMode"=>"0"), $CpId);     

    //   
    $WhereArr[0]['Mode']="CampKey";
    CreateSystemReport("EffKeyPaid", 
        array("Mode"=>"PAID", "Name"=>"x-reportEffKeyPaid", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffKeyPaid"), 
        $WhereArr, array("GroupBy"=>"CampKey"), $CpId);                     

    // 
    $WhereArr[0]['Mode']="Ref";
    CreateSystemReport("EffReferer", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportEffReferer", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffReferer"), 
        $WhereArr, array("GroupBy"=>"Ref", "TrafficMode"=>"0"), $CpId);        

    // 
    $WhereArr[0]['Mode']="Country";
    CreateSystemReport("EffCountry", 
        array("Mode"=>"PAID", "Name"=>"x-reportEffCountry", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffCountry"), 
        $WhereArr, array("GroupBy"=>"Country"), $CpId);       

    // 
    $WhereArr[0]['Mode']="Site";
    CreateSystemReport("EffSite", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportEffSite", 
                    "GroupId"=>"x-groupTraffic", "Descr"=>"x-reportDescrEffSite"), 
        $WhereArr, array("GroupBy"=>"Site", "TrafficMode"=>"0"), $CpId);                         

    // SITE ACTIVITY

    //    
    $WhereArr[0]['Mode']="Site";
    CreateSystemReport("ActSite", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActSite", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActSite"), 
        $WhereArr, array("GroupBy"=>"Site", "TrafficMode"=>"0"), $CpId);                         

    // 
    $WhereArr[0]['Mode']="Host";
    CreateSystemReport("ActSiteHost", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActSiteHost", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActSiteHost"), 
        $WhereArr, array("GroupBy"=>"Host", "TrafficMode"=>"0"), $CpId);

    // 
    $WhereArr[0]['Mode']="Country";
    CreateSystemReport("ActCountry", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActCountry", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActCountry"), 
        $WhereArr, array("GroupBy"=>"Country", "TrafficMode"=>"0"), $CpId);       

    // 
    $WhereArr[0]['Mode']="Page";
    CreateSystemReport("ActPage", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActPage", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActPage"), 
        $WhereArr, array("GroupBy"=>"Page", "TrafficMode"=>"0"), $CpId);       

    // 
    $WhereArr[0]['Mode']="PageAddr";
    CreateSystemReport("ActPageAddr", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActPageAddr", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActPageAddr"), 
        $WhereArr, array("GroupBy"=>"PageAddr", "TrafficMode"=>"0"), $CpId);       

    //  
    $WhereArr[0]['Mode']="PageTitle";
    CreateSystemReport("ActPageTitle", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActPageTitle", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActPageTitle"), 
        $WhereArr, array("GroupBy"=>"PageTitle", "TrafficMode"=>"0"), $CpId);                  

    // 
    $WhereArr[0]['Mode']="Action";
    CreateSystemReport("ActAction", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActAction", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActAction"), 
        $WhereArr, array("GroupBy"=>"Action", "TrafficMode"=>"0"), $CpId);       

    // 
    $WhereArr[0]['Mode']="Order";
    CreateSystemReport("ActSale", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportActSale", 
                    "GroupId"=>"x-groupActivity", "Descr"=>"x-reportDescrActSale"), 
        $WhereArr, array("GroupBy"=>"Order", "TrafficMode"=>"0"), $CpId);       

    // VISITORS

    // 
    $WhereArr[0]['Mode']="Country";
    CreateSystemReport("VisCountry", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisCountry", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisCountry"), 
        $WhereArr, array("GroupBy"=>"Country", "TrafficMode"=>"0"), $CpId);     

    // 
    $WhereArr[0]['Mode']="City";
    CreateSystemReport("VisCity", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisCity", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisCity"), 
        $WhereArr, array("GroupBy"=>"City", "TrafficMode"=>"0"), $CpId);

    //  
    $WhereArr[0]['Mode']="Resolution";
    CreateSystemReport("VisRes", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisRes", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisRes"), 
        $WhereArr, array("GroupBy"=>"Resolution", "TrafficMode"=>"0"), $CpId);          

    //  
    $WhereArr[0]['Mode']="Pixel";
    CreateSystemReport("VisColor", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisColor", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisColor"), 
        $WhereArr, array("GroupBy"=>"Pixel", "TrafficMode"=>"0"), $CpId);      

    //  
    $WhereArr[0]['Mode']="Flash";
    CreateSystemReport("VisFlash", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisFlash", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisFlash"), 
        $WhereArr, array("GroupBy"=>"Flash", "TrafficMode"=>"0"), $CpId);        

    // 
    $WhereArr[0]['Mode']="AgentGrp";
    CreateSystemReport("VisAgentGrp", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisAgentGrp", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisAgentGrp"), 
        $WhereArr, array("GroupBy"=>"AgentGrp", "TrafficMode"=>"0"), $CpId);      

    //  
    $WhereArr[0]['Mode']="AgentOS";
    CreateSystemReport("VisOS", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisOS", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisOS"), 
        $WhereArr, array("GroupBy"=>"AgentOS", "TrafficMode"=>"0"), $CpId);      

    // 
    $WhereArr[0]['Mode']="Vis";
    CreateSystemReport("VisIp", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisIp", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisIp"), 
        $WhereArr, array("GroupBy"=>"Vis", "TrafficMode"=>"0"), $CpId); 

    // 
    $WhereArr[0]['Mode']="Tags";
    CreateSystemReport("VisTag", 
        array("Mode"=>"NATURAL", "Name"=>"x-reportVisTag", 
                    "GroupId"=>"x-groupVisitors", "Descr"=>"x-reportDescrVisTag"), 
        $WhereArr, array("GroupBy"=>"Tags", "TrafficMode"=>"0"), $CpId);              
}
 

 
$PeriodTimes['0-a-0']=array("DT"=>"4", "UPC"=>"1", "UP"=>"m"); 
$PeriodTimes['0-y-0']=array("DT"=>"4", "UPC"=>"2", "UP"=>"w");
$PeriodTimes['0-d-0']=array("DT"=>"1", "UPC"=>"1", "UP"=>"h");
$PeriodTimes['0-m-0']=array("DT"=>"1", "UPC"=>"1", "UP"=>"d");
$PeriodTimes['0-w-0']=array("DT"=>"1", "UPC"=>"1", "UP"=>"d");
$PeriodTimes['1-d-0']=array("DT"=>"4", "UPC"=>"1", "UP"=>"d");
$PeriodTimes['1-m-0']=array("DT"=>"4", "UPC"=>"1", "UP"=>"d");
$PeriodTimes['1-w-0']=array("DT"=>"4", "UPC"=>"1", "UP"=>"d");
$PeriodTimes['1-y-0']=array("DT"=>"4", "UPC"=>"1", "UP"=>"d");     

function CreateSystemReport($SysName, $EditArr, $WhereArr, $SaveReport,$ToCpId=0)
{
    global $Db, $Logs, $PeriodTimes,$nsConsole;
    $nsConsole->Stop=true;
    $Mode=V($EditArr['Mode']);
    $PeriodIds=array();
    $SiteStr="-1";

    $GroupId=V($EditArr['GroupId']);
    $Descr=V($EditArr['Descr'],"");

    if (!ValidId($GroupId)) {
        $GroupId=$Db->ReturnValue("SELECT ID FROM ?_static_report_group WHERE NAME=?",$GroupId);
    }
    $SaveReport['Filter']="";
    $SaveReport['SiteId']="-1";
    if (!isset($SaveReport['TrafficMode'])) $SaveReport['TrafficMode']="0";

    if (!$ToCpId) {
        $CompId=0;
        $Query = "INSERT INTO ?_static_report 
                         (SYSTEM_NAME, COMPANY_ID, NAME, SITES, MODE, GROUP_ID, DESCRIPTION) VALUES (?, ?, ?, ?, ?, ?, ?)";
        $Db->Query($Query, $SysName, $CompId, $EditArr['Name'], $SiteStr, $Mode, $GroupId, $Descr);
        $SRId=$Db->LastInsertId;

        foreach ($PeriodTimes as $T=>$Arr) {
            $Query = "INSERT INTO ?_static_report_periods 
                             (REPORT_ID, PERIOD, DAY_TIME, UPDATE_PERIOD_CNT, UPDATE_PERIOD) VALUES (?,?,?,?,?)";
            $Db->Query($Query,$SRId,$T,$Arr['DT'],$Arr['UPC'],$Arr['UP']);
            $PeriodIds[$T]=$Db->LastInsertId;
        }

    }
    else {
        $Query = "SELECT ID FROM ?_static_report WHERE SYSTEM_NAME=?";
        $SRId=$Db->ReturnValue($Query, $SysName);
        if ($SRId) {
        $Query = "SELECT ID, PERIOD FROM ?_static_report_periods WHERE REPORT_ID=? ";
        $Sql = new Query($Query, false, $SRId);
        while ($Row=$Sql->Row()) {
            $PeriodIds[$Row->PERIOD]=$Row->ID;
        }}
    }

    static $CpArr=array();
    if ($ToCpId&&!in_array($ToCpId,$CpArr)) $CpArr[]=$ToCpId;
    if (empty($CpArr)) {
        $Query = "SELECT ID FROM ?_client ORDER BY ID";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    }

    foreach ($CpArr as $CompId) {

    $CacheArr=array();
    foreach ($PeriodIds as $T=>$PeriodId) {
        $SaveReport['DynamicPeriod']=(string) $T=="0-a-0"?"-1":$T;
        $SaveReport['EndDate']="";
        if (!isset($SaveReport['TrafficMode'])) $SaveReport['TrafficMode']="0";
        $SaveReport['StartDate']="";
        $SaveReport['ViewDate']="";

        $Cache = new nsQueryCache($CompId);
        $Cache->QueryParams=$SaveReport;
        if (ValidVar($WhereArr)) $Cache->QueryParams['WhereArr']=$WhereArr;
        $Cache->Mode=$Mode;
        $Cache->GetQuerySetId();
        $Cache->GetCacheId();
        if (!$Cache->CacheId) $Cache->CreateCacheRecord(0);
        $Cache->SetCacheType(1);

        $CacheArr[]=$Cache->CacheId;
        $Query = "SELECT ID FROM ?_{$CompId}_static_report_cache WHERE REPORT_ID=? AND PERIOD_ID=? AND CACHE_ID=?";
        $CheckId=$Db->ReturnValue($Query, $SRId, $PeriodId, $Cache->CacheId);
        if (!$CheckId) {
            $Query = "INSERT INTO ?_{$CompId}_static_report_cache (REPORT_ID, PERIOD_ID, CACHE_ID) VALUES (?, ?, ?)";
            $Db->Query($Query, $SRId, $PeriodId, $Cache->CacheId);
            SetUpdateTime($SRId,$PeriodId);
        }

        $Cache=false;
    }

    if(!empty($CacheArr)) {
        $Query = "DELETE FROM ?_{$CompId}_static_report_cache WHERE REPORT_ID=? AND CACHE_ID NOT IN (?)";
        $Db->Query($Query, $SRId, $CacheArr);
    }

    }
}

function ReCreateUserReportGroups($Groups=array())
{
    global $Db;
    $Query = "INSERT INTO ?_static_report_group (ID, COMPANY_ID, NAME) VALUES ";
    foreach ($Groups as $i=>$Row) {
        if ($i>0) $Query.=", ";
        $Query.="(".$Row->ID.", ".$Row->COMPANY_ID.", '".es($Row->NAME)."')";
    }
    if (!empty($Groups)) $Db->Query($Query);
}

function GetAllUserReportGroups()
{
    $Groups=array();
    $Query = "SELECT * FROM ?_static_report_group WHERE COMPANY_ID!=0";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $Groups[]=$Row;
    return $Groups;
}

function ReCreateUserReports($Reports=array())
{
    global $Db, $ReplaceReportId, $nsConsole;
    $nsConsole->Stop=true;
    
    foreach ($Reports as $Report) {
        $Query = "INSERT INTO ?_static_report 
            (COMPANY_ID, GROUP_ID, NAME, SITES, MODE, DESCRIPTION) VALUES (?,?,?,?,?,?)";
        $Db->Query($Query, $Report->COMPANY_ID,$Report->GROUP_ID,$Report->NAME,$Report->SITES,$Report->MODE,$Report->DESCRIPTION);
        $SRId=$Db->LastInsertId;
        $ReplaceReportId[$Report->ID]=$SRId;
        foreach ($Report->Periods as $T=>$Period) {
            $Query = "INSERT INTO ?_static_report_periods 
                             (REPORT_ID, PERIOD, DAY_TIME, UPDATE_PERIOD_CNT, UPDATE_PERIOD) VALUES (?,?,?,?,?)";
            $Db->Query($Query,$SRId,$T,$Period->DAY_TIME,$Period->UPDATE_PERIOD_CNT,$Period->UPDATE_PERIOD);
            $PeriodId=$Db->LastInsertId;

            $SaveReport=unserialize($Period->PARAMS_SET);
            if (isset($SaveReport['WhereArr'])) {
                $WhereArr=$SaveReport['WhereArr'];
                unset($SaveReport['WhereArr']);
            }
            $SaveReport['DynamicPeriod']=(string) $T=="0-a-0"?"-1":$T;
            $SaveReport['EndDate']="";
            $SaveReport['StartDate']="";
            $SaveReport['ViewDate']="";
            $SaveReport['TrafficMode']="";

            $Cache = new nsQueryCache($Report->COMPANY_ID);
            $Cache->QueryParams=$SaveReport;
            if (ValidVar($WhereArr)) $Cache->QueryParams['WhereArr']=$WhereArr;
            $Cache->Mode=$Report->MODE;
            $Cache->GetQuerySetId();
            $Cache->GetCacheId();
            if (!$Cache->CacheId) $Cache->CreateCacheRecord(0);
            $Cache->SetCacheType(1);

            $Query = "INSERT INTO ?_{$Report->COMPANY_ID}_static_report_cache (REPORT_ID, PERIOD_ID, CACHE_ID) VALUES (?,?,?)";
            $Db->Query($Query, $SRId, $PeriodId, $Cache->CacheId);
            SetUpdateTime($SRId,$PeriodId);            
        }
    }
}

function GetAllUserReports()
{
    $Reports=array();
    $Query = "SELECT SR.* FROM ?_static_report SR WHERE SR.COMPANY_ID!=0";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $Row->Periods=array();
        $Reports[]=$Row;
    }
    
    foreach ($Reports as $i=>$Row) {
        $Query = "
            SELECT
                RP.*, C.CACHE_TYPE, C.QUERY_SET_ID, C.MODE,
                QS.PARAMS_SET
                FROM ?_static_report_periods RP
                    INNER JOIN ?_{$Row->COMPANY_ID}_static_report_cache RC
                        ON RC.REPORT_ID=RP.REPORT_ID AND RC.PERIOD_ID=RP.ID
                    INNER JOIN ?_{$Row->COMPANY_ID}_cache C
                        ON C.ID=RC.CACHE_ID
                    INNER JOIN ?_{$Row->COMPANY_ID}_cache_query_set QS
                        ON QS.ID=C.QUERY_SET_ID
                WHERE RP.REPORT_ID=? 
        ";
        $Sql = new Query($Query, false, $Row->ID);
        while ($SubRow=$Sql->Row()) {
            $Reports[$i]->Periods[$SubRow->PERIOD]=$SubRow;
        }
    }
    
    return $Reports;
}



function CreateHiddenReports($ToCpId=0)
{
    global $Db, $nsUser, $nsConsole;
    $nsConsole->Stop=true;
    
    // 
    static $ClientArr=array();
    if ($ToCpId) $ClientArr[]=$ToCpId;
    if (empty($ClientArr)) {
        $Query = "SELECT ID FROM ?_client";
        $Sql = new Query($Query);
        while($Row=$Sql->Row()) $ClientArr[]=$Row->ID;
    }
    
    foreach ($ClientArr as $CompId) {
        $Cache= new nsQueryCache($CompId);
        $Cache->Mode="NATURAL";
        $Cache->QueryParams=array("DynamicPeriod"=>"0-d-0");
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
        $Cache= new nsQueryCache($CompId);
        $Cache->Mode="PAID";
        $Cache->QueryParams=array("DynamicPeriod"=>"0-d-0");
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);            
    }
    
    // 
    static $SiteArr=array();
    if (empty($SiteArr)) {
        $Where=($ToCpId)?" WHERE COMPANY_ID=$ToCpId":"";
        $Query = "SELECT ID, COMPANY_ID FROM ?_site $Where";
        $Sql = new Query($Query);
        while($Row=$Sql->Row()) $SiteArr[]=$Row;
    }    
    
    foreach ($SiteArr as $Row) {
        $Cache= new nsQueryCache($Row->COMPANY_ID);
        $Cache->Mode="NATURAL";
        $Cache->QueryParams=array("SiteId"=>$Row->ID, "DynamicPeriod"=>"0-d-0");
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
        $Cache= new nsQueryCache($Row->COMPANY_ID);
        $Cache->Mode="PAID";
        $Cache->QueryParams=array("SiteId"=>$Row->ID, "DynamicPeriod"=>"0-d-0");
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
    }
    
    
    //  
    static $CampGrpArr=array();
        if (empty($CampGrpArr)) {
        $Where=($ToCpId)?" WHERE COMPANY_ID=$ToCpId":"";            
        $Query = "SELECT ID, COMPANY_ID FROM ?_campaign $Where";
        $Sql = new Query($Query);
        while($Row=$Sql->Row()) $CampGrpArr[]=$Row;
    }

    foreach ($CampGrpArr as $Row) {
        $Cache = new nsQueryCache($Row->COMPANY_ID);
        $Cache->Mode="PAID";
        $Cache->UpdateInterval=360;
        $Cache->QueryParams=CampQueryParams($Row->ID,$Row->COMPANY_ID);
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
    }
    
    
    //    
    $Where=($ToCpId)?" WHERE CP.COMPANY_ID=$ToCpId":"";                
    $Query = "
        SELECT CP.ID, CP.COMPANY_ID, SC.ID AS CAMP_ID, ST.ID AS SPLIT_ID  
            FROM ?_camp_piece CP
            LEFT JOIN ?_sub_campaign SC
                ON SC.SUB_ID=CP.ID
            LEFT JOIN ?_split_test ST
                ON ST.SUB_ID=CP.ID
        $Where
    ";
    $Sql = new Query($Query);
    $CampArr=array();
    while($Row=$Sql->Row()) $CampArr[]=$Row;        

    foreach ($CampArr as $Row) {
        if (!$Row->ID||!$Row->COMPANY_ID) continue;
        if (!$Row->CAMP_ID && !$Row->SPLIT_ID) continue; 
        $Cache = new nsQueryCache($Row->COMPANY_ID);
        $Cache->Mode=($Row->CAMP_ID)?"PAID":"SPLIT";
        $Cache->UpdateInterval=360;
        if ($Row->CAMP_ID) $Cache->QueryParams=SubCampQueryParams($Row->ID,$Row->COMPANY_ID);
        if ($Row->SPLIT_ID) $Cache->QueryParams=SplitQueryParams($Row->ID,$Row->COMPANY_ID);
        if (!$Cache->GetCacheId()) $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
    }
}

function CreateAllSystemPeriods()
{
    global $Db;
    $Query = "REPLACE INTO ?_periods (NAME, TEMPLATE, COMPANY_ID, DELETED, SYSTEM_TEMPLATE) VALUES 
    ('', '0-a-0', 0, '0', '1'),    
    ('', '0-d-0', 0, '0', '1'),
    ('', '1-d-0', 0, '0', '1'),
    ('', '0-w-0', 0, '0', '1'),
    ('', '1-w-0', 0, '0', '1'),
    ('', '0-m-0', 0, '0', '1'),
    ('', '1-m-0', 0, '0', '1'),
    ('', '0-y-0', 0, '0', '1'),
    ('', '1-y-0', 0, '0', '1')
    ";
    $Db->Query($Query);
}

function CreateAllSystemReportGroups()
{
    global $Db;
    $Query = "REPLACE INTO ?_static_report_group (COMPANY_ID, NAME) VALUES 
        (0, 'x-groupTraffic'), (0, 'x-groupActivity'), (0, 'x-groupVisitors'), (0, 'x-groupCustom')
    ";
    $Db->Query($Query);
}

function RebuildCache()
{
    global $Db, $nsConsole;
    if (function_exists("ini_set")) @ini_set("memory_limit","40M");
    if (function_exists("set_time_limit")) @set_time_limit(0);
    $nsConsole->Stop=true;

    $Groups=GetAllUserReportGroups();
    $Reports=GetAllUserReports();

    $Db->Query("TRUNCATE TABLE ?_user_cache");
    $Db->Query("TRUNCATE TABLE ?_static_report_periods");
    $Db->Query("TRUNCATE TABLE ?_static_report_group");
    $Db->Query("TRUNCATE TABLE ?_static_report");
    $Db->Query("TRUNCATE TABLE ?_static_report_archive");
    $Db->Query("TRUNCATE TABLE ?_report_time_stat");
    $Db->Query("TRUNCATE TABLE ?_periods");
    $Db->Query("TRUNCATE TABLE ?_cron_log");
    $Db->Query("TRUNCATE TABLE ?_cron_delete_log");
    $Db->Query("TRUNCATE TABLE ?_cron_archive_log");

    $Query = "SELECT ID FROM ?_client ORDER BY ID";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    foreach ($CpArr as $CpId) {
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_cache");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_cache_cron_log");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_cache_data");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_cache_query_set");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_cache_popularity");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_static_report_cache");
        $Db->Query("TRUNCATE TABLE ?_{$CpId}_static_archive_cache");
    }

    CreateAllSystemPeriods();
    CreateAllSystemReportGroups();
    CreateAllSystemReports();
    CreateHiddenReports();

    ReCreateUserReportGroups($Groups);
    ReCreateUserReports($Reports);
    ReCreateArchives();
}

function ReCreateArchives($ClientArr=array(), $Reports=array(), $Periods=array(), $ExistingOnly=false)
{
    global $Db, $ReplaceReportId, $Logs, $nsConsole;
    $nsConsole->Stop=true;
    
    if (empty($ClientArr)) {
        $Query = "SELECT ID FROM ?_client";
        $Sql = new Query($Query);
        while($Row=$Sql->Row()) $ClientArr[]=$Row->ID;
    }

    if (empty($Reports)) {
        if ($ExistingOnly) $Query = "SELECT SR.*, COUNT(SA.ID) AS CNT FROM ?_static_report SR 
                            INNER JOIN ?_static_report_archive SA ON SA.REPORT_ID=SR.ID
                            GROUP BY SR.ID
                            HAVING CNT > 0";
        else $Query = "SELECT * FROM ?_static_report";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) {
            if ($Row->COMPANY_ID!=0 && !in_array($Row->COMPANY_ID,$ClientArr)) continue;
            $Reports[]=$Row;
        }
    }

    if (empty($Periods)) {
        $Query = "SELECT * FROM ?_periods";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) {
            if ($Row->COMPANY_ID!=0 && !in_array($Row->COMPANY_ID,$ClientArr)) continue;
            $Arr=explode('-',$Row->TEMPLATE);
            if ($Arr[0]==0 || $Arr[2]==1) continue;
            if ($Arr[1]=='d' && $Arr[0]<7) continue;
            $Periods[$Row->COMPANY_ID][]=$Row->TEMPLATE;
        }
        foreach ($Periods as $CpId=>$Arr) {
            if ($CpId>0) {
                $Periods[$CpId]=array_merge($Periods[$CpId],$Periods[0]);
                $Periods[$CpId]=array_unique($Periods[$CpId]);
            }
        }
    }

    foreach ($Reports as $Row) {
        if (!isset($Periods[$Row->COMPANY_ID])) $Periods[$Row->COMPANY_ID]=$Periods[0];
        foreach ($Periods[$Row->COMPANY_ID] as $Tpl) {
            $CpArr=$Row->COMPANY_ID>0?array(0=>$Row->COMPANY_ID):$ClientArr;
            SetArchivePeriod($Row,$CpArr,$Tpl);
        }
    }

    $Query = "SELECT MAX(ID) FROM ?_static_report";
    $MaxId=$Db->ReturnValue($Query);
    $TmpIds=array();
    foreach ($ReplaceReportId as $OldId => $NewId) {
        $MaxId++;
        $Query = "UPDATE ?_archive SET REPORT_ID=? WHERE REPORT_ID=?";
        $Db->Query($Query,$MaxId,$OldId);
        $TmpIds[$MaxId]=$NewId;
    }

    foreach ($TmpIds as $OldId=>$NewId) {
        $Query = "UPDATE ?_archive SET REPORT_ID=? WHERE REPORT_ID=?";
        $Db->Query($Query,$NewId,$OldId);        
    }
}

function CheckReportsInstalled()
{
    global $Db, $nsProduct;
    $CheckId1=$Db->ReturnValue("SELECT ID FROM ?_periods LIMIT 1");
    if (!$CheckId1) CreateAllSystemPeriods();
    $CheckId2=$Db->ReturnValue("SELECT ID FROM ?_static_report_group LIMIT 1");
    if (!$CheckId2) CreateAllSystemReportGroups();
    $CheckId3=$Db->ReturnValue("SELECT ID FROM ?_static_report LIMIT 1");  
    if (!$CheckId3) CreateAllSystemReports();
    if (!$CheckId3) CreateHiddenReports();
    $CheckId4=$Db->ReturnValue("SELECT ID FROM ?_static_report_archive LIMIT 1");
    if (!$CheckId4) ReCreateArchives();
    if (!$CheckId1||!$CheckId2||!$CheckId3||!$CheckId4) $nsProduct->Redir("default", "", "admin");
}


?>