<?
function GetConstPath(&$Arr, $Inx, $Group=true) {
	global $CpId, $ViewDate, $StartDate, $EndDate,$TrafficMode,$Limit,$Filter,$DatesUsed;
    $URL="CpId=$CpId&TrafficMode=$TrafficMode&Limit=$Limit&Filter=$Filter&";
    //     DatesUsed
	if (!$DatesUsed) $URL.="StartDate=$StartDate&EndDate=$EndDate&ViewDate=$ViewDate&";
	for($i=0;$i<=$Inx;$i++) {
		if ($Inx!=$i||!$Group) {
			$URL.="WhereArr[$i][Mode]=".$Arr[$i]['Mode']."&";
			if (isset($Arr[$i]['Id'])&&$Arr[$i]['Id']!="") $URL.="WhereArr[$i][Id]=".$Arr[$i]['Id']."&";
		}
		if ($Inx==$i&&$Group) $URL.="GroupBy=".$Arr[$i]['Mode']."&";
		if (V($Arr[$i]['OrderTo'])) $URL.="WhereArr[$i][OrderTo]=".$Arr[$i]['OrderTo']."&";
		if (V($Arr[$i]['OrderBy'])) $URL.="WhereArr[$i][OrderBy]=".$Arr[$i]['OrderBy']."&";
	}
	return $URL;
}

function DummyUser( &$nsUser, $CpId=false ) {
    if (!defined('CRON_MODE')) return false;
    global $Db;
    if (!$nsUser) $nsUser = (object)array();
    $nsUser->GRAPH_PLACE = 0;
    $nsUser->Logged = true;
    $nsUser->DEF_LOGS_ORDER='';
    $nsUser->DEMO=true;
    $nsUser->TZ = '';
    $nsUser->ADMIN=$nsUser->SUPER_USER=$nsUser->MERCH=false;
    if ($CpId) $nsUser->TZ = $Db->ReturnValue("SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0", $CpId);
    if (!$nsUser->TZ) $nsUser->TZ="0";
    $nsUser->_TZ=-$nsUser->TZ;
    $nsUser->SQL_TZ=@SqlTZ($nsUser->TZ);
    $nsUser->_SQL_TZ=@SqlTZ($nsUser->TZ,$nsUser->SQL_TZ);
    $nsUser->Columns = (object)array('HITS'=>1, 'SALES'=>1,'ACTIONS'=>1,'CLICKS'=>1,
                                                                                                  'ROI'=>1,'CONVERSIONS'=>1,'GRAPHS'=>1,'NEWRET'=>1,'VISITS'=>1);
}


function GetReportParamsTable( $Params ) {
    $Table = array();
    if (empty($Params)) return $Table;
    global $Lang, $Db, $nsLang;
    $nsLang->TplInc("constructor/periods");
    $nsLang->TplInc("inc/filter");
    $nsLang->TplInc("constructor/constructor_form");

    foreach ($Params as $k=>$v) {
    if (in_array($k, array('GroupBy', 'WhereArr', 'FilterFor', 'UserOrder', 'Limit'))) continue;
        if ($v=='') continue;
        if ($k=='SiteId') {
            if ($v==-1 || $v==0) $v= $Lang['NoChoosenSite'];
            else $v = $Db->ReturnValue('SELECT HOST FROM ?_site WHERE ID=?', $v);
            $k = $Lang['ChoosenSite'];
        }
        if ($k=='DynamicPeriod') { $v = @$Lang[$v]; $k = $Lang['Period']; }
        if ($k=='StartDate') { $k = $Lang['Period']; $v = $Lang['PeriodFrom']. ' ' .$v; }
        if ($k=='EndDate') { $k = $Lang['Period']; $v = $Lang['PeriodTill']. ' ' .$v; }
        if ($k=='Filter') { $k = $Lang['Filter']; }
        if ($k=='TrafficMode') { $k =$Lang['TrafficType']; $v = $Lang['TrafficMode'.$v]; }
        if ($k=='Date') { $k = $Lang['Date']; }
        $Table[$k]=$v;
    }
    return $Table;
}


function RefCut($Ref, $MaxLen=45) {

	$Len=strlen($Ref);
	if ($Len>$MaxLen+1) {
		$Ref=substr_replace($Ref, "...", 30, $Len-30-(($MaxLen-30)+3));
	}
	return $Ref;
}


function ReportAddJoin($Join)
{
    global $Report, $PrevReport;
    $Report->JoinArr[]=$Join;
    if ($PrevReport) $PrevReport->tlsJoinArr[]=$Join;
}

function ReportAddWhere($Where)
{
    global $Report, $PrevReport;
    $Report->WhereArr[]=$Where;
    if ($PrevReport) $PrevReport->tlsWhereArr[]=$Where;
}


function SortRows($a, $b) {
	global $OrderTo, $OrderBy, $SaveMode, $GroupBy;
    $Key=false;
    if ($OrderBy=="DEFAULT") $Key="CntClick";
    if ($OrderBy=="NAME") $Key="Name";
    if ($OrderBy=="CNT") $Key="CntClick";
	if ($OrderBy=="UNI") $Key="UniClick";
	if ($OrderBy=="ACTCONV") $Key="ActionConv";
	if ($OrderBy=="SALECONV") $Key="SaleConv";
	if ($OrderBy=="ACTIONCNT") $Key="CntAction";
	if ($OrderBy=="ACTIONUNI") $Key="UniAction";
	if ($OrderBy=="SALECNT") $Key="CntSale";
	if ($OrderBy=="SALEUNI") $Key="UniSale";
	if ($OrderBy=="ROI") $Key="ROI";
	if ($OrderBy=="COST") $Key="CampCost";
	if ($OrderBy=="INCOME"&&$SaveMode=="PAID") $Key="TotalIncome";
	if ($OrderBy=="INCOME"&&$SaveMode=="NATURAL") $Key="Income";
    if ($OrderBy=="NEW") $Key="New";
    if ($OrderBy=="RETURNING") $Key="Returning";

    if ($OrderBy=="NAME" && in_array($GroupBy,array("Date", "Month", "Time", "Year", "WeekDay"))) {
        $Key="Stamp";
    }

  	if ($a[$Key] < $b[$Key]) {
  		return ($OrderTo == 'ASC' ? -1 : 1);
  	} else if ($a[$Key] > $b[$Key]) {
  		return ($OrderTo == 'ASC' ? 1 : -1);
  	} else {
  		return 0;
  	}
}


function GetDateArrayFromPeriod($StartDate=false,$EndDate=false, $Limit=false, $OrderTo=false)
{
    global $CpId,$Db;
    if (!$StartDate && $Limit && $OrderTo) {
        $Limit--;
        if (strtolower($OrderTo)=='desc') {
            $Query = "SELECT DATE_ADD(CURRENT_DATE, INTERVAL -$Limit DAY)";
            $StartDate=$Db->ReturnValue($Query);
        }
        else {
            $Query = "SELECT DATE_FORMAT(MIN(STAMP),'%Y-%m-%d') FROM ?_{$CpId}_stat_log";
            $StartDate=$Db->ReturnValue($Query);
        }
    }
    if (!$StartDate) return false;
    if (!$EndDate) $EndDate=date("Y-m-d");

    $Query = "SELECT TO_DAYS('$EndDate') - TO_DAYS('$StartDate')";
    $DaysCnt=$Db->ReturnValue($Query)+1;
    $Arr=explode("-",$StartDate);
    $TimeArr['Y']=$Arr[0];
    $TimeArr['m']=$Arr[1];
    $TimeArr['d']=$Arr[2];

    $List=array();
    $i=$TimeArr['d'];
    while ($i<($TimeArr['d']+$DaysCnt)) {
        $List[mktime(0,0,1,$TimeArr['m'],$i,$TimeArr['Y'])]=date("Y-m-d",mktime(0,0,1,$TimeArr['m'],$i,$TimeArr['Y']));
        $i++;
    }
    if (strtolower($OrderTo)=='desc') $List=array_reverse($List);
    return $List;
}



////////////////////////////////////////////////
/*
    1-d-1
    

1-d-1 - 1     
2-m-0 -    (  )
*/


function GetDateFromPeriod($Period, $UseTz=false, $TZ=false)
{
    $ReturnPeriod['StartDate']="";
    $ReturnPeriod['EndDate']="";
    if ($Period=="") return $ReturnPeriod;

    global $Db;
    $Intervals['h']="HOUR";
    $Intervals['d']="DAY";
    $Intervals['w']="WEEK";
    $Intervals['m']="MONTH";
    $Intervals['y']="YEAR";

    $Date="";
    $PArr=explode("-", $Period);
    if ($PArr[1]=='a') return $ReturnPeriod;

    if (!isset($PArr[1]) || $PArr[1]=="") $I="DAY";
    else $I=$Intervals[ $PArr[1] ];
    $Itv=V($PArr[1], "d");

    if (!isset($PArr[2])) $M=0;
    else $M=$PArr[2];

    $Num = $PArr[0];

    if ($UseTz) $Now=date("Y-m-d H:i:s", UserDate("stamp",$TZ));
    else $Now=gmdate("Y-m-d H:i:s");

    if ($Num==0) $M=0;

    //   
    if ($M==1) {
        if ($PArr[1]=="w") {
            $I="DAY";
            $Num=($Num*7)-1;
        }
        $Query = "SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL -$Num $I), '%Y-%m-%d')";
        $Date=$Db->ReturnValue($Query);
        $ReturnPeriod['StartDate']=$Date." 00:00:00";
        return $ReturnPeriod;
    }

    //     ( ,   )
    if ($M==0) {
        if ($Itv=="d") $Func=" (DATE_ADD('$Now', INTERVAL -{NUM} DAY)) ";
        if ($Itv=="w") $Func=" (DATE_ADD('$Now', INTERVAL -((IF(DAYOFWEEK('$Now')=1,7,DAYOFWEEK('$Now')-1))+(7*{NUM}))+1 DAY)) ";
        if ($Itv=="m") $Func=" ((PERIOD_ADD(EXTRACT(YEAR_MONTH FROM '$Now'), -{NUM})*100)+1) ";
        if ($Itv=="y") $Func="  (( (EXTRACT(YEAR FROM '$Now')-{NUM} )*100+1)*100+1) ";

        $Query = "SELECT DATE_FORMAT(".str_replace("{NUM}", $Num, $Func).", '%Y-%m-%d')";
        $Date=$Db->ReturnValue($Query);
        $ReturnPeriod['StartDate']=$Date." 00:00:00";

        if ($Num==0) $ReturnPeriod['EndDate']="";
        else {
            $Query = "SELECT DATE_FORMAT(".str_replace("{NUM}", "0", $Func).", '%Y-%m-%d')";
            $Date=$Db->ReturnValue($Query);
            if ($Itv=="d"||$Itv=="w"||$Itv=="m"||$Itv=="y") $Date=$Db->ReturnValue("SELECT DATE_ADD('$Date', INTERVAL -1 DAY)");
            $ReturnPeriod['EndDate']=$Date." 23:59:59";
        }
        return $ReturnPeriod;
    }
}

function GetPeriodsList($CpId=0) {
    global $Lang;
    $FormPeriodsArr=array();
    $Query = "SELECT TEMPLATE, NAME FROM ?_periods WHERE COMPANY_ID IN (0, $CpId) AND
                        DELETED != '1' GROUP BY TEMPLATE ORDER BY TEMPLATE";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
        $FormPeriodsArr[$Row->TEMPLATE]=$Row;
    }
    $PArr=array_keys($FormPeriodsArr);
    usort($PArr,"SortPeriods");
    return SyncKeysWValues($FormPeriodsArr,$PArr);
}

$PeriodsOrderArr=array("a"=>0, "h"=>1, "d"=>2, "w"=>3, "m"=>4, "y"=>5);

function ComparePeriods( $a, $b ) {
    global $PeriodsOrderArr;
    if ($a==$b) return 0;
    foreach ($PeriodsOrderArr as $k=>$v) {
        if ($k==$a) return 1;
        if ($k==$b) return -1;
    }
    return 0;
}

function FindClosestPeriod($P = false, $Periods = array()) {
    $Arr = explode('-', $P);
    if (!$P || count($Arr)<3) return $P;
    usort($Periods, 'SortPeriods');
    $Cnt = $Arr[0];
    $Pr = '';
    foreach ($Periods as $Row) {
        if ($Row=='0-a-0') continue;
        $RowArr = explode('-', $Row);
        if ($RowArr[2] != $Arr[2]) continue;
        if ( ComparePeriods($Arr[1], $RowArr[1]) > 0 || $RowArr[0] > $Arr[0] ) continue;
        $Pr = $RowArr[1];
    }
    if ($Pr) foreach ($Periods as $Row) {
        if ($Row=='0-a-0') continue;
        $RowArr = explode('-', $Row);
        if ($RowArr[2] != $Arr[2]) continue;
        if ($RowArr[1] != $Pr) continue;
        if ($RowArr[0] > $Arr[0]) continue;
        $Cnt = $RowArr[0];
    }
    if ($Cnt<0 || !$Pr) return $P;
    return "$Cnt-$Pr-{$Arr[2]}";
}


function SortPeriods($a,$b)
{
    global $PeriodsOrderArr;
    if ($a==$b) return 0;
    if ($a=='-1' && $b!='-1') return -1;
    if ($a!='-1'&&$b=='-1') return 1;

    $Arr1=explode("-",$a);
    $Arr2=explode("-",$b);
    if ($Arr1[1]=='a') return -1;
    if ($Arr2[1]=='a') return 1;

    if ($Arr1[0]!=$Arr2[0] && ($Arr1[0]==0||$Arr2[0]==0)) {
        if ($Arr1[0]==0) return -1;
        if ($Arr2[0]==0) return 1;
    }

    if ($Arr1[2]!=$Arr2[2]) return ($Arr1[2]<$Arr2[2])?1:-1;

    if ($PeriodsOrderArr[$Arr1[1]]==$PeriodsOrderArr[$Arr2[1]]) {
        if ($Arr1[0]==$Arr2[0]) return 0;
        return ($Arr1[0]<$Arr2[0])?-1:1;
    }
    return ($PeriodsOrderArr[$Arr1[1]]<$PeriodsOrderArr[$Arr2[1]])?-1:1;
}


function VisLenName($S1=0,$S2=0)
{
    global $Lang;
    $S1Type=$S2Type='';
    if ($S1>0&&$S1<1000000000) {
        $S1Type='Seconds';
        if ($S1>=60) {
            if (!($S1%3600)) {$S1=$S1/3600; $S1Type='Hours';}
            elseif (!($S1%60)) {$S1=$S1/60; $S1Type='Minutes';}
        }
    }
    if ($S2>0&&$S2<1000000000) {
        $S2Type='Seconds';
        if ($S2>=60) {
            if (!($S2%3600)) {$S2=$S2/3600; $S2Type='Hours';}
            elseif (!($S2%60)) {$S2=$S2/60; $S2Type='Minutes';}
        }
    }
    if ($S1Type=='') return "< {$S2}{$Lang[$S2Type]}";
    if ($S2Type=='') return "> {$S1}{$Lang[$S1Type]}";
    if ($S1Type==$S2Type) return "$S1 - $S2{$Lang[$S1Type]}";
    else return "{$S1}{$Lang[$S1Type]} - {$S2}{$Lang[$S2Type]}";
}

?>