<?
//    ReportData
//     ,    
$RData = new ReportData($SaveMode);
$RData->TopCaption = @$ReportCaption;
$RData->ReportCaptionLast = @$ReportCaptionLast;
$RData->ReportValues = @$ReportValues;
$RData->ShowNextStep = (!@$LastReport && !@$CurrentCompany->DISABLE_CONSTRUCTOR && !@$ArchiveId);
$RData->CurrentPath=@$CurrentPath;
$RData->CurrentOrderBy=@$OrderBy;
$RData->CurrentOrderTo=@$OrderTo;
$RData->EnableHighlight=true;
if (!@$ArchiveMode) $RData->EmailMode=$SaveMode;
if (@$ArchiveMode) $RData->EnableSorting = false;
$RData->Report=&$Report;
if ($Report->_OnlyAction) $RData->ColumnOrder=array('Name','CntAction','UniAction','New','Returning','ActionConv');
if ($Report->_OnlySale) $RData->ColumnOrder=array('Name','ProdQuant','CntSale','UniSale','New','Returning','Income','TotalIncome','ActionConv');
if ($nsUser->Columns->GRAPHS) $RData->GraphPlace=$nsUser->GRAPH_PLACE;

if (isset($WhereArr[count($WhereArr)-1]['Name'])) $RData->AddColumn("Name",$WhereArr[count($WhereArr)-1]['Name'],"NAME");
else $RData->AddColumn("Name",$Lang['GrByGeneral'],"NAME");

if ($Report->_GetVisits && ($nsUser->Columns->HITS ||$nsUser->Columns->CLICKS) &&
    !array_intersect($SessionGroups,$UsedGroupsArr)) {
    $RData->AddColumn("CntClick",$Lang['RHeaderPV'],"CNT");
}

if ($SaveMode=='NATURAL' && in_array($GroupBy,array('Split','Ref','Source','SourceGrp','Key'))) {
    $RData->SuperColumns['Click']['Name']=$Lang['RHeaderHit'];
}
if (array_intersect(array('PagesNode'),$UsedGroupsArr)) {
    $RData->SuperColumns['Click']['Name']=$Lang['RHeaderHit'];
}

$RData->AddColumn("UniClick",$Lang['RHeaderUni'],"UNI","Visitor");
if ($Report->SessVisits&&$nsUser->Columns->VISITS) {
    $RData->AddColumn("Visits",$Lang['RHeaderVisits'],"VISITS","Visitor");
}
if ($Report->NewVsRet&&$nsUser->Columns->NEWRET) {
    $RData->AddColumn("New",$Lang['RHeaderNew'],"NEW",(!$Report->_OnlyAction&&!$Report->_OnlySale)?"Visitor":"");
    $RData->AddColumn("Returning",$Lang['RHeaderReturn'],"RETURNING",(!$Report->_OnlyAction&&!$Report->_OnlySale)?"Visitor":"");
}

if ($Report->_GetSales&&$nsUser->Columns->SALES) {
    $RData->AddColumn("CntSale",$Lang['RHeaderTotal'],"SALECNT",(!$Report->_OnlySale)?"Sale":"");
    $RData->AddColumn("UniSale",$Lang['RHeaderUni'],"SALEUNI",(!$Report->_OnlySale)?"Sale":"");
    if ($SaveMode=='NATURAL') $RData->AddColumn("Income",$Lang['RHeaderIncome'],"INCOME",(!$Report->_OnlySale)?"Sale":"");
    if (!$Report->_GetCost&&$SaveMode=='PAID') $RData->AddColumn("TotalIncome",$Lang['RHeaderIncome'],"INCOME",(!$Report->_OnlySale)?"Sale":"");
}
if ($Report->_GetActions&&$nsUser->Columns->ACTIONS) {
    $RData->AddColumn("CntAction",$Lang['RHeaderTotal'],"ACTIONCNT",(!$Report->_OnlyAction)?"Action":"");
    $RData->AddColumn("UniAction",$Lang['RHeaderUni'],"ACTIONUNI",(!$Report->_OnlyAction)?"Action":"");
}
if ($nsUser->Columns->CONVERSIONS) {
    if ($Report->_GetActionConv&&$Report->_GetActions&&$nsUser->Columns->ACTIONS) $RData->AddColumn("ActionConv",$Lang[(!$Report->_OnlyAction)?'RHeaderAction':'RHeaderConversion'],"ACTCONV",(!$Report->_OnlyAction)?"Conv":"",1);
    if ($Report->_GetSaleConv&&$Report->_GetSales&&$nsUser->Columns->SALES) $RData->AddColumn("SaleConv",$Lang[(!$Report->_OnlySale)?'RHeaderSale':'RHeaderConversion'],"SALECONV",(!$Report->_OnlySale)?"Conv":"",1);
}
if ($Report->_GetCost&&$SaveMode=='PAID'&&$nsUser->Columns->ROI) {
    $RData->AddColumn("ROI",$Lang['RHeaderROI'],"ROI",false,1,1);
    $RData->AddColumn("CampCost",$Lang['RHeaderCost'],"COST",false,false,1);
    $RData->AddColumn("TotalIncome",$Lang['RHeaderIncome'],"INCOME");
}

if (in_array($GroupBy, array('Order', 'Sale'))) {
    $RData->RemoveColumn('CntSale');
    $RData->RemoveColumn('CntClick');
    $RData->AddColumn("ProdQuant",$Lang['RHeaderProducts'],"CNT");
}

if (array_intersect($SessionGroups,$UsedGroupsArr)) {
    $RData->RemoveColumn('CntSale');
    $RData->RemoveColumn('UniSale');
    $RData->RemoveColumn('Income');
}

if (in_array('ConvLength',$UsedGroupsArr)) {
    $RData->RemoveColumn('CntClick');
    $RData->RemoveColumn('Visits');
    $RData->RemoveColumn('UniClick');
    $RData->RemoveColumn('New');
    $RData->RemoveColumn('Returning');
    $RData->RemoveColumn('UniSale');
}

?>