<?
class nsDatabaseLite
{
	var $ID;

	function nsDatabaseLite($DbUser=false, $DbPass=false, $DbHost=false, $DbPort=false, $DbName=false)
	{
		$this->AutoFree=true;
		$this->LastAffected=false;
		$this->LastInsertId=false;
        $this->DoPrepareQuery=true;
        $this->LoggerFunc="";
        $this->ErrorFunc="";
		$ID = @mysql_connect($DbHost, $DbUser, $DbPass);
		if (!$ID) return false;
		if (!@mysql_select_db($DbName, $ID)) return false;
		$this->ID = $ID;
        //$this->SetVariable('time_zone', '+0:00');
	}

	function Close()
	{
		@mysql_close($this->ID);
	}
    
    function SetPfx($Query)
    {
        $Arr=array();
        preg_match_all("/\?\{([a-zA-Z0-9_]+)\}/", $Query, $Arr);
        if (!empty($Arr) && !empty($Arr[0])) {
            foreach ($Arr[1] as $k) $Query=preg_replace("/\?\{$k\}/", @constant($k), $Query);
        }
        $Query=preg_replace("/(JOIN|FROM|INTO|UPDATE|TABLE)(\s+`?)\?([^\s]+)/i", "\\1\\2".NS_DB_PFX."_tracker\\3", $Query);
        return $Query;
    }

    function PrepareQuery($Query=false, $Args=array(), $PreNum=0) 
    {
        $Query=$this->SetPfx($Query);
        if (!$this->DoPrepareQuery) return $Query;
        if (strpos($Query,"?")===false) return $Query;
        $Result=$Named=$Constant=false;
        $ResArr=$Replace=$QueryArr=array(); 
        if (!preg_match_all("/\?([%|#]?)([a-zA-Z0-9_]*)/", $Query, $ResArr)) return $Query;
        foreach ($ResArr[2] as $i=>$v) {
            if ($ResArr[1][$i]=='#') $Constant=true; 
            if ($v && $ResArr[1][$i]!='#') $Named=true;
        }
        if ($Named && (!is_array($Args[$PreNum])||count(array_slice($Args,$PreNum))>1)) return $Query;
        if ($Named) $Replace=$Args[$PreNum];
        else for($i=$PreNum;$i<count($Args);$i++) $Replace[]=$Args[$i];
        
        if (!$Constant && (is_null($Replace) || empty($Replace))) return $Query;
        
        $p1=$p=$const=0;
        foreach ($ResArr[0] as $i=>$t) {
            $p=strpos($Query,$t,$p);
            $QueryArr[]=substr($Query,$p1,$p-$p1);
            $p1=$p=$p+strlen($ResArr[0][$i]);
        }
        if (!empty($QueryArr)) $QueryArr[]=substr($Query,$p);

        foreach ($ResArr[0] as $i=>$t) {
            $k=$Named?$ResArr[2][$i]:$i-$const;
            $Result .= array_shift($QueryArr);

            if ($ResArr[1][$i]=="%" && is_array($Replace[$k])) {
                $j=0;
                foreach ($Replace[$k] as $k1=>$v1) {
                    if ($j>0) $Result.=", ";
                    $Result .= "`$k1`='".$this->es($v1)."'";
                    $j++;
                }
            }
            
            if ($ResArr[1][$i]=="#") {$Result .= @constant($ResArr[2][$i]); $const++;}            

            if ($ResArr[1][$i]=="") {
                if (is_array($Replace[$k])) {$Result .= implode(", ",$this->es($Replace[$k])); continue; }
                if (is_null($Replace[$k])) $Result .= 'NULL';
                else $Result .= '\''.$this->es($Replace[$k]).'\'';                
            }
        }
        $Result .= array_shift($QueryArr);
        return $Result;
    }
    
    
    function escape_string($Str){
        if (is_null($Str) || $Str===false) return "";        
        if (version_compare(phpversion(),"4.3.0")=="-1") return mysql_escape_string($Str);
        else return mysql_real_escape_string($Str);
    }
    
    function es($Var=false) {return is_array($Var)?$this->EscapeArray($Var):$this->escape_string($Var); }
    
    function EscapeArray($Array=array()) {
        foreach ($Array as $k=>$v) $Array[$k]="'".$this->escape_string($v)."'";
        return $Array;
    }


	function Select($Query = false, $Type = "OBJ")
	{    
		if (!$Query) return false;
		if (!$Type) $Type="OBJ";
		if ($Query == "void") return true;
		$Args=func_get_args();
		$Query=$this->PrepareQuery($Query, $Args, 2);
	
		$this->LastQuery = $Query;
		$this->LastError="";
        if ($this->LoggerFunc) $StartTime=$this->GetMicrotime();
		$ResultLink = @mysql_query($Query, $this->ID);
		if (@mysql_error()) {if ($this->ErrorFunc) {$Func=$this->ErrorFunc; $Func($Query,@mysql_error());}return false;}
		if ($Type == "OBJ") $Result = @mysql_fetch_object($ResultLink);
		if ($Type == "ARR") $Result = @mysql_fetch_array($ResultLink, MYSQL_ASSOC);
		if ($Type == "ROW") $Result = @mysql_fetch_row($ResultLink);
		if (@mysql_error()) {if ($this->ErrorFunc) {$Func=$this->ErrorFunc; $Func($Query,@mysql_error());}return false;}
        if ($this->LoggerFunc) { $Func=$this->LoggerFunc; $Func($Query,$this->GetMicrotime()-$StartTime, '', @mysql_num_rows($ResultLink));}            
		@mysql_free_result($ResultLink);
		$this->LastResult = $Result;
		return $Result;
	}

	function Query($Query = false)
	{
		if (!$Query) return false;
		if ($Query == "void") return true;
		$this->LastAffected=false;
		$this->LastInsertId=false;
        $Args=func_get_args();
        $Query=$this->PrepareQuery($Query, $Args, 1);
        
		$this->LastError="";
        if ($this->LoggerFunc) $StartTime=$this->GetMicrotime();
		$ResultLink = @mysql_query($Query, $this->ID);
		if (@mysql_error()) {if ($this->ErrorFunc) {$Func=$this->ErrorFunc; $Func($Query,@mysql_error());}return false;}
        if ($this->LoggerFunc) { $Func=$this->LoggerFunc; $Func($Query,$this->GetMicrotime()-$StartTime, '', @mysql_affected_rows($this->ID));}            
		$this->LastAffected = @mysql_affected_rows($this->ID);
		$this->LastInsertId = @mysql_insert_id($this->ID);
		@mysql_free_result($ResultLink);
		$this->LastQuery = $Query;
		return true;
	}


	function SetMysql40Mode() 
	{
		$Version=$this->ReturnValue("SELECT VERSION()");
		$this->Version=$Version;
		if ($this->CompareVersions($Version, "4.1") == 1) {
			$this->Query(" SET SESSION sql_mode='MYSQL40' ");
		}
	}

    function SetVariable($Name, $Value) {
        $this->Query("SET SESSION $Name = ? ", $Value);
    }

	function ReturnValue($Query = false)
	{
		if (!$Query) return false;
        $Args=func_get_args();
        $Query=$this->PrepareQuery($Query, $Args, 1);
        $PQ=$this->DoPrepareQuery;
        $this->DoPrepareQuery=false;
        $Res = $this->Select($Query, "ROW");
        $this->DoPrepareQuery=$PQ;
		return ($Res)?$Res[0]:false;
	}

	function CompareVersions($Str1="", $Str2="", $Position=false)
	{
		if (!$Str1&&!$Str2) return 0;
		if (!$Position&&function_exists("version_compare")) {
			return version_compare($Str1, $Str2);
		}
		if (!$Str2) return 1;
		if (!$Str1) return -1;
		if ($Str1==$Str2) return 0;

		$Arr1=explode(".", $Str1);
		$Arr2=explode(".", $Str2);

		if (count($Arr1)!=count($Arr2)) {
			if (count($Arr1)>count($Arr2)) {
				for ($i=count($Arr2);$i<count($Arr1);$i++) $Arr2[$i]=0;
			}
			else {
				for ($i=count($Arr1);$i<count($Arr2);$i++) $Arr1[$i]=0;
			}
		}
		$iStop=($Position)?$Position:count($Arr1);
		for ($i=0;$i<$iStop;$i++) {
			$V1=intval($Arr1[$i]);
			$V2=intval($Arr2[$i]);
			if ($V1==$V2) continue;
			if ($V1<$V2) return -1;
			if ($V1>$V2) return 1;
		}

		return 0;
	}

    //    
    //     
    function GetMicrotime() 
    { 
        list($usec, $sec) = explode(" ", microtime()); 
        return ((float)$usec + (float)$sec); 
    } 

}



class nsTrackQuery
{

	function nsTrackQuery($Query = false, $Type = "OBJ")
	{
		if (!$Type)$Type="OBJ";
		global $_NS_TRACK_VARS;
		$Db=&$_NS_TRACK_VARS['Db'];
		$this->DbId = $Db->ID;
        $this->Db=&$Db;
		if (!$this->DbId) return false;
		if (!$Query) return false;
		if ($Query == "void") return true;
		$this->QID=false;
        $this->LoggerFunc=$Db->LoggerFunc;
        $this->ErrorFunc=$Db->ErrorFunc;
        $Args=func_get_args();
        $Query=$Db->PrepareQuery($Query, $Args, 2);
        
		$this->Query = $Query;
		$this->Position = -1;
		$this->Type = $Type;
		$this->AutoFree = $Db->AutoFree;
		$this->Count = false;
		$this->LastRow=false;	
        
        if ($this->LoggerFunc) $this->StartTime=$Db->GetMicrotime();        
		$QID = @mysql_query($Query, $this->DbId);
		if (@mysql_error()) {if ($this->ErrorFunc) {$Func=$this->ErrorFunc; $Func($Query,@mysql_error());}return false;}
		$this->QID = $QID;
	}

	function Count()
	{
		if (!$this->Count) $this->Count = @mysql_num_rows($this->QID);
		return $this->Count;	
	}

	function Row()
	{
		if (!$this->QID) return false;
		$Row=false;
		if ($this->Type == "OBJ") $Row = @mysql_fetch_object($this->QID);
		if ($this->Type == "ARR") $Row = @mysql_fetch_array($this->QID, MYSQL_ASSOC);
		if ($this->Type == "ROW") $Row = @mysql_fetch_row($this->QID);
		if (@mysql_error()) {if ($this->ErrorFunc) {$Func=$this->ErrorFunc; $Func($Query,@mysql_error());}return false;}
        if (!$Row&&$this->LoggerFunc) { $Func=$this->LoggerFunc; $Func($Query,$this->Db->GetMicrotime()-$this->StartTime, '', $this->Count());}            
		if (!$Row) $this->Free();
		$this->Position++; 
		$this->LastRow = $Row;
		return $Row;
	}

	function Free()
	{
		@mysql_free_result($this->QID);
	}

}
?>