<?

class NS_TRACK_GENERAL {


function UpdateVisitorAction()
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$Actions=&$_NS_TRACK_VARS['Actions'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$UpdateVisPath=&$_NS_TRACK_VARS['UpdateVisPath'];

	if (!NS_TRACK_MISC::ValidArr($Actions)||empty($Actions)) return false;
	foreach ($Actions as $ActionId=>$Arr) {
		$UpdateVisPath=true;
		$Item=NS_TRACK_MISC::ValidVar($Actions[$ActionId]['Item']);
		if (!$LogId) $LogId=NS_TRACK_GENERAL::GetLogRecord();
		$Query = "
			INSERT INTO ?_{$CompanyId}_stat_action
				(LOG_ID, ACTION_ID, SITE_ID) VALUES (?, ?, ?)
		";
		$Db->Query($Query, $LogId, $ActionId, $StId);
		$StatActionId=$Db->LastInsertId;
		if (NS_TRACK_MISC::ValidVar($Item)!=false) {
			$ItemId=NS_TRACK_ACTION::GetActionItemId($Item, $CompanyId);
			$Query = "
				INSERT INTO ?_action_set
				(STAT_ACTION_ID, ACTION_ITEM_ID, COMPANY_ID) VALUES
				(?, ?, ?)
			";
			$Db->Query($Query, $StatActionId, $ItemId, $CompanyId);
		}
		$Item=false;
	}
}

function UpdateVisitorPath()
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$PageId=&$_NS_TRACK_VARS['PageId'];
	$RefSet=&$_NS_TRACK_VARS['RefSet'];
	$QueryId=&$_NS_TRACK_VARS['QueryId'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$SiteHostId=&$_NS_TRACK_VARS['SiteHostId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$SSL=&$_NS_TRACK_VARS['SSL'];

	if (!$PageId) return false;
	if (!$LogId) $LogId=NS_TRACK_GENERAL::GetLogRecord();
	$Scheme=($SSL)?1:0;
	$Query = "
		UPDATE ?_{$CompanyId}_stat_log SET
        PAGE_ID = ?, REFERER_SET = ?, QUERY_ID=?, SITE_HOST_ID=? , SCHEME=?
		WHERE ID=?
	";
	$Db->Query($Query, $PageId, $RefSet, $QueryId, $SiteHostId, $Scheme, $LogId);
}

function UpdateVisitorSplit($SplitCamp)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$LogId=&$_NS_TRACK_VARS['LogId'];

	if (!$LogId) $LogId=NS_TRACK_GENERAL::GetLogRecord();
	$Query = "INSERT INTO ?_{$CompanyId}_stat_split 	(LOG_ID, SPLIT_ID) 	VALUES (?, ?)";
	$Db->Query($Query, $LogId, $SplitCamp);
}

function UpdateVisitorClick()
{


	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$SourceId=&$_NS_TRACK_VARS['SourceId'];
	$KeyId=&$_NS_TRACK_VARS['KeyId'];
	$ClickSubId=&$_NS_TRACK_VARS['ClickSubId'];
	$UpdateVisPath=&$_NS_TRACK_VARS['UpdateVisPath'];
	$CookieLogSet=&$_NS_TRACK_VARS['CookieLogSet'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$Fraud=&$_NS_TRACK_VARS['Fraud'];

	$Query = "SELECT ID FROM ?_camp_piece WHERE ID = ?";
	$CheckId=$Db->ReturnValue($Query, $ClickSubId);
	if (!$CheckId) {
		$ClickSubId=false;
		return false;
	}

	if (!$LogId) $LogId=NS_TRACK_GENERAL::GetLogRecord();
	$UpdateVisPath=true;
	$CookieLogSet=true;
	if (!$Fraud) $Fraud="0";
	$Query = "
		INSERT INTO ?_{$CompanyId}_stat_click
			(LOG_ID, SOURCE_HOST_ID, KEYWORD_ID, CAMP_ID, FRAUD) VALUES (?, ?, ?, ?, ?)
	";
	$Db->Query($Query, $LogId, $SourceId, $KeyId, $ClickSubId, $Fraud);
}

function UpdateVisitorSale()
{

	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$Cost=&$_NS_TRACK_VARS['Cost'];
	$Items=&$_NS_TRACK_VARS['Items'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$CustomId=&$_NS_TRACK_VARS['CustomId'];
	$AddInfo=&$_NS_TRACK_VARS['AddInfo'];
    $SaleTag=&$_NS_TRACK_VARS['SaleTag'];

    if ($Cost) $Cost=NS_TRACK_SALE::PrepareCost($Cost);

	if (!$LogId) $LogId=NS_TRACK_GENERAL::GetLogRecord();
	if ($CustomId&&NS_TRACK_GENERAL::CheckDblSale($StId, $CustomId)) return false;

	if ($AddInfo===false) $AddInfo="";

	if ($Cost==0&&NS_TRACK_MISC::ValidArr($Items)&&count($Items)>0) {
		for($i=0;$i<count($Items);$i++) $Cost+=$Items[$i][2]*$Items[$i][1];
	}

	$Query = "
		INSERT INTO ?_{$CompanyId}_stat_sale
			(LOG_ID, COST, SITE_ID, CUSTOM_ORDER_ID, ADDITIONAL) VALUES (?, ?, ?, ?, ?)
    ";
	$Db->Query($Query, $LogId, $Cost, $StId, $CustomId, $AddInfo);
	$SaleId=$Db->LastInsertId;
    $DbItems=array();

	if (NS_TRACK_MISC::ValidArr($Items)) {
		for($i=0;$i<count($Items);$i++) {
			$Count=$Items[$i][2];
			settype($Count, "integer");
			if (!$Count) continue;
			$Cost=$Items[$i][1];
            if ($Cost) $Cost=NS_TRACK_SALE::PrepareCost($Cost);
			settype($Cost, "float");
			$ItemId=NS_TRACK_SALE::GetSaleItem($Items[$i][0], $CompanyId);
            if (!in_array($ItemId,$DbItems)) {
    			$Query = "
    				INSERT INTO ?_sale_set
    				(SALE_ID, ITEM_ID, QUANT, COST, COMPANY_ID) VALUES (?, ?, ?, ?, ?)
    			";
    			$Db->Query($Query, $SaleId, $ItemId, $Count, $Cost, $CompanyId);
                $DbItems[]=$ItemId;
            }
            else {
                $Query = "UPDATE ?_sale_set SET QUANT = QUANT + ? WHERE SALE_ID=? AND ITEM_ID=?";
                $Db->Query($Query,$Count,$SaleId,$ItemId);
            }
		}
	}

    if ($SaleTag) {
        $TmpArr=explode(";",$SaleTag);
        $TagIds=$TagArr=array();
        foreach ($TmpArr as $Tag) {
            $Tag=trim($Tag);
            if (!$Tag) continue;
            $TagArr[ md5($Tag) ]=$Tag;
        }
        $TagIds=NS_TRACK_GENERAL::GetTagId($TagArr);
        foreach ($TagIds as $TagId) {
            $Query = "INSERT INTO ?_sale_tag_rel (COMPANY_ID,SALE_ID,TAG_ID) VALUES (?,?,?)";
            $Db->Query($Query,$CompanyId,$SaleId,$TagId);
        }
    }
}


///////////////////////////////////////////////////////
///

function BotLogRecord()
{
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    $StId=&$_NS_TRACK_VARS['StId'];
    $IpId=&$_NS_TRACK_VARS['IpId'];
    $AgentId=&$_NS_TRACK_VARS['AgentId'];
    $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
    $PqId=&$_NS_TRACK_VARS['PqId'];
    $RefSet=&$_NS_TRACK_VARS['RefSet'];
    $SSL=&$_NS_TRACK_VARS['SSL'];
    $Scheme=($SSL)?1:0;
    $Stamp=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());

    $Query = "INSERT INTO ?_{$CompanyId}_bot_log
        (SITE_ID,STAMP,UA_ID,PQ_ID,IP_ID,REFERER_SET,SCHEME) VALUES (?,?,?,?,?,?,?)";
    $Db->Query($Query,$StId,$Stamp,$AgentId,$PqId,$IpId,$RefSet,$Scheme);
}

function GetLogRecord()
{
	global $_COOKIE;

	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$IpId=&$_NS_TRACK_VARS['IpId'];
	$AgentId=&$_NS_TRACK_VARS['AgentId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$FindLastNode=&$_NS_TRACK_VARS['FindLastNode'];
    $SessionId=&$_NS_TRACK_VARS['SessionId'];

	$CookieLog=0;
	$CookieStr=(NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'log']))?$_COOKIE[NS_COOKIE_PFX.'log']:false;
	if ($CookieStr) {
		$CookieStr=@urldecode($CookieStr);
		$CookieStr=@stripslashes($CookieStr);
		$CookieArr=@unserialize($CookieStr);
		if (NS_TRACK_MISC::ValidArr($CookieArr)&&NS_TRACK_MISC::V($CookieArr[$StId])) $CookieLog=$CookieArr[$StId];
		if (NS_TRACK_MISC::ValidId($CookieLog) && $CookieLog > 0) $FindLastNode=false;
	}
	$Stamp=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	$Query ="INSERT INTO ?_{$CompanyId}_stat_log
        (VISITOR_ID, SITE_ID, STAMP, COOKIE_LOG, IP_ID, AGENT_ID) VALUES (?, ?, ?, ?, ?, ?)";
	$Db->Query($Query, $VisId, $StId, $Stamp, $CookieLog, $IpId, $AgentId);
	$LogId=$Db->LastInsertId;
    $SessionId=NS_TRACK_GENERAL::SetUserSession($LogId, $Stamp);
    NS_TRACK_GENERAL::UpdateSessionPath();
    return $LogId;
}

function SetUserSession($LogId, $Stamp)
{
    global $_NS_TRACK_VARS;
    $Settings=&$_NS_TRACK_VARS['Settings'];
    $Db=&$_NS_TRACK_VARS['Db'];
    $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
    $VisId=&$_NS_TRACK_VARS['VisId'];
    $StId=&$_NS_TRACK_VARS['StId'];
    $FirstSession=1;
    if ($Settings['All']->SESSION_BREAK_TIME==0) return 0;
    $Query = "
        SELECT SS.ID, ((UNIX_TIMESTAMP(?) - UNIX_TIMESTAMP(S_LOG.STAMP))/60) AS DIFF,
                    SS.VISIT_LENGTH, UNIX_TIMESTAMP(S_LOG.STAMP) AS STAMP,
                    S_LOG.ID AS LOG_ID
        FROM ?_{$CompanyId}_stat_log S_LOG
            INNER JOIN ?_{$CompanyId}_stat_session_log SESS_LOG
                ON SESS_LOG.LOG_ID=S_LOG.ID
            INNER JOIN ?_{$CompanyId}_stat_session SS
                ON SS.ID=SESS_LOG.SESSION_ID
        WHERE S_LOG.VISITOR_ID=? AND S_LOG.SITE_ID=?
        ORDER BY S_LOG.ID DESC LIMIT 1
    ";
    $Check=$Db->Select($Query,false,$Stamp,$VisId,$StId);
    $SessionId=0;
    $PrevLogId=isset($Check->LOG_ID)?$Check->LOG_ID:0;
    if (!$Check || $Check->DIFF>$Settings['All']->SESSION_BREAK_TIME) {
        $FirstSession=($Check)?0:1;
        $Query = "INSERT INTO ?_{$CompanyId}_stat_session
                        (START_LOG_ID,END_LOG_ID,VISITOR_ID,FIRST_SESSION,VISIT_DEPTH)
                        VALUES (?,?,?,?,?)";
        $Db->Query($Query,$LogId,$LogId,$VisId,$FirstSession,1);
        $SessionId=$Db->LastInsertId;
        $Query = "UPDATE ?_visitor SET SESSION_COUNT=SESSION_COUNT+1 WHERE ID=?";
        $Db->Query($Query,$VisId);
    }
    else {
        $Query = "UPDATE ?_{$CompanyId}_stat_session
                    SET END_LOG_ID=?, VISIT_LENGTH = VISIT_LENGTH+(UNIX_TIMESTAMP(?)-?), VISIT_DEPTH=VISIT_DEPTH+1
                    WHERE ID=?";
        $Db->Query($Query,$LogId,$Stamp,$Check->STAMP,$Check->ID);
        $SessionId=$Check->ID;
    }
    $Query = "INSERT INTO ?_{$CompanyId}_stat_session_log (SESSION_ID, LOG_ID, PREV_LOG_ID) VALUES (?,?,?)";
    $Db->Query($Query,$SessionId,$LogId,$PrevLogId);

    return $SessionId;
}

function UpdateSessionPath()
{
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    $SessionId=&$_NS_TRACK_VARS['SessionId'];
    $PqId=&$_NS_TRACK_VARS['PqId'];
    $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
    $Path='';
    if (!$SessionId || !$PqId) return 0;
    $Query = "SELECT ID,PATH FROM ?_{$CompanyId}_stat_session_path WHERE SESSION_ID=?";
    $Check=$Db->Select($Query,false,$SessionId);
    if (!$Check) {
        $Query = "INSERT INTO ?_{$CompanyId}_stat_session_path (SESSION_ID,PATH) VALUES (?,?)";
        $Db->Query($Query,$SessionId,$PqId);
        $Path=$PqId;
    }
    else {
        $Query = "UPDATE ?_{$CompanyId}_stat_session_path SET PATH=? WHERE SESSION_ID=?";
        $Path=$Check->PATH.($Check->PATH?',':'').$PqId;
        $Db->Query($Query,$Path,$SessionId);
    }
    $Query = "UPDATE ?_{$CompanyId}_stat_session SET VISIT_PATH=? WHERE ID=?";
    $Db->Query($Query,md5($Path),$SessionId);
}

//////////////////////////////////////////////////////
// MISC


function GetTagId($TagArr)
{
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    $QueryClass=&$_NS_TRACK_VARS['QueryClass'];
    $Ids=array();
    $Query = "SELECT ID, MD5_HASH FROM  ?_tag WHERE MD5_HASH IN (?)";
    $Sql = new $QueryClass($Query,false,array_keys($TagArr));
    while ($Row=$Sql->Row()) { $Ids[]=$Row->ID; unset($TagArr[$Row->MD5_HASH]); }
    if (!empty($TagArr)) foreach ($TagArr as $md5=>$Tag) {
        $Query = "INSERT INTO ?_tag (MD5_HASH,TAG) VALUES (?,?)";
        $Db->Query($Query,$md5,$Tag);
        $Ids[]=$Db->LastInsertId;
    }
    return $Ids;
}

function GetCurrentSite($StId=false,$StTextId=false)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$Site=false;
    if ($StId) $Site=$Db->Select("SELECT * FROM ?_site WHERE ID=?",false,$StId);
    if ($StTextId) $Site=$Db->Select("SELECT * FROM ?_site WHERE TEXT_ID=?",false,$StTextId);
    if (!$Site) return false;

	$_NS_TRACK_VARS['COOKIE_DOMAIN']=$Site->COOKIE_DOMAIN;
    $_NS_TRACK_VARS['StId']=$Site->ID;
	return $Site;
}

function GetSiteHosts($StId, $Site=false)
{
	$Where="";
	global $_NS_TRACK_VARS;
	$QueryClass=&$_NS_TRACK_VARS['QueryClass'];

	if ($Site&&NS_TRACK_MISC::ValidId($Site->ID)&&$Site->USE_HOSTS) $Where=" AND ENABLED = '1'";
	$Hosts=array();
	$Query = "SELECT * FROM ?_site_host WHERE SITE_ID=? $Where";
	$Sql = new $QueryClass($Query, false, $StId);
	while ($Row=$Sql->Row()) $Hosts[$Row->HOST]=$Row;
	return $Hosts;
}

function CurrentSiteHost($HostsArr=false, $PathArr=false, $Site=false)
{
	$HostId=0;
	if (!$PathArr) return 0;
	if (isset($HostsArr[NS_TRACK_MISC::ToLower($PathArr['host'])])) $HostId=$HostsArr[NS_TRACK_MISC::ToLower($PathArr['host'])]->ID;
	if (!$HostId&&$Site&&!$Site->USE_HOSTS) return NS_TRACK_GENERAL::AddNewSiteHost($Site->ID, $PathArr['host']);
	return (NS_TRACK_MISC::ValidId($HostId))?$HostId:0;
}

function AddNewSiteHost($SiteId, $Host)
{
	global $_NS_TRACK_VARS;
	$HostsArr=&$_NS_TRACK_VARS['HostsArr'];
	$Db=&$_NS_TRACK_VARS['Db'];

	$Host=NS_TRACK_MISC::ToLower(trim($Host));
	$Query = "INSERT INTO ?_site_host (SITE_ID, HOST, ENABLED) VALUES (?, ?, '1')";
	$Db->Query($Query, $SiteId, $Host);
	$NewId=$Db->LastInsertId;
	$Query = "SELECT * FROM ?_site_host WHERE ID = ?";
	$OHost=$Db->Select($Query, false, $NewId);
	$HostsArr[$Host]=$OHost;
	return $NewId;
}


function PreparePathAddr($Addr,$Type='')
{
    if (!strpos($Addr,"?")) $Addr=urldecode($Addr);
	$Arr=@parse_url($Addr);
	if (!isset($Arr['path'])) $Arr['path']="";
	$Arr['path']=ereg_replace("/+", "/", $Arr['path']);
	if ($Arr['path']=="") $Arr['path']="/";
	if (!NS_TRACK_MISC::ValidVar($Arr['host'])) return false;
	$Arr['host']=NS_TRACK_MISC::ToLower($Arr['host']);
    if (substr($Arr['host'], -1)=='.') $Arr['host'] = substr($Arr['host'], 0, -1);
    if ($Arr['host']=='pagead2.googlesyndication.com'&&$Type=='ref') {
        $QueryArr=NS_TRACK_QUERY::ParseTemplate($Arr['query']);
        global $_NS_TRACK_VARS;
        $Ref=&$_NS_TRACK_VARS['Ref'];
        $Ref=$QueryArr['url'];
        if (isset($QueryArr['url'])) return NS_TRACK_GENERAL::PreparePathAddr($QueryArr['url']);
    }
	if (!isset($Arr['query'])) $Arr['query']="";
	return $Arr;
}


function GlueUrl($parsed=false)
{
   if (!$parsed||!is_array($parsed)) return false;
       $uri = isset($parsed['scheme']) ? $parsed['scheme'].':'.((strtolower($parsed['scheme']) == 'mailto') ? '':'//'): '';
       $uri .= isset($parsed['user']) ? $parsed['user'].($parsed['pass']? ':'.$parsed['pass']:'').'@':'';
       $uri .= isset($parsed['host']) ? $parsed['host'] : '';
       $uri .= isset($parsed['port']) ? ':'.$parsed['port'] : '';
       $uri .= isset($parsed['path']) ? $parsed['path'] : '';
       $uri .= isset($parsed['query']) ? '?'.$parsed['query'] : '';
       $uri .= isset($parsed['fragment']) ? '#'.$parsed['fragment'] : '';
   return $uri;
}

function ValidHost($Host)
{
	$Arr1=array();
	$Arr2=array();
	$From="~!@#$%^&*()_+|`=\\{}[]:\";',/<>?";
	$To="                                 ";
	$Arr1=explode(".", $Host);
	for($i=0;$i<count($Arr1);$i++) {
		$Arr1[$i]=strtr($Arr1[$i], $From, $To);
		$Arr1[$i]=preg_replace("/\s+/", " ", $Arr1[$i]);
		if ($Arr1[$i]=="") continue;
		$Arr2[]=$Arr1[$i];
	}
	if (count($Arr2)<2) return false;
	$Host=implode(".",$Arr2);
	return $Host;
}


function SetCookieLog($StartNewNode=true, $SetLogId=false)
{
	global $nsUser, $_COOKIE;
	global $_NS_TRACK_VARS;

	$Db=&$_NS_TRACK_VARS['Db'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$FindLastNode=&$_NS_TRACK_VARS['FindLastNode'];
	$CookieStr=(NS_TRACK_MISC::ValidVar($_COOKIE[NS_COOKIE_PFX.'log']))?$_COOKIE[NS_COOKIE_PFX.'log']:false;
	if ($CookieStr) {
		$CookieStr=@urldecode($CookieStr);
		$CookieStr=@stripslashes($CookieStr);
		$CookieArr=@unserialize($CookieStr);
		if (!NS_TRACK_MISC::ValidArr($CookieArr)) $CookieArr=array();
	}
	else $CookieArr=array();
	$CookieArr[$StId]=$SetLogId?$SetLogId:$LogId;
	$CookieStr=serialize($CookieArr);

	$Domain=false;
	if (defined("COOKIE_DOMAIN")) $Domain=COOKIE_DOMAIN;
	if (isset($_NS_TRACK_VARS['COOKIE_DOMAIN'])) $Domain=$_NS_TRACK_VARS['COOKIE_DOMAIN'];

	NS_TRACK_GENERAL::TrackingCookie(NS_COOKIE_PFX."log", $CookieStr, time()+60*60*24*10*365, "/", $Domain);
	$FindLastNode=false;

	if (!$StartNewNode && $SetLogId) {
		$Query = "UPDATE ?_{$CompanyId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
		$Db->Query($Query, $SetLogId, $LogId);
	}

	if (!$StartNewNode) return;
	$Db->Query("UPDATE ?_{$CompanyId}_stat_log SET COOKIE_LOG=? WHERE ID=?", $LogId, $LogId);
}

function FlushImg()
{
    if (NS_TRACKER_DELAYED) return;
	if (defined("NO_TRACK_IMG")&&NO_TRACK_IMG) return;
	$Img="R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==";
	Header("Content-type: image/gif");
	echo base64_decode($Img);
	exit();
}

function FinishTracking($Reason=false)
{
	global $_NS_TRACK_VARS;
    if ($Reason&&!NS_TRACKER_DELAYED) Header("X-ST-Exit: $Reason");
    if ($Reason&&NS_TRACKER_DELAYED&&defined("NO_CRON_COMMENTS")&&!NO_CRON_COMMENTS)
        echo "$Reason\n\n";
	if (!defined("NS_PHP_TRACKING")) {
		if (isset($_NS_TRACK_VARS['ExitFunc'])) {
			$ExitFunc=$_NS_TRACK_VARS['ExitFunc'];
			return $ExitFunc();
		}
		else return NS_TRACK_GENERAL::FlushImg();
	}
	return false;
}

function TrackingCookie($Name=false, $Value=false, $Expire=false, $Path=false, $Domain=false, $Secure=false)
{
    if (NS_TRACKER_DELAYED) {
        NS_TRACK_DELAYED::WriteDelayedCookie($Name, $Value, $Expire, $Path, $Domain, $Secure);
    }
	elseif (defined("NS_PHP_TRACKING")) {
		setcookie($Name, $Value, $Expire, $Path, $Domain, $Secure);
	}
	else {
		global $nsUser;
		$nsUser->SetCookie($Name, $Value, $Expire, $Path, $Domain, $Secure);
	}
	global $_COOKIE;
	$_COOKIE[$Name]=$Value;
}







function CheckPathDblClick($Time=false)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$PageId=&$_NS_TRACK_VARS['PageId'];
	$RefSet=&$_NS_TRACK_VARS['RefSet'];
	$QueryId=&$_NS_TRACK_VARS['QueryId'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
    if ($Time) $TimeDblPageLoad=$Time;
	else $TimeDblPageLoad=&$_NS_TRACK_VARS['TimeDblPageLoad'];

    $GmTime=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	//$GmTime = gmdate("Y-m-d H:i:s");
	$TimeLimit=(NS_TRACK_MISC::ValidVar($TimeDblPageLoad))?$TimeDblPageLoad:1;
	$Query="
		SELECT
			S_LOG.ID
		FROM ?_{$CompanyId}_stat_log S_LOG
		WHERE S_LOG.VISITOR_ID=?
		AND S_LOG.PAGE_ID=?
		AND S_LOG.QUERY_ID=?
		AND S_LOG.REFERER_SET=?
		AND S_LOG.SITE_ID=?
			AND ((UNIX_TIMESTAMP('$GmTime') - UNIX_TIMESTAMP(S_LOG.STAMP)) < '$TimeLimit')
		ORDER BY S_LOG.STAMP DESC
		LIMIT 1
	";
	$CheckId=$Db->ReturnValue($Query, $VisId, $PageId, $QueryId, $RefSet, $StId);
	if ($CheckId) $Skip=true;
}

function CheckAdvDblClick()
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$ClickSubId=&$_NS_TRACK_VARS['ClickSubId'];
	$KeyId=&$_NS_TRACK_VARS['KeyId'];
	$SourceId=&$_NS_TRACK_VARS['SourceId'];

	if (!$ClickSubId) return;
	$TimeDblAdvClick=&$_NS_TRACK_VARS['TimeDblAdvClick'];
    $GmTime=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	//$GmTime = gmdate("Y-m-d H:i:s");

	$TimeLimit=@$TimeDblAdvClick?$TimeDblAdvClick:5;
	$Query="
		SELECT
			S_LOG.ID
		FROM  ?_{$CompanyId}_stat_log S_LOG
			INNER JOIN ?_{$CompanyId}_stat_click S_CLICK
				ON S_CLICK.LOG_ID=S_LOG.ID
		WHERE S_LOG.VISITOR_ID=?
		AND S_LOG.SITE_ID=?
		AND S_CLICK.KEYWORD_ID=?
		AND S_CLICK.CAMP_ID=?
		AND S_CLICK.SOURCE_HOST_ID=?
			AND ((UNIX_TIMESTAMP('$GmTime') - UNIX_TIMESTAMP(S_LOG.STAMP)) < '$TimeLimit')
		ORDER BY S_LOG.STAMP DESC
		LIMIT 1
	";
	$CheckId=$Db->ReturnValue($Query, $VisId, $StId, $KeyId, $ClickSubId, $SourceId);

	if ($CheckId) $Skip=true;
}


function CheckDblSale($StId, $CustomId)
{
	if (!$CustomId) return false;

	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];

	$Query = "SELECT ID FROM ?_{$CompanyId}_stat_sale WHERE SITE_ID=? AND CUSTOM_ORDER_ID=?";
	$CheckId=$Db->ReturnValue($Query, $StId, $CustomId);
	return ($CheckId)?true:false;
}

function CheckSaleDblClick()
{


	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$TimeDblSale=&$_NS_TRACK_VARS['TimeDblSale'];
    $GmTime=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	//$GmTime = gmdate("Y-m-d H:i:s");
	$TimeLimit=(NS_TRACK_MISC::ValidVar($TimeDblSale))?$TimeDblSale:5;
	$Query = "
		SELECT
			S_LOG.ID
		FROM ?_{$CompanyId}_stat_log S_LOG
		INNER JOIN ?_{$CompanyId}_stat_sale S_SALE
			ON S_SALE.LOG_ID=S_LOG.ID
		WHERE S_LOG.VISITOR_ID=?
		AND S_LOG.SITE_ID=?
			AND ((UNIX_TIMESTAMP('$GmTime') - UNIX_TIMESTAMP(S_LOG.STAMP)) < '$TimeLimit')
		ORDER BY S_LOG.STAMP DESC
		LIMIT 1
	";
	$CheckId=$Db->ReturnValue($Query, $VisId, $StId);
	if ($CheckId) $Skip=true;
}


function CheckActionDblClick($ActionId)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$TimeDblEvent=&$_NS_TRACK_VARS['TimeDblEvent'];
    $GmTime=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	//$GmTime = gmdate("Y-m-d H:i:s");
	$TimeLimit=(NS_TRACK_MISC::ValidVar($TimeDblEvent))?$TimeDblEvent:5;
	$Query = "
		SELECT
			S_LOG.ID
		FROM ?_{$CompanyId}_stat_log S_LOG
		INNER JOIN ?_{$CompanyId}_stat_action S_ACTION
			ON S_ACTION.LOG_ID=S_LOG.ID
		WHERE S_LOG.VISITOR_ID=?
		AND S_LOG.SITE_ID=?
		AND S_ACTION.ACTION_ID=?
			AND ((UNIX_TIMESTAMP('$GmTime') - UNIX_TIMESTAMP(S_LOG.STAMP)) < '$TimeLimit')
		ORDER BY S_LOG.STAMP DESC
		LIMIT 1
	";
	$CheckId=$Db->ReturnValue($Query, $VisId, $StId, $ActionId);
	if ($CheckId) $Skip=true;
}

function CheckClickFraud(&$Settings, $VisId=false, $SubId=false)
{

	if (!$SubId||!$VisId) return 0;
	if (!$Settings['All']->FRAUD_ENABLE) return 0;
	if ($Settings['All']->FRAUD_COUNT<1) return 0;
	if ($Settings['All']->FRAUD_PERIOD <1) return 0;

	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];

	$Stamp=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	$Query = "
		SELECT COUNT(S_LOG.ID)
		FROM ?_{$CompanyId}_stat_log S_LOG
		INNER JOIN ?_{$CompanyId}_stat_click S_CLICK
			ON S_CLICK.LOG_ID=S_LOG.ID

		WHERE S_LOG.VISITOR_ID=?
				AND S_CLICK.CAMP_ID=?
				AND S_LOG.STAMP >= DATE_ADD('$Stamp', INTERVAL -{$Settings['All']->FRAUD_PERIOD} MINUTE)
	";
	$Count=$Db->ReturnValue($Query, $VisId, $SubId);
	if (!$Count) return 0;
	if ($Count>=$Settings['All']->FRAUD_COUNT) return 1;
}


function CheckTrackingMode()
{
	global $_NS_TRACK_VARS, $_COOKIE;
	$Db=&$_NS_TRACK_VARS['Db'];
	$Settings=&$_NS_TRACK_VARS['Settings'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$VisId=&$_NS_TRACK_VARS['VisId'];
	$ClickSubId=&$_NS_TRACK_VARS['ClickSubId'];
	$TM=$Settings['All']->TRACKING_MODE;
	if (!$TM) return false;
	$Mode="";
	$PaidPoint="";
	$NaturalPoint="";
	$NonePoint="";


	$PriorArr=explode("|", $TM);
	$Mode=NS_TRACK_MISC::ValidVar($PriorArr[0], "NONE");
	if (NS_TRACK_MISC::ValidVar($PriorArr[1])) {
		$EntryArr=explode(";", $PriorArr[1]);
		for($i=0;$i<count($EntryArr);$i++) {
			$TmpArr=explode(":", $EntryArr[$i]);
			if (NS_TRACK_MISC::ValidVar($TmpArr[0])=="NONE") $NonePoint=NS_TRACK_MISC::ValidVar($TmpArr[1], "LAST");
			if (NS_TRACK_MISC::ValidVar($TmpArr[0])=="PAID") $PaidPoint=NS_TRACK_MISC::ValidVar($TmpArr[1], "LAST");
			if (NS_TRACK_MISC::ValidVar($TmpArr[0])=="NATURAL") $NaturalPoint=NS_TRACK_MISC::ValidVar($TmpArr[1], "LAST");
		}
	}

	// FIRST -    
	// LAST -   

	$RequestedMode=($ClickSubId)?"PAID":"NATURAL";

	// return true -    
	// return false - 
	if ($Mode=="NONE" && $NonePoint=="LAST") return false;

	//          
	if ($Mode=="PAID" && $PaidPoint=="LAST" && $ClickSubId) return false;
	if ($Mode=="NATURAL" && $NaturalPoint=="LAST" && !$ClickSubId) return false;

	//          
	if ($Mode=="NONE" && $NonePoint=="FIRST") {
		$NodeId=NS_TRACK_GENERAL::FindSomeNode("ANY", "FIRST");
		//   ,      ,    
		if ($NodeId) return NS_TRACK_GENERAL::UpdateCookieLog($NodeId);
		//   ,       
		return false;
	}



	//      
	//     PAID    NATURAL
	//   ,       PAID
	//   ,     
	//  ,        
	$NodeId=NS_TRACK_GENERAL::FindSomeNode($Mode, (($Mode=="PAID")?$NaturalPoint:$PaidPoint));
	if ($NodeId) return NS_TRACK_GENERAL::UpdateCookieLog($NodeId);

	if ($Mode==$RequestedMode) return false;

	//    ,  ,      
	//    -   ,    .
	$NodeId=NS_TRACK_GENERAL::FindSomeNode( (($Mode=="PAID")?"NATURAL":"PAID") , (($Mode=="PAID")?$NaturalPoint:$PaidPoint) );
	if ($NodeId) return NS_TRACK_GENERAL::UpdateCookieLog($NodeId);
	return false;
}


function FindSomeNode($Mode="ANY", $Order="LAST")
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$VisId=&$_NS_TRACK_VARS['VisId'];

	$JoinStr="";
	$JoinArr=array();
	$WhereStr="";
	$WhereArr=array();

	if ($Mode=="PAID") {
		$JoinArr[]="INNER JOIN ?_{$CompanyId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID";
	}
	if ($Mode=="NATURAL") $WhereArr[]="S_LOG.REFERER_SET>0";
	if ($Mode=="ANY") {
		$JoinArr[]="LEFT JOIN ?_{$CompanyId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID";
		$WhereArr[]=" (S_LOG.REFERER_SET>0  OR S_CLICK.ID > 0) ";
	}

	if (count($JoinArr)) $JoinStr=implode("\n", $JoinArr);
	$WhereArr[]="S_LOG.ID=S_LOG.COOKIE_LOG";
	$WhereArr[]="S_LOG.VISITOR_ID=$VisId";
	$WhereArr[]="S_LOG.SITE_ID=$StId";

	if (count($WhereArr)) $WhereStr="WHERE ".implode(" AND ", $WhereArr);

	$Order=($Order=="LAST")?"DESC":"ASC";

	$Query = "
		SELECT S_LOG.ID
			FROM ?_{$CompanyId}_stat_log S_LOG
			$JoinStr
			$WhereStr
			ORDER BY S_LOG.STAMP $Order
			LIMIT 1
	";
	return $Db->ReturnValue($Query);
}

function UpdateCookieLog($LogId)
{
	NS_TRACK_GENERAL::SetCookieLog(false, $LogId);
	return $LogId;
}

function CheckStopTracking()
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];
	$Query = "SELECT ID FROM ?_config WHERE STOP_TRACKING='1' AND (COMPANY_ID=0 OR COMPANY_ID=?)";
	return $Db->ReturnValue($Query, $CompanyId);
}

function TmpCurrentPath($Current)
{
    $TmpCurrent=$Current;
    $TmpCurrent=str_replace("://","",$TmpCurrent);
    $TmpArr=explode("/",$TmpCurrent);
    if (count($TmpArr)==2 && substr($TmpCurrent,-1)=='/') $TmpCurrent=substr($Current,0,-1);
    else $TmpCurrent=  $Current;
    return $TmpCurrent;
}

}

?>