<?

class NS_TRACK_PAGE {

function GetPageId($PathArr=false, $StId=false)
{
	if (!$PathArr||!$StId) return 0;
	
	global $_NS_TRACK_VARS;
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$Db=&$_NS_TRACK_VARS['Db'];
	$Site=&$_NS_TRACK_VARS['Site'];
	$HostsArr=&$_NS_TRACK_VARS['HostsArr'];
	$SSL=&$_NS_TRACK_VARS['SSL'];
        
	if (!isset($HostsArr[NS_TRACK_MISC::ToLower($PathArr['host'])])) {
		$Skip=true;
		return 0;
	}

	if (NS_TRACK_MISC::ValidVar($PathArr['scheme'])=="https") $SSL=true;
	$Path=$PathArr['path'];
	$Path=trim($Path);
	$Query = "SELECT ID, IGNORE_PAGE FROM ?_site_page WHERE PATH = ? AND SITE_ID=?";
	$Check=$Db->Select($Query, false, $Path, $StId);
	if (isset($Check->IGNORE_PAGE) && $Check->IGNORE_PAGE) {
		$Skip=true;
		return 0;
	}
	if (NS_TRACK_MISC::ValidId($Check->ID)) return $Check->ID;

	$Query = "INSERT INTO ?_site_page (SITE_ID, PATH) VALUES (?,?)";
	$Db->Query($Query, $StId,$Path);
	return $Db->LastInsertId;
}

function SetPage2QueryRelation()
{
    global $_NS_TRACK_VARS;
    $StId=&$_NS_TRACK_VARS['StId'];
    $SiteHostId=&$_NS_TRACK_VARS['SiteHostId'];
    $QueryId=&$_NS_TRACK_VARS['QueryId'];
    $PageId=&$_NS_TRACK_VARS['PageId'];
    $PageTitle=&$_NS_TRACK_VARS['PageTitle'];
    $PageCharset=&$_NS_TRACK_VARS['PageCharset'];
    $TitleUpdate=&$_NS_TRACK_VARS['TitleUpdate'];
    $Db=&$_NS_TRACK_VARS['Db'];
    $QueryClass=&$_NS_TRACK_VARS['QueryClass'];    
    $Current=&$_NS_TRACK_VARS['Current'];    

    if ($TitleUpdate) {
        $PageTitle=NS_TRACK_PAGE::PreparePageTitle($PageTitle, $PageCharset);
        $TitleId=NS_TRACK_PAGE::GetTitleId($PageTitle);
    }
    else $TitleId=0;
    if (!$QueryId) $QueryId=0;
    $Query = "SELECT ID, GRP_ID FROM ?_page_query WHERE SITE_HOST_ID=? AND PAGE_ID=? AND QUERY_ID=?";
    $Check=$Db->Select($Query, false, $SiteHostId, $PageId, $QueryId);
    if (!$Check) {
        $Query = "INSERT INTO ?_page_query (SITE_ID,SITE_HOST_ID,PAGE_ID,QUERY_ID,TITLE_ID) VALUES (?,?,?,?,?)";
        $Db->Query($Query,$StId,$SiteHostId,$PageId,$QueryId,$TitleId);
        $CheckId=$Db->LastInsertId;
        $GrpId=0;
    }
    else {
        $CheckId=$Check->ID;
        $GrpId=$Check->GRP_ID;
    }

    if (!$GrpId) {
        $Query = "SELECT ID FROM ?_site_page_grp WHERE ? REGEXP REG_EXP LIMIT 1";
        $Check=$Db->Select($Query,"OBJ",$Current);
        if ($Check) {
            $GrpId=$Check->ID;
            $Query="UPDATE ?_page_query SET GRP_ID=? WHERE ID=?";
            $Db->Query($Query,$GrpId,$CheckId);
        }
    }
    
    if ($TitleUpdate) $Db->Query("UPDATE ?_page_query SET TITLE_ID=? WHERE ID=?",$TitleId,$CheckId);
    
    return $CheckId;
}

function PreparePageTitle($PageTitle=false, $PageCharset=false)
{
    if (!$PageTitle) return '';
    global $_NS_TRACK_VARS;
    $CurrentCharset=&$_NS_TRACK_VARS['CurrentCharset'];
    if (!isset($CurrentCharset['charset'])) return $PageTitle;
    $Convert=new nsConvertCharset();
    $NewPageTitle=$Convert->Convert($PageTitle, $PageCharset, $CurrentCharset['charset']);
    return ($NewPageTitle)?$NewPageTitle:$PageTitle;
}

function GetTitleId($PageTitle=false)
{
    if (!$PageTitle) return 0;
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    
    $Query = "SELECT ID FROM ?_page_title WHERE MD5_SEARCH=MD5(?)";
    $CheckId=$Db->ReturnValue($Query, $PageTitle);
    if (NS_TRACK_MISC::ValidId($CheckId)) return $CheckId;
    $Query ="INSERT INTO ?_page_title (TITLE, MD5_SEARCH) VALUES (?, MD5(?))";
    $Db->Query($Query, $PageTitle, $PageTitle);
    return $Db->LastInsertId;
}


}


?>