<?

class NS_TRACK_SALE {

function GetSaleItem($ItemName=false, $CompanyId=false)
{
	if (!$ItemName||!$CompanyId) return 0;
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];

	$Query = "SELECT ID FROM ?_sale_item WHERE NAME=? AND COMPANY_ID=?";
	$CheckId=$Db->ReturnValue($Query, $ItemName, $CompanyId);
	if (NS_TRACK_MISC::ValidId($CheckId)) return $CheckId;
	$Query ="INSERT INTO ?_sale_item (COMPANY_ID, NAME) VALUES (?, ?)";
	$Db->Query($Query, $CompanyId, $ItemName);
	return $Db->LastInsertId;
}


 
function PrepareSaleItems($Arr)
{
	$Items=array();
	$TmpArr=array();
	for($i=0;$i<count($Arr);$i++) {
		$Str=$Arr[$i];
		preg_match_all("/{{([^}}]*)}}/", $Str, $TmpArr);
		$TmpArr=$TmpArr[1];
		$Items[]=$TmpArr;
	}
	return $Items;
}

function PrepareCost($Cost=false)
{
    if (!$Cost) return false;
    $Cost=str_replace(",",".",$Cost);
    $Cost=str_replace("..", ".",$Cost);
    $Cost=preg_replace("/[^\d\.]/i", "",  $Cost);
    return $Cost;
}

}


?>