<?function CacheCheck($Params) {
    extract($Params);
    $CacheId = V($CacheId,0);
    $CacheAjax = V($CacheAjax,0);
    $AdditionalHash = V($AdditionalHash,'');
    $EnableChecking = V($EnableChecking,false);
    $Additional = V($Additional,false);
    $ReportId = V($ReportId,0);
    $FunnelId = V($FunnelId,0);
    $CustomReportId = V($CustomReportId,0);
    $CacheObj = V($CacheObj,false);
 
    global $nsLang, $CpId, $Lang, $nsUser, $Settings;
    $nsLang->IncFile("inc/cache.php")
    ?>

<script>
var cacheParams = {
    greenLight:true, 
    runByAjax:<?=(($CacheAjax==2)?"true":"false")?>,
    cacheId:'<?=@$CacheId?>', 
    cpId:'<?=@$CpId?>',
    addHash:'<?=@$AdditionalHash?>', 
    addStr:'<?=@$Additional?>',
    updateCacheMode:'<?=@$CacheAjax?>', 
    userId:'<?=$nsUser->UserId()?>',
    cronOnly:'<?=@$CacheObj->CronOnly?>',
    reportId:'<?=@$ReportId?>', 
    funnelId:'<?=@$FunnelId?>', 
    customReportId:'<?=@$CustomReportId?>',
    cacheURL:'<?=getURL("cache", "CpId=$CpId", "cron")?>',
    cacheUpdateCookieName:'<?=COOKIE_PFX?>cache_check'
}
</script>
<script src="<?=FileLink("js/cache_check.js")?>"></script>
<?if ($CacheAjax==1&&$EnableChecking) {?>
<script>if (!cacheParams.runByAjax) var intv =  window.setInterval(checkCache, 5000);</script>
<?}?>

<div id="PrepareFailed" style="display:none;" class="MsgBlock MsgErr WSignal">
    <p><?=$Lang['PrepareFailed']?></p></div>
<div id="CacheCheckDiv" style="<?=(($EnableChecking)?"":"display:none")?>;">
<div class=SpacerMedium></div>
<div class="MsgBlock MsgMsg" style="text-align:center;">

<span align=center id="WaitCron" style="<?=($CacheAjax==1)?"":"display:none;"?>">
<?=$Lang['WaitaMinute']?><br><img src="<?=FileLink("images/prepare.gif")?>" width=32 height=32 border=0>
</span>
<span align=center id="WaitAjax" style="<?=($CacheAjax==2)?"":"display:none;"?>">
<?=$Lang['WaitaMinuteAjax']?><br><img src="<?=FileLink("images/prepare.gif")?>" width=32 height=32 border=0>
</span>

<div id="WhatToDoForm" style="text-align:center;<?=($CacheAjax==0)?"":"display:none;"?>">
    <?if (@$CacheObj->CronOnly) {?>
        <input id="RunNow" type=button value="<?=$Lang['RunNow']?>" onclick="runPrepare(1)">
    <?}?>
    <table width=50% cellpadding=0 cellspacing=0 border=0 align=center style="<?=@$CacheObj->CronOnly?'display:none;':''?>">
    <tr><td style="padding:2px;"><b><?=$Lang['WhatToDo']?></b></td></tr>
    <tr><td style="padding:2px;">
    <?if (@$CacheObj->CronOnly) {?>
    <select id="WhatToDo" disabled><option value=1><?=$Lang['WaitForCron']?></option></select>
    <?} else {?>
    <select id="WhatToDo">
    <?if (@$Settings['All']->CRON_ENABLE) {?>
    <option value=1 <?=V($_COOKIE[COOKIE_PFX.'cache_check'])==1?"selected":""?>>
    <?=$Lang['WaitForCron']?></option><?}?>
    <option value=2 <?=V($_COOKIE[COOKIE_PFX.'cache_check'])==2?"selected":""?>><?=$Lang['RunAjax']?></option>
    </select>
    <?}?>
    </td></tr>
    <tr><td style="padding:2px;">
        <table cellpadding=0 cellspacing=0 border=0><tr>
        <td style="padding:0px;"><input type=checkbox id="DontAsk"></td>
        <td width=100% style="padding:0px;padding-left:5px;"><label for="DontAsk"><?=$Lang['DontAsk']?></label></td>
        </tr></table>
    </td></tr>
    <tr><td style="padding:2px;">
    <input type=button value="<?=$Lang['Go']?>" onclick="runPrepare()">
    </td></tr>    
    </table>
    
</div>
</div>
<div id=SpacerLarge style='background:#fff;'></div>
</div>


<?if ($EnableChecking||$CacheAjax==1) {?>
<script>
if (cacheParams.runByAjax)  runCache('<?=getURL("cache", "DoCacheId=".$CacheId."&CpId=".$CpId, "cron")?>');
</script>
<?}?>

<?}?>