<?$PageTitle=$Lang['Title']?>
<?include $nsTemplate->Inc("inc/header");?>
<?include $nsTemplate->Inc("inc/submenu");?>

<script>

function CopyText(ObjID)
{
    if (document.body.createTextRange) {
        var BodyRange = document.body.createTextRange(); 
        BodyRange.moveToElementText(_(ObjID)); 
        BodyRange.execCommand('Copy');  
    } else alert('Your browser does not support such feature.');
    return false;
}

</script>

<div style="padding:20px;">

General information
<textarea id="GeneralInfo" style="width:100%;" rows=20>
Php version: <?=$PhpVersion?> 
Mysql version: <?=$MyVersion?> 
Tracker version: <?=$TrackerVersion?> 
Tracker license: <?=$TrackerLicense?> 
<?if ($nsProduct->LICENSE==3) {?>
Number of clients: <?=count($Clients)?> 
<?}?>
Number of sites: <?=count($Sites)?> 
Number of users: <?=$NumberOfUsers?> 
Number of admins: <?=$NumberOfAdmins?> 

============================
    Main
============================

Tracking enabled: <?=$Config[0][0]->STOP_TRACKING?"No":"Yes"?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".($Config[$Cp][0]->STOP_TRACKING?"No":"Yes")."\r\n";
}}?>
SSL-protected URL of the tracker: <?=$Config[0][0]->SSL_LINK?$Config[0][0]->SSL_LINK:"None"?> 
Tracking mode: <?=$PriorStr?> 

Use IP tracking: <?=$Config[0][0]->IP_TRACKING?"Yes":"No"?>  
Track by IP only if cookies are disabled: <?=$Config[0][0]->IP_NO_COOKIE?"Yes":"No"?>  
Number of days since the last visit with the same IP: <?=$Config[0][0]->IP_PERIOD?> 

Enable click fraud detection: <?=$Config[0][0]->FRAUD_ENABLE?"Yes":"No"?>  
Number of clicks from the same visitor to consider them fraudulent: <?=$Config[0][0]->FRAUD_COUNT?> 
Number of minutes in which the number of clicks specified above should be performed by the same visitor: <?=$Config[0][0]->FRAUD_PERIOD?> 

Numerical campaign parameter name: <?=$Config[0][0]->VAR_CAMPAIGN?$Config[0][0]->VAR_CAMPAIGN:'c'?> 
Text-based campaign parameter name: <?=$Config[0][0]->VAR_CAMPAIGN_SOURCE?$Config[0][0]->VAR_CAMPAIGN_SOURCE:'disabled'?> 
Text-based keyword parameter name: <?=$Config[0][0]->VAR_KW?$Config[0][0]->VAR_KW:'kw'?> 
Numerical keyword parameter name: <?=$Config[0][0]->VAR_KEYWORD?$Config[0][0]->VAR_KEYWORD:'k'?> 

Product default language: <?=$nsProduct->DEFAULT_LANG?> 
Product default charset: <?=$DefLangCharset?> 
Product default skin: <?=$nsProduct->DEFAULT_SKIN?>   

Automatically detect the main charset of a search engine: <?=$Config[0][0]->CATCH_CHARSET?"Yes":"No"?>  
Only log sales for previously tracked visitors: <?=$Config[0][0]->SALE_ONLY_EXISTING?"Yes":"No"?> 

Date format: <?=$Config[0][0]->FORMAT_DATE?> 
Time format: <?=$Config[0][0]->FORMAT_TIME?> 

Number of rows to display in reports: <?=$Config[0][0]->CACHE_ROWS_CNT?> 
Idle time (in minutes) after which a new session starts: <?=$Config[0][0]->SESSION_BREAK_TIME?> 
Maximum number of seconds since the last activity to consider the visitor to be online: <?=$Config[0][0]->ONLINE_PERIOD?>

Use fallback file based storage for redirect URLs: <?=$Config[0][0]->USE_STORE?"Yes":"No"?>

P3P compact privacy policy: <?=$P3PStr?> 
P3P compact privacy policy location: <?=$P3PRef?> 

============================
    Debugging information
============================

Browsers imported: <?=$BrowserGroups?'Yes':'No'?> 
User agents imported: <?=$AgentGroups?'Yes':'No'?> 
Countries imported: <?=$Countries?'Yes':'No'?> 
Ignored IPs: <?if (!empty($IpIgnore)) {
        foreach ($IpIgnore as $i=>$Row) {
            if ($i>0) echo ", ";
            echo $Row->TEMPLATE;
        } 
} else echo 'None'; ?> 
Ignored referrer groups: <?if (!empty($IgnoredRefGroups)) {
        foreach ($IgnoredRefGroups as $i=>$Row) {
            if ($i>0) echo ", ";
            echo $Row->NAME;
        } 
} else echo 'None'; ?> 
Ignored referrer hosts: <?if (!empty($IgnoredRefHosts)) {
        foreach ($IgnoredRefHosts as $i=>$Row) {
            if ($i>0) echo ", ";
            echo $Row->HOST;
        } 
} else echo 'None'; ?> 
Ignored user agent groups: <?if (!empty($IgnoredAgentGroups)) {
        foreach ($IgnoredAgentGroups as $i=>$Row) {
            if ($i>0) echo ", ";
            echo $Row->NAME;
        } 
} else echo 'None'; ?> 
Ignored user agents: <?if (!empty($IgnoredAgents)) {
        foreach ($IgnoredAgents as $i=>$Row) {
            if ($i>0) echo ", ";
            echo $Row->USER_AGENT;
        } 
} else echo 'None'; ?> 
'Store' folder is writable: <?=$StoreIsWritable?'Yes':'No'?> 
'Install folder is deleted: <?=$InstallDeleted?'Yes':'No'?> 
'conf.vars.php' is writable: <?=$ConfIsWritable?'Yes':'No'?> 
Cron script last launched: <?=$CronLastLaunched?> (in GMT)

============================
    Companies
============================

<?foreach ($Clients as $Cp=>$Row) {?>
<?=$Row->NAME?>: 
|-- Hide from the companies list: <?=$Row->HIDDEN?'Yes':'No'?> 
|-- Currency symbol: <?=$Row->CURRENCY?> 
|-- Max number of sites: <?=$Row->MAX_SITES>0?$Row->MAX_SITES:'Unlimited'?> 
|-- Allow PHP tracking code: <?=$Row->ALLOW_PHP_TRACKING||$nsProduct->LICENSE!=3?'Yes':'No'?> 
|-- Disable caching: <?=$Config[$Cp][0]->CACHE_DYNAMIC_ENABLE?'No':'Yes'?> 
|-- Disable reports constructor: <?=$Row->DISABLE_CONSTRUCTOR?'Yes':'No'?> 
|-- Timezone for cached reports: <?=$Config[$Cp][0]->TIMEZONE?> 
<?echo "\r\n"; }?>
============================
    Sites
============================

<?foreach ($Sites as $Cp=>$Arr)  foreach ($Arr as $SiteId=>$Row) {?>
<?=$Row->HOST?>: 
|-- Gather statistics only for the selected domains: <?=$Row->USE_HOSTS?'Yes':'No'?>  
<?if ($Row->USE_HOSTS&&isset($SiteHosts[$SiteId])) {?>
|-- (<?foreach ($SiteHosts[$SiteId] as $i=>$HostRow) { if ($i>0) echo ", "; if ($HostRow->ENABLED) echo $HostRow->HOST;}?>) 
<?}?>
|-- Cookie domain: <?=$Row->COOKIE_DOMAIN?> 
|-- Text id: <?=$Row->TEXT_ID?>  
|-- All hosts: <?if (!empty($SiteHosts[$SiteId])) {
    foreach ($SiteHosts[$SiteId] as $i=>$HostRow) {
        if ($i>0) echo ", ";
        echo $HostRow->HOST;
    }
} else echo "No hosts\r\n";?> 
<?echo "\r\n"; }?>
============================
    Current user information
============================

Login: <?=$nsUser->UserInfo['LOGIN']?> 
Interface language: <?=$nsUser->ULANG?> 
Language charset: <?=$LangConfig['charset']?> 
Skin: <?=$nsUser->USKIN?> 
Ignore this user when tracking statistics: <?=V($_COOKIE['ns_skip'])?'Yes':'No'?> 
Always open filters in the reports: <?=$nsUser->ADVANCED_MODE?'Yes':'No'?> 
Timezone: <?=$nsUser->TZ?> 
Default traffic mode in constructor: <?=$TrafficModes[$nsUser->TRAFFIC_MODE]?> 
Page encoding: <?=$nsUser->ENC?> 
Show graphs: <?=$nsUser->GRAPH_PLACE==0?'Below statistics':'Above statistics'?> 
Disable 'smart cache': <?=$nsUser->DISABLE_SMART?'Yes':'No'?> 
Default action the updating report from cache: <?=$CacheUpdateActions[$nsUser->CACHE_UPDATE_MODE]?> 
Show these columns in reports: <?if (!empty($nsUser->Columns)) {
    foreach ($UserColumns as $i=>$Col) {
        if (!$nsUser->Columns->$Col) continue;
        if ($i>0) echo ", "; 
        echo $Col;
    } 
} else echo "No columns are showed";?>  

============================
    Cron processes
============================

Cron is enabled: <?=$Config[0][0]->CRON_ENABLE?'Yes':'No'?> 
Maximum CPU load: <?=$Config[0][0]->CRON_MAX_CPU?> 
Full path to GetLoadAvg.exe: <?=$Config[0][0]->CPU_AVG_PATH?> 

Caching is enabled: <?=$Config[0][0]->CACHE_DYNAMIC_ENABLE?'Yes':'No'?> 
Popular reports: <?=$Config[0][0]->CACHE_POPULAR_CNT?>-<?=$Config[0][0]->CACHE_POPULAR_PERIOD?> 
Smart caching is enabled:  <?=$Config[0][0]->CACHE_SMART_ENABLE?'Yes':'No'?> 
How many days keep reports run time statistics: <?=$Config[0][0]->CACHE_SMART_KEEP_DAYS?>  
Maximum number of seconds that loading of a real time report should take: <?=$Config[0][0]->CACHE_SMART_TIME?>  

Automatic removal is enabled: <?=$Config[0][0]->DELETE_ENABLE?'Yes':'No'?> 
Launch period: <?=$Config[0][0]->DELETE_RUN_PERIOD?> 
What types of data to delete: <?=$Config[0][0]->DELETE_FUNCS?> | <?=$Config[0][0]->DELETE_SUB_FUNCS?> 
Delete keep period: <?=$Config[0][0]->DELETE_KEEP_PERIOD?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".($Config[$Cp][0]->DELETE_KEEP_PERIOD)."\r\n";
}}?>

Archiving is enabled: <?=$Config[0][0]->ARCHIVE_ENABLE?'Yes':'No'?> 

============================
    Statistics storage settings
============================

Store complete visitor paths: <?=$Config[0][0]->KEEP_VISITOR_PATH==1?"Store":"Don't store"?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".$StorageParams[$Config[$Cp][0]->KEEP_VISITOR_PATH]."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".$StorageParams[$Config[$Cp][$SiteId]->KEEP_VISITOR_PATH]."\r\n";
}
}}?>

Store complete paths for visitors which arrived directly to the site:  <?=$Config[0][0]->KEEP_NO_REF==1?"Store":"Don't store"?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".$StorageParams[$Config[$Cp][0]->KEEP_NO_REF]."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".$StorageParams[$Config[$Cp][$SiteId]->KEEP_NO_REF]."\r\n";
}
}}?>

============================
    Duplicates protection 
============================

Ignore a duplicate request to the same page by the same visitor for the specified number of seconds: <?=EchoDupl(0,0,'STOP_DBL_PAGE_LOAD','TIME_DBL_PAGE_LOAD')?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".(EchoDupl($Cp,0,'STOP_DBL_PAGE_LOAD','TIME_DBL_PAGE_LOAD'))."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".(EchoDupl($Cp,$SiteId,'STOP_DBL_PAGE_LOAD','TIME_DBL_PAGE_LOAD'))."\r\n";
}
}}?>

Ignore a duplicate click by the same visitor for the specified number of seconds: <?=EchoDupl(0,0,'STOP_DBL_ADV_CLICK','TIME_DBL_ADV_CLICK')?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".(EchoDupl($Cp,0,'STOP_DBL_ADV_CLICK','TIME_DBL_ADV_CLICK'))."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".(EchoDupl($Cp,$SiteId,'STOP_DBL_ADV_CLICK','TIME_DBL_ADV_CLICK'))."\r\n";
}
}}?>

Do not log a duplicate action by the same visitor for the specified number of seconds: <?=EchoDupl(0,0,'STOP_DBL_EVENT','TIME_DBL_EVENT')?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".(EchoDupl($Cp,0,'STOP_DBL_EVENT','TIME_DBL_EVENT'))."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".(EchoDupl($Cp,$SiteId,'STOP_DBL_EVENT','TIME_DBL_EVENT'))."\r\n";
}
}}?>

Do not log a duplicate sale by the same visitor for the specified number of seconds: <?=EchoDupl(0,0,'STOP_DBL_SALE','TIME_DBL_SALE')?> 
<?if ($nsProduct->LICENSE==3) {  
foreach ($Clients as $Cp=>$Row) { 
if (isset($Config[$Cp][0])) echo "|-- {$Row->NAME}: ".(EchoDupl($Cp,0,'STOP_DBL_SALE','TIME_DBL_SALE'))."\r\n";
if (isset($Sites[$Cp])) foreach ($Sites[$Cp] as $SiteId=>$SiteRow) {
    if (isset($Config[$Cp][$SiteId])) echo "|---- {$SiteRow->HOST}: ".(EchoDupl($Cp,$SiteId,'STOP_DBL_SALE','TIME_DBL_SALE'))."\r\n";
}
}}?>
</textarea>
<input type=button value="Copy to clipboard" onclick="return CopyText('GeneralInfo');">

<br><br>
Php info:
<?if ($PhpInfo) {?>
<textarea id="PhpInfo" style="width:100%;" rows=20><?=$PhpInfo?></textarea>
<input type=button value="Copy to clipboard" onclick="return CopyText('PhpInfo');">
<?} else {?>
    <iframe id="PhpInfo" src="<?=getURL('info','Mode=phpinfo')?>" style="width:100%;height:200px;border:1px solid #ccc;overflow:scroll;"></iframe>
<?}?>

<br><br>
Mysql info:
<textarea id="MysqlInfo" style="width:100%;" rows=10>
<?foreach ($Tables as $Row) {
    echo "{$Row->Name}, {$Row->Type} --- {$Row->Rows} (".FileSizeStr($Row->Data_length+$Row->Index_length).") \n";
}
?>

<?foreach ($MyVars as $Row) echo "{$Row->Variable_name}: {$Row->Value}\n";?>
</textarea>
<input type=button value="Copy to clipboard" onclick="return CopyText('MysqlInfo');">

</div>

<?include $nsTemplate->Inc("inc/footer");?>