<html <?=@$nsLang->htmlTagArguments?>>

<head>
<meta name="robots" content="noindex,nofollow">
<title>Tracker - <?=@$MetaTitle ? $MetaTitle : strip_tags($PageTitle) ?></title>
<link rel="shortcut icon" href="<?=FileLink("images/favicon.ico")?>" type="image/x-icon" />
<link rel="stylesheet" href="<?=FileLink("css/common.css")?>" />
<link rel="stylesheet" href="<?=FileLink("css/elements.css")?>" />
<link rel="stylesheet" href="<?=FileLink("css/livesearch.css")?>" />
<link rel="stylesheet" href="<?=FileLink("css/ajax.css")?>" />
<link rel="stylesheet" href="<?=getURL("system","m=css","pub")?>" />
<script language="javascript" src="<?=PATH."/jslib/jquery.js?".filemtime(SELF.'/jslib/jquery.js');?>"></script>
<script language="javascript" src="<?=PATH."/jslib/jquery.plugin.js?".filemtime(SELF.'/jslib/jquery.plugin.js');?>"></script>
<script language="javascript" src="<?=PATH."/jslib/main.js?".filemtime(SELF.'/jslib/main.js');?>"></script>
<script language="javascript" src="<?=PATH."/jslib/ajax.div.js?".filemtime(SELF.'/jslib/ajax.div.js');?>"></script>
<script language="javascript" src="<?=PATH."/jslib/search.js?".filemtime(SELF.'/jslib/search.js');?>"></script>
<script language="javascript" src="<?=PATH."/jslib/cookies.js?".filemtime(SELF.'/jslib/cookies.js');?>"></script>
<script language="javascript" src="<?=FileLink("js/cards.js");?>"></script>
<?if ($nsUser->Logged()) {?>
<script language="javascript" src="<?=getURL("system","m=js","admin")?>"></script>
<?}?>
<?=V($AdditionalHead)?>

<?if ($nsProduct->SKIN!='default') {?>
<link rel="stylesheet" href="<?=FileLink("css/thisskin.css")?>" />
<link rel="stylesheet" href="<?=getURL("system","m=thiscss","pub")?>" />
<?}?>
</head>


<body <?=V($AdditionalBody)?>>
<div id="BackTrans"></div>
<div id="GlobalAjaxLoading" ><div id="GA1"></div><div id="GA2"></div></div>
<div id="GlobalAjaxDiv"></div>
<div id="GlobalSearchResults"></div>
<div id='Total'>
<div id="Header">

<?include $nsTemplate->Inc('inc/top_panel.inc')?>

<table cellspacing=0 class=TabTable><tr>
<td valign=bottom align=center class=TabTableTd>
<?if ($nsUser->Logged() && !defined('UPDATE_MODE') ) include $nsTemplate->Inc("inc/menu"); 
else echo '&nbsp;';?>
</td></tr></table>

<div id='ConsultBlock'><?if ($Consult->ShowHelpLink()) {?>
<div style='width:294px;height:10px;float:right;'>
<?include SELF."/consult/".$nsLang->CurrentLang."/context_block.php"?>
</div>
<?}?></div>

<!--  -->
<table border="0" cellpadding="0" cellspacing="0" width="100%" height=10>
<tr><td class='MenuPath'>
<?include $nsTemplate->Inc("inc/path");?>
</td></tr>
</table>
<!--  -->
<div id='SpacerMedium'></div>
</div>



<!--   -->
<div id='Content'>

<?if ($Consult->ShowHelp()) {
	include $Consult->Header;
	include $Consult->Link;
	include $Consult->Footer;
}

$MsgTableClass=array("__Errors"=>"ErrorTable", "__Messages"=>"MsgTable", "__Alerts"=>"AlertTable");

foreach (array("__Errors", "__Messages", "__Alerts") as $LogKey) {
    if (!empty($_SESSION[$LogKey])) {?>
	<div id='<?=$LogKey?>' class="<?=$MsgTableClass[$LogKey]?>">
    <?if (count($_SESSION[$LogKey])> 1) {?>
        <ul class=MsgBlockUl>
        <?foreach ($_SESSION[$LogKey] as $MsgText) {?><li><?=$MsgText?></li><?}?>
        </ul>
    <?}
	else foreach ($_SESSION[$LogKey] as $MsgText) {?><?=$MsgText?><?}?>
    </div>
    <div id='SpacerMedium'></div>
<?}}?>
<?$Logs->Clear()?>