
var TrBack1 = ''
var TrBack2 = '#f5f5f5'

var TdSelect1 = ''
var TdSelect2 = '#e8f8e7'
var TdSelect3 = '#f5f5f5'

var ConstPreventClick=false;

function ConstHLRow(oTr,Mode) {
    if ($(oTr).attr('rowsel')!= '0' || $(oTr).attr('colsel') != '0') return false
    if (Mode=='over') $(oTr).css('background-color', TrBack2)
    if (Mode=='out') $(oTr).css('background-color', TrBack1)
}

function ConstSR(oTd) {
    if (ConstPreventClick) return ConstPreventClick=false
    var oTr = $(oTd).parent('tr')
    $(oTr).attr('rowsel', $(oTr).attr('rowsel') == '1' ? '0' : '1')
    ConstSetRowHighlight(oTr)
}

function ConstSC(oTd) {
    if (ConstPreventClick) return ConstPreventClick=false
    var oTr=oTd.parentNode
    var oTable=oTd.parentNode
    while (oTr.tagName.toLowerCase()!='tr') oTr=oTr.parentNode
    while (oTable.tagName.toLowerCase()!='table') oTable=oTable.parentNode
    $(oTr).attr('rowsel',0)

    if (oTable.selectedCell) ConstSetColumnHightlight(oTable,'remove')
    if (oTable.selectedCell) {
        $(oTable.selectedCell.rowObj).attr('rowsel','0').attr('colsel','0')
        ConstSetRowHighlight(oTable.selectedCell.rowObj)
        if (oTable.selectedCell.row == $(oTr).attr('dataIndex') &&
            oTable.selectedCell.cell == $(oTd).attr('dataIndex')) {
             ConstHLRow(oTr,'over')
             oTable.selectedCell = false
             return false
        }
    }

    oTable.selectedCell = { row: $(oTr).attr('dataIndex'), cell: $(oTd).attr('dataIndex'),
                            rowObj:oTr }
    $(oTr).attr('colsel','1')
    ConstSetColumnHightlight(oTable,'set')
    ConstSetRowHighlight(oTr)
}

function ConstSetRowHighlight(oTr) {
    var tr = $(oTr)
    if (tr.attr('rowsel') == '1' && tr.attr('colsel') != '1')
        tr.css('background-color', TdSelect2)
    if (tr.attr('colsel') == '1') tr.css('background-color', TdSelect3)
    if (tr.attr('rowsel') != '1' && tr.attr('colsel') != '1')
        tr.css('background-color', TdSelect1)
}

function ConstSetColumnHightlight(oTable,Mode) {
    var selectedCell = oTable.selectedCell
    if (!selectedCell) return false
    for (var i=0; i < oTable.rows.length; i++) {
        var oTr = oTable.rows[i]
        var tr = $(oTr)
        if (tr.attr('dataIndex') == null) continue
        if (parseInt(tr.attr('dataIndex')) > parseInt(selectedCell.row)) continue
        if (parseInt(tr.attr('dataIndex')) == parseInt(selectedCell.row)) {
            for (var j=0; j <= parseInt(selectedCell.cell); j++)
                $(oTr.cells[j]).css('background-color', ((Mode=='set') ? TdSelect2 : TdSelect1))
        } else $(oTr.cells[parseInt(selectedCell.cell)]).css('background-color',
                ((Mode=='set') ? TdSelect2 : TdSelect1))
    }
}

function SwitchGraph(id) {
	if (typeof(CurGraph)=="object" && CurGraph.id != id) $(CurGraph).hide()
    $('#'+id).show()
    CurGraph = _(id)
}

function goTo(Position) { window.location=_('A_'+Position).href; }

function showTotals(oA, subSumEnabled, recalcPerc) {
    var a = $(oA);
    a.hide();
    $('img[loadingimg=1]', a.parent()).show();
    var URL = window.location.href + '&TotalsOnly='+(subSumEnabled == '1' ? 2 : 1);
    var table = a.parents('table').eq(0);
    requestURL(URL,false,function(data) {
        a.parents('tr').eq(0).replaceWith(data);
        if (recalcPerc) recalcPercents( table );
    });
}

function recalcPercents( table ) {
    table.find('td[colsum=1]').each(function(){
        var inx = this.cellIndex;
        var sum = parseInt($('b', this).text().replace(',', ''));
        if (!sum || sum==0) return true;
        $('td[dataIndex='+inx+']>p.ReportColumn', table).each(function() {
            var p = $(this);
            var s = p.find('span.ReportSubColumn');
            if (!s.length || $.trim( s.text() ).length > 1) return true;
            var value = parseInt(p.text().replace(',', ''));
            if (!value || value=='0') var perc=0;
            else var perc = Math.ceil( ((100/sum)*value) * 100) / 100;
            s.text( '('+perc+'%)');
        });
    });
};

function toggleCheckAllRows(id, name, oCheck, callback) {
    $('input[type=checkbox][customname='+name+']', '#'+id).attr('checked', oCheck.checked ? true : false)
    if (callback) callback(oCheck.checked)
}