function CheckForUpdatesResponse(Res)
{
    _('CheckForUpdates').disabled=false
    hideGlobalLoading()
    if (!Res || Res=='xmlcheck-error') alert(UpdatesErrorText)
    else if (Res=='xmlcheck-none') alert(NoUpdatesText)
    else UpdatesAvailable=true
    ShowStep1()
}

function CheckForUpdates()
{
    _('CheckForUpdates').disabled=true
    requestURL(RequestUpdateURL, showGlobalLoading, CheckForUpdatesResponse)
}

function DownloadUpdatesResponse(Res)
{
    _('DownloadUpdates').disabled=false
    hideGlobalLoading()
    if (!Res || Res=='xmldownload-error') alert(DownloadErrorText)
    if (Res=='xmldownload-ok') window.location.reload()
}

function DownloadUpdates()
{
    _('DownloadUpdates').disabled=true
    requestURL(DownloadUpdateURL, showGlobalLoading, DownloadUpdatesResponse)
}

function ShowStep1()
{
    if (AllowAutoCheck != 1) {
        $('#AutoCheck').hide(); $('#AutoDownload').hide(); $('#ManualGet').show()
        return
    }
    if (AllowAutoCheck && (UpdatesAvailable=='' || UpdatesAvailable=='xmlcheck-none')) {
        $('#AutoCheck').show(); $('#AutoDownload').hide(); $('#ManualGet').hide()
        return
    }
    if (AllowAutoCheck && UpdatesAvailable && UpdatesAvailable!='xmlcheck-none') {
        $('#AutoCheck').hide();
        if (AllowLocalRewrite) { $('#AutoDownload').show(); $('#ManualGet').hide() } 
        else { $('#AutoDownload').hide(); $('#ManualGet').show(); }
        return
    }    
}

var CurrentStartRow=0
var CurrentUpdateMode='agent'

function RunDatabaseUpdateResponse(Res)
{
    if (Res=="xmlupdate-refresh") {
        window.location.reload()
        return false
    }

    var HTML=''
    if (CurrentUpdateMode=='agent' 
    && (_('UpdateGroups').checked||_('UpdateAgents').checked)) HTML=UAtext
    if (CurrentUpdateMode=='search' 
    && (_('UpdateGroups').checked||_('UpdateSEngines').checked)) HTML=Searchtext
    if (CurrentUpdateMode=='geo'&& _('UpdateLocations').checked) HTML=Geotext
    
    HTML+='<b>'+Res+'</b>%'
    if (CurrentUpdateMode=='geo' && Res==100) HTML=Donetext

    if (Res==100 && CurrentUpdateMode=='agent') {
        CurrentUpdateMode='search';Res=0;HTML='';CurrentStartRow=0;}
    if (Res==100 && CurrentUpdateMode=='search') {
        CurrentUpdateMode='geo';Res=0;HTML='';CurrentStartRow=0;}

    _('DbProgressPerc').innerHTML=HTML
    _('DbProgressBar').width=Res+'%'

    if (Res==100) { hideGlobalLoading(); return false; }
    if (Res<100) { 
        if (Res>0) CurrentStartRow+=UpdateRowStep;
        RunDatabaseUpdate();
    }
}

function RunDatabaseUpdate()
{
    $('#DbProgressBtn').hide()
    $('#DbOptions').hide()
    $('#DbProgress').show()
    showGlobalLoading()

    var UpdateGroups=_('UpdateGroups').checked?1:0
    var UpdateAgents=_('UpdateAgents').checked?1:0
    var UpdateSEngines=_('UpdateSEngines').checked?1:0
    var UpdateLocations=_('UpdateLocations').checked?1:0
    var URLAdd=''
    URLAdd+='&UpdateOptions[UpdateGroups]='+UpdateGroups
    URLAdd+='&UpdateOptions[UpdateAgents]='+UpdateAgents
    URLAdd+='&UpdateOptions[UpdateSEngines]='+UpdateSEngines
    URLAdd+='&UpdateOptions[UpdateLocations]='+UpdateLocations
    var URL = DbUpdateURL+CurrentStartRow+'&UpdateMode='+CurrentUpdateMode+URLAdd
    requestURL(URL, false, RunDatabaseUpdateResponse)  
}

function ShowDbOptions()
{
    SetOptionsPosition();
    if (typeof(window.addEventListener) != 'undefined') 
        window.addEventListener('resize', SetOptionsPosition, false)
    if (typeof(window.attachEvent) != 'undefined') 
        window.attachEvent('onresize', SetOptionsPosition)
    $('#DbOptions').toggle('normal')
}

function SetOptionsPosition()
{
    var X=0;
    var p=_('DbProgressBtn')
    while (p.offsetParent) {
        X += p.offsetLeft
        p = p.offsetParent
    }
    _('DbOptions').style.left=
        X-Math.floor((parseInt(_('DbOptions').style.width)-
                        _('DbProgressBtn').offsetWidth)/2)
}


function CheckOptions()
{
    var C=0
    C+=(_('UpdateGroups').checked?1:0)
    C+=(_('UpdateAgents').checked?1:0)
    C+=(_('UpdateSEngines').checked?1:0)
    C+=(_('UpdateLocations').checked?1:0)
    _('RunUpdate').disabled=(C>0&&!WaitingForCron)?false:true
}
