<div id='FilterWrapper' class='FilterWrapper'>
<ul class='FilterOptions'>

<?include $nsTemplate->Inc('filter/site.option.inc');?>
<?include $nsTemplate->Inc('filter/date.option.inc');?>

<?if (!$VisId) {?><li name='ChooseOnline' show='more'><?if ($OnlineOnly) {?>
<?=$Lang['OnlineOnly']?><span><?=$OnlinePeriod?>s</span><?}
else echo $Lang['OnlineFilter']?></li><?}?>

<li name='ChooseFilter' show='more'><?if ($Filter) {?>
<?=$Lang['Filter']?><span><?=$FilterFor?>: <?=$Filter?></span><?} 
else echo $Lang['NoFilter']?></li>

<li name='ChooseVisitor' show='more'><?if ($VisId){?>
<?=$Lang['VisitorID']?><span><?=$VisId?></span><?}
else echo $Lang['NoVisitorSelected']?></li>

<li name='ChooseOnPage' show='more-even'><?=$Lang['VisitorsOnPage']?><span><?=$OnPage?></span></li>

<?include $nsTemplate->Inc('filter/sorting.option.inc');?>

<li name='ChooseSteps' show='more'><?=$Lang['QuickFilter']?></li>

<li show='manual'><a href="javascript:window.location.reload()"><span><?=$Lang['RefreshFilter']?></span></a></li>
<?include $nsTemplate->Inc('filter/more.option.inc');?>


</ul>
<div class='Filter'>
<div class='SubmitElement'><input type=submit value="<?=$Lang['Refresh']?>"></div>


<?include $nsTemplate->Inc('filter/site.inc');?>
<?include $nsTemplate->Inc('filter/date.inc');?>


<?if (!$VisId) {?>
<div class='FilterElement' id='ChooseOnline'>
<label>
<input type=checkbox id="OnlineOnly" name="OnlineOnly" value=1 <?=(($OnlineOnly)?"checked":"")?> onclick="showOnlinePeriod();">
<?=$Lang['OnlineOnly']?></label>
<label>
<input id="OnlinePeriod" type=text name=OnlinePeriod size=5 style="width:65px;padding-left:3px;"value="<?=$OnlinePeriod?>">
<?=$Lang['OnlinePeriod']?></label>
</div>
<?}?>

<div class='FilterElement' id='ChooseFilter'>
<label>
<input type=text style="width:107px;padding-left:3px;" name=Filter ondblclick="this.value=''"  value="<?=$Filter?>">
</label>
<select name=FilterFor style="width:107px;">
<option value="IP" <?=(($FilterFor=="IP")?"selected":"")?>><?=$Lang['ByIp']?></option>
<option value="Action" <?=(($FilterFor=="Action")?"selected":"")?>><?=$Lang['ByAction']?></option>
<option value="ActionItem" <?=(($FilterFor=="ActionItem")?"selected":"")?>><?=$Lang['ByActionItem']?></option>
<option value="Path" <?=(($FilterFor=="Path")?"selected":"")?>><?=$Lang['ByPath']?></option>
<option value="Sale" <?=(($FilterFor=="Sale")?"selected":"")?>><?=$Lang['BySale']?></option>
<option value="SaleItem" <?=(($FilterFor=="SaleItem")?"selected":"")?>><?=$Lang['BySaleItem']?></option>
<option value="Agent" <?=(($FilterFor=="Agent")?"selected":"")?>><?=$Lang['ByAgent']?></option>
<option value="Ref" <?=(($FilterFor=="Ref")?"selected":"")?>><?=$Lang['ByRef']?></option>
<option value="Key" <?=(($FilterFor=="Key")?"selected":"")?>><?=$Lang['ByKey']?></option>
<option value="Tag" <?=(($FilterFor=="Tag")?"selected":"")?>><?=$Lang['ByTag']?></option>
<option value="Country" <?=(($FilterFor=="Country")?"selected":"")?>><?=$Lang['ByCountry']?></option>
<option value="City" <?=(($FilterFor=="City")?"selected":"")?>><?=$Lang['ByCity']?></option>
</select>
</div>

<div class='FilterElement' id='ChooseVisitor'>
<label>
<?=$Lang['Vis']?>:
<input type=text size=5 class=DateFld name=VisId ondblclick="this.value=''" value="<?=$VisId?>">
</label>
</div>

<div class='FilterElement' id='ChooseOnPage'>
<label>
<input type=text style="width:50px;padding-left:3px;" name="OnPage" value="<?=$OnPage?>">
<?=$Lang['VisitorsOnPage']?>
</label>
</div>


<?include $nsTemplate->Inc('filter/sorting.inc');?>


<div class='FilterElement' id='ChooseSteps'>
<label>
<input type=checkbox <?=@$HideSteps['Referrer']?'':'checked'?> onclick="$('.Referrer').toggle();">
<?=$Lang['ShowReferrer']?></label>    
<label>
<input type=checkbox <?=@$HideSteps['StepDefault']?'':'checked'?> onclick="$('.StepDefault').toggle();">
<?=$Lang['ShowDefault']?></label>
<label>
<input type=checkbox <?=@$HideSteps['StepAction']?'':'checked'?> onclick="$('.StepAction').toggle();">
<?=$Lang['ShowAction']?></label>
<label>
<input type=checkbox <?=@$HideSteps['StepClick']?'':'checked'?> onclick="$('.StepClick').toggle();">
<?=$Lang['ShowClick']?></label>
<label>
<input type=checkbox <?=@$HideSteps['StepSplit']?'':'checked'?> onclick="$('.StepSplit').toggle();">
<?=$Lang['ShowSplit']?></label>
<label>
<input type=checkbox <?=@$HideSteps['StepSale']?'':'checked'?> onclick="$('.StepSale').toggle();">
<?=$Lang['ShowSale']?></label>
</div>


</div></div>

<script>
var pathFilter = createFilter('FilterWrapper');
</script>