<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#

// Database
// -  ,      
//          

class nsDatabase
{
	var $ID;
	var $AutoFree;
	var $LastInsertId;
	var $LastError;
	var $LastQuery;
    var $LoggerFunc;
    var $GetTime;

	function nsDatabase()
	{
		//   
		global $Lang, $Logs, $DbUser, $DbPass, $DbHost, $DbPort, $DbName;
		if (!$DbHost || !$DbName) return false;
		if ($DbPort) $DbHost = $DbHost.":".$DbPort;

		// AutoFree -       (mysql_free_result -  )
		$this->AutoFree = true;
		//     mysql  
		$this->LastError = "";
		//  ,   mysql
		$this->LastAffected=false;
		$this->LastInsertId=false;

		//  true,      
		$this->GetTime=false;
		$this->ResTime=0;
		//     ,      
		//       
		//  GetTime=false,      
		$this->LoggerFunc="";
        //       
        $this->NoDebug=false;
        //    
        $this->DoPrepareQuery=true;

		//     
		$ID = @mysql_connect($DbHost, $DbUser, $DbPass);
		if (!$ID) return false;
		//   
		@mysql_select_db($DbName, $ID) or $Logs->DbErr(false, $Lang["DbSetErr"], "DIE");
		$this->ID = $ID;

		//           
		//        ,     .
		$GLOBALS['DBCON']=&$this->ID;

		$this->Version=false;
        //$this->SetVariable('time_zone', '+0:00');

		//      ..,       
		unset($GLOBALS['DbName'], $GLOBALS['DbHost'], $GLOBALS['DbPost'], $GLOBALS['DbUser'], $GLOBALS['DbPass']);
	}

	//   
	function Close()
	{
		global $Lang, $Logs;
		@mysql_close($this->ID) or $Logs->DbErr(false, $Lang['DbCloseErr']);
	}

    function SetPfx($Query)
    {
        $Arr=array();
        if (preg_match_all("/\?\{([a-zA-Z0-9_]+)\}/", $Query, $Arr)) {
            foreach ($Arr[1] as $k) $Query=preg_replace("/\?\{$k\}/", constant($k), $Query);
        }
        $Query=preg_replace("/(JOIN|FROM|INTO|UPDATE|TABLE)(\s+`?)\?([^\s]+)/i", "\\1\\2".PFX."_tracker\\3", $Query);
        return $Query;
    }

    function PrepareQuery($Query=false, $Args=array(), $PreNum=0) 
    {
        $Query=$this->SetPfx($Query);
        if (!$this->DoPrepareQuery) return $Query;
        if (strpos($Query,"?")===false) return $Query;
        $Result=$Named=$Constant=false;
        $ResArr=$Replace=$QueryArr=array(); 
        if (!preg_match_all("/\?([%|#]?)([a-zA-Z0-9_]*)/", $Query, $ResArr)) return $Query;
        foreach ($ResArr[2] as $i=>$v) {
            if ($ResArr[1][$i]=='#') $Constant=true; 
            if ($v && $ResArr[1][$i]!='#') $Named=true;
        }
        if ($Named && (!is_array($Args[$PreNum])||count(array_slice($Args,$PreNum))>1)) return $Query;
        if ($Named) $Replace=$Args[$PreNum];
        else for($i=$PreNum;$i<count($Args);$i++) $Replace[]=$Args[$i];

        if (!$Constant && (is_null($Replace) || empty($Replace))) return $Query;

        $p1=$p=$const=0;
        foreach ($ResArr[0] as $i=>$t) {
            $p=strpos($Query,$t,$p);
            $QueryArr[]=substr($Query,$p1,$p-$p1);
            $p1=$p=$p+strlen($ResArr[0][$i]);
        }
        if (!empty($QueryArr)) $QueryArr[]=substr($Query,$p);

        foreach ($ResArr[0] as $i=>$t) {
            $k=$Named?$ResArr[2][$i]:$i-$const;
            $Result .= array_shift($QueryArr);

            if ($ResArr[1][$i]=="%" && is_array($Replace[$k])) {
                $j=0;
                foreach ($Replace[$k] as $k1=>$v1) {
                    if ($j>0) $Result.=", ";
                    $Result .= "`$k1`='".es($v1)."'";
                    $j++;
                }
            }

            if ($ResArr[1][$i]=="#") {$Result .= @constant($ResArr[2][$i]); $const++;}            

            if ($ResArr[1][$i]=="") {
                if (is_array($Replace[$k])) {$Result .= implode(", ",es($Replace[$k])); continue; }
                if (is_null($Replace[$k])) $Result .= 'NULL';
                else $Result .= '\''.es($Replace[$k]).'\'';                
            }
        }
        $Result .= array_shift($QueryArr);
        return $Result;
    }


	// 
	/**
	* @return result
	* @param string $Query
	* @param string $Type 
	* @desc    ( )
	*     SELECT   ,
	*      
	* $Query -  (  "void" -  true  ).
	* $Type -    
	* ARR -  
	* ROW -  
	* OBJ - 
	*/
	function Select($Query = false, $Type = "OBJ")
	{    
		global $Lang, $Logs;
		if (!$Query || !$this->ID) return false;
		if (!$Type) $Type="OBJ";
		if ($Query == "void") return true;
		$Args=func_get_args();
		$Query=$this->PrepareQuery($Query, $Args, 2);

		$this->LastQuery = $Query;
		$this->LastError="";
		if ($this->GetTime) $StartTime=$this->GetMicroTime();
		$ResultLink = @mysql_query($Query, $this->ID);
		if (@mysql_error()) {$this->LastError = @mysql_error(); $Logs->DbErr($Query, $Lang['DbQueryErr']); return;}
        $RCnt=mysql_num_rows($ResultLink);
		if ($Type == "OBJ") $Result = @mysql_fetch_object($ResultLink);
		if ($Type == "ARR") $Result = @mysql_fetch_array($ResultLink, MYSQL_ASSOC);
		if ($Type == "ROW") $Result = @mysql_fetch_row($ResultLink);
		if (@mysql_error()) {$this->LastError = @mysql_error(); $Logs->DbErr($Query, $Lang['DbFetchErr']); return;}
		if ($this->GetTime) $this->ResTime=$this->GetMicroTime()-$StartTime;
		if ($this->LoggerFunc&&!$this->NoDebug) {
			$Func=$this->LoggerFunc;
			$Func($Query, $this->ResTime, $this->LastError,$RCnt);
		}
		if ($this->AutoFree) @mysql_free_result($ResultLink);
		$this->LastResult = $Result;
		
		
		return $Result;
	}

	/**
	* @return bool
	* @param string $Query
	* @desc     ,  SELECT
	* INSERT, UPDATE  ..
	*/
	function Query($Query = false)
	{
		global $Lang, $Logs;
		if (!$Query || !$this->ID) return false;
		if ($Query == "void") return true;
		$this->LastAffected=false;
		$this->LastInsertId=false;
        $Args=func_get_args();
        $Query=$this->PrepareQuery($Query, $Args, 1);
        
		$this->LastError="";
		if ($this->GetTime) $StartTime=$this->GetMicroTime();

		$ResultLink = @mysql_query($Query, $this->ID);
		if ($this->GetTime) $this->ResTime=$this->GetMicroTime()-$StartTime;
		if (@mysql_error()) {$this->LastError = @mysql_error(); $Logs->DbErr($Query, $Lang['DbQueryErr']); return false;}
		$this->LastAffected = @mysql_affected_rows($this->ID);
		$this->LastInsertId = @mysql_insert_id($this->ID);
		if ($this->AutoFree) @mysql_free_result($ResultLink);
        if ($this->LoggerFunc&&!$this->NoDebug) {
            $Func=$this->LoggerFunc;
            $Func($Query, $this->ResTime, $this->LastError, $this->LastAffected);
        }
		$this->LastQuery = $Query;
		
		return true;
	}

	//      
	// SELECT ID FROM my_table -    ID (  ,    )
	function ReturnValue($Query = false)
	{
		if (!$Query) return false;
        if (!$this->ID) return false;
        $Args=func_get_args();
        $Query=$this->PrepareQuery($Query, $Args, 1);
        $PQ=$this->DoPrepareQuery;
		$this->DoPrepareQuery=false;
		$Res = $this->Select($Query, "ROW");
        $this->DoPrepareQuery=$PQ;
        return ($Res)?$Res[0]:false;
	}


	function SetMysql40Mode() 
	{
		$Version=$this->ReturnValue("SELECT VERSION()");
		$this->Version=$Version;
		if (CompareVersions($Version, "4.1") == 1) {
			$this->Query(" SET SESSION sql_mode='MYSQL40' ");
		}
	}

    function SetVariable($Name, $Value) {
        $this->Query("SET SESSION $Name = ? ", $Value);
    }

	//          ,  .
	// $Table -  
	// $Where - .  AGE='17' AND HAIR = 'blond'
	//  
	function CNT($Table = false, $Where = false)
	{
		if (!$Table) return false;
		if ($Where) $Where = "WHERE ".$Where;
		$Query = "SELECT COUNT(*) AS CNT FROM $Table $Where";
		$Count = $this->Select($Query);
		return $Count->CNT;
	}

	//       
	//  ,   , 
	//  true,   
	function IsExists($Table = false, $Field = false, $Value = false) 
	{
		if (!$Table || !$Field || !$Value) return false;
		$Query = "SELECT $Field FROM $Table WHERE $Field = $Value";
        $Query=$this->SetPfx($Query);
		$Check = $this->Select($Query);
        if (!$Check) return false;
		if ($Check->$Field == $Value) return true;
		else return false;
	}

	//    
	//     
	function GetMicrotime() 
	{ 
		list($usec, $sec) = explode(" ", microtime()); 
		return ((float)$usec + (float)$sec); 
	} 

}

//////////////////////////////////////////
// 
//  Query
//   ,    
//   Database    
/*
   

$Query = "SELECT * FROM my_table";
$Sql = new Query($Query);
while ($Row = $Sql->Row()) {
	Dump($Row);
}

*/

class Query
{

	//      SELECT 
	//    ,     Database
	//        . 
	//   ,      .

	//  $Query == "void" -  true.


	function Query($Query = false, $Type = "OBJ")
	{
		global $Lang, $Logs;
		if (!$Type)$Type="OBJ";
		$Db=&$GLOBALS['DBCLASS'];
        $this->QID=false;
		$this->DbId = $Db->ID;
        if (!$this->DbId) return false;
		if (!$this->DbId) {$Logs->Err($Lang['DbNoHandler']); return false;}
		if (!$Query) return false;
		if ($Query == "void") return true;

        $Args=func_get_args();
        $Query=$Db->PrepareQuery($Query, $Args, 2);

		//  true,      
		$this->GetTime=$Db->GetTime;
		$this->ResTime=0;
		$this->PrevTime=0;
		//     ,      
		//       
		//  GetTime=false,      
		$this->LoggerFunc=$Db->LoggerFunc;
        //       
        $this->NoDebug=false;
		
		$this->Query = $Query;

		//       -1
		//       0
		$this->Position = -1;

		//    .      , 
		//  false
		//       .
		$this->LastRec = false;

		$this->Type = $Type;
		$this->AutoFree = $Db->AutoFree;
		$this->Count = false;

		//     
		$this->LastRow=false;	
		
		//        
		$this->PrevTime=$this->GetMicroTime();
		$QID = @mysql_query($Query, $this->DbId);
		$this->ResTime+=$this->GetMicroTime()-$this->PrevTime;
        $this->QID = $QID;
        if (!$this->NoDebug) $this->Count();
                
		if (@mysql_error()) {
				$Logs->DbErr($Query, $Lang['DbQueryErr']); 
				$this->QID=false;
                if ($this->LoggerFunc&&!$this->NoDebug) {
                    $Func=$this->LoggerFunc;
                    $Func($this->Query, $this->ResTime, @mysql_error(), $this->Count());
                }
				return false;
		}
	}

	//     
	//        
	function Count()
	{
		if (!$this->Count) $this->Count = @mysql_num_rows($this->QID);
		return $this->Count;	
	}


	//   
	function Row()
	{
		if (!$this->QID) return false;
        if (!$this->DbId) return false;
		global $Lang, $Logs;
		$Row=false;

		//      LastRec -  false
		if ($this->LastRec && $this->Position >= $this->LastRec) return false;
	
		if ($this->GetTime&&$this->Position==-1) $this->PrevTime=$this->GetMicroTime();
		if ($this->GetTime) {
			$Prev=$this->PrevTime;
			$this->PrevTime=$this->GetMicroTime();
			$Diff=$this->PrevTime-$Prev;
		}
		if ($this->GetTime&&$this->Position>-1) $this->ResTime+=$Diff;

		if ($this->Type == "OBJ") $Row = @mysql_fetch_object($this->QID);
		if ($this->Type == "ARR") $Row = @mysql_fetch_array($this->QID, MYSQL_ASSOC);
		if ($this->Type == "ROW") $Row = @mysql_fetch_row($this->QID);
		if (@mysql_error()) {
            $Logs->DbErr($this->Query, $Lang['DbFetchErr']);
            return false;
        }
		if ($this->AutoFree && !$Row) $this->Free();

		if (!$Row&&$this->GetTime) {
			if ($this->ResTime==0) $this->ResTime=$this->GetMicroTime()-$this->PrevTime;
			if ($this->LoggerFunc&&!$this->NoDebug) {
				$Func=$this->LoggerFunc;
				$Func($this->Query, $this->ResTime, @mysql_error(), $this->Count());
			}
		}

		$this->Position++; 
		$this->LastRow = $Row;
		return $Row;
	}

	//      
	//   
	function Seek($Pos = false)
	{
		if (!$this->QID) return false;
		if (!$Pos || $Pos <= 0) return false;
		if ($this->LastRec > -1 && $Pos > $this->LastRec) return false;
		if ($Pos < $this->Position) return false;
		global $Logs;
		@mysql_data_seek($this->QID, $Pos);
		if (@mysql_error()) {$Logs->DbErr($this->Query, $Lang['DbSeekErr']); return;}
		$this->Position = $Pos;
	}

	//  
	function Free()
	{
		@mysql_free_result($this->QID);
	}

	//    
	//     
	function GetMicrotime() 
	{ 
		list($usec, $sec) = explode(" ", microtime()); 
		return ((float)$usec + (float)$sec); 
	} 

}


function QueryAllArray($Query, $Type='OBJ')
{
    global $DbLastQuery;
	$Db=&$GLOBALS['DBCLASS'];
    $Query=$Db->SetPfx($Query);
	if (func_num_args()>2) {
		$Args=func_get_args();
		$Query=$Db->PrepareQuery($Query, $Args, 2);
	}
    $Return=array();
	$Sql = new Query($Query, $Type);
	while ($Row = $Sql->Row()) $Return[] = $Row;
	return $Return;
}

?>