<?
if (!defined("NS_TRACKER_INDEX")) exit;
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/pagenums2.class.php";
$nsLang->TplInc("inc/reports");

$RunId=ValidVar($_REQUEST['RunId']);
$ViewDate=ValidVar($_REQUEST['ViewDate']);
$ShowSleep=ValidVar($_REQUEST['ShowSleep']);
if (!$ViewDate || !ValidDate($ViewDate)) $ViewDate=UserDate();


$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("archive_log", "", "admin");
$MenuSection="admin";

//$Settings=GetSettings();
$CpuAvail=GetCpuLoad(true);
if ($CpuAvail==-1) $CpuAvail=false;

$ClientCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_client");


if (!$RunId) {
    
    $LogArr=array();
    $Where=($ShowSleep)?"":" AND CDL.MESSAGE != 'x-sleep'";
    $Query = "
        SELECT CL.*, CL.ID AS RUN_ID,
        MAX(CDL.CPU_LOAD) AS MAX_CPU,
        SUM(CDL.RUN_TIME) AS SUM_TIME,
        UNIX_TIMESTAMP(CL.STAMP) AS USTAMP,
        DATE_FORMAT(DATE_ADD(CL.STAMP,INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE),'%Y-%m-%d %H:%i') AS RUN_STAMP
        FROM ?_cron_log CL 
            INNER JOIN ?_cron_archive_log CDL
                ON CDL.TASK_PROCESS_ID=CL.ID
        WHERE CL.TASK='DELETE'
            AND CL.STAMP BETWEEN DATE_ADD('$ViewDate 00:00:00', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) 
                                AND DATE_ADD('$ViewDate 23:59:59', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)
                                $Where 
        GROUP BY CL.ID
        ORDER BY STAMP DESC
    ";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $Row->SUM_TIME=number_format($Row->SUM_TIME,3,'.','');
        $Row->TIME_ARR=TimeArr($Row->SUM_TIME);        
        $LogArr[]=$Row;
    }

    $Pages = new PageNums(count($LogArr),20);
    $Pages->Args="&ViewDate=$ViewDate&CpId=$CpId&ShowSleep=$ShowSleep";
    $Pages->Calculate();
    if ($Pages->Pages>1) $LogArr=array_slice($LogArr,$Pages->PageStart,$Pages->Limit);    

    include_once $nsTemplate->Inc();
}

if ($RunId) {
    
    $LogArr=array();
    $Args['runid']=$RunId;
    $Query = "
        SELECT CDL.*, C.NAME AS CLIENT_NAME, SR.NAME AS REPORT_NAME,
                    DATE_FORMAT(CDL.START_DATE,'%d-%m-%Y') AS START_DATE,
                    DATE_FORMAT(CDL.END_DATE,'%d-%m-%Y') AS END_DATE
            FROM ?_cron_archive_log CDL
                INNER JOIN ?_client C
                    ON C.ID=CDL.COMPANY_ID
                INNER JOIN ?_static_report SR
                    ON SR.ID=CDL.REPORT_ID
            WHERE TASK_PROCESS_ID=?
            ORDER BY STAMP DESC, ID DESC
    ";
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        if (!$ShowSleep && $Row->MESSAGE=='x-sleep') continue;
        if (isset($Lang[$Row->REPORT_NAME])) $Row->REPORT_NAME=$Lang[$Row->REPORT_NAME];
        $Row->RUN_TIME=number_format($Row->RUN_TIME,3,'.','');
        $Row->TIME_ARR=TimeArr($Row->RUN_TIME);    
        $LogArr[]=$Row;
    }
    
    include_once $nsTemplate->Inc("admin.archive_log_list");
}
?>