<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

ExtendUser();

require_once SELF."/lib/delete/period.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/reports/misc.func.php";

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$nsLang->TplInc("inc/reports");
$nsLang->TplInc("constructor/periods");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("archiving", "", "admin");
$MenuSection="admin";

$Query = "SELECT * FROM ?_client WHERE HIDDEN!='1' ORDER BY NAME";
$Sql = new Query($Query);
$ClientsArr=array();
while ($Row=$Sql->Row()) $ClientsArr[]=$Row; 


$EditArr=V($_REQUEST['EditArr']);
$RPeriod=V($_REQUEST['RPeriod'],array());
$DoArchive=V($_REQUEST['DoArchive'],array());

$EnableForAll=V($_REQUEST['EnableForAll']);
$DisableForAll=V($_REQUEST['DisableForAll']);
$ToAll=V($_REQUEST['ToAll']);

if (!$nsUser->DEMO) {
    if ($EditArr) UpdateSettings($EditArr);
}

$Query = "SELECT * FROM ?_config WHERE SITE_ID=0";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $Settings[$Row->COMPANY_ID]=$Row;

$EditArr['ArchiveEnable']=V($EditArr['ArchiveEnable'], V($Settings[0]->ARCHIVE_ENABLE,0));
$EditArr['ArchiveRows']=V($EditArr['ArchiveRows'], V($Settings[0]->ARCHIVE_ROWS,1000));

$Query = "SELECT * FROM ?_static_report_group ORDER BY NAME";
$RGroups=array();
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];       
    $RGroups[$Row->ID]=$Row;
}

$Query = "
    SELECT SR.*, CL.NAME AS CLIENT_NAME, COUNT(SRA.ID) AS ARCH
    FROM ?_static_report SR
        LEFT JOIN ?_client CL
            ON CL.ID=SR.COMPANY_ID
        LEFT JOIN ?_static_report_archive SRA
            ON SRA.REPORT_ID=SR.ID
    GROUP BY SR.ID
    ORDER BY SR.GROUP_ID, SR.NAME
";
$ReportArr=array();
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if ($nsProduct->LICENSE == 4 && $Row->MODE=='PAID') continue;
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];       
    $ReportArr[$Row->GROUP_ID][$Row->ID]=$Row;
}


$KeepPeriodDate=GetKeepPeriodDate($Settings[0]->DELETE_KEEP_PERIOD);

$ReportCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_static_report WHERE MODE IN (?)", 
                                                          $nsProduct->LICENSE==4?'NATURAL': array('NATURAL', 'PAID'));
$Query = "

    SELECT 
    P.TEMPLATE, P.NAME,
    COUNT(RA.ID) AS CNT

    FROM ?_periods P

    LEFT JOIN ?_static_report_archive RA
        ON RA.PERIOD=P.TEMPLATE

    WHERE P.COMPANY_ID=0 AND P.DELETED!='1' AND P.SYSTEM_TEMPLATE='1'
    GROUP BY P.TEMPLATE
";
$Sql = new Query($Query);
$PeriodStat=array();
while ($Row=$Sql->Row()) {
    $Arr=explode('-',$Row->TEMPLATE);
    if ($Arr[0]==0 || $Arr[2]==1) continue;
    if (isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
    if ($Row->CNT==0) $Row->STATUS=$Lang['None'];
    if ($Row->CNT>=$ReportCnt) $Row->STATUS=$Lang['AllReports'];
    if ($Row->CNT>0 && $Row->CNT < $ReportCnt) $Row->STATUS=str_replace("{NUM}",$Row->CNT,$Lang['NumOfReports']);
    $PeriodStat[$Row->TEMPLATE]=$Row;
}

$PArr=array_keys($PeriodStat);
usort($PArr,"SortPeriods");
$Tmp=array();
foreach ($PArr as $P) $Tmp[$P]=$PeriodStat[$P];
$PeriodStat=$Tmp;


include $nsTemplate->Inc();



function UpdateSettings($Arr=array())
{
    global $Db, $nsProduct, $Logs;
    extract($Arr);
    $ArchiveEnable=V($ArchiveEnable,0);
    $ArchiveRows=V($ArchiveRows,1000);
    
    $Query = "
        UPDATE ?_config SET  
            ARCHIVE_ENABLE=?, ARCHIVE_ROWS=?
        WHERE COMPANY_ID=0 AND SITE_ID=0
    ";
    $Db->Query($Query, $ArchiveEnable, $ArchiveRows);


    /////////  
    global $DoArchive, $RPeriod, $ToAll,$DisableForAll,$EnableForAll, $nsProduct;
    if ($EnableForAll) $EnableForAll=$ToAll;
    if ($DisableForAll) $DisableForAll=$ToAll;

    $Query = "SELECT P.* FROM ?_periods P";
    $Sql = new Query($Query);
    $Periods=array();
    while ($Row=$Sql->Row()) {
        $Arr=explode('-',$Row->TEMPLATE);
        if ($Arr[0]==0 || $Arr[2]==1) continue;
        $Periods[$Row->COMPANY_ID][]=$Row->TEMPLATE;
    }

    $ReportIds=array();
    $ReportArr=array();
    foreach ($DoArchive as $ReportId=>$V) { if ($V) $ReportIds[]=$ReportId;}
    foreach ($RPeriod as $ReportId=>$V) { if ($V&&!in_array($ReportId,$ReportIds)) $ReportIds[]=$ReportId;}
    $Query = "SELECT * FROM ?_static_report  WHERE ID IN (?) AND MODE IN (?)";
    if (!empty($ReportIds)) {
        $Sql = new Query($Query,false,$ReportIds, $nsProduct->LICENSE==4?'NATURAL': array('NATURAL', 'PAID'));
        while ($Row=$Sql->Row()) $ReportArr[$Row->ID]=$Row;
    }


    $CpArr=array();
    $Query = "SELECT ID FROM ?_client";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    foreach ($RPeriod as $ReportId => $P) {
        if (!empty($P)) {
            $Db->Query("DELETE FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD NOT IN (?)",$ReportId,$P);
            foreach ($P as $Tpl) {
                if ($Tpl==-1) continue;
                $Query="SELECT ID FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD=?";
                $PId=$Db->ReturnValue($Query,$ReportId,$Tpl);
                $RowCp=($ReportArr[$ReportId]->COMPANY_ID>0)?array(0=>$ReportArr[$ReportId]->COMPANY_ID):$CpArr;
                $PId=SetArchivePeriod($ReportArr[$ReportId],$RowCp,$Tpl,$PId);
            }
        }
        else $Db->Query("DELETE FROM ?_static_report_archive WHERE REPORT_ID=?",$ReportId);
    }
    
    $DeleteArr=array();
    foreach ($DoArchive as $ReportId=>$V) {
        if ($V!=1) {$DeleteArr[]=$ReportId;continue;}
        if (isset($RPeriod[$ReportId])) continue;
        $Query = "SELECT ID FROM ?_static_report_archive WHERE REPORT_ID=?";
        $CheckId=$Db->ReturnValue($Query,$ReportId);
        if ($CheckId) continue;
        $Query = "SELECT COMPANY_ID FROM ?_static_report WHERE ID=?";
        $CpId=$Db->ReturnValue($Query,$ReportId);
        $PArr=array();
        if ($CpId>0 && isset($Periods[$CpId])) $PArr=array_merge($Periods[0],$Periods[$CpId]);
        else $PArr=$Periods[0];
        $RowCp=($CpId>0)?array(0=>$CpId):$CpArr;
        foreach ($PArr as $Tpl) {
            $PId=SetArchivePeriod($ReportArr[$ReportId],$RowCp,$Tpl);      
        }
    }
    if (!empty($DeleteArr)) {
        $Db->Query("DELETE FROM ?_static_report_archive WHERE REPORT_ID IN (?)",$DeleteArr);
        foreach ($CpArr as $CpId) {
            $Db->Query("DELETE FROM ?_{$CpId}_static_archive_cache WHERE REPORT_ID IN (?)",$DeleteArr);
        }
    }
    
    if ($DisableForAll) {
        $Query = "SELECT ID FROM ?_static_report_archive WHERE PERIOD=?";
        $Sql = new Query($Query,false,$ToAll);
        $PeriodIds=array();
        while ($Row=$Sql->Row()) $PeriodIds[]=$Row->ID;
        if (!empty($PeriodIds)) {
            foreach ($CpArr as $CpId) {
                $Query = "DELETE FROM ?_{$CpId}_static_archive_cache WHERE PERIOD_ID IN (?)";
                $Db->Query($Query,$PeriodIds);
            }
        }
        $Query = "DELETE FROM ?_static_report_archive WHERE PERIOD=?";
        $Db->Query($Query,$ToAll);
    }
    
    if ($EnableForAll) {
        $Query = "SELECT * FROM ?_static_report";
        $Sql = new Query($Query);
        $ReportIds=array();
        while ($Row=$Sql->Row()) $ReportIds[$Row->ID]=$Row;
        foreach ($ReportIds as $ReportId=>$Row) {
            $Query="SELECT ID FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD=?";
            $PId=$Db->ReturnValue($Query,$ReportId,$EnableForAll);
            $PId=SetArchivePeriod($Row,$CpArr,$EnableForAll,$PId);      
        }
    }

    $nsProduct->Redir("archiving");    
}

?>