<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

/////////////////////////////////////////////
///////// require libraries here
require_once SELF."/lib/delete.func.php";
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/graph.class.php";
require_once SELF."/lib/reports/create_cache.func.php";
require_once SELF."/lib/delete/period.func.php";
require_once SELF."/lib/delete/delete.func.php";

/////////////////////////////////////////////
///////// prepare any variables
$PageTitle=$Lang['Title'];

$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$PageTitle;
$ProgPath[1]['Url']=getURL("base_stat", "", "admin");
$MenuSection="admin";

extract(VPack(array('DoOptimize','EndDate','DoClear','ForClient','SiteId','ClearCache','ClearArchive','CheckTables',
                                'RepairTables','RebuildCache','ClearReportStat','ClearAll','MustDie')));

$ClientStat=V($_REQUEST['ClientStat'],'all');

if ($RebuildCache&&!$nsUser->DEMO) DoRebuildCache();
$EndTime=false;
if ($EndDate) $EndTime=$EndDate." 23:59:59";

if (!$ForClient&&V($_GP['ForClient'])!="all"&&ValidId($CurrentCompany->ID)) $ForClient=$CurrentCompany->ID;

$ClArr=array();
$StatLogArr=array();
$ActionLogArr=array();
$SaleLogArr=array();
$SplitLogArr=array();
$ClickLogArr=array();
$CacheLogArr=array();

$ArchiveLogArr=array();
$EnableDeleteOptions=0;
$DeleteOptions=array();
$DeleteButtons=array();
$DelBtnNames=array('DeleteStat'=>'RemAllStat', 'PagesOnly'=>'RemPageViews', 'Ref'=>'RemReferers', 
                                    'Key'=>'RemKeywords', 'Vis'=>'RemVisitors', 'Addr'=>'RemPages', 'SItem'=>'RemProducts', 
                                    'AItem'=>'RemActionItems');
$FuncsRel=array('Ref'=>array('HostGroups'),'Vis'=>array('NamedVisitors','AgentGroups'),'Addr'=>array('PageGroups'));

$Now=gmdate("Y-m-d H:i:s", time());
$Query = "SELECT IF (STAMP < DATE_ADD(?, INTERVAL -24 HOUR), 1, 0) FROM ?_cron_log";
$CronEnabled=$Db->ReturnValue($Query,$Now);
$EnableDeleteOptions=false;

if ( !$CronEnabled || !$Settings['All']->DELETE_ENABLE) {
    $EnableDeleteOptions=true;
    $DeleteOptions=explode("|",$Settings['All']->DELETE_FUNCS);
    $SubOptions=explode("|",$Settings['All']->DELETE_SUB_FUNCS);    
    if (!in_array('KeepStat', $DeleteOptions) && !in_array('PagesOnly',$DeleteOptions)) $DeleteButtons[]='DeleteStat'; 
    if (!in_array('KeepStat',$DeleteOptions) && in_array('PagesOnly',$DeleteOptions)) $DeleteButtons[]='PagesOnly';
    if (in_array('Ref',$DeleteOptions)) $DeleteButtons[]='Ref';
    if (in_array('Key',$DeleteOptions)) $DeleteButtons[]='Key';
    if (in_array('Vis',$DeleteOptions)) $DeleteButtons[]='Vis';
    if (in_array('Addr',$DeleteOptions)) $DeleteButtons[]='Addr';
    if (in_array('SItem',$DeleteOptions)) $DeleteButtons[]='SItem';
    if (in_array('AItem',$DeleteOptions)) $DeleteButtons[]='AItem';
    if (empty($DeleteButtons)) $EnableDeleteOptions=false;
}


$Query = "SELECT C.ID, C.NAME, S.HOST, S.ID AS SITE_ID FROM ?_client C 
    INNER JOIN ?_site S ON S.COMPANY_ID=C.ID ORDER BY C.NAME";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
	if (!$nsUser->ADMIN&&$Row->ID!=$nsUser->COMPANY_ID) continue;
	if ($nsProduct->LICENSE==2&&$Row->ID!=$CurrentCompany->ID) continue;
	$ClArr[$Row->ID]['Name']=$Row->NAME;
	$ClArr[$Row->ID]['Sites'][$Row->SITE_ID]=$Row->HOST;

    if ($ClientStat!='all' && $Row->ID!=$ClientStat) continue;

	$StatLogArr[]=PFX."_tracker_{$Row->ID}_stat_log";
	$ActionLogArr[]=PFX."_tracker_{$Row->ID}_stat_action";
	$SaleLogArr[]=PFX."_tracker_{$Row->ID}_stat_sale";
	$SplitLogArr[]=PFX."_tracker_{$Row->ID}_stat_split";
	$ClickLogArr[]=PFX."_tracker_{$Row->ID}_stat_click";
    
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_cache";
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_cache_cron_log";
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_cache_populatiry";
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_cache_data";
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_cache_query_set";
    $CacheLogArr[]=PFX."_tracker_{$Row->ID}_static_report_cache";
    
    $ArchiveLogArr[]=PFX."_tracker_{$Row->ID}_static_archive_cache";
}

$ArchiveLogArr[]=PFX."_tracker_static_report_archive";
$ArchiveLogArr[]=PFX."_tracker_archive";


/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
	if ($DoOptimize) OptimizeTables();
    if ($ClearCache) ClearCache($ClientStat);
    if ($ClearArchive) ClearArchive($ClientStat);
    if ($ClearReportStat) ClearReportStat();
    if ($ClearAll && 
        (($nsProduct->LICENSE==2&&$nsUser->SUPER_USER) || 
        ($nsProduct->LICENSE==3&&$nsUser->SUPER_ADMIN))) {
            ClearAllStatistics();
            $nsProduct->Redir('base_stat');
        }
}

///////////////////////////////////////////////

if ($EnableDeleteOptions) {

    $Query = "SELECT * FROM ?_config WHERE SITE_ID=0";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $Settings[$Row->COMPANY_ID]=$Row;

    $MinDeleteDate=false;
    $MinStamp=false;

    $Query = "SELECT * FROM ?_client";
    $Sql = new Query($Query);
    $CpArr=array();
    $SelectArr=array(); $FromArr=array(); $SelectStr=""; $FromStr="";
    while ($Row=$Sql->Row()) {
        if ($Settings[$Row->ID]->DELETE_ENABLE==0) continue;
        $Row->ShowRemoveDate=false;
        $Row->KeepPeriodDate= false;
        $Row->DateRange = false;
        if ($Settings[$Row->ID]->DELETE_ENABLE==1) {
            $Row->KeepPeriodDate=GetKeepPeriodDate($Settings[$Row->ID]->DELETE_KEEP_PERIOD);
            $Row->ShowRemoveDate=true; 
        }
        if ($Settings[$Row->ID]->DELETE_ENABLE==4) {
            $Row->DateRange =  _date($Settings[$Row->ID]->DELETE_RANGE_START).' - '.
                                               _date($Settings[$Row->ID]->DELETE_RANGE_END);
            $Row->ShowRemoveDate=true; 
        }
        if ($Settings[0]->ARCHIVE_ENABLE) {
        $SelectArr[]="DATE_FORMAT(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE),'%Y-%m-%d') AS M{$Row->ID}";
        $SelectArr[]="UNIX_TIMESTAMP(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE)) AS U{$Row->ID}";
        $FromArr[]=PFX."_tracker_{$Row->ID}_static_archive_cache C{$Row->ID}";
        }
        $CpArr[]=$Row;
    }

    $MinStamp=time();
    $MinDeleteDate=false;

    if (!empty($SelectArr)) {
    $SelectStr=implode(", ",$SelectArr);
    $FromStr=implode(", ",$FromArr);
    $Query = "SELECT $SelectStr FROM $FromStr";
    $MinDates=$Db->Select($Query);
    foreach ($CpArr as $Row) {
        $CpId=$Row->ID;
        $U="U$CpId";
        $M="M$CpId";
        if ($MinDates->$U<$MinStamp) {
            $MinStamp=$MinDates->$U;
            $MinDeleteDate=$MinDates->$M;
        }
    }
    }


    $KeepPeriodDate=GetKeepPeriodDate($Settings[0]->DELETE_KEEP_PERIOD);
    $DateRange = $Settings[0]->DELETE_RANGE_START? _date($Settings[0]->DELETE_RANGE_START).' - '.
                                                                                         _date($Settings[0]->DELETE_RANGE_END): ''; 
    
    if ($MinDeleteDate) {
        $MinDeleteDateAlert=$Db->ReturnValue("SELECT IF (? < ?, 1, 0)", $MinDeleteDate, $KeepPeriodDate);
        $MinDeleteDate=($MinDeleteDateAlert)?$MinDeleteDate:$KeepPeriodDate;
    } else $MinDeleteDate=$KeepPeriodDate?$KeepPeriodDate:$DateRange;
    
    if (count($CpArr)==1) $CpArr=array();
    
    foreach ($CpArr as $i=>$Row) {

        if (!$Row->ShowRemoveDate && !$DateRange) {
            $Row->KeepPeriodDate=_date($MinDeleteDate);
            $Row->ShowRemoveDate=true;  
        }
        if (!$Row->ShowRemoveDate && $DateRange) {
            $Row->DateRange=$DateRange;
            $Row->ShowRemoveDate=true;  
        }

        $CpArr[$i]=$Row;
    }
    
    $MinDeleteDate=_date($MinDeleteDate);

}


/////////////////////////////////////////////
///////// display section here

$NeedsRepair=false;
if ($RepairTables) $CheckTables=1;
if ($CheckTables) {
    $Query = "SHOW TABLES";
    $Sql = new Query($Query,"ROW");
    $TableArr=array();
    while ($Row=$Sql->Row()) $TableArr[]=$Row[0];
    foreach ($TableArr as $Table) {
        if (strpos($Table,PFX."_tracker")===false) continue;
        $Query = "CHECK TABLE $Table";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) {
            $NeedsRepair=true; 
            if (strtolower($Row->Msg_text)=='ok' || strtolower($Row->Msg_text)=='table is already up to date') {
                $NeedsRepair=false;
                break;
            }
            if ($NeedsRepair && !$RepairTables) break(2);
        }
        if ($RepairTables&&$NeedsRepair) {
            $Query = "REPAIR TABLE $Table";
            $Db->Query($Query);          
            $NeedsRepair=false;      
        }
    }
}
if ($CheckTables && !$RepairTables && !$NeedsRepair) $Logs->Msg($Lang['NoDamage']);
if ($CheckTables && !$RepairTables && $NeedsRepair) $Logs->Err($Lang['TablesDamaged']);
if ($RepairTables) $Logs->Msg($Lang['Repaired']);

$Query = "SHOW TABLE STATUS";
$Sql = new Query($Query);

$TotalSize=0;
$TotalRows=0;
$TotalOverhead=0;
$TotalCache=0;
$TotalArchive=0;
$TotalSizeClient=0;
$TotalRowsClient=0;
$TotalReportStat=0;

$StatSize=0;
$ActionsSize=0;
$SalesSize=0;
$CampSize=0;
$PathSize=0;
$SplitSize=0;
$CacheSize=0;
$ArchiveSize=0;
$OtherSize=0;

$StatRows=0;
$ActionsRows=0;
$SalesRows=0;
$CampRows=0;
$PathRows=0;
$SplitRows=0;
$CacheRows=0;
$ArchiveRows=0;
$OtherRows=0;


while ($Row=$Sql->Row()) {
	$StatTable=false;
    $CacheTable=false;
    $ArchiveTable=false;
	if (strpos($Row->Name, PFX."_tracker")===false) continue;
    if ($Row->Name==PFX."_tracker_report_time_stat") $TotalReportStat=$Row->Data_length+$Row->Index_length;
    
	$TotalSize+=$Row->Data_length+$Row->Index_length;
	$TotalRows+=$Row->Rows;
	$TotalOverhead+=$Row->Data_free;

    if (in_array($Row->Name, $CacheLogArr)) {
        $CacheSize+=$Row->Data_length+$Row->Index_length;
        $CacheRows+=$Row->Rows;
        $CacheTable=true;
        if (strpos($Row->Name, "_cache_data")!==false) {
            $TotalCache+=$Row->Data_length+$Row->Index_length;
        }
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
    }
    
    if (in_array($Row->Name, $ArchiveLogArr)) {
        $ArchiveSize+=$Row->Data_length+$Row->Index_length;
        $ArchiveRows+=$Row->Rows;
        if ($Row->Name==PFX."_tracker_archive") $TotalArchive=$Row->Data_length+$Row->Index_length;
        if ($ClientStat=='all') $ArchiveTable=true;
    }

	if (in_array($Row->Name, $StatLogArr)) {
		$StatSize+=$Row->Data_length+$Row->Index_length;
		$StatRows+=$Row->Rows;
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
		$StatTable=true;
	}

	if (in_array($Row->Name, $ClickLogArr)) {
		$CampSize+=$Row->Data_length+$Row->Index_length;
		$CampRows+=$Row->Rows;
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
		$StatTable=true;
	}

	if (in_array($Row->Name, $SaleLogArr)) {
		$SalesSize+=$Row->Data_length+$Row->Index_length;
		$SalesRows+=$Row->Rows;
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
		$StatTable=true;
	}

	if (in_array($Row->Name, $ActionLogArr)) {
		$ActionsSize+=$Row->Data_length+$Row->Index_length;
		$ActionsRows+=$Row->Rows;
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
		$StatTable=true;
	}
	
	if (in_array($Row->Name, $SplitLogArr)) {
		$SplitSize+=$Row->Data_length+$Row->Index_length;
		$SplitRows+=$Row->Rows;
        $TotalSizeClient+=$Row->Data_length+$Row->Index_length;
        $TotalRowsClient+=$Row->Rows;
		$StatTable=true;
	}
	
	if (!$StatTable&&!$CacheTable&&!$ArchiveTable) {
		$OtherSize+=$Row->Data_length+$Row->Index_length;
		$OtherRows+=$Row->Rows;
	}
	
}

$SizePie=new StatGraph("SizePie");
$SizePie->Name=$Lang['SizeDiff'];
$SizePie->Display=true;
$SizePie->Vars['disp_type']="pie";
$SizePie->CanDump=true;

DrawPie($SizePie, $Lang['SitePath'], $StatSize, "330099", 0);
DrawPie($SizePie, $Lang['ActionStat'], $ActionsSize, "339933", 1);
if ($nsProduct->LICENSE !=4 ) DrawPie($SizePie, $Lang['SaleStat'], $SalesSize, "CC6600", 2);
if ($nsProduct->LICENSE !=4 ) DrawPie($SizePie, $Lang['SplitStat'], $SplitSize, "FF0099", 3);
if ($nsProduct->LICENSE !=4 ) DrawPie($SizePie, $Lang['CampStat'], $CampSize, "9999FF", 4);
DrawPie($SizePie, $Lang['TblCache'], $CacheSize, "33CC00", 6);
if ($ClientStat=='all' ) DrawPie($SizePie, $Lang['OtherTables'], $OtherSize, "FF0000", 7);


$MinTable=false;
$MaxTable=false;
$MinStamp=0;
$MaxStamp=0;
$MinId=0;
$MaxId=0;
for($i=0;$i<count($StatLogArr);$i++) {
	$Query = "SELECT MIN(ID) AS MIN_ID, MAX(ID) AS MAX_ID FROM $StatLogArr[$i]";
	$MM=$Db->Select($Query);
	if (ValidId($MM->MIN_ID)&&$MM->MIN_ID>0) {
		$MM->MIN_STAMP=$Db->ReturnValue("SELECT UNIX_TIMESTAMP(STAMP) FROM ".$StatLogArr[$i]." WHERE ID=?",$MM->MIN_ID);
		$MM->MAX_STAMP=$Db->ReturnValue("SELECT UNIX_TIMESTAMP(STAMP) FROM ".$StatLogArr[$i]." WHERE ID=?",$MM->MAX_ID);
		if ($MinStamp>$MM->MIN_STAMP||$MinStamp==0) {
			$MinStamp=$MM->MIN_STAMP;
			$MinTable=$StatLogArr[$i];
			$MinId=$MM->MIN_ID;
		}
		if ($MaxStamp<$MM->MAX_STAMP||$MaxStamp==0) {
			$MaxStamp=$MM->MAX_STAMP;
			$MaxTable=$StatLogArr[$i];
			$MaxId=$MM->MAX_ID;
		}
	}
}

$MinDays=$MaxDays=false;
if ($MinId&&$MaxId) {
	$MinStamp=_date($MinStamp);
	$MinDays=$Db->ReturnValue("SELECT TO_DAYS(STAMP) FROM $MinTable WHERE ID=?",$MinId);
	$MaxDays=$Db->ReturnValue("SELECT TO_DAYS(STAMP) FROM $MaxTable WHERE ID=?",$MaxId);
}
$DayCnt=$MaxDays-$MinDays;
if ($DayCnt>0) $AvgDaySize=round($TotalSize/$DayCnt, 2);
else $AvgDaySize=0;


include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here

function OptimizeTables()
{
	global $Logs, $Db, $Lang;
	$Query="SHOW TABLE STATUS";
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {
		if (strpos($Row->Name, PFX."_tracker")===false) continue;
		if ($Row->Data_free>0) $Db->Query("OPTIMIZE TABLE $Row->Name");
	}
	$Logs->Msg($Lang['SuccOptimize']);
}

function ClearCache($ClientId)
{
    global $Db,$Logs,$Lang;
    $Where=($ClientId!='all')?"WHERE ID=$ClientId":"";
    $Sql = new Query("SELECT ID FROM ?_client $Where");
    while ($Row=$Sql->Row()) $Db->Query("TRUNCATE TABLE ?_{$Row->ID}_cache_data");
    $Logs->Msg($Lang['CacheDeleted']);
}

function ClearArchive($ClientId)
{
    global $Db,$Logs,$Lang;
    $ids = array();
    $Query = "SELECT ID FROM ?_client";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $ids[]=$Row->ID;
    $Db->Query("DELETE FROM ?_archive");
    foreach ($ids as $CpId) {
        $Query = "DELETE FROM ?_{$CpId}_static_archive_cache";
        $Db->Query($Query);
    }
    $Query  = "DELETE FROM ?_static_report_archive";
    $Db->Query($Query);
    $Logs->Msg($Lang['ArchiveDeleted']);
}

function ClearReportStat()
{
    global $Db, $Logs, $Lang;
    $Query = "TRUNCATE TABLE ?_report_time_stat";
    $Db->Query($Query);
    $Logs->Msg($Lang['ReportStatDeleted']);    
}

/////////////////////////////////////////////
///////// library section

function DrawPie(&$Graph, $Name, $Size, $Color, $Inx)
{
	$Graph->Vars['piece'.$Inx.'_caption']=$Name;
	$Graph->Vars['piece'.$Inx.'_value']=$Size;
	$Graph->Vars['piece'.$Inx.'_color']=$Color;
	$Graph->Vars['piece'.$Inx.'_description']="";
}


function DoRebuildCache()
{
    global $nsProduct, $Logs, $Lang;
    RebuildCache();
    $Logs->Msg($Lang['RebuildCacheDone']);
    $nsProduct->Redir('base_stat');
}


?>