<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");


/////////////////////////////////////////////
///////// require libraries here
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/pagenums2.class.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/lib/company.func.php";
require_once SELF."/lib/delete.func.php";
require_once SELF."/lib/reports/static_report.func.php";

/////////////////////////////////////////////
///////// prepare any variables
$PageTitle=$Lang['Title'];

$nsLang->TplInc("inc/top_panel.inc");
$nsLang->TplInc('constructor/periods');
$MenuSection="admin";
$PlaceForPlus=false;


$EditId=V($_GP['EditId']);
$EditArr=V($_GP['EditArr']);
$EditArr2=V($_GP['EditArr2']);
$SortTo=V($_GP['SortTo']);
$HostId=V($_GP['HostId']);
$Templ=V($_GP['Templ']);
$Enable=V($_GP['Enable']);
$NewHost=V($_GP['NewHost']);
$Expand=V($_GP['Expand']);

$DeleteId=(ValidId($_GP['DeleteId']))?$_GP['DeleteId']:false;
$SortId=(ValidId($_GP['SortId']))?$_GP['SortId']:false;
$ShowHidden=(ValidId($_GP['ShowHidden']))?$_GP['ShowHidden']:false;
$DeletePage=(ValidId($_GP['DeletePage']))?$_GP['DeletePage']:false;
$DeleteHost=(ValidId($_GP['DeleteHost']))?$_GP['DeleteHost']:false;
$SiteId=(ValidId($_GP['SiteId']))?$_GP['SiteId']:false;
$DelSiteHost=(ValidId($_GP['DelSiteHost']))?$_GP['DelSiteHost']:false;
$UseHosts=V($_GP['UseHosts']);

$ChangeTracking=V($_GP['ChangeTracking']);
$DisableCacheSettings=false;

$ClientsCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_client");
$SitesCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_site");
$ShowExpand=-1;

if (ValidId($HostId)) {
	$EditHost=GetHost($HostId);
	$EditId=$EditHost->COMPANY_ID;
}
if (ValidId($EditId)) $EditCompany=GetCompany($EditId);


$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=($nsProduct->LICENSE==3&&$nsUser->ADMIN)?$Lang['Title']:$Lang['ClientTitle'];
$ProgPath[1]['Url']=getURL("company", ($nsProduct->LICENSE==3&&$nsUser->ADMIN)?"":"EditId=".$EditId, "admin");
if (ValidId($EditId)) {
	$ProgPath[2]['Name']=$EditCompany->NAME;
	$ProgPath[2]['Url']=getURL("company", "EditId=".$EditCompany->ID, "admin");
}


if (!$nsUser->ADMIN&&!$EditId) $nsProduct->Redir("no_permission", "", "error");
if ($nsUser->MERCHANT&&$EditId!=$nsUser->COMPANY_ID) $nsProduct->Redir("no_permission", "", "error");
if ($nsProduct->LICENSE!=3&&$EditId!=$CurrentCompany->ID) $nsProduct->Redir("no_permission", "", "error");

if ($EditId && $EditId!='new') {
$Settings=GetSettings($EditCompany->ID);
if (!$Settings['All']->CACHE_DYNAMIC_ENABLE) $DisableCacheSettings=true;
}

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {

	if (!$HostId&&ValidArr($EditArr)&&V($EditId)=="new") CreateCompany($EditArr);
	if (!$HostId&&ValidArr($EditArr)&&ValidId($EditId)) UpdateCompany($EditId, $EditArr);
	if (ValidId($DeleteId)) DeleteCompany($DeleteId);
	if (ValidId($DeleteHost)) DeleteHost($EditId, $DeleteHost);
	if ($HostId=="new"&&ValidArr($EditArr)) CreateNewHost($EditId, $EditArr);
	if (ValidId($HostId)&&!V($EditPage)&&!V($EditEvent)&&ValidArr($EditArr)) UpdateHost($HostId, $EditArr);
	if (ValidId($DelSiteHost)) DeleteSiteHost($DelSiteHost);
    if ($UseHosts && $HostId) UpdateUseHosts($HostId, $UseHosts); 
	if ($ChangeTracking&&$EditId&&($nsUser->ADMIN||$nsUser->SUPER_USER)&&$nsProduct->LICENSE==3) ChangeTracking($ChangeTracking,$EditId);

}
/////////////////////////////////////////////
///////// display section here



//// companies list
if (!$HostId&&!$EditId) {
	if (isset($ShowHidden)&&$ShowHidden==1) $Hidden="";
	else $Hidden="HIDDEN!='1'";
	$RecCount=$Db->CNT("?_client", $Hidden);
	$Pages=new PageNums($RecCount, 50);
	$Pages->Calculate();
	if ($Hidden) $Hidden="WHERE ".$Hidden;
	$Query = "SELECT *, UNIX_TIMESTAMP(MODIFIED) AS MODIFIED FROM ?_client $Hidden ORDER BY NAME ASC LIMIT $Pages->PageStart,$Pages->Limit";
	$Sql = new Query($Query);
	while ($Row = $Sql->Row()) {
		$Row->NAME=stripslashes($Row->NAME);
		$Row->DESCRIPTION=stripslashes($Row->DESCRIPTION);
		$ClientsArr[$Sql->Position]=$Row;
		$PrevRow=&$ClientsArr[$Sql->Position];
	}
	$SubMenu[0]['Name']=$Lang['AddNew'];
	$SubMenu[0]['Link']=getURL("company", "EditId=new");
	$SubMenu[1]['Name']=$Lang['ShowHidden'];
	$SubMenu[1]['Link']=getURL("company", "ShowHidden=1");
	include $nsTemplate->Inc("admin.company");
}

// edit company
if ($EditId && !$HostId) {
    
    if ($nsUser->ADMIN&&$nsProduct->LICENSE==3) {
        $SubMenu[0]['Name']=$Lang['BackToList'];
        $SubMenu[0]['Link']=getURL("company");
    }
    
    $Periods=array();
    $Query = "SELECT * FROM ?_periods WHERE COMPANY_ID=0";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $Row->NAME=V($Row->NAME,V($Lang[$Row->TEMPLATE],$Row->TEMPLATE));
        $Periods[$Row->TEMPLATE]=$Row->NAME; 
    }

    if ($EditId!='new') {
        $CSitesCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_site WHERE COMPANY_ID=?",$EditId);
        if ($CSitesCnt==0) $Consult->CurrentHelp="no_site";
        $PageTitle=stripslashes($EditCompany->NAME);
        $EditCompany->NAME=stripslashes(htmlspecialchars($EditCompany->NAME));
        $EditCompany->DESCRIPTION=stripslashes(htmlspecialchars($EditCompany->DESCRIPTION));
        $TableCaption=$Lang['CaptionEdit'].$EditCompany->NAME;        
        $HostsArr=GetHostsList($EditCompany->ID);

        if ($SitesCnt<$nsProduct->MAX_SITES && (($EditCompany->MAX_SITES>0 && $CSitesCnt<$EditCompany->MAX_SITES)||$EditCompany->MAX_SITES==0) ) {
            $SubMenu[1]['Name']=$Lang['AddNewHost'];
            $SubMenu[1]['Link']=getURL("company", "HostId=new&EditId=$EditId");
        }
        $SubMenu[2]['Name']=$Lang['Stat'];
        $SubMenu[2]['Link']=getURL("natural_constructor", "CpId=$EditId", "report");   
        $EditArr['Watch']=(CheckCompWatch($EditCompany->ID, $nsUser->UserId()))?1:0;     
    }
    else {
        $TableCaption=$Lang['CaptionNew'];
        $EditArr['Watch']=V($EditArr['Watch']);
    }
    
    $EditArr['Name']=V($EditArr['Name'],V($EditCompany->NAME));
    $EditArr['Hidden']=V($EditArr['Hidden'],V($EditCompany->HIDDEN));
    $EditArr['Descr']=V($EditArr['Descr'],V($EditCompany->DESCRIPTION));
    $EditArr['Currency']=V($EditArr['Currency'],V($EditCompany->CURRENCY));
    $EditArr['CurrencyPos']=V($EditArr['CurrencyPos'],V($EditCompany->CURRENCY_POSITION,0));
    $EditArr['MaxSites']=V($EditArr['MaxSites'],V($EditCompany->MAX_SITES,0));
    $EditArr['AllowPhp']=V($EditArr['AllowPhp'],V($EditCompany->ALLOW_PHP_TRACKING,0));
    $EditArr['CacheEnableDynamic']=V($EditArr['CacheEnableDynamic'],V($Settings['Client']->CACHE_DYNAMIC_ENABLE,0));
    $EditArr['DisableConstructor']=V($EditArr['DisableConstructor'],V($EditCompany->DISABLE_CONSTRUCTOR,0));
    $EditArr['TZ']=V($EditArr['TZ'],V($Settings['Client']->TIMEZONE,0));
    $EditArr['Delayed']=V($EditArr['Delayed'],V($Settings['Client']->DELAYED_TRACKING,0));        
    $EditArr['DefPeriod']=V($EditArr['DefPeriod'],V($Settings['Client']->DEFAULT_PERIOD));

    include $nsTemplate->Inc("admin.company_edit");
}


//// new host
if ($HostId=="new") {
	$PageTitle=stripslashes($EditCompany->NAME);
	$TableCaption=$Lang['CaptionNew'];
	if (!ValidArr($EditArr)) {
		$EditArr['Host']="";
		$EditArr['UseHosts']=0;
		$EditArr['Watch']=0;
		$EditArr['ShowTitles']=0;
		$EditArr['CookieDomain']='';
        $EditArr['TextId']='';
	}
	else {
		if (!V($EditArr['UseHosts'])) $EditArr['UseHosts']=0;
		if (!V($EditArr['Watch'])) $EditArr['Watch']=0;
		if (!V($EditArr['ShowTitles'])) $EditArr['ShowTitles']=0;
	}
	$SubMenu[0]['Name']=$Lang['BackToEdit'];
	$SubMenu[0]['Link']=getURL("company", "EditId=$EditId");
	if ($nsUser->ADMIN&&$nsProduct->LICENSE==3) {
		$SubMenu[1]['Name']=$Lang['BackToList'];
		$SubMenu[1]['Link']=getURL("company");
	}
    $PageGrpArr=array();
    $PagesArr=array();

	include $nsTemplate->Inc("admin.host_edit");
}

//// edit host
if (ValidId($HostId)&&ValidId($EditId)&&!$EditPage) {
	$PageTitle=stripslashes($EditCompany->NAME);
	$EditSet=$Db->Select("SELECT * FROM ?_config WHERE SITE_ID=?",false,$EditHost->ID);

	$TableCaption=$Lang['CaptionEdit'].$EditHost->HOST;
	if (!V($EditArr['Host'])) $EditArr['Host']=$EditHost->HOST;
	if (!V($EditArr['UseHosts'])) $EditArr['UseHosts']=$EditHost->USE_HOSTS;
	if (!V($EditArr['CookieDomain'])) $EditArr['CookieDomain']=$EditHost->COOKIE_DOMAIN;
    if (!V($EditArr['ShowTitles'])) $EditArr['ShowTitles']=$EditSet->SHOW_PAGE_TITLE;
    $EditArr['TextId']=V($EditArr['TextId'],V($EditHost->TEXT_ID));
	$EditArr['Watch']=(CheckSiteWatch($HostId, $nsUser->UserId()))?1:0;
	$EventCaption=$Lang['CaptionEdit'];
	$EditArr['Host']=htmlspecialchars(stripslashes($EditArr['Host']));
	$SubMenu[0]['Name']=$Lang['BackToEdit'];
	$SubMenu[0]['Link']=getURL("company", "EditId=$EditId");
	if ($nsUser->ADMIN&&$nsProduct->LICENSE==3) {
		$SubMenu[1]['Name']=$Lang['BackToList'];
		$SubMenu[1]['Link']=getURL("company");
	}

	include $nsTemplate->Inc("admin.host_edit");
}


/////////////////////////////////////////////
///////// process functions here


function CreateNewHost($CompId, $Arr)
{
	global $Db, $nsProduct, $Logs, $Lang, $SitesCnt,$nsUser;
	if ($SitesCnt>=$nsProduct->MAX_SITES) {
		$Logs->Err($Lang['StCntExceed']);
		return false;
	}
	$CSiteCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_site WHERE COMPANY_ID=?",$CompId);
	$MaxCSiteCnt=$Db->ReturnValue("SELECT MAX_SITES FROM ?_client WHERE ID=?",$CompId);
	if ($MaxCSiteCnt > 0 && $nsProduct->LICENSE==3 && $CSiteCnt >= $MaxCSiteCnt) {
		$Logs->Err($Lang['StCntExceed']);
		return false;
	}
	extract($Arr);
	if (!V($UseHosts)) $UseHosts=0;
	if (!V($ShowTitles)) $ShowTitles=0;
    $TextId=V($TextId,"");
    if ($TextId&&CheckTextId($TextId,'new')) {$Logs->Err($Lang['TextIdErr']); return false;}
	if(!$Host) $ErrArr['Host']=$Lang['MustFill'];
	$Host=ToLower(trim($Host));
	$Check=@parse_url($Host);
	if (ValidArr($Check)&&V($Check['scheme'])) {
		$Host=str_replace($Check['scheme']."://", "", $Host);
	}
	if (isset($ErrArr)) {$Logs->Msg($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}

	$Query = "INSERT INTO ?_site (COMPANY_ID, USE_HOSTS, HOST, COOKIE_DOMAIN, TEXT_ID) VALUES (?, ?, ?, ?, ?)";
	$Db->Query($Query, $CompId, $UseHosts, $Host, $CookieDomain, $TextId);
	$SiteId=$Db->LastInsertId;
	$Query = "INSERT INTO ?_config 
        (COMPANY_ID, SITE_ID, KEEP_VISITOR_PATH, KEEP_NO_REF, SHOW_PAGE_TITLE) 
        VALUES (?, ?, '2', '2', ?)";
	$Db->Query($Query,$CompId,$SiteId,$ShowTitles);

	CreateNewSiteHost($SiteId, $Host, true);
	$Query = "INSERT INTO ?_site_page (SITE_ID, PATH) VALUES (?, '/')";
	$Db->Query($Query, $SiteId);
    
    $Cache= new nsQueryCache($CompId);
    $Cache->Mode="NATURAL";
    $Cache->QueryParams=array("SiteId"=>$SiteId, "DynamicPeriod"=>"0-d-0");
    $Cache->CreateCacheRecord(1);
    $Cache->SetCacheType(2);

    $Cache= new nsQueryCache($CompId);
    $Cache->Mode="PAID";
    $Cache->QueryParams=array("SiteId"=>$SiteId, "DynamicPeriod"=>"0-d-0");
    $Cache->CreateCacheRecord(1);
    $Cache->SetCacheType(2);
    
	if ($UseHosts==1) $nsProduct->Redir("company", "EditId=$CompId&HostId=$SiteId&RCrt=1"); 
	else $nsProduct->Redir("company", "EditId=$CompId&RCrt=1");
}

function UpdateHost($Id, $Arr)
{
	global $Db, $nsProduct, $Logs, $Lang, $EditId, $nsUser, $NewHost, $Enable;
	extract($Arr);
	if (V($UseHosts)!=1) $UseHosts=0;
	if (!V($ShowTitles)) $ShowTitles=0;
	if(!$Host) $ErrArr['Host']=$Lang['MustFill'];
    $TextId=V($TextId,"");
    if ($TextId&&CheckTextId($TextId,$Id)) {$Logs->Err($Lang['TextIdErr']); return false;}
	$Host=ToLower(trim($Host));
	$Check=@parse_url($Host);
	if (ValidArr($Check)&&V($Check['scheme'])) {
		$Host=str_replace($Check['scheme']."://", "", $Host);
	}
	if (isset($ErrArr)) {$Logs->Msg($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
	$Query = "UPDATE ?_site SET HOST = ?, USE_HOSTS=?, COOKIE_DOMAIN=?, TEXT_ID=? WHERE ID = ?";
	$Db->Query($Query, $Host, $UseHosts, $CookieDomain,$TextId, $Id);
    $Query = "UPDATE ?_config SET SHOW_PAGE_TITLE=? WHERE SITE_ID=?";
    $Db->Query($Query, $ShowTitles, $Id);
    
    if (V($NewHost)) CreateNewSiteHost($Id, $NewHost, true);
    if (ValidArr($Enable)&&$UseHosts) SetEnable($Enable, true); 
    
	$CheckId=CheckSiteWatch($Id, $nsUser->UserId());
	$SiteWatch=ValidId($CheckId);
	if (V($Watch)==1&&!$SiteWatch) SetSiteWatch($Id, $nsUser->UserId());
	if (V($Watch)!=1&&$SiteWatch)  RemoveSiteWatch($Id, $nsUser->UserId());
	$nsProduct->Redir("company", "EditId=$EditId&HostId=$Id&RUpd=1");	
}

function CheckTextId($TextId, $SiteId)
{
    global $Db;
    return $Db->ReturnValue("SELECT ID FROM ?_site WHERE TEXT_ID=? AND ID!=?",$TextId,$SiteId);
}

function CreateCompany($Arr)
{
	global $Db, $nsProduct, $Logs, $Lang, $ClientsCnt, $nsUser;
	extract($Arr);
	if(!$Name) $ErrArr['Name']=$Lang['MustFill'];
	if (!isset($Hidden)) $Hidden=0;
	if (!isset($AllowPhp)) $AllowPhp=0;
	if (!V($MaxSites)) $MaxSites="0";
    if (!V($CacheEnableDynamic)) $CacheEnableDynamic="0";
    $CacheEnableDynamic=!$CacheEnableDynamic;
    if (!V($DisableConstructor)) $DisableConstructor="0";
    $TZ=V($TZ, "0");
    $DefPeriod=V($DefPeriod,'');
    $Delayed=V($Delayed,0);
	if (isset($ErrArr)) {$Logs->Msg($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
	$Query = "INSERT INTO ?_client (HIDDEN, NAME, DESCRIPTION, CURRENCY, CURRENCY_POSITION, DISABLE_CONSTRUCTOR) VALUES (?, ?, ?, ?, ?, ?)";
	$Db->Query($Query, $Hidden, $Name, $Descr, $Currency, $CurrencyPos, $DisableConstructor);
	$NewId=$Db->LastInsertId;
	if ($nsProduct->LICENSE==3 && $nsUser->ADMIN) {	
		$Query = "UPDATE ?_client SET MAX_SITES = ?, ALLOW_PHP_TRACKING = ? WHERE ID = ?";
		$Db->Query($Query, $MaxSites, $AllowPhp, $NewId);
	}
	$Query = "INSERT INTO ?_config (COMPANY_ID, SITE_ID, KEEP_VISITOR_PATH, 
                                KEEP_NO_REF, CACHE_DYNAMIC_ENABLE, TIMEZONE, DELETE_ENABLE, DELAYED_TRACKING,
                                DEFAULT_PERIOD) 
                                VALUES (?,?,?,?,?,?,?,?,?)";
	$Db->Query($Query, $NewId, '0', '2', '2', $CacheEnableDynamic,$TZ,'3',$Delayed,$DefPeriod);
	CreateStatTables($NewId);

    $Cache= new nsQueryCache($NewId);
    $Cache->Mode="NATURAL";
    $Cache->QueryParams=array("DynamicPeriod"=>"0-d-0");
    $Cache->CreateCacheRecord(1);
    $Cache->SetCacheType(2);

    $Cache= new nsQueryCache($NewId);
    $Cache->Mode="PAID";
    $Cache->QueryParams=array("DynamicPeriod"=>"0-d-0");
    $Cache->CreateCacheRecord(1);
    $Cache->SetCacheType(2);

    CreateAllSystemReports($NewId);
    CreateHiddenReports($NewId);
    ReCreateArchives(array(0=>$NewId), false,false,true);
	$nsProduct->Redir("company", "RCrt=1&EditId=$NewId");
}

function UpdateCompany($Id, $Arr) 
{
	global $Db, $nsProduct, $Logs, $Lang, $nsUser, $DisableCacheSettings, $Settings;
	extract($Arr);
	if(!$Name) $ErrArr['Name']=$Lang['MustFill'];
	if (!isset($Hidden)) $Hidden=0;
	if (!isset($AllowPhp)) $AllowPhp=0;
	if (!V($MaxSites)) $MaxSites="0";
    if (!V($CacheEnableDynamic)) $CacheEnableDynamic="0";
    $CacheEnableDynamic=!$CacheEnableDynamic;    
    if (!V($DisableConstructor)) $DisableConstructor="0";
    $DefPeriod=V($DefPeriod,'');
    
    $EditCompany=$Db->Select("SELECT * FROM ?_client WHERE ID=?", false, $Id);
    if ($DisableCacheSettings) {
        $CacheEnableDynamic=$Settings['Client']->CACHE_DYNAMIC_ENABLE;
        $DisableConstructor=$EditCompany->DISABLE_CONSTRUCTOR;
    }
    if ($nsProduct->LICENSE==2) $CacheEnableDynamic=1;
    
    $TZ=V($TZ, "0");
    $Delayed=V($Delayed,0);
	if (isset($ErrArr)) {$Logs->Msg($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
    $Query = "UPDATE ?_client SET ?%upd WHERE ID = ?id";
    $Db->Query($Query, 
            array('upd'=>array("NAME"=>$Name,"DESCRIPTION"=>$Descr,"HIDDEN"=>$Hidden,"CURRENCY"=>$Currency,
                                            "CURRENCY_POSITION"=>$CurrencyPos,"DISABLE_CONSTRUCTOR"=>$DisableConstructor),
                     'id'=>$Id));
	if ($nsProduct->LICENSE==3 && $nsUser->ADMIN) {	
		$Query = "UPDATE ?_client SET MAX_SITES = ?, ALLOW_PHP_TRACKING = ? WHERE ID = ?";
		$Db->Query($Query, $MaxSites, $AllowPhp, $Id);
	}


    $Query = "SELECT ID FROM ?_static_report LIMIT 1";
    $CheckId=$Db->ReturnValue($Query);  
    $Settings=GetSettings($Id);
    if ($CacheEnableDynamic && !$Settings['Client']->CACHE_DYNAMIC_ENABLE) {
        //if ($CheckId) UpdateStaticReportTime($Id);
        CreateHiddenReports($Id);
    }
    if (!$CheckId) CreateAllSystemReports();

    $Query = "UPDATE ?_config SET CACHE_DYNAMIC_ENABLE = ?, TIMEZONE=?, DELAYED_TRACKING=?,
                    DEFAULT_PERIOD=? 
                    WHERE COMPANY_ID=?";
    $Db->Query($Query, $CacheEnableDynamic, $TZ, $Delayed, $DefPeriod, $Id);

	if (V($Watch)&&!CheckCompWatch($Id, $nsUser->UserId())) SetCompWatch($Id, $nsUser->UserId());
	if (!V($Watch)) RemoveCompWatch($Id, $nsUser->UserId());

	if ($nsUser->ADMIN) $nsProduct->Redir("company", "RUpd=1");
	if ($nsUser->MERCHANT) $nsProduct->Redir("company", "RUpd=1&EditId=$Id");
}


function UpdateStaticReportTime($CpId)
{
    global $Db;
    $Query = "
        SELECT SR.*, P.ID AS PERIOD_ID 
        FROM ?_static_report SR
            INNER JOIN ?_static_report_periods P
                ON P.REPORT_ID=SR.ID 
        WHERE SR.COMPANY_ID=?";
    $Sql = new Query($Query, false, $CpId);
    $Arr=array();
    while ($Row=$Sql->Row()) $Arr[]=$Row;
    
    foreach ($Arr as $Row) {
        SetUpdateTime($Row->ID, $Row->PERIOD_ID,NextUpdateTime($CpId,$Row->ID,$Row->PERIOD_ID));
    }
}

function UpdateUseHosts($Id,$Use)
{
    if ($Use==-1) $Use=0;
    global $Db;
    $Query = "UPDATE ?_site SET USE_HOSTS=? WHERE ID=?";
    $Db->Query($Query, $Use, $Id);
}



function SetSiteWatch($SiteId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (SITE_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $SiteId, $UserId);
}

function RemoveSiteWatch($SiteId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE SITE_ID=? AND USER_ID=?";
	$Db->Query($Query, $SiteId, $UserId);
}


function CheckSiteWatch($SiteId, $UserId)
{
	global $Db;
	$Query = "SELECT ID FROM ?_watch WHERE SITE_ID=? AND USER_ID=?";
	return $Db->ReturnValue($Query, $SiteId, $UserId);
}




function SetCompWatch($CompId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (COMPANY_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $CompId, $UserId);
}

function RemoveCompWatch($CompId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE COMPANY_ID=? AND USER_ID=?";
	$Db->Query($Query, $CompId, $UserId);
}


function CheckCompWatch($CompId, $UserId)
{
	global $Db;
	$Query = "SELECT ID FROM ?_watch WHERE COMPANY_ID=? AND USER_ID=?";
	return $Db->ReturnValue($Query, $CompId, $UserId);
}


function CreateNewSiteHost($SiteId, $Host, $NoRedir=false)
{
	global $Db, $EditId, $nsProduct;
	$Host=ToLower(trim($Host));
	$Check=array();
	$Check=@parse_url($Host);
	if (ValidArr($Check)&&V($Check['scheme'])) {
		$Host=str_replace($Check['scheme']."://", "", $Host);
	}
	$CheckId=$Db->ReturnValue("SELECT ID FROM ?_site_host WHERE SITE_ID=? AND HOST = ?", $SiteId, $Host);
	if (!$CheckId) {
		$Query = "INSERT INTO ?_site_host (SITE_ID, HOST, ENABLED) VALUES (?, ?, '1')";
		$Db->Query($Query, $SiteId, $Host);
	}
	if (!$NoRedir) $nsProduct->Redir("company", "RCrt=1&EditId=$EditId&HostId=$SiteId");
}

function SetEnable($Arr, $NoRedir=false)
{
	global $Db, $EditId, $HostId, $nsProduct;
	foreach ($Arr as $SHost => $Enable) {
		if ($Enable!=1&&$Enable!=0) continue;
		$Query = "UPDATE ?_site_host SET ENABLED = ? WHERE ID = ?";
		$Db->Query($Query, $Enable, $SHost);
	}
	if (!$NoRedir) $nsProduct->Redir("company", "EditId=$EditId&HostId=$HostId&RUpd=1");
}

function DeleteSiteHost($Id)
{
	global $Db, $EditId, $HostId, $nsProduct;
	$SiteId=$Db->ReturnValue("SELECT SITE_ID FROM ?_site_host WHERE ID = ?", $Id);
	$Query = "DELETE FROM ?_site_host WHERE ID = ?";
	$Db->Query($Query, $Id);
    $Query = "DELETE FROM ?_page_query WHERE SITE_HOST_ID = ?";
    $Db->Query($Query, $Id);
	DeleteSiteHostStat($EditId, $SiteId, $Id);
	$nsProduct->Redir("company", "RDlt=1&EditId=$EditId&Expand=$SiteId");
}

/////////////////////////////////////////////
///////// free section


function ChangeTracking($Mode,$CpId)
{
	global $Db, $nsProduct;
	if ($Mode==-1) $Mode=0;
	$Query = "UPDATE ?_config SET STOP_TRACKING = ? WHERE COMPANY_ID=? AND SITE_ID=0";
	$Db->Query($Query,$Mode, $CpId);
    $nsProduct->Redir("company", "EditId=$CpId");

}

?>