<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

/////////////////////////////////////////////
///////// prepare any variables

$PageTitle=$Lang['Title'];

$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$PageTitle;
$ProgPath[1]['Url']=getURL("ip_ignore", "", "admin");
$MenuSection="admin";


$NewIp=trim(V($_REQUEST['NewIp']));
$NewIpDescr=V($_REQUEST['NewIpDescr']);
$NewIpClient=V($_REQUEST['NewIpClient']);
if ($NewIp&&!ValidIP($NewIp) && !ValidIpTempl($NewIp)) {
	$Logs->Err($Lang['WrongIp']);
	$NewIp=false;
}

$RemoveIP=V($_GP['RemoveIP']);
if (!ValidArr($RemoveIp)) $RemoveIp=false;

$MyIP=$_SERVER['REMOTE_ADDR'];

$CompanyList = array();
$Query = "SELECT * FROM ?_client ORDER BY NAME ASC";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    $CompanyList[$Row->ID]=$Row;
}

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
	if ($NewIp && ValidIp($NewIp)) AddNewIp($NewIp, $NewIpDescr, $NewIpClient);
	if ($NewIp && ValidIpTempl($NewIp)) AddNewIpTempl($NewIp, $NewIpDescr);
	if ($RemoveIP) RemoveIp($RemoveIP);
}

/////////////////////////////////////////////
///////// display section here

$IpList=array();
$Query = "SELECT * FROM ?_ip WHERE IGNORED = '1' ORDER BY IP ASC";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
	$Row->TEMPLATE=false;
    $Row->COMPANY_ID=false;
    $Row->ID = $Row->IP;
	$IpList[0][]=$Row;
}
$Query = "SELECT * FROM ?_ip_ignore ORDER BY IF(COMPANY_ID>0, 1, 0) ASC, TEMPLATE ASC";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
	if (!$Row->IP) $Row->IP = $Row->TEMPLATE;
	$IpList[$Row->COMPANY_ID][]=$Row;
}


include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here

function AddNewIp($IP, $Descr=false, $ClientId=false) {
	global $Db, $nsProduct;
	if (!$Descr) $Descr="";
    if (!$ClientId) {
    	$Query = "SELECT ID FROM ?_ip WHERE IP='$IP'";
    	$CheckId=$Db->ReturnValue($Query);
    	if ($CheckId) $Query = "UPDATE ?_ip SET IGNORED='1', DESCRIPTION=? WHERE ID = $CheckId";
    	else $Query = "INSERT INTO ?_ip (IP, IGNORED, DESCRIPTION) VALUES ('$IP', '1', ?)";
    	$Db->Query($Query, $Descr);
    } 
    else {
        $Query = "SELECT ID FROM ?_ip_ignore WHERE IP = ? ";
        $CheckId=$Db->ReturnValue($Query, $IP);
        if ($CheckId) return false;
        $Query = "INSERT INTO ?_ip_ignore (IP, DESCRIPTION, COMPANY_ID) VALUES (?,?,?)";
        $Db->Query($Query, $IP, $Descr, $ClientId);
    }
	$nsProduct->Redir("ip_ignore", "RCrt=1", "admin");
}

function AddNewIpTempl($IP, $Descr=false) {
	global $Db, $nsProduct;
	global $Lang, $Logs;
	if (!$Descr) $Descr="";

	$Query = "SELECT ID FROM ?_ip_ignore WHERE TEMPLATE = ? ";
	$CheckId=$Db->ReturnValue($Query, $IP);
	if ($CheckId) return false;

	$Arr=explode(".", $IP);
	$t=0;
	foreach ($Arr as $i=>$s) {
		if ($t!=2 && $s=="*") $t=1;
		if ($t==1 && $s!="*") $t=2;
		if ($t==2 && $s=="*") {
			$Logs->Err($Lang['WrongIp']);
			return;
		}
	}
	$StartIp=trim(sprintf("%u\n", ip2long(str_replace("*", "0", implode(".", $Arr)))));
	$EndIp=trim(sprintf("%u\n", ip2long(str_replace("*", "255", implode(".", $Arr)))));

	$Query = "INSERT INTO ?_ip_ignore (TEMPLATE, START_INT, END_INT, DESCRIPTION) VALUES (?, ?, ?, ?)";
	$Db->Query($Query, $IP, $StartIp, $EndIp, $Descr);

	$nsProduct->Redir("ip_ignore", "RCrt=1", "admin");
}

function RemoveIp($Arr) {
	global $Db, $nsProduct;
	foreach ($Arr as $IP => $Value) {
		if ($Value!=1) continue;
        if ( strval(intval($IP)) == $IP ) {
            $Query = "DELETE FROM  ?_ip_ignore WHERE ID = ?";
            $Db->Query($Query, $IP);
        }
        else {
            $Query = "UPDATE ?_ip SET IGNORED='0' WHERE IP = ?";
            $Db->Query($Query, $IP);            
        }
	}
	$nsProduct->Redir("ip_ignore", "RUpd=1", "admin");
}

/////////////////////////////////////////////
///////// library section
?>