<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

/////////////////////////////////////////////
///////// require libraries here

require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/reports/misc.func.php";

/////////////////////////////////////////////
///////// prepare any variables


$EditId=ValidVar($_GP['EditId'], "new");
$EditArr=ValidVar($_GP['EditArr']);
$FormClicked=ValidVar($_GP['FormClicked']);
$DeleteId=ValidVar($_GP['DeleteId']);

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("constructor/periods");

$ProgPath[0]['Name']=$Lang['MSettings'];
$ProgPath[0]['Url']=getURL("settings", "CpId=$CpId", "admin");
$ProgPath[1]['Name']=$PageTitle;
$ProgPath[1]['Url']=getURL("periods", "CpId=$CpId", "admin");
$MenuSection="settings";

if (!$CpId) $CpId=$CurrentCompany->ID;

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
    if ($FormClicked) UpdateTemplate($EditId, $EditArr);
    if ($DeleteId) DeleteTemplate($DeleteId);  
}

/////////////////////////////////////////////
///////// display section here


if ($EditId=="new") {
    $EditArr['Name']=ValidVar($EditArr['Name']);
    $EditArr['Num']=ValidVar($EditArr['Num'], $FormClicked?"0":"1");
    $EditArr['Period']=ValidVar($EditArr['Period'], "d");
    $EditArr['Mode']=ValidVar($EditArr['Mode']);
    $Caption=$Lang['NewTemplate'];
}

if (ValidId($EditId) && $EditId>0) {
    $Caption=$Lang['EditTemplate'];
    $Query = "SELECT * FROM ?_periods WHERE ID = ?";
    $Period=$Db->Select($Query, false, $EditId);
    $EditArr['Name']=$Period->NAME;
    $Tmp=explode("-", $Period->TEMPLATE);
    $EditArr['Num']=$Tmp[0];
    $EditArr['Period']=$Tmp[1];
    $EditArr['Mode']=$Tmp[2];
}

if ($EditId=="new" && !$FormClicked){
    $SubMenu[0]['Name']=$Lang['NewTemplate'];
    $SubMenu[0]['Link']="javascript:;";
    $SubMenu[0]['Onclick']="ShowForm();";
}



$TmplArr=array();
$Query = "SELECT * FROM ?_periods WHERE DELETED='0' AND COMPANY_ID IN (0, ?) ORDER BY TEMPLATE";
$Sql = new Query($Query, false, $CpId);
while ($Row=$Sql->Row()) {
    if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
    $Arr=explode("-",$Row->TEMPLATE);
    $Row->Num=$Arr[0];
    $Row->Period=$Arr[1];
    $Row->Mode=$Arr[2];
    $TmplArr[$Row->TEMPLATE]=$Row;
}
$PArr=array_keys($TmplArr);
usort($PArr,"SortPeriods");
$TmplArr=SyncKeysWValues($TmplArr,$PArr);    




include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here


function UpdateTemplate($Id, $Arr)
{
    global $Db, $Lang, $Logs, $nsProduct, $CpId;
    if ($Arr['Num']=="" || intval($Arr['Num'])!=$Arr['Num'] || intval($Arr['Num'])<0 ) {$Logs->Err($Lang['ChoosePeriod']); return;}
    if (!$Arr['Name']) {$Logs->Err($Lang['ChooseName']); return;}

    $Arr['Mode']=ValidVar($Arr['Mode'],0);

    $Templ=$Arr['Num']."-".$Arr['Period']."-".$Arr['Mode'];
    $Query = "SELECT ID FROM ?_periods WHERE TEMPLATE = ? AND COMPANY_ID = ? AND DELETED = '1' ";
    $CheckId=$Db->ReturnValue($Query, $Templ, $CpId);
    if ($CheckId) {
        $Id=$CheckId;
        $Query = "UPDATE ?_periods SET DELETED='0' WHERE ID = ?";
        $Db->Query($Query, $Id);
    }
    else {
        $Query = "SELECT ID FROM ?_periods WHERE TEMPLATE = ? AND COMPANY_ID IN (0, ?) AND ID!=?";
        $CheckId=$Db->ReturnValue($Query, $Templ, $CpId, $Id);
        if ($CheckId) return $Logs->Err($Lang['TemplExists']);
    }

    if ($Id=="new") $Query = "INSERT INTO ?_periods (COMPANY_ID, NAME, TEMPLATE) VALUES ($CpId, ?, ?)";
    if ($Id!="new") {
        $OldTempl=$Db->ReturnValue("SELECT TEMPLATE FROM ?_periods WHERE ID=?", $Id);
        if ($OldTempl!=$Templ) UpdatePeriodsTime($Templ, $OldTempl);
        $Query = "UPDATE ?_periods SET COMPANY_ID=$CpId, NAME=?, TEMPLATE=? WHERE ID=$Id AND SYSTEM_TEMPLATE!='1' ";  
    }
    $Db->Query($Query, $Arr['Name'], $Templ);

    $nsProduct->Redir("periods", "CpId=$CpId&RUpd=1", "admin");
}


function UpdatePeriodsTime($Templ, $OldTempl)
{
    global $Db, $CpId;
    $Query = "SELECT * FROM ?_static_report_periods WHERE PERIOD=? ORDER BY PERIOD";
    $Sql = new Query($Query, false, $OldTempl);
    $Periods=array();
    while ($Row=$Sql->Row()) $Periods[]=$Row;
    
    foreach ($Periods as $Row) {
        $Query = "UPDATE ?_static_report_periods SET PERIOD=? WHERE ID=?";
        $Db->Query($Query, $Templ, $Row->ID);
        SetUpdateTime($Row->REPORT_ID,$Row->ID,NextUpdateTime($CpId,$Row->REPORT_ID,$Row->ID));
    }
}

function DeleteTemplate($Id)
{
    global $Db, $nsProduct;
    $Query = "UPDATE ?_periods SET DELETED='1' WHERE ID = ? AND SYSTEM_TEMPLATE!='1' ";
    $Db->Query($Query, $Id);
    $nsProduct->Redir("periods", "RDlt=1");
}


/////////////////////////////////////////////
///////// library section


?>