<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

/////////////////////////////////////////////
///////// require libraries here
require_once SELF."/lib/company.func.php";
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("inc/reports");

/////////////////////////////////////////////
///////// prepare any variables

$ProgPath=array();
$ProgPath[0]['Name']=$Lang['MReports'];
$ProgPath[0]['Url']=$nsProduct->SelfAction();
$MenuSection="logs";
$PageTitle = $Lang['Reports'];

$ReportsList = array();
$GroupsArr = array();
$RepLink = array();
$Query = "
        SELECT SR.*, RG.NAME AS GROUP_NAME, W.ID AS W_ID
            FROM ?_static_report SR
                INNER JOIN ?_static_report_group RG
                    ON RG.ID=SR.GROUP_ID 
                LEFT JOIN ?_watch W
                    ON W.USER_ID=? AND W.REPORT_ID=SR.ID
            WHERE SR.COMPANY_ID IN (0, ?) 
            GROUP BY SR.ID
            ORDER BY IF(RG.COMPANY_ID>0, 1, 0) ASC, IF(RG.COMPANY_ID>0, RG.NAME, RG.ID) ASC, SR.NAME
";
$Sql = new Query($Query, false, $nsUser->UserId(), $CpId, $CpId);
while ($Row=$Sql->Row()) {
    if ($Row->MODE=='PAID' && @$nsProduct->LICENSE == 4) continue;
    $Row->A_CNT = false;
    $Row->EDIT=$Row->DELETE=false;
    if ($Row->USER_ID==$nsUser->UserId() || 
        $nsUser->SUPER_ADMIN || ($nsProduct->LICENSE==2&&$nsUser->SUPER_USER)) {
        $Row->EDIT=$Row->DELETE=true;
    }
    if ($Row->COMPANY_ID==0) $Row->DELETE=false;
    
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];
    if (isset($Lang[$Row->GROUP_NAME])) $Row->GROUP_NAME=$Lang[$Row->GROUP_NAME];        
    if (isset($Lang[$Row->DESCRIPTION])) $Row->DESCRIPTION=$Lang[$Row->DESCRIPTION];
    $GroupsArr[$Row->GROUP_ID]=$Row->GROUP_NAME;        
    $ReportsList[$Row->GROUP_ID][$Row->ID]=$Row;
    $RepLink[$Row->ID] =& $ReportsList[$Row->GROUP_ID][$Row->ID];
}

$Query = "SELECT DISTINCT REPORT_ID FROM ?_archive";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $RepLink[$Row->REPORT_ID]->A_CNT = 1;



/////////////////////////////////////////////
///////// call any process functions


/////////////////////////////////////////////
///////// display section here
include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here


/////////////////////////////////////////////
///////// library section

/*
function SetToMyTracker($Arr)
{
    global $Db, $nsUser, $nsProduct, $Tab;
    
    $Query = "SELECT REPORT_ID FROM ?_watch WHERE USER_ID=? AND REPORT_ID!=0";
    $Sql = new Query($Query,false,$nsUser->UserId());
    $RepArr=array();
    while ($Row=$Sql->Row()) $RepArr[]=$Row->REPORT_ID;
    $ToDelete=array_diff($RepArr,$Arr);
    $ToInsert=array_diff($Arr,$RepArr);
    
    if (count($Arr)==1 && $Arr[0]=="-1") {
        $Query = "DELETE FROM ?_watch WHERE USER_ID=? AND REPORT_ID!=0";
        $Db->Query($Query,$nsUser->UserId());        
        $ToDelete=array();
        $ToInsert=array();
    }
    
    if (!empty($ToDelete)) {
        $Query = "DELETE FROM ?_watch WHERE USER_ID=? AND REPORT_ID IN (?)";
        $Db->Query($Query,$nsUser->UserId(), $ToDelete);
    }
    
    if (!empty($ToInsert)) {
        foreach ($ToInsert as $RepId) {
        $Query = "INSERT INTO ?_watch (USER_ID, REPORT_ID) VALUES (?,?)";
        $Db->Query($Query,$nsUser->UserId(),$RepId);
        }
    }
    $nsProduct->Redir(false,"Tab=$Tab");
}
*/
?>