<?
if (!defined("NS_TRACKER_INDEX")) exit;

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("admin.group_order");

require_once SELF."/lib/reports/const_groups.arr.php";
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/delete/period.func.php";

extract(VPack(array('WhereArr','SaveReport','Periods','ArchPeriods','Sites','EditArr','EditId','FormClicked',
                                   'SaveMode','CpId','NoCpId','DeleteId','DayTime','UpdatePeriod','UpdatePeriodCnt'),
                         array('Periods'=>array(), 'ArchPeriods'=>array(), 'EditId'=>'new', 'CpId'=>$CurrentCompany->ID,
                                   'DayTime'=>array(), 'UpdatePeriod'=>array(), 'UpdatePeriodCnt'=>array())));
$PeriodPriority = array('h'=>0,'d'=>1,'w'=>2,'m'=>3,'y'=>4);

$ProgPath=array();
$ProgPath[0]['Name']=$Lang['MReports'];
$ProgPath[0]['Url']=getURL("reports","","admin");

if (!$nsUser->DEMO) {
    if ($DeleteId) DeleteStaticReport($DeleteId);
}

$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("inc/reports");

$GroupArr=array();
$PeriodsArr=array();
$ArchPeriodsArr=array();

$DeletedPeriods=array();
$NoDynamicPeriods=false;
$Query = "SELECT * FROM ?_periods WHERE COMPANY_ID IN (0, $CpId) ORDER BY TEMPLATE";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME = $Lang[$Row->TEMPLATE];
    if ($Row->DELETED) $DeletedPeriods[$Row->TEMPLATE]=$Row->NAME;
    else $PeriodsArr[$Row->TEMPLATE]=$Row->NAME;
    
    $Arr=explode('-',$Row->TEMPLATE);
    if ($Arr[0]==0 || $Arr[2]==1) continue;
    $ArchPeriodsArr[$Row->TEMPLATE]=$Row->NAME;
}

$PArr=array_keys($ArchPeriodsArr);
usort($PArr,"SortPeriods");
$Tmp=array();
foreach ($PArr as $P) $Tmp[$P]=$ArchPeriodsArr[$P];
$ArchPeriodsArr=$Tmp;
    

$Query = "
    SELECT * 
    FROM ?_static_report_group 
    WHERE COMPANY_ID IN (0, $CpId) 
    ORDER BY IF(COMPANY_ID>0, 1, 0) ASC, IF(COMPANY_ID>0, NAME, ID) ASC";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];
    $GroupArr[]=$Row;
}

//$Settings=GetSettings($CpId);
$CacheEnabled=CacheEnabled($Settings);


if ($EditId) {

    $LangKey=($SaveMode=="NATURAL")?"NaturalConstPath":"PaidConstPath";
    if ($EditId!="new" && !$SaveReport) {
        
        $Query = "SELECT * FROM ?_static_report WHERE ID = $EditId";
        $EditReport=$Db->Select($Query);
        if (!$EditReport) $nsProduct->Redir("reports");   
        $AllowEdit=false;
        if ($nsUser->SUPER_ADMIN || ($nsProduct->LICENSE==2 && $nsUser->SUPER_USER)) $AllowEdit=true;
        if (!$AllowEdit && $EditReport->COMPANY_ID>0 && $nsUser->UserId()==$EditReport->USER_ID) $AllowEdit=true;
        if (!$AllowEdit) $nsProduct->Redir("reports"); 
        
        if (isset($Lang[$EditReport->NAME])) $EditReport->NAME=$Lang[$EditReport->NAME];
        if (isset($Lang[$EditReport->DESCRIPTION])) $EditReport->DESCRIPTION=$Lang[$EditReport->DESCRIPTION];
        
        $EditReport->Add=array();
        if ($EditReport->ADDITIONAL_TASK) {
            $Arr=explode(";",$EditReport->ADDITIONAL_TASK);
            if (!empty($Arr)) {
                foreach ($Arr as $AT) {
                    $SubArr=explode("=",$AT);
                    if (!V($SubArr[0])||!V($SubArr[1])) continue;
                    $EditReport->Add[$SubArr[0]]=$SubArr[1];
                }
            }
        }

        $Actions=array("NATURAL"=>"natural_constructor", "PAID"=>"paid_constructor");
        $SubMenu['Report']['Name']=$Lang['ViewData'];
        $SubMenu['Report']['Link']=getURL($Actions[$EditReport->MODE], "CpId=$CpId&ReportId=$EditId", "report");
                            
        $Cache=CacheByStaticReport($EditId,$CpId);
        if (!$Cache) $nsProduct->Redir("reports", "", "admin");
        $SaveMode=$Cache->Mode;
        $LangKey=($SaveMode=="NATURAL")?"NaturalConstPath":"PaidConstPath";
        $SaveReport=$Cache->Params;
        $WhereArr=$Cache->QuerySetArr;
        $Periods=$Cache->Periods;
        $Sites=$Cache->Sites;
        $EditArr['Name']=$Cache->ReportName;
        foreach ($Periods as $T=>$V) {
            if (!isset($PeriodsArr[$T]) && isset($DeletedPeriods[$T])) $PeriodsArr[$T]=$DeletedPeriods[$T];
            if (!isset($PeriodsArr[$T]) && !isset($DeletedPeriods[$T]))  unset($Periods[$T]);
        }
        
        $EditReport->WATCH=$Db->ReturnValue("SELECT ID FROM ?_watch WHERE USER_ID=? AND REPORT_ID=?",$nsUser->UserId(),$EditId);
        
        $ProgPath[0]['Url']=getURL("reports","Tab=".$EditReport->GROUP_ID,"admin");
        $ProgPath[1]['Name']=isset($Lang[$EditArr['Name']])?$Lang[$EditArr['Name']]:$EditArr['Name'];
        $ProgPath[1]['Url']=getURL("static_report","EditId=$EditId","admin");        
    }
    else {
        $ProgPath[1]['Name']="New report";
        $ProgPath[1]['Url']=getURL("static_report","EditId=$EditId","admin");        
    }
    
    if (isset($SaveReport['DynamicPeriod']) && !isset($Periods[$SaveReport['DynamicPeriod']])) {
        $Periods[$SaveReport['DynamicPeriod']]=array('DAY_TIME'=>"4", 'UPDATE_PERIOD'=>"d", 'UPDATE_PERIOD_CNT'=>"1");
    }
    
    if (V($SaveReport['DynamicPeriod'])=="-1" && 
        (empty($Periods) || (count($Periods)==1&&isset($Periods['-1']))) && 
        !V($SaveReport['ViewDate']) && !V($SaveReport['StartDate']) && !V($SaveReport['EndDate'])) {
            $Periods["0-a-0"]=array('DAY_TIME'=>"4", 'UPDATE_PERIOD'=>"d", 'UPDATE_PERIOD_CNT'=>"1");
    }
    

    $EditArr['Name']=V($EditArr['Name'],V($EditReport->NAME));
    if (isset($Lang[$EditArr['Name']])) $EditArr['Name']=$Lang[$EditArr['Name']];
    $EditArr['GroupId']=V($EditArr['GroupId'], V($EditReport->GROUP_ID,4));
    $EditArr['Descr']=V($EditArr['Descr'], V($EditReport->DESCRIPTION));
    $EditArr['OrderBy']=V($EditArr['OrderBy'], V($EditReport->Add['OrderBy'], V($WhereArr[count($WhereArr)-1]['OrderBy'])));
    $EditArr['OrderTo']=V($EditArr['OrderTo'], V($EditReport->Add['OrderTo'], V($WhereArr[count($WhereArr)-1]['OrderTo'])));
    $EditArr['Watch']=V($EditArr['Watch'],V($EditReport->WATCH,0));
    if ($EditArr['OrderBy']=="DEFAULT") $EditArr['OrderBy']=false;

    $SaveReport['SiteId']=V($SaveReport['SiteId'], "");
    $SaveReport['GroupBy']=V($SaveReport['GroupBy'], "");
    $SaveReport['ViewDate']=V($SaveReport['ViewDate'], "");
    $SaveReport['StartDate']=V($SaveReport['StartDate'], "");
    $SaveReport['EndDate']=V($SaveReport['EndDate'], "");
    $SaveReport['Filter']=V($SaveReport['Filter'], "");
    $SaveReport['DynamicPeriod']=V($SaveReport['DynamicPeriod'], "");
    $SaveReport['TrafficMode']=V($SaveReport['TrafficMode'], 0);

    if ($SaveReport['ViewDate']||$SaveReport['StartDate']||$SaveReport['EndDate']) $NoDynamicPeriods=true;

    $PageTitle=htmlspecialchars(stripslashes(V($EditArr['Name'])));

    if (!$nsUser->DEMO) {
        if ($FormClicked && $WhereArr && $EditId=="new") UpdateStaticReport();
        if ($FormClicked && $WhereArr && $EditId!="new") UpdateStaticReport($EditId);
    }

    if (!$NoDynamicPeriods) {
    foreach ($Periods as $T=>$V) {
        if (!is_array($V)) {
            $V=false;
            $V['UPDATE_PERIOD_CNT']=1;
            $V['UPDATE_PERIOD']="d";
            $V['DAY_TIME']=1;
            $Periods[$T]=$V;
        }
    }

    if (!empty($UpdatePeriodCnt)) {
        foreach ($UpdatePeriodCnt as $T=>$UPC) if (isset($Periods[$T])) $Periods[$T]['UPDATE_PERIOD_CNT']=$UPC;
    }
    if (!empty($UpdatePeriod)) {
        foreach ($UpdatePeriod as $T=>$UP) if (isset($Periods[$T]))  $Periods[$T]['UPDATE_PERIOD']=$UP;
    }
    if (!empty($DayTime)) {
        foreach ($DayTime as $T=>$DT) if (isset($Periods[$T]))  $Periods[$T]['DAY_TIME']=$DT;
    }
    
    $Query = "SELECT * FROM ?_static_report_archive WHERE REPORT_ID=?";
    $Sql = new Query($Query,false,$EditId);
    $ArchPeriods=array();
    while ($Row=$Sql->Row()) $ArchPeriods[$Row->PERIOD]=1;
    }
    
    $OnlySiteId=false;
    if (!empty($WhereArr) && is_array($WhereArr)) {
        foreach ($WhereArr as $Row) {
            if ($Row['Mode']=='Site') $OnlySiteId=V($Row['Id']);
            if ($Row['Mode']=='Host' && V($Row['Id'])) {
                $OnlySiteId=$Db->ReturnValue("SELECT SITE_ID FROM ?_site_host WHERE ID=?",$Row['Id']);
            }
        }
    }
    
    $SitesArr=array();
    $Where="";
    if ($OnlySiteId) $Where=" AND ID=$OnlySiteId ";
    $Query = "SELECT ID, HOST FROM ?_site WHERE COMPANY_ID=$CpId $Where ORDER BY HOST";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $SitesArr[]=$Row;
    }
    if (!is_array($Sites)) $Sites=array();
    
    $LangArr=&$$LangKey;
    $NameSorting=$Lang[$LangArr[ $SaveReport['GroupBy'] ]];
    
    $PArr=array_keys($PeriodsArr);
    usort($PArr,"SortPeriods");
    $PeriodsArr=SyncKeysWValues($PeriodsArr,$PArr);
    
    include $nsTemplate->Inc("inc/header");
    include $nsTemplate->Inc("inc/submenu");
    include $nsTemplate->Inc("constructor/static_report");
    include $nsTemplate->Inc("inc/footer");
}


///////////////////////////////////////////////////////////////////////
//////////////////////////////////////



function UpdateStaticReport($EditId=false)
{
    global $Db, $SaveMode, $SaveReport, $WhereArr;
    global $EditArr, $Logs, $Lang, $nsProduct, $nsUser, $CpId, $NoCpId;
    global $Periods, $ArchPeriods, $Sites, $DayTime, $UpdatePeriod, $UpdatePeriodCnt;
    global $NoDynamicPeriods;

    $CompId=$CpId;
    $UserId=0;
    if ($EditId) {
        $Query = "SELECT * FROM ?_static_report WHERE ID=?";
        $EditReport=$Db->Select($Query,false,$EditId);
        $CompId=$EditReport->COMPANY_ID;
        $UserId=$EditReport->USER_ID;
        if (isset($Lang[$EditReport->NAME]) && $Lang[$EditReport->NAME]==V($EditArr['Name'])) $EditArr['Name']=$EditReport->NAME;
    }

    if (!$EditArr['Name']) return $Logs->Err($Lang['NameMustFill']);
    if (!$EditArr['GroupId']&&!$EditArr['NewGroup']) { $Logs->Err($Lang['ChooseGrp']); $nsProduct->Redir('static_report', "EditId=$EditId"); }    
    if (!$Periods&&!$NoDynamicPeriods) { $Logs->Err($Lang['MustChoosePeriods']); $nsProduct->Redir('static_report', "EditId=$EditId"); }
    if (!$Sites) return $Logs->Err($Lang['MustChooseSites']);
    $PeriodStr=implode(";",array_keys($Periods));
    $SiteStr=implode(";",array_keys($Sites));

    $Watch=V($EditArr['Watch'],0);

    if ($CpId==0 && 
        (($nsProduct->LICENSE==2 && $nsUser->SUPER_USER) || 
            ($nsProduct->LICENSE==3 && $nsUser->SUPER_ADMIN))) {
        $Watch=0;
    }
    if ($UserId && $nsUser->UserId()!=$UserId) $Watch=0;

    $GroupId=V($EditArr['GroupId']);
    $NewGroup=V($EditArr['NewGroup'],"");
    $Descr=V($EditArr['Descr'],"");
    $OrderBy=V($EditArr['OrderBy']);
    $OrderTo=V($EditArr['OrderTo']);
    $Additional="";
    if ($OrderBy&&$OrderTo) $Additional="OrderBy=$OrderBy;OrderTo=$OrderTo";

    if ($NewGroup) {
        $Query="INSERT INTO ?_static_report_group (COMPANY_ID,NAME) VALUES (?,?)";
        $Db->Query($Query,$CpId,$NewGroup);
        $GroupId=$Db->LastInsertId;
    }

    if ($NoCpId) $CompId=0;
    if ($EditId)  {
        $Query = "UPDATE  ?_static_report SET 
                COMPANY_ID=?, NAME=?, SITES=?, MODE=?, GROUP_ID=?, DESCRIPTION=?, ADDITIONAL_TASK=? WHERE ID = ?";
        $Db->Query($Query, $CompId, $EditArr['Name'], $SiteStr, $SaveMode, $GroupId, $Descr, $Additional, $EditId);
    }
    else {
        $Query = "INSERT INTO ?_static_report 
                (COMPANY_ID, NAME, SITES, MODE, GROUP_ID, DESCRIPTION, ADDITIONAL_TASK, USER_ID) VALUES (?, ?, ?, ?, ?, ?, ?, ?)";
        $Db->Query($Query, $CompId, $EditArr['Name'], $SiteStr, $SaveMode, $GroupId, $Descr, $Additional, $nsUser->UserId());
    }

    $SRId=($EditId)?$EditId:$Db->LastInsertId;

    if(!$NoDynamicPeriods) {
    //  
    $TIdArr=array();
    $PeriodIds=array();
    foreach ($Periods as $T=>$v) {
        $DT=V($DayTime[$T],"4"); 
        $UP=V($UpdatePeriod[$T],"d");
        $UPC=V($UpdatePeriodCnt[$T],"1");
        if ($UPC<1) $UPC=1;
        $Query = "
            SELECT ID FROM ?_static_report_periods WHERE 
            REPORT_ID=? AND PERIOD = ? AND DAY_TIME=? AND UPDATE_PERIOD_CNT=? AND UPDATE_PERIOD=? 
        ";
        $Check=$Db->Select($Query,false,$SRId,$T,$DT,$UPC,$UP);
        if (!$Check) {
            $Query = "INSERT INTO ?_static_report_periods (REPORT_ID, PERIOD, DAY_TIME, UPDATE_PERIOD_CNT, UPDATE_PERIOD) VALUES (?,?,?,?,?)";
            $Db->Query($Query,$SRId,$T,$DT,$UPC,$UP);
            $TIdArr[]=$Db->LastInsertId;
            $PeriodIds[$T]=$Db->LastInsertId;
            SetUpdateTime($SRId,$Db->LastInsertId, NextUpdateTime($CpId,$SRId,false,$T,$DT,$UPC,$UP));
        }
        else {
            $TIdArr[]=$Check->ID;
            $PeriodIds[$T]=$Check->ID;
            SetUpdateTime($SRId,$Check->ID,NextUpdateTime($CpId,$SRId,$Check->ID,$T,$DT,$UPC,$UP));
        }
    }
    $TIdStr=implode(",",$TIdArr);
    if (!empty($TIdArr)) $Query = "DELETE FROM ?_static_report_periods WHERE REPORT_ID=? AND ID NOT IN ($TIdStr)";
    else $Query = "DELETE FROM ?_static_report_periods WHERE REPORT_ID=?";
    $Db->Query($Query,$SRId);
    }
    else $Periods=array("-1"=>"1");
    //--  

    $CpArr=array();
    if ($CompId==0) {
        $Query = "SELECT ID FROM ?_client ORDER BY RAND()";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;                
    }
    else $CpArr[]=$CompId;

    $PeriodsArr=array_keys($Periods);
    $SitesArr=array_keys($Sites);

    foreach ($CpArr as $CompId) {
    $CacheArr=array();
    for($i=0;$i<count($PeriodsArr);$i++){
        for($j=0;$j<count($SitesArr);$j++){
            $SaveReport['DynamicPeriod']=(string) $PeriodsArr[$i]=="0-a-0"?"-1":$PeriodsArr[$i];
            $SaveReport['SiteId']=(string) $SitesArr[$j];
            $PeriodId=(!$NoDynamicPeriods)?$PeriodIds[$PeriodsArr[$i]]:0;

            $Cache = new nsQueryCache($CompId);
            $Cache->QueryParams=$SaveReport;
            $tmp=ReportParent::RemoveSorting(array('WhereArr'=>$WhereArr));
            $WhereArr = @$tmp['WhereArr'];
            if (V($WhereArr)) $Cache->QueryParams['WhereArr']=$WhereArr;
            $Cache->Mode=$SaveMode;
            $Cache->GetQuerySetId();
            $Cache->GetCacheId();
            if (!$Cache->CacheId) $Cache->CreateCacheRecord(0);
            $Cache->SetCacheType(1);

            $CacheArr[]=$Cache->CacheId;

            $Query = "SELECT ID FROM ?_{$CompId}_static_report_cache WHERE REPORT_ID=? AND PERIOD_ID=? AND CACHE_ID=?";
            $CheckId=$Db->ReturnValue($Query,$SRId,$PeriodId,$Cache->CacheId);
            if (!$CheckId) {
                $Query = "INSERT INTO ?_{$CompId}_static_report_cache (REPORT_ID, PERIOD_ID, CACHE_ID) VALUES (?, ?, ?)";
                $Db->Query($Query, $SRId, $PeriodId, $Cache->CacheId);
            }
        }
    }

    if(count($CacheArr)>0) {
        $Query = "DELETE FROM ?_{$CompId}_static_report_cache WHERE REPORT_ID=? AND CACHE_ID NOT IN (?)";
        $Db->Query($Query, $SRId, $CacheArr);
    }

    $CpArr=array();
    if ($CompId>0) $CpArr[]=$CompId;
    else {
        $Sql = new Query("SELECT ID FROM ?_client");
        while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    }
    if (empty($ArchPeriods)) {
        $Db->Query("DELETE FROM ?_static_report_archive WHERE REPORT_ID=?",$SRId);
        foreach ($CpArr as $CpId) {
            $Db->Query("DELETE FROM ?_{$CpId}_static_archive_cache WHERE REPORT_ID =?",$SRId);
        }
    }
    else $Db->Query("DELETE FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD NOT IN (?)",$SRId,$ArchPeriods);

    $Query = "SELECT * FROM ?_static_report WHERE ID =?";
    $Report=$Db->Select($Query,false,$SRId);

    foreach ($ArchPeriods as $Tpl) {
        if ($Tpl==-1) continue;
        $Query="SELECT ID FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD=?";
        $PId=$Db->ReturnValue($Query,$SRId,$Tpl);
        $PId=SetArchivePeriod($Report,$CpArr,$Tpl,$PId);
    }

    }

    if (!$Watch) $Db->Query("DELETE FROM ?_watch WHERE USER_ID=? AND REPORT_ID=?", $nsUser->UserId(), $SRId);
    if ($Watch) {
        if (!$Db->ReturnValue("SELECT ID FROM ?_watch WHERE USER_ID=? AND REPORT_ID=?",$nsUser->UserId(),$SRId)) {
            
            $Db->Query("INSERT INTO ?_watch (USER_ID,REPORT_ID) VALUES (?,?)", $nsUser->UserId(),$SRId);
        }
    }

    $nsProduct->Redir("reports", "", "admin");
}






?>