<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==4) $nsProduct->Redir("default", "", "admin"); 

/////////////////////////////////////////////
///////// require libraries here
require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sort.func.php";
require_once SELF."/lib/delete.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/lib/reports/hidden_reports.func.php";
$nsLang->TplInc("inc/menu");

/////////////////////////////////////////////
///////// prepare any variables

extract(VPack(array('EditId','DeleteId','EditArr','ParentId','EditCost','EditCostId','SumThis','UpdateSum',
                                'DelCostId','UpdateMode')));
$MaxYear=date("Y")+5;
$ProgPath[0]['Name']=$Lang['MCampaign'];
$ProgPath[0]['Url']=getURL("campaign", "CpId=$CpId", "admin");


/////////////////////////////////////////////
///////// call any process functions
if (!$nsUser->DEMO) {

	if ($EditId && $EditArr) UpdateSubCampaign($EditId, $EditArr);
    if ($DeleteId) DeleteSubCampaign($CpId, $DeleteId);
	if ($EditCostId && $EditCost) UpdateCost($EditCostId, $EditCost);
    if ($DelCostId) DeleteCost($DelCostId);
    if ($UpdateSum) UpdateSumThis($SumThis);
	

}
/////////////////////////////////////////////
///////// display section here

if ($EditId) {
    
    $GrpArr=array();
    $EditCost = array();
    $CostArr=array();
    $CostArr2=array();
    $TotalCost=0;

    $Query = "SELECT * FROM ?_campaign WHERE COMPANY_ID=? ORDER BY NAME";
    $Sql = new Query($Query,false,$CpId);
    while ($Row=$Sql->Row()) $GrpArr[]=$Row;

    if ($EditId != 'new') {
        $Query = "
            SELECT TCP.*, TSC.TYPE, TSC.SRC_ID, W.ID AS WATCH,
                C.NAME AS CAMP_NAME
                FROM ?_camp_piece TCP
                    INNER JOIN ?_sub_campaign TSC ON TSC.SUB_ID=TCP.ID
                    LEFT JOIN ?_watch W ON W.SUB_ID = TCP.ID AND W.USER_ID=?
                    LEFT JOIN ?_campaign C ON C.ID=TCP.CAMPAIGN_ID
                WHERE TCP.ID = ?
        ";
        $SubCamp=$Db->Select($Query, false, $nsUser->UserId(), $EditId);
        if (!$SubCamp) $nsProduct->Redir('campaign');
        $SubCamp->Currency[0]=$CurrentCompany->CURRENCY;
        $SubCamp->Currency[1]=$CurrentCompany->CURRENCY_POSITION;

        $SubMenu[0]['Name']=$Lang['BackToList'];
        $SubMenu[0]['Link']=getURL("campaign", "ParentId=".$SubCamp->CAMPAIGN_ID);
        $SubMenu[1]['Name']=$Lang['CodeGen'];
        $SubMenu[1]['Link']=getURL("campaign_link", "CampId=$EditId", "admin");
        $SubMenu[2]['Name']=$Lang['Stat'];
        $SubMenu[2]['Link']=getURL("paid_constructor", "CampId=$EditId", "report");
        $SubMenu[3]['Name']=$Lang['AddSale'];
        $SubMenu[3]['Link']=getURL("sale", "CampId=$EditId", "admin");

        $Query = "
            SELECT *, 
                UNIX_TIMESTAMP(START_DATE) AS STAMP1, 
                UNIX_TIMESTAMP(END_DATE) AS STAMP2
            FROM ?_camp_cost CC
            WHERE CC.SUB_CAMPAIGN = ?
            ORDER BY START_DATE ASC, ID ASC
        ";
        $Sql = new Query($Query, false, $EditId);
        while ($Row=$Sql->Row()) {
            $Row->TITLE="";
            if ($Row->MODE==0) {
                if ($Row->STAMP1) $Row->TITLE.=_date($Row->START_DATE);
                if ($Row->STAMP1&&$Row->STAMP2) $Row->TITLE.=" - ";
                if ($Row->STAMP2) $Row->TITLE.=_date($Row->END_DATE);
                $CostArr[]=$Row;
                if ($Row->SUM_THIS==1) $TotalCost+=$Row->COST;
            }
            if ($Row->MODE==1) {
                $Row->TITLE=_date($Row->START_DATE);
                $CostArr2[]=$Row;
            }
        }
    } else {
        $SubMenu[0]['Name']=$Lang['BackToList'];
        $SubMenu[0]['Link']=getURL("campaign");
    }

    $PageTitle=V($SubCamp->NAME, $Lang['NewCampaign']);
    if (V($SubCamp->CAMPAIGN_ID)) {
        $ProgPath[1]['Name']=$SubCamp->CAMP_NAME;
        $ProgPath[1]['Url']=getURL('campaign', "ParentId=".$SubCamp->CAMPAIGN_ID);
    }
    $ProgPath[2]['Name']=V($SubCamp->NAME, $Lang['NewCampaign']);
    $ProgPath[2]['Url']=$nsProduct->SelfAction("EditId=$EditId");

    $EditArr['Name']=V($EditArr['Name'],V($SubCamp->NAME));
    $EditArr['Descr']=V($EditArr['Descr'],V($SubCamp->DESCRIPTION));
    $EditArr['Type']=V($EditArr['Type'],V($SubCamp->TYPE, 0));
    $EditArr['SrcId']=V($EditArr['SrcId'],V($SubCamp->SRC_ID));
    $EditArr['Watch']=V($EditArr['Watch'],V($SubCamp->WATCH));
    $EditArr['ParentId']=V($ParentId, V($EditArr['ParentId'], V($SubCamp->CAMPAIGN_ID)));

    if ($EditCostId) {
        $Query = "
                SELECT *, 
                    UNIX_TIMESTAMP(START_DATE) AS STAMP1, 
                    UNIX_TIMESTAMP(END_DATE) AS STAMP2 
                    FROM ?_camp_cost 
                    WHERE ID=? AND SUB_CAMPAIGN=?";
        $EditCostObj=$Db->Select($Query, false, $EditCostId, $EditId);
    } else $EditCostId = 'new';

    $EditCost['StartDate']=V($EditCost['StartDate'],V($EditCostObj->START_DATE));
    $EditCost['EndDate']=V($EditCost['EndDate'],V($EditCostObj->END_DATE));
    $EditCost['Name']=V($EditCost['Name'],V($EditCostObj->NAME));  
    $EditCost['Cost']=V($EditCost['Cost'],V($EditCostObj->COST));

    include $nsTemplate->Inc("admin.sub_edit");  
}




/////////////////////////////////////////////
///////// process functions here

function UpdateSubCampaign($Id, $Arr)
{
    global $Db, $Logs, $nsProduct, $Lang, $nsUser, $CurrentCompany, $CpId;
    extract($Arr);

    if(!V($Name)) $ErrArr['Name']=$Lang['MustFill'];
    $Type = V($Type,0);
    $SrcId = V($SrcId,'');
    $Watch = V($Watch);
    $Descr = V($Descr);
    $ParentId = V($ParentId,0);

    if ($SrcId) {
        $Query = "SELECT ID FROM ?_sub_campaign WHERE SRC_ID != '' AND SRC_ID=? AND SUB_ID!=? ";
        $CheckId = $Db->ReturnValue($Query, $SrcId, $Id);
        if ($CheckId) {
            $ErrArr['Grp']=$Lang['UniSrc'];
            return;
    }}

    if (isset($ErrArr)) {$Logs->Err($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}

    if ($Id != 'new') {
        $Query = "
            SELECT TCP.*, TSC.TYPE, TSC.SRC_ID, W.ID AS WATCH
                FROM ?_camp_piece TCP
                    INNER JOIN ?_sub_campaign TSC ON TSC.SUB_ID=TCP.ID
                    LEFT JOIN ?_watch W ON W.SUB_ID = TCP.ID AND W.USER_ID=?
                WHERE TCP.ID = ?
        ";
        $SubCamp=$Db->Select($Query, false, $nsUser->UserId(), $Id);
        $Query = "UPDATE ?_camp_piece SET CAMPAIGN_ID=?, NAME=?, DESCRIPTION=? WHERE ID=?";
        $Db->Query($Query, $ParentId, $Name, $Descr, $Id);
        $Query = "UPDATE ?_sub_campaign SET TYPE=?, SRC_ID=? WHERE SUB_ID=?";
        $Db->Query($Query, $Type, $SrcId, $Id);

        if ($Watch && !$SubCamp->WATCH) SetSubWatch($Id, $nsUser->UserId());
        if (!$Watch) RemoveSubWatch($Id, $nsUser->UserId());
    }
    else {
        $Query = "INSERT INTO ?_camp_piece (CAMPAIGN_ID, NAME, DESCRIPTION, COMPANY_ID) VALUES (?,?,?,?)";
        $Db->Query($Query, $ParentId, $Name, $Descr, $CurrentCompany->ID);
        $Id=$Db->LastInsertId;
        $Query = "INSERT INTO ?_sub_campaign (SUB_ID, TYPE, SRC_ID) VALUES (?,?,?)";
        $Db->Query($Query, $Id, $Type, $SrcId);        
        
        $Cache = new nsQueryCache($CurrentCompany->ID);
        $Cache->Mode="PAID";
        $Cache->QueryParams=SubCampQueryParams($Id);
        $Cache->UpdateInterval=360;
        $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);
    }

    $nsProduct->Redir("sub_camp", "RUpd=1&EditId=$Id");
}

function UpdateCost($Id, $Arr)
{
	global $Db, $Logs, $nsProduct, $Lang, $EditId;
	extract($Arr);
	if(!V($Cost)) $ErrArr['Cost']=$Lang['MustFill'];
    $Name = V($Name,'');
    $EndDate = V($EndDate,null);
    $Mode = V($Mode,0);
	$StartDate = V($StartDate,null);
    $Cost=str_replace(",", ".", $Cost);
	if ($Mode==1 && !$StartDate) $ErrArr['StartDate']=$Lang['MustFill'];
	if ($Mode==1 && $StartDate) {
		$Query = "SELECT ID FROM ?_camp_cost WHERE SUB_CAMPAIGN=? AND START_DATE = ? AND ID!=?";
		$CheckId=$Db->ReturnValue($Query, $EditId, $StartDate, $Id);
		if ($CheckId>0) $ErrArr['StartDate']=$Lang['DateDuplicate'];
	}
	if (isset($ErrArr)) {$Logs->Err($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
    
    if ($Id != 'new') {
	   $Query = "UPDATE ?_camp_cost SET NAME = ?, START_DATE = ?, END_DATE = ?, COST = ? WHERE ID = ?";
	   $Db->Query($Query, $Name, $StartDate, $EndDate, $Cost, $Id);
       $Msg = 'RUpd';
    }
    else {
        $Query = "INSERT INTO ?_camp_cost (SUB_CAMPAIGN, NAME, START_DATE, END_DATE, COST, MODE) 
                    VALUES (?,?,?,?,?,?)";
        $Db->Query($Query, $EditId, $Name, $StartDate, $EndDate, $Cost, $Mode);
        $Id = $Db->LastInsertId;
        $Msg = 'RCrt';
    }

	UpdatePerClickEndDate($EditId);
	$nsProduct->Redir("sub_camp", "$Msg=1&EditId=$EditId");
}


function UpdatePerClickEndDate($EditId)
{
	global $Db;
	$Query = "SELECT * FROM ?_camp_cost WHERE SUB_CAMPAIGN=? ORDER BY START_DATE";
	$Sql = new Query($Query, false, $EditId);
	$Cost=array();
	while ($Row=$Sql->Row()) $Cost[]=$Row;
	for ($i=0;$i<count($Cost);$i++) {
		if (isset($Cost[$i+1])) {
			$Query = "UPDATE ?_camp_cost SET END_DATE = ? WHERE ID = ?";
			$Db->Query($Query, $Cost[$i+1]->START_DATE, $Cost[$i]->ID);
		}
		else $Db->Query("UPDATE ?_camp_cost SET END_DATE ='' WHERE ID =?", $Cost[$i]->ID);
	}
}

function UpdateSumThis($Arr)
{
	global $Db, $EditId, $UpdateMode;
	$Mode = $UpdateMode==1 ? 1 : 0;
	$Query = "UPDATE ?_camp_cost SET SUM_THIS = '0' WHERE SUB_CAMPAIGN=? AND MODE=?";
	$Db->Query($Query, $EditId, $Mode);
	if (empty($Arr)) return;
	foreach ($Arr as $Key => $Value) {
		if ($Value!=1) continue;
		$Query = "UPDATE ?_camp_cost SET SUM_THIS = '1' WHERE ID=? AND MODE=?";
		$Db->Query($Query, $Key, $Mode);
	}
}

function DeleteCost($Id)
{
	global $Db, $nsProduct, $EditId;
	$Query = "DELETE FROM ?_camp_cost WHERE ID = ?";
	$Db->Query($Query, $Id);
	$nsProduct->Redir("sub_camp", "RDlt=1&EditId=$EditId");
}

function SetSubWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (SUB_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $GrpId, $UserId);
}

function RemoveSubWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE SUB_ID=? AND USER_ID=?";
	$Db->Query($Query, $GrpId, $UserId);
}

?>