<?
if (!defined("NS_TRACKER_INDEX")) exit;

extract(VPack(array('Mode', 'EditId', 'EditArr', 'DeleteId', 'UnsetId', 'ImportId', 'SetIgnoreId', 'CompanyId')));

$PageTitle=$Lang['Title'];
$SkinsArr=array();
$LangsArr=array();
$ErrArr=array();
$MenuSection="admin";

require_once SYS."/system/lib/validate.func.php";

/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged())$nsProduct->Redir("login", "", "admin");
if (!$nsUser->SUPER_USER && !$nsUser->ADMIN && $EditId!=$nsUser->UserId()) 
    $nsProduct->Redir("users", "EditId=".$nsUser->UserId(), "admin"); 

if (!$nsUser->DEMO || $nsUser->SUPER_ADMIN || ($nsProduct->LICENSE!=3&&$nsUser->SUPER_USER)) {
    if ($EditId&&$EditArr) UpdateUser($EditId,$EditArr);
    if ($DeleteId) DeleteUser($DeleteId);
    if ($UnsetId) DeleteUser($UnsetId,true);
    if ($ImportId) ImportUser($ImportId,$Mode);
}

$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
if ($nsUser->ADMIN || $nsUser->SUPER_USER) {
$ProgPath[1]['Name']=($nsUser->ADMIN)?$Lang['Title2']:$Lang['Title'];
$ProgPath[1]['Url']=getURL("users", "", "admin");
}

if (!$EditId) {

    $List=GetUsers();
    $UserList=array();
    $AdminList=array();
    $ClientArr=array();
    $NonTrackerUsersList=array();
    
    $Query = "
            SELECT SU.*, SU.ID AS USER_ID
            FROM ?{PFX}_system_user SU
            LEFT JOIN ?_admin A
                ON A.USER_ID=SU.ID
            LEFT JOIN ?_user U
                ON U.USER_ID=SU.ID
            WHERE A.ID IS NULL AND U.ID IS NULL
    ";
    $Sql = new Query($Query);
    while ($Row = $Sql->Row()) $NonTrackerUsersList[]=$Row;
    
    if ($nsProduct->LICENSE!=3) $CompanyId=false;

    foreach ($List as $Id=>$Row) {
        if ($Row->MERCH_ID||$nsProduct->LICENSE!=3) {
            $UserList[$Row->COMPANY_ID][$Id]=$Row;
            if (!in_array($Row->COMPANY_ID,$ClientArr)) $ClientArr[$Row->COMPANY_ID]=$Row->COMPANY_ID;
        }
        if ($Row->ADMIN_ID&&$nsProduct->LICENSE==3) $AdminList[$Id]=$Row;
    }
    $ShowModeSelect = (!empty($UserList)+!empty($AdminList)+!empty($NonTrackerUsersList));
    if (!$Mode && !empty($AdminList)) $Mode='admins';
    if (!$Mode && !empty($UserList)) $Mode='users';
    if (!$Mode && !empty($NonTrackerUsersList)) $Mode='noperms';

    if ($Mode=='admins' && empty($AdminList)) $Mode='users';
    if ($Mode=='users' && empty($UserList)) $Mode='noperms';
    if ($Mode=='noperms' && empty($NonTrackerUsersList)) $Mode='admins';

    if ($CompanyId && !in_array($CompanyId,$ClientArr)) $CompanyId=false;
    if (!empty($ClientArr)) {
        $Query = "SELECT ID, NAME FROM ?_client WHERE ID IN (?)";
        $Sql = new Query($Query,false,$ClientArr);
        while ($Row=$Sql->Row()) $ClientArr[$Row->ID]=$Row;
    }

    $SubMenu['AddUser']['Name']=$Lang['AddUser'];
    $SubMenu['AddUser']['Link']=getURL("users","Mode=users&EditId=new");
    if ($nsProduct->LICENSE==3 && $nsUser->USER_LEVEL<2) {
        $SubMenu['AddAdmin']['Name']=$Lang['AddAdmin'];
        $SubMenu['AddAdmin']['Link']=getURL("users","Mode=admins&EditId=new");
    }

    include $nsTemplate->Inc("admin.users");
}

if ($EditId) {

    $CompList=array();
    $Query = "SELECT * FROM ?_client WHERE HIDDEN != '1' ORDER BY NAME";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $CompList[]=$Row;

    $SkinsArr=array();
    $Path=SELF."/skins";
    clearstatcache();
    $Dir=@opendir($Path);
    while ($Row = readdir($Dir)) {
        if ($Row == "." || $Row == ".." || $Row=="CVS") continue;
        if (is_file($Row)) continue;
        $Name = strtoupper(substr($Row,0,1)).substr($Row,1);
        $SkinsArr[$Row]=$Name;
    }

    $LangsArr=$nsLang->GetList();

    if ($EditId!='new') {
        $EditUser=GetUsers($EditId);
        if (!$EditUser) $nsProduct->Redir('users','','admin');
        $Mode=($EditUser->MERCH_ID)?'users':'admins';

        $ProgPath[3]['Name']=$EditId==$nsUser->UserId()?$Lang['Profile']:$EditUser->NAME;
        $ProgPath[3]['Url']=getURL("users", "EditId=$EditId", "admin");
    }
    else {
        $ProgPath[3]['Name']=($Mode=='users')?$Lang['NewUser']:$Lang['NewAdmin'];
        $ProgPath[3]['Url']=getURL("users", "Mode=$Mode&EditId=$EditId", "admin");
    }

    if (!$Mode) $Mode='users';
    if ($EditId==$nsUser->UserId() && $nsUser->TZ && V($_COOKIE[COOKIE_PFX.'auto_tz'])) {
        $Lang['AutoTZ'].=" (".(($nsUser->TZ>=0)?"+":"").$nsUser->TZ.")";
    }    

    $EditArr['Name']=V($EditArr['Name'],V($EditUser->NAME));
    $EditArr['Login']=V($EditArr['Login'],V($EditUser->LOGIN));
    $EditArr['Email']=V($EditArr['Email'],V($EditUser->EMAIL));
    $EditArr['Company']=V($EditArr['Company'],V($EditUser->COMPANY_ID));
    $EditArr['Super']=V($EditArr['Super'],V($EditUser->SUPER));
    $EditArr['Demo']=V($EditArr['Demo'],V($EditUser->DEMO));
    $EditArr['CanChangeSkin']=V($EditArr['CanChangeSkin'],V($EditUser->CAN_CHANGE_SKIN));
    $EditArr['AllowSchedule']=V($EditArr['AllowSchedule'],V($EditUser->ALLOW_SCHEDULE_EMAILS));
    $EditArr['PercentCalc']=V($EditArr['PercentCalc'],V($EditUser->PERCENT_CALC));

    $EditArr['Ignore']=V($EditArr['Ignore'],V($_COOKIE['ns_skip']));
    $EditArr['TrafficMode']=V($EditArr['TrafficMode'],V($EditUser->TRAFFIC_MODE));
    $EditArr['USkin']=V($EditArr['USkin'],V($EditUser->SKIN));
    $EditArr['ULang']=V($EditArr['ULang'],V($EditUser->LANG));
    $EditArr['HelpMode']=V($EditArr['HelpMode'],V($EditUser->HELP_MODE));
    $EditArr['TZ']=V($EditArr['TZ'],V($EditUser->TIMEZONE));
    $EditArr['Enc']=V($EditArr['Enc'],V($EditUser->PAGE_ENCODING));
    $EditArr['DisableSmart']=V($EditArr['DisableSmart'],V($EditUser->DISABLE_SMART));
    $EditArr['CacheUpdateMode']=V($EditArr['CacheUpdateMode'],V($EditUser->CACHE_UPDATE_MODE));
    $EditArr['GraphPlace']=V($EditArr['GraphPlace'],V($EditUser->GRAPH_PLACE));

    $EditArr['ColHits']=V($EditArr['ColHits'],V($EditUser->HITS));
    $EditArr['ColNewRet']=V($EditArr['ColNewRet'],V($EditUser->NEWRET));
    $EditArr['ColVisits']=V($EditArr['ColVisits'],V($EditUser->VISITS));
    $EditArr['ColClicks']=V($EditArr['ColClicks'],V($EditUser->CLICKS));
    $EditArr['ColSales']=V($EditArr['ColSales'],V($EditUser->SALES));
    $EditArr['ColActions']=V($EditArr['ColActions'],V($EditUser->ACTIONS));
    $EditArr['ColROI']=V($EditArr['ColROI'],V($EditUser->ROI));
    $EditArr['ColConv']=V($EditArr['ColConv'],V($EditUser->CONVERSIONS));
    $EditArr['Graphs']=V($EditArr['Graphs'],V($EditUser->GRAPHS));

    if (@$ProgPath[1]) $ProgPath[1]['Url']=getURL("users", "Mode=$Mode&CompanyId={$EditArr['Company']}", "admin");

    include $nsTemplate->Inc("admin.user_edit");
}


function UpdateUser($Id,$Arr)
{
    global $Db,$nsProduct,$nsUser,$Logs,$Lang,$ErrArr,$Mode,$Settings;    
    $EditUser=GetUsers($Id);
    if ($EditUser) $Mode=($EditUser->MERCH_ID)?'users':'admins';
    if ($nsUser->USER_LEVEL==3 && $Id!=$nsUser->UserId()) return false;
    if ($EditUser && $nsUser->USER_LEVEL>$EditUser->USER_LEVEL) return false;
    //if ( (!$nsUser->ADMIN || ($nsProduct->LICENSE!=3 && !$nsUser->SUPER_USER)) && $Mode=='admins') return false;
    extract($Arr);

    $Name=V($Name);
    $Login=V($Login);
    $Email=V($Email);
    $Company=V($Company);
    $Pass=V($Pass);
    $Pass2=V($Pass2);
    $ULang=V($ULang);
    $USkin=V($USkin);

    //  
    $TZ=V($TZ,$Id!=$nsUser->UserId()?V($EditUser->TIMEZONE,$Id=='new'?'a':0):0);
    $TrafficMode=V($TrafficMode,$Id!=$nsUser->UserId()?V($EditUser->TRAFFIC_MODE):0);
    $HelpMode=V($HelpMode,$Id!=$nsUser->UserId()?V($EditUser->HELP_MODE):0);
    $Enc=V($Enc,$Id!=$nsUser->UserId()?V($EditUser->PAGE_ENCODING):'');
    $DisableSmart=V($DisableSmart,$Id!=$nsUser->UserId()?V($EditUser->DISABLE_SMART):0);
    $CacheUpdateMode=V($CacheUpdateMode,$Id!=$nsUser->UserId()?V($EditUser->CACHE_UPDATE_MODE):0);
    $GraphPlace=V($GraphPlace,$Id!=$nsUser->UserId()?V($EditUser->GRAPH_PLACE):0);
    $PercentCalc=V($PercentCalc,$Id!=$nsUser->UserId()?V($EditUser->PERCENT_CALC):0);

    // 
    $ColHits=V($ColHits,$Id!=$nsUser->UserId()?V($EditUser->HITS,$Id=='new'?1:0):0);
    $ColVisits=V($ColVisits,$Id!=$nsUser->UserId()?V($EditUser->VISITS,$Id=='new'?0:0):0);
    $ColNewRet=V($ColNewRet,$Id!=$nsUser->UserId()?V($EditUser->NEWRET,$Id=='new'?0:0):0);
    $ColClicks=V($ColClicks,$Id!=$nsUser->UserId()?V($EditUser->CLICKS,$Id=='new'?1:0):0);
    $ColSales=V($ColSales,$Id!=$nsUser->UserId()?V($EditUser->SALES,$Id=='new'?1:0):0);
    $ColActions=V($ColActions,$Id!=$nsUser->UserId()?V($EditUser->ACTIONS,$Id=='new'?1:0):0);
    $ColROI=V($ColROI,$Id!=$nsUser->UserId()?V($EditUser->ROI,$Id=='new'?1:0):0);
    $ColConv=V($ColConv,$Id!=$nsUser->UserId()?V($EditUser->CONVERSIONS,$Id=='new'?1:0):0);
    $Graphs=V($Graphs,$Id!=$nsUser->UserId()?V($EditUser->GRAPHS,$Id=='new'?1:0):0);

    $Login=ToLower($Login);
    if (CheckSymb_($Login)) $ErrArr['Login']=$Lang['SymbErr'];
    if (!$Email) $ErrArr['Email']=$Lang['MustFill'];
    if (!ValidMail($Email)) $ErrArr['Email']=$Lang['MustFillCorr'];
    if (!$Name) $ErrArr['Name']=$Lang['MustFill'];
    if (!$Login) $ErrArr['Login']=$Lang['MustFill'];
    if ($Pass!=$Pass2) $ErrArr['Pass2']=$Lang['PassNotPass2'];
    if (strlen($Login)<3) $ErrArr['Login']=$Lang['LoginTooShort'];
    if (strlen($Login)>64) $ErrArr['Login']=$Lang['LoginTooLong'];
    if ($Id=='new'&&!$Pass) $ErrArr['Pass']=$Lang['MustFill'];

    if ($Pass || $Id=='new') {
        if (CheckSymb_($Pass)) $ErrArr['Pass']=$Lang['SymbErr'];
        if (strlen($Pass)<3) $ErrArr['Pass']=$Lang['PassTooShort'];
        if (strlen($Pass)>64) $ErrArr['Pass']=$Lang['PassTooLong'];
    }

    if ($Login) {
        $Query = "SELECT ID FROM ?{PFX}_system_user WHERE LOGIN = ? AND ID != ?";
        $CheckId=$Db->ReturnValue($Query, $Login,$Id);
        if ($CheckId) $ErrArr['Login']=$Lang['LoginExists'];
    }
    if ($Email) {
        $Query = "SELECT ID FROM ?{PFX}_system_user WHERE EMAIL = ? AND ID != ?";
        $CheckId=$Db->ReturnValue($Query,$Email,$Id);
        if ($CheckId) $ErrArr['Email']=$Lang['EmailExists'];
    }

    if (!empty($ErrArr)) return false;

    $DefaultCompany=$Db->ReturnValue("SELECT ID FROM ?_client ORDER BY ID");
    
    //   
    if ($Id=='new') {
        $Query = "INSERT INTO ?{PFX}_system_user (LOGIN,NAME,EMAIL)  VALUES (?,?,?)";
        $Db->Query($Query, $Login, $Name, $Email);
        $Id=$Db->LastInsertId;    
        
        $Company=($nsProduct->LICENSE==3&&$nsUser->ADMIN)?V($Company,$DefaultCompany):$DefaultCompany;
        if (!$nsUser->ADMIN) $Company=$nsUser->COMPANY_ID;
    }
    else {
        $Query = "UPDATE ?{PFX}_system_user SET LOGIN = ? , NAME = ?, EMAIL = ? WHERE ID = ?";
        $Db->Query($Query, $Login, $Name, $Email, $Id);
        
        $Company=($nsUser->ADMIN)?V($Company,V($EditUser->COMPANY_ID,$DefaultCompany)):
                                                            V($EditUser->COMPANY_ID,$DefaultCompany);
    }
    
    if ($Pass) $Db->Query("UPDATE ?{PFX}_system_user SET PWD=? WHERE ID=?",md5($Pass),$Id);
    
    if ($Id==$nsUser->UserId()) $Demo=V($EditUser->DEMO,0);
    elseif ($nsProduct->LICENSE!=3) $Demo=V($Demo,0);
    elseif ($nsProduct->LICENSE==3) $Demo= (V($EditUser->ID) && $nsUser->USER_LEVEL<=$EditUser->USER_LEVEL)?
                                                                        V($Demo,0):V($EditUser->DEMO,0);
    
    //    
    if ($Mode=='users') {

        $Super=( ($nsUser->ADMIN||$nsUser->SUPER_USER) && $Id!=$nsUser->UserId())?
                            V($Super,0): V($EditUser->SUPER_USER,0);

        $Db->Query("DELETE FROM ?_admin WHERE USER_ID=?",$Id);
        $CheckId=$Db->ReturnValue("SELECT ID FROM ?_user WHERE USER_ID=?",$Id);
        if (!$CheckId) {
            $Query = "INSERT INTO ?_user (USER_ID,COMPANY_ID,SUPER_USER,MODIFIED,DEMO) VALUES (?,?,?,NOW(),?)";
            $Db->Query($Query,$Id,$Company,$Super,$Demo);
        }
        else {
            $Query = "UPDATE ?_user SET COMPANY_ID=?, SUPER_USER=?, MODIFIED=NOW(), DEMO=? WHERE USER_ID=?";
            $Db->Query($Query,$Company,$Super,$Demo,$Id);
        }
    }

    if ($Mode=='admins') {

        $AdminCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_admin WHERE SUPER_ADMIN='1'");
        $Super=( ($nsProduct->LICENSE==2 || $nsUser->SUPER_ADMIN) && $Id!=$nsUser->UserId())?
                            V($Super,0): V($EditUser->SUPER_ADMIN,0);
        if ( V($EditUser->SUPER_ADMIN) && !$Super && $AdminCnt==1) {
            MoveCurrentUserToAdmin();
        }

        $Db->Query("DELETE FROM ?_user WHERE USER_ID=?",$Id);
        $CheckId=$Db->ReturnValue("SELECT ID FROM ?_admin WHERE USER_ID=?",$Id);
        if (!$CheckId) {
            $Query = "INSERT INTO ?_admin (USER_ID,SUPER_ADMIN,MODIFIED,DEMO) VALUES (?,?,NOW(),?)";
            $Db->Query($Query,$Id,$Super,$Demo);
        }
        else {
            $Query = "UPDATE ?_admin SET SUPER_ADMIN=?, MODIFIED=NOW(), DEMO=? WHERE USER_ID=?";
            $Db->Query($Query,$Super,$Demo,$Id);
        }
    }


    if ($Id!=$nsUser->UserId() && (
            ($Mode=='admins'&&$nsUser->SUPER_ADMIN) || 
            ($Mode=='users'&&$nsUser->ADMIN || ($nsUser->SUPER_USER&&$nsProduct->LICENSE!=3)) 
        )) {
        $CanChangeSkin = V($CanChangeSkin,0);
        $AllowSchedule = V($AllowSchedule,0);
    }
    else {
        $CanChangeSkin = V($EditUser->CAN_CHANGE_SKIN, 0);
        $AllowSchedule = V($EditUser->ALLOW_SCHEDULE_EMAILS, 0);
    }
    if ($Id == $nsUser->UserId()) $CanChangeSkin = V($EditUser->CAN_CHANGE_SKIN, 0);
    if ($Id == $nsUser->UserId()) $AllowSchedule = V($EditUser->ALLOW_SCHEDULE_EMAILS, 0);
    if (@$EditUser->ADMIN_ID) $AllowSchedule = 1;

    // 
    $CheckId=$Db->ReturnValue("SELECT ID FROM ?_user_settings WHERE USER_ID=?",$Id);
    if (!$CheckId) {
        $Query = "INSERT INTO ?_user_settings (USER_ID, HELP_MODE, TIMEZONE, 
                                                    PAGE_ENCODING, DISABLE_SMART, CACHE_UPDATE_MODE, 
                                                    GRAPH_PLACE, TRAFFIC_MODE, CAN_CHANGE_SKIN, ACTIVITY_ORDER, 
                                                    ALLOW_SCHEDULE_EMAILS, PERCENT_CALC) 
                            VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
        $Db->Query($Query,$Id,$HelpMode,$TZ,$Enc,$DisableSmart,
                                $CacheUpdateMode,$GraphPlace,$TrafficMode, $CanChangeSkin, null, $AllowSchedule, $PercentCalc);
    }
    else {
        $Query = "UPDATE ?_user_settings SET  HELP_MODE=?, TIMEZONE=?, 
                                                    PAGE_ENCODING=?, DISABLE_SMART=?, CACHE_UPDATE_MODE=?, 
                                                    GRAPH_PLACE=?, TRAFFIC_MODE=?, CAN_CHANGE_SKIN=?, 
                                                    ALLOW_SCHEDULE_EMAILS=?, PERCENT_CALC=? 
                                            WHERE USER_ID=?";
        $Db->Query($Query,$HelpMode,$TZ,$Enc,$DisableSmart,
                            $CacheUpdateMode,$GraphPlace,$TrafficMode,$CanChangeSkin,$AllowSchedule,$PercentCalc,$Id);
    }

    // 
    $CheckId=$Db->ReturnValue("SELECT ID FROM ?_user_column WHERE USER_ID=?",$Id);
    if (!$CheckId) {
        $Query = "INSERT INTO ?_user_column (USER_ID, HITS, VISITS, NEWRET, CLICKS, SALES, ACTIONS,
                                                                        ROI, CONVERSIONS, GRAPHS) 
                                                                        VALUES (?,?,?,?,?,?,?,?,?,?)";
        $Db->Query($Query,$Id,$ColHits,$ColVisits,$ColNewRet,$ColClicks,$ColSales,$ColActions,$ColROI,$ColConv,$Graphs);
    }
    else {
        $Query = "UPDATE ?_user_column SET  HITS=?, VISITS=?, NEWRET=?, CLICKS=?, SALES=?, ACTIONS=?,
                                                                        ROI=?, CONVERSIONS=?, GRAPHS=? WHERE USER_ID=?";
        $Db->Query($Query,$ColHits,$ColVisits,$ColNewRet,$ColClicks,$ColSales,$ColActions,$ColROI,$ColConv,$Graphs,$Id);
    }

    //   
    $CheckId=$Db->ReturnValue("SELECT ID FROM ?{PFX}_system_user2lang WHERE UID=? AND PROD_ID=?",
                                                    $Id,$nsProduct->ID);
    if (!$CheckId) {
        $Query = "INSERT INTO ?{PFX}_system_user2lang (UID,PROD_ID,LANG) VALUES (?,?,?)";
        $Db->Query($Query,$Id,$nsProduct->ID,$ULang);
    }
    else {
        $Query = "UPDATE ?{PFX}_system_user2lang SET PROD_ID=?,LANG=? WHERE UID=?";
        $Db->Query($Query,$nsProduct->ID,$ULang,$Id);        
    }

    if ( ($Id==$nsUser->UserId() && $nsUser->CAN_CHANGE_SKIN) || (
           $Id != $nsUser->UserId() && ($Mode=='admins'&&$nsUser->SUPER_ADMIN) || 
            ($Mode=='users'&&$nsUser->ADMIN || ($nsUser->SUPER_USER&&$nsProduct->LICENSE!=3)))
    ) {
        $CheckId=$Db->ReturnValue("SELECT ID FROM ?{PFX}_system_user2skin WHERE UID=? AND PROD_ID=?",
                                                        $Id,$nsProduct->ID);
        if (!$CheckId) {
            $Query = "INSERT INTO ?{PFX}_system_user2skin (UID,PROD_ID,SKIN) VALUES (?,?,?)";
            $Db->Query($Query,$Id,$nsProduct->ID,$USkin);
        }
        else {
            $Query = "UPDATE ?{PFX}_system_user2skin SET PROD_ID=?,SKIN=? WHERE UID=?";
            $Db->Query($Query,$nsProduct->ID,$USkin,$Id);        
        }
    }

    $SetIgnoreUrl="";
    if ($Id==$nsUser->UserId()) {
        if (V($Ignore)) $nsUser->SetCookie(COOKIE_PFX.'skip', "1", time()+60*60*24*10*365, "/");
        else $nsUser->SetCookie(COOKIE_PFX.'skip', "", time()-100, "/");
        if ($Settings['All']->SSL_LINK) {
            $Arr=parse_url($Settings['All']->SSL_LINK);
            if ($Arr['host']!=$_SERVER['HTTP_HOST']) 
                $SetIgnoreUrl=urlencode($Settings['All']->SSL_LINK."pub/ajax.html?Mode=ignore_me&Value=$Ignore");
        }
    }

    $nsProduct->Redir("users", "RUpd=1&EditId=$Id&SetIgnoreUrl=$SetIgnoreUrl");
}

function DeleteUser($Id=false,$Unset=false)
{
    if (!$Id) return false;
    global $Db, $nsProduct, $nsUser,$nsLogs;
    if ($Id==$nsUser->UserId()) return false;

    $EditUser=GetUsers($Id);
    if (!$EditUser) return false;

    $Mode=($EditUser->MERCH_ID)?'users':'admins';
    if ($nsUser->USER_LEVEL>$EditUser->USER_LEVEL) return false;
    $CompanyId=V($EditUser->COMPANY_ID);

    $AdminCnt=$Db->ReturnValue("SELECT COUNT(*) FROM ?_admin WHERE SUPER_ADMIN='1'");
    if (V($EditUser->SUPER_ADMIN)&&$AdminCnt==1) MoveCurrentUserToAdmin();

    if (!$Unset) {
        $Query = "DELETE FROM ?{PFX}_system_user WHERE ID=?";
        $Db->Query($Query,$Id);
    }
    $Query = "DELETE FROM ?_user WHERE USER_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_admin WHERE USER_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_user_settings WHERE USER_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_user_column WHERE USER_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?{PFX}_system_user2lang WHERE UID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?{PFX}_system_user2skin WHERE UID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_user_cache WHERE USER_ID=?";
    $Db->Query($Query,$Id);
    $Query = "DELETE FROM ?_watch WHERE USER_ID=?";
    $Db->Query($Query,$Id);

    $nsProduct->Redir('users',"Mode=$Mode&CompanyId=$CompanyId");
}

function ImportUser($Id=false,$Mode=false)
{
    global $Db,$nsProduct,$nsUser;
    if (!$Id||!$Mode) return false;
    if (!$nsUser->ADMIN||$nsProduct->LICENSE!=3) $Mode='users';

    $CheckUser=GetUsers($Id);
    if ($CheckUser->MERCH_ID||$CheckUser->ADMIN_ID) return false;

    if ($Mode=='admins') $Db->Query("INSERT INTO ?_admin (USER_ID,MODIFIED) VALUES (?,NOW())",$Id);
    if ($Mode=='users') $Db->Query("INSERT INTO ?_user (USER_ID,COMPANY_ID,MODIFIED) VALUES (?,?,NOW())",
                                                            $Id,V($nsUser->COMPANY_ID,0));

    $Query = "INSERT INTO ?_user_column (USER_ID, HITS, NEWRET, CLICKS, SALES, ACTIONS,
                                                                        ROI, CONVERSIONS, GRAPHS) 
                                                                        VALUES (?,'1','1','1','1','1','1','1','1')";
    $Db->Query($Query,$Id);

    $nsProduct->Redir('users',"EditId=$Id");
}

function MoveCurrentUserToAdmin()
{
    global $Db,$nsUser,$nsProduct;
    if (!$nsUser->ADMIN_ID) {
        $Query = "INSERT INTO ?_admin (USER_ID,SUPER_ADMIN,MODIFIED) VALUES (?,'1',NOW())";
        $Db->Query($Query,$nsUser->UserId());
        $Query = "DELETE FROM ?_user WHERE USER_ID=?";
        $Db->Query($Query,$nsUser->UserId());
    }
    else $Db->Query("UPDATE ?_admin SET SUPER_ADMIN='1' WHERE USER_ID=?",$nsUser->UserId());
}

function GetUsers($Id=false)
{
    if ($Id=='new') return false;
    global $Db,$Mode,$nsUser,$nsProduct;
    if (!$nsUser->SUPER_ADMIN && !$nsUser->SUPER_USER && !$nsUser->ADMIN && $Id!=$nsUser->UserId()) 
        return array();
    $WhereArr=array(); $WhereStr="";
    $JoinArr=array(); $JoinStr="";
    $SelectArr=array(); $SelectStr="";
    $Args=array();

    $JoinArr[]="LEFT JOIN ?_user M_USR ON M_USR.USER_ID=SU.ID";
    $JoinArr[]="LEFT JOIN ?_client CL ON CL.ID=M_USR.COMPANY_ID";
    $SelectArr[]="CL.NAME AS COMP_NAME";

    $JoinArr[]="LEFT JOIN ?_admin A_USR ON A_USR.USER_ID=SU.ID";

    if ($Id) {$WhereArr[]="SU.ID=?uid";$Args['uid']=$Id;}

    if ($Id!=$nsUser->UserId()) {
        if ($nsUser->SUPER_ADMIN || ($nsUser->SUPER_USER&&$nsProduct->LICENSE!=3)) 
                $WhereArr[]=" (M_USR.ID IS NOT NULL OR A_USR.ID IS NOT NULL) ";
        if ($nsUser->SUPER_USER && $nsProduct->LICENSE==3) {
                $WhereArr[]=" (M_USR.ID IS NOT NULL AND A_USR.ID IS NULL) ";
                $WhereArr[]=" M_USR.COMPANY_ID = ?cp "; $Args['cp']=$nsUser->COMPANY_ID;
        }
        if ($nsUser->ADMIN && !$nsUser->SUPER_ADMIN && $nsProduct->LICENSE==3) 
                $WhereArr[]=" (M_USR.ID IS NOT NULL OR (A_USR.ID IS NOT NULL AND A_USR.SUPER_ADMIN!='1'))";
    }

    $WhereStr=(!empty($WhereArr))?" WHERE ".implode(" AND ",$WhereArr):"";
    $JoinStr=(!empty($JoinArr))?implode(" \n ",$JoinArr):"";
    $SelectStr=(!empty($SelectArr))?", ".implode(",",$SelectArr):"";

    $List=array();
    $Ids=array();
    $Query = "
        SELECT
        SU.*, UC.*, US.*, SU.ID AS USER_ID,
        0 AS MERCH_ID, 0 AS ADMIN_ID, 0 AS COMPANY_ID, U_LANG.LANG, U_SKIN.SKIN
        $SelectStr
        FROM ?{PFX}_system_user SU
            $JoinStr
            LEFT JOIN ?_user_column UC ON UC.USER_ID=SU.ID 
            LEFT JOIN ?_user_settings US ON US.USER_ID=SU.ID
            LEFT JOIN ?{PFX}_system_user2lang U_LANG ON U_LANG.UID=SU.ID
            LEFT JOIN ?{PFX}_system_user2skin U_SKIN ON U_SKIN.UID=SU.ID
        $WhereStr
    ";
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        $Row->USER_LEVEL=1000;
        $List[$Row->USER_ID]=$Row;
        $Ids[]=$Row->USER_ID;
    }

    if (!empty($Ids)) {
        $Query = "SELECT *, ID AS MERCH_ID, SUPER_USER AS SUPER FROM ?_user WHERE USER_ID IN (?)";
        $Sql = new Query($Query,'ARR',$Ids);
        while ($Row=$Sql->Row()) {
            if ($nsProduct->LICENSE==3) $Row['USER_LEVEL']=($Row['SUPER'])?2:3;
            else  $Row['USER_LEVEL']=($Row['SUPER'])?1:2;
            foreach ($Row as $k=>$v) $List[$Row['USER_ID']]->$k=$v;
        }
        $Query = "SELECT *, ID AS ADMIN_ID, SUPER_ADMIN AS SUPER FROM ?_admin WHERE USER_ID IN (?)";
        $Sql = new Query($Query,'ARR',$Ids);
        while ($Row=$Sql->Row()) {
            if ($nsProduct->LICENSE==3) $Row['USER_LEVEL']=($Row['SUPER'])?0:1;
            else  $Row['USER_LEVEL']=0;     
            foreach ($Row as $k=>$v) $List[$Row['USER_ID']]->$k=$v;
        }
    }

    if ($Id&&!empty($List)) foreach ($List as $Row) return $Row;
    return $List;
}

?>