<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");


/////////////////////////////////////////////
///////// require libraries here
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/customreport.class.php";
require_once SELF."/lib/reports/misc.func.php";
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("admin.reports");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->IncFile("inc/cache.php");

/////////////////////////////////////////////
///////// prepare any variables
$SiteId=V($_REQUEST['SiteId']);
$CpId=V($_REQUEST['CpId']);
$StartDate=(ValidDate($_GP['StartDate']))? $_GP['StartDate']:false;
$EndDate=(ValidDate($_GP['EndDate']))? $_GP['EndDate']:false;
$ViewDate=(ValidDate($_GP['ViewDate']))? $_GP['ViewDate']:false;
$FormClicked=V($_REQUEST['FormClicked']);
$DynamicPeriod=V($_REQUEST['DynamicPeriod'],"-1");
if($DynamicPeriod=='0-a-0') $DynamicPeriod="-1";

$StartDay=false;
$EndDay=false;
$SitesArr=array();


$nsLang->TplInc("constructor/periods");
//    
$FormPeriodsArr=array();
$Query = "SELECT * FROM ?_periods WHERE COMPANY_ID IN (0, $CpId) AND DELETED != '1' ORDER BY TEMPLATE";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
    $FormPeriodsArr[$Row->TEMPLATE]=$Row;
}
$PArr=array_keys($FormPeriodsArr);
usort($PArr,"SortPeriods");
$FormPeriodsArr=SyncKeysWValues($FormPeriodsArr,$PArr);    


if (!ValidId($SiteId)&&!ValidId($CpId)) $nsProduct->Redir("default");
if (ValidId($CpId)) {
	$Query = "SELECT * FROM ?_client WHERE ID = ?";
	$Comp=$Db->Select($Query, false, $CpId);
	$PageTitle=$Comp->NAME;
	$Query = "SELECT * FROM ?_site WHERE COMPANY_ID=?";
	$Sql = new Query($Query, false, $CpId);
	while ($Row=$Sql->Row()) {
		$SitesArr[]=$Row;
		$IdArr[]=$Row->ID;
	}
	$SiteList=implode(",", $IdArr);
}
if (ValidId($SiteId)) {
	$Query = "SELECT * FROM ?_site WHERE ID = ?";
	$Site=$Db->Select($Query, false, $SiteId);
	$PageTitle=$Site->HOST;
	$SiteList=$SiteId;
}
$PageTitle.=" : ".$Lang['Title'];

$ProgPath[0]['Name']=$Lang['MReports'];
$ProgPath[0]['Url']=getUrl("reports", "CpId=$CpId&SiteId=$SiteId", "admin");
$ProgPath[1]['Name']=$Lang['OtherReports'];
$ProgPath[1]['Url']=getUrl("reports", "Tab=Custom&CpId=$CpId&SiteId=$SiteId", "admin");
$ProgPath[2]['Name']=$Lang['Compare'];
$ProgPath[2]['Url']=getUrl("compare", "CpId=$CpId&SiteId=$SiteId", "report");



if (!$StartDate&&!$EndDate&&!$ViewDate&&!$FormClicked) $ViewDate=UserDate();
$MenuSection="logs";


/////////////////////////////////////////////
///////// call any process functions


/////////////////////////////////////////////
///////// display section here

$WhereArr=array();
$WhereStr="";
$DynamicDate="";
if ($DynamicPeriod!="-1" && $DynamicPeriod!==""  && $DynamicPeriod!=="0-a-0") {
    $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
    $StartDay=$StartDate=$DynamicDate['StartDate'];
    $EndDay=$EndDate=$DynamicDate['EndDate'];
    $ViewDate="";
} else {
    if ($StartDate) $StartDay=$StartDate." 00:00:00";
    if ($EndDate) $EndDay=$EndDate." 23:59:59";
}
if ($ViewDate) {
	$EndDay=$Db->ReturnValue("SELECT DATE_ADD('$ViewDate', INTERVAL 1 DAY)")." 23:59:59";
	$StartDay=$ViewDate." 00:00:00";
}
if ($StartDay&&!$EndDay) $WhereArr[]="S_LOG.STAMP >= DATE_ADD('$StartDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
if (!$StartDay&&$EndDay) $WhereArr[]="S_LOG.STAMP <= DATE_ADD('$EndDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
if ($StartDay&&$EndDay) $WhereArr[]="S_LOG.STAMP BETWEEN DATE_ADD('$StartDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) AND DATE_ADD('$EndDay', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
$WhereArr[]="S_LOG.SITE_ID IN ($SiteList)";
if (Count($WhereArr)>0) 	$WhereStr=implode(" AND ", $WhereArr);


$TotalCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
    FROM  ?_{$CpId}_stat_log S_LOG 
    WHERE $WhereStr
";
$RefCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_log S_LOG 
    INNER JOIN ?_referer_set RS
    ON RS.ID=S_LOG.REFERER_SET
    WHERE RS.HOST_ID>0
    AND $WhereStr
";
$SearchCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_log S_LOG 
    INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
    INNER JOIN ?_host H ON H.ID=RS.HOST_ID
    INNER JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
    WHERE HG.NAME_KEY != ''
    AND $WhereStr
";
$KeyCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_log S_LOG 
    INNER JOIN ?_referer_set RS
    ON RS.ID=S_LOG.REFERER_SET
    WHERE RS.NATURAL_KEY>0
    AND $WhereStr
";
$ActionCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_action S_ACTION
    INNER JOIN ?_{$CpId}_stat_log S_LOG 
    ON S_LOG.ID=S_ACTION.LOG_ID
    WHERE $WhereStr
";
$SaleCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_sale S_SALE
    INNER JOIN ?_{$CpId}_stat_log S_LOG 
    ON S_LOG.ID=S_SALE.LOG_ID
    WHERE $WhereStr
";
$ClickCntQuery = "
    SELECT 
    COUNT(DISTINCT S_LOG.VISITOR_ID)  AS CNT
    FROM ?_{$CpId}_stat_click S_CLICK
    INNER JOIN ?_{$CpId}_stat_log S_LOG 
    ON S_LOG.ID=S_CLICK.LOG_ID
    WHERE $WhereStr
";

$QueryArr=array(
                    "Total"=>$TotalCntQuery,
                    "Ref"=>$RefCntQuery,
                    "Search"=>$SearchCntQuery,
                    "Key"=>$KeyCntQuery,
                    "Action"=>$ActionCntQuery
                    );
if ($nsProduct->LICENSE!=4) $QueryArr = array_merge($QueryArr, array("Sale"=>$SaleCntQuery, "Click"=>$ClickCntQuery));
$Cache=new CustomReport($CpId);
$Cache->CustomId=$CustomReportId=1;
$Cache->CacheJob($QueryArr,1);

//$EnableCacheChecking=$Cache->EnableCacheChecking;

$Data = @$Cache->Data;


//Dump($Cache->Data);
///  
$TotalCnt=V($Data['Total']->CNT,0);
$TotalCntPerc=100;

///   
$RefCnt=V($Data['Ref']->CNT,0);
$RefCntPerc=($RefCnt>0)?round((100/$TotalCnt)*$RefCnt, 2):0;

//   
$SearchCnt=V($Data['Search']->CNT,0);
$SearchCntPerc=($SearchCnt>0)?round((100/$TotalCnt)*$SearchCnt, 2):0;

///   
$NoRefCnt=$TotalCnt-$RefCnt;
$NoRefCntPerc=($NoRefCnt>0)?round((100/$TotalCnt)*$NoRefCnt, 2):0;

///    
$KeyCnt=V($Data['Key']->CNT,0);
$KeyCntPerc=($KeyCnt>0)?round((100/$TotalCnt)*$KeyCnt, 2):0;

///   
$ActionCnt=V($Data['Action']->CNT,0);
$ActionCntPerc=($ActionCnt>0)?round((100/$TotalCnt)*$ActionCnt, 2):0;

if ($nsProduct->LICENSE !=4 ) {
///   
$SaleCnt=V($Data['Sale']->CNT,0);
$SaleCntPerc=($SaleCnt>0)?round((100/$TotalCnt)*$SaleCnt, 2):0;

///    
$ClickCnt=V($Data['Click']->CNT,0);
$ClickCntPerc=($ClickCnt>0)?round((100/$TotalCnt)*$ClickCnt, 2):0;
}

include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here





/////////////////////////////////////////////
///////// library section






?>