<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

require_once SELF."/lib/company.func.php";
require_once SELF."/class/pagenums2.class.php";
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/lib/delete.func.php";
require_once SELF."/lib/call_card.func.php";
require_once SELF.'/class/report_data.class.php';
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/export_params.func.php";

if (!function_exists('RefCut')) {
    function RefCut($Ref, $MaxLen=45) {
        $Len = strlen($Ref); return ($Len>$MaxLen) ? substr_replace($Ref, "...", 30, $Len-30-(($MaxLen-30)+3)) : $Ref; }
}
if (!function_exists('LogStamp')) {
    function LogStamp($Stamp) { return _date($Stamp, 'datetime'); }
}

$nsLang->TplInc("inc/menu");
$nsLang->TplInc("pagenums.class");
$nsLang->TplInc("inc/getuserhost");
$nsLang->TplInc("inc/filter");
$nsLang->TplInc("constructor/periods");

$ModesWDel=array("Sales", "Actions", "Clicks", "Split");
$UserRss = false;
$StartDay=$EndDay=$PrevDate=$NextDate=false;

extract(VPack(array('SiteId','CpId','Mode','Filter','FilterFor','Limit','Start','ViewDate', 'StartDate', 'EndDate',
                                   'FormClicked','DeleteId','DeleteArr','UserOrder','ExactFilter', 'DoDelete', 'DynamicPeriod', 'Rss', 'Params'),
                         array('Mode'=>'Hits', 'Limit'=>50, 'Start'=>0, 'UserOrder'=>'-1', 'DynamicPeriod'=>'-1')));

if ($Params) @extract(@unserialize(@gzuncompress(@base64_decode($Params))));

if ($Mode=='Hits') $Rss=false;
if ($Rss) {
    $Query = "SELECT *, UNIX_TIMESTAMP(LAST_REC_DATE) AS STAMP FROM ?_user_rss WHERE USER_ID=? AND LOG_ID=?";
    $Sql = new Query($Query, false, $nsUser->UserId(), $Mode);
    while ($Row=$Sql->Row()) {
        if ($Row->PARAMS != $Params) continue;
        $UserRss = $Row;
    }
    if (!$UserRss) {
        $Query = "INSERT INTO ?_user_rss (USER_ID, LOG_ID, PARAMS, LAST_REC_DATE) VALUES (?,?,?, DATE_ADD(NOW(), INTERVAL -1 DAY))";
        $Db->Query($Query, $nsUser->UserId(), $Mode, $Params);
        $UserRss = $Db->Select("SELECT *, UNIX_TIMESTAMP(LAST_REC_DATE) AS STAMP FROM ?_user_rss WHERE ID=?", false, $Db->LastInsertId);
    }
    $StartDate = $EndDate = $ViewDate = false;
    $StartDay = date('Y-m-d H:i:s', $UserRss->STAMP);
    //$DynamicPeriod = '7-d-1';
}
if ($StartDate || $EndDate || $ViewDate) $DynamicPeriod = '-1';

$AllowedLogs = array('Hits','Actions','Ref','Key');
if ($nsProduct->LICENSE!=4) $AllowedLogs = array_merge($AllowedLogs, array('Clicks', 'Sales', 'Split', 'Fraud'));
if (!in_array($Mode, $AllowedLogs))  $nsProduct->Redir("default", "", "admin");
$Print = V($_REQUEST['_print']);
if (@$_REQUEST['_csv'] || @$_REQUEST['_xml'] || @$_REQUEST['NoLimit']) $Limit = 1000000;
if ($Rss) $Limit = V($Setting['All']->RSS_ROWS, 200);

$UserOrder=PrepareUserOrder($nsUser->DEF_LOGS_ORDER, $UserOrder, $Mode);
$ProgPath=array(array('Name'=>$Lang['MReports'], 'Url'=>getUrl("reports", "CpId=$CpId&SiteId=$SiteId&Tab=Logs", "admin")));
$CacheEnable=CacheEnabled($Settings);
$AllSites = !$SiteId;
$MenuSection="logs";

if (!$ViewDate&&!$StartDate&&!$EndDate&&!$FormClicked) $ViewDate=UserDate();

if ($FilterFor=="IP" && !ValidIp($Filter)) {
	$Filter=false;
	$Logs->Err($Lang['IpErr']);
}

$nsProduct->SearchAction=$nsProduct->Action.":$Mode";

if ($Mode=="Hits") $PageTitle=$Lang['LogHits'];
if ($Mode=="Clicks") $PageTitle=$Lang['LogClicks'];
if ($Mode=="Actions") $PageTitle=$Lang['LogActions'];
if ($Mode=="Sales") $PageTitle=$Lang['LogSales'];
if ($Mode=="Split") $PageTitle=$Lang['LogSplits'];
if ($Mode=="Ref") $PageTitle=$Lang['LogRef'];
if ($Mode=="Key") $PageTitle=$Lang['LogKeys'];
if ($Mode=="Fraud") $PageTitle=$Lang['ClickFraud'];

$ProgPath[1]['Name']=$PageTitle;
$ProgPath[1]['Url']=$nsProduct->SelfAction("Mode=$Mode&CpId=$CpId&SiteId=$SiteId");

$Get="&CpId=$CpId&SiteId=$SiteId&FormClicked=1&DynamicPeriod=$DynamicPeriod&ViewDate=$ViewDate&StartDate=$StartDate&EndDate=$EndDate";
$Get .= "&Filter=$Filter&FilterFor=$FilterFor&";

if (!$CpId) $CpId=@$_SESSION['CpId'];
if (!$CpId) $nsProduct->Redir("default", "", "admin");
$Client=GetCompany($CpId);
if (!$Client) $nsProduct->Redir("default", "", "admin");

$ShowPageTitles=array();
$SitesArr=array();
$SitesIds=array();
$Query = "SELECT S.ID, S.HOST, C.SHOW_PAGE_TITLE FROM ?_site S
        INNER JOIN ?_config C ON C.SITE_ID=S.ID
        WHERE S.COMPANY_ID=?
";
$Sql = new Query($Query, false, $CpId);
while ($Row=$Sql->Row()) {
    $ShowPageTitles[$Row->ID]=$Row->SHOW_PAGE_TITLE;
	$SitesArr[$Row->ID]=$Row;
	$SitesIds[]=$Row->ID;
}
if (empty($SitesIds)) $SitesIds[]=-1;
if ($SiteId && in_array($SiteId, $SitesIds)) $SitesIds = array(0=>$SiteId);

$FormPeriodsArr=GetPeriodsList($CpId);

$FilterNames=array();

if (!$nsUser->DEMO && $DoDelete) {
	if ($Mode=="Sales" && $DeleteId&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteOneSale($CpId, $DeleteId);
	if ($Mode=="Actions" && $DeleteId&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteOneAction($CpId, $DeleteId);
	if ($Mode=="Clicks" && $DeleteId&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteOneClick($CpId, $DeleteId);

    if ($Mode=="Sales" && $DeleteArr&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteMultiSale($CpId, $DeleteArr);
    if ($Mode=="Actions" && $DeleteArr&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteMultiAction($CpId, $DeleteArr);
    if ($Mode=="Clicks" && $DeleteArr&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteMultiClick($CpId, $DeleteArr);

    if ($Mode=="Split"&&$DeleteArr&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteMultiSplit($CpId, $DeleteArr);
	if ($Mode=="Split"&&$DeleteId&&($nsUser->ADMIN||$nsUser->SUPER_USER)) DeleteOneSplit($CpId, $DeleteId);
}

if (!$Rss) {
    if ($ViewDate) {
    	$StartDay=$ViewDate." 00:00:00";
    	$EndDay=$ViewDate." 23:59:59";
        $PrevDate = $Db->ReturnValue("SELECT DATE_ADD(?, INTERVAL -1 DAY)",$ViewDate);
        $NextDate = $Db->ReturnValue("SELECT DATE_ADD(?, INTERVAL 1 DAY)", $ViewDate);
    }
    if ($StartDate && !@$StartDay) $StartDay=$StartDate." 00:00:00";
    if ($EndDate) $EndDay=$EndDate." 23:59:59";

    if ($DynamicPeriod!="-1" && $DynamicPeriod!=="" ) {
        $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
        $StartDay=$DynamicDate['StartDate'];
        $EndDay=$DynamicDate['EndDate'];
        $ViewDate="";
    }
}

$WhereStr=$JoinStr=$CntJoinStr="";
$WhereArr = $Args=$JoinArr=$CntJoinArr=array();

if ($StartDay&&!$EndDay) $WhereArr[]="S_LOG.STAMP >= DATE_ADD(?start, INTERVAL ?_tz HOUR_MINUTE)";
if (!$StartDay&&$EndDay) $WhereArr[]="S_LOG.STAMP <= DATE_ADD(?end, INTERVAL ?_tz HOUR_MINUTE)";
if ($StartDay&&$EndDay) $WhereArr[]="S_LOG.STAMP BETWEEN DATE_ADD(?start, INTERVAL ?_tz HOUR_MINUTE)
                                                                        AND DATE_ADD(?end, INTERVAL ?_tz HOUR_MINUTE)";
$Args['start'] = $StartDay;
$Args['end'] = $EndDay;
$Args['_tz'] = $nsUser->_SQL_TZ;
$Args['tz'] = $nsUser->SQL_TZ;
$Args['filter'] = $ExactFilter ? $Filter : "%$Filter%";
$Args['cp'] = $CpId;
$Args['site'] = $SitesIds;

if ($Filter) {
	if ($FilterFor=="IP") {
		$IpId=$Db->ReturnValue("SELECT ID FROM ?_ip WHERE IP=?", $Filter);
        $Args['ipid'] = $IpId;
		$WhereArr[]="V.LAST_IP_ID=?ipid";
		$JoinArr[]="INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID";
	}
	if ($FilterFor=="HIT_PATH") {
		$WhereArr[]="(SP.PATH LIKE ?filter OR Q.QUERY_STRING LIKE ?filter OR CONCAT(SP.PATH, '?', Q.QUERY_STRING) LIKE ?filter)";
		$JoinArr[]="INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID";
		$JoinArr[]="INNER JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID";
	}
	if ($FilterFor=="HIT_REF") {
		$WhereArr[]="R.REFERER LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET";
		$JoinArr[]="INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID";
	}
	if ($FilterFor=="CLICK_CAMP_NAME") {
		$WhereArr[]="CP.NAME LIKE ?filter ";
		$JoinArr[]="	INNER  JOIN ?_camp_piece CP	ON CP.ID=S_CLICK.CAMP_ID";
	}
	if ($FilterFor=="CLICK_HOST") {
		$WhereArr[]="H.HOST  LIKE ?filter ";
		$JoinArr[]="INNER 	JOIN ?_host H ON H.ID=S_CLICK.SOURCE_HOST_ID";
	}
	if ($FilterFor=="CLICK_KEYWORD") {
		$WhereArr[]="K.KEYWORD LIKE ?filter ";
		$JoinArr[]="INNER 	JOIN ?_keyword K ON K.ID=S_CLICK.KEYWORD_ID";
	}
	if ($WhereArr=="ACTION_NAME") {
		$WhereArr[]="VA.NAME LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_visitor_action VA ON VA.ID=S_ACTION.ACTION_ID";
	}
	if ($FilterFor=="ACTION_ITEM") {
		$WhereArr[]="AI.NAME LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_visitor_action VA ON VA.ID=S_ACTION.ACTION_ID";
		$JoinArr[]="INNER JOIN ?_action_set TAS ON TAS.STAT_ACTION_ID=S_ACTION.ACTION_ID AND TAS.COMPANY_ID=?cp";
		$JoinArr[]="INNER JOIN ?_action_item AI ON AI.ID=TAS.ACTION_ITEM_ID AND AI.COMPANY_ID=?cp";
	}
	if ($FilterFor=="SALE_NAME") {
		$WhereArr[]="SI.NAME LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_sale_set SS ON SS.SALE_ID=S_SALE.ID";
		$JoinArr[]="INNER JOIN ?_sale_item SI ON SI.ID=SS.ITEM_ID";
	}
	if ($FilterFor=="SALE_CUSTOM") {
		$WhereArr[]="S_SALE.CUSTOM_ORDER_ID LIKE ?filter ";
	}
	if ($FilterFor=="SPLIT_PATH") {
		$WhereArr[]="SP.PATH LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID";
	}
	if ($FilterFor=="SPLIT_NAME") {
		$WhereArr[]="CP.NAME LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_camp_piece CP ON CP.ID=S_SPLIT.SPLIT_ID";
	}
	if ($FilterFor=="REF_REFERER") {
		$JoinArr[]="INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET";
		$JoinArr[]="INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID";
		$FilterArr[]="R.REFERER LIKE ?filter ";
	}
	if ($FilterFor=="KEY_WORD") {
		$WhereArr[]="K.KEYWORD LIKE ?filter ";
		$JoinArr[]="INNER JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY";
	}
    if ($FilterFor=='TAGS') {
        $JoinArr[]="INNER JOIN ?_sale_tag_rel STR ON STR.COMPANY_ID=?cp AND STR.SALE_ID=S_SALE.ID";
        $JoinArr[]="INNER JOIN ?_tag TG ON TG.ID=STR.TAG_ID";
        $WhereArr[]="TG.TAG LIKE ?filter ";
    }
    if ($FilterFor=='SALE_SOURCE') {
        $CntJoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S_PARENT ON S_PARENT.ID=S_LOG.COOKIE_LOG";
        $CntJoinArr[]="LEFT JOIN ?_referer_set RS ON RS.ID=S_PARENT.REFERER_SET";
        $CntJoinArr[]="LEFT JOIN ?_host H ON H.ID=RS.HOST_ID";
        $CntJoinArr[]="LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID";
        $CntJoinArr[]="LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_PARENT.ID";
        $CntJoinArr[]="LEFT JOIN ?_host H2 ON H2.ID = S_CLICK.SOURCE_HOST_ID";
        $CntJoinArr[]="LEFT JOIN ?_host_grp HG2 ON HG2.ID=H2.GRP_ID";
        $WhereArr[] = "(H.HOST LIKE ?filter OR HG.NAME LIKE ?filter OR H2.HOST LIKE ?filter OR HG2.NAME LIKE ?filter )";
    }
    if ($FilterFor=='SALE_KEYWORD') {
        $CntJoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S_PARENT ON S_PARENT.ID=S_LOG.COOKIE_LOG";
        $CntJoinArr[]="LEFT JOIN ?_referer_set RS ON RS.ID=S_PARENT.REFERER_SET";
        $CntJoinArr[]="LEFT JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY";
        $CntJoinArr[]="LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_PARENT.ID";
        $CntJoinArr[]="LEFT JOIN ?_keyword K2 ON K2.ID=S_CLICK.KEYWORD_ID";
        $WhereArr[]="(K.KEYWORD LIKE ?filter OR K2.KEYWORD LIKE ?filter)";
    }
}

$WhereArr[]="S_LOG.SITE_ID IN (?site)";

$WhereStr= !empty($WhereArr) ? "WHERE ".implode(" AND ", array_unique($WhereArr)) : '';
$JoinStr= !empty($JoinArr) ? implode("\n", array_unique($JoinArr)) : '';
$CntJoinStr= !empty($CntJoinArr) ? implode("\n", array_unique($CntJoinArr)) : '';

$R = new ReportData();
$R->EnableSorting=false;
$R->ShowNextStep=false;
$R->ShowSimpleName=true;
$R->EnableSubValues=false;
$R->ShowNoRecords = true;
$R->ShowSubSum = false;
$R->ShowRealSum = false;
$R->XlsExportEnable = $R-> CsvExportEnable = !$Print;
$R->JsFilterObject = 'pathFilter';
$R->Id = 'logs';
$R->TopCaption = $PageTitle;
$R->ReportCaptionLast = $PageTitle;
$R->ColumnOrder = array('STAMP','LAST_IP');
$R->SuperColumns = array();
$R->AddColumn('STAMP', $Lang['Time'], false, false, array('FormatFunc'=>'LogStamp', 'Width'=>'10%', 'String'=>true));
$R->AddColumn('LAST_IP', $Lang['IP'], false, false, array('NoFormat'=>true, 'Width'=>'10%', 'String'=>true));

if ($Mode=="Hits") {
    $Pages=new PageNums($Db->ReturnValue("SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG $JoinStr $WhereStr ", $Args), $Limit);
    $Pages->Calculate();

	$Query = "
		SELECT S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
			S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP,
			SP.PATH, Q.QUERY_STRING, R.REFERER, SH.HOST AS SITE_HOST, PT.TITLE AS PTITLE

			FROM ?_{$CpId}_stat_log S_LOG
			INNER JOIN ?_site_page SP 	ON SP.ID=S_LOG.PAGE_ID
            INNER JOIN ?_page_query PQ
                    ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID
            LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID
		    LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID
		    LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
			LEFT JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
			LEFT JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID
			LEFT JOIN ?_referer R ON R.ID=RS.REFERER_ID
		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'REFERER'));
    $R->AddColumn('PATH', $Lang['Page'], false, false, array('NoFormat'=>true, 'Width'=>'40%', 'String'=>true));
    $R->AddColumn('REFERER', $Lang['Ref'], false, false, array('NoFormat'=>true, 'Width'=>'40%', 'String'=>true));
	$FilterNames['HIT_PATH']=$Lang['ByPage'];
	$FilterNames['HIT_REF']=$Lang['ByRef'];
}

if ($Mode=="Clicks") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID
            $JoinStr $WhereStr
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, SH.HOST AS SITE_HOST,
        S_CLICK.CAMP_ID, CP.NAME AS CAMP_NAME,
        S_CLICK.KEYWORD_ID, K.KEYWORD AS PAID_KEYWROD, K1.KEYWORD AS NATURAL_KEYWORD,
        H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME,
		SP.PATH AS PATH, S_CLICK.ID AS DELETE_ID, PT.TITLE AS PTITLE,
        R.REFERER AS SOURCE_REFERER

		FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID
        INNER JOIN ?_site_page SP   ON SP.ID=S_LOG.PAGE_ID
        INNER JOIN ?_page_query PQ
            ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID

        INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
        INNER JOIN ?_camp_piece CP ON CP.ID=S_CLICK.CAMP_ID
        INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID

        LEFT JOIN ?_host H ON H.ID=S_CLICK.SOURCE_HOST_ID
        LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
        LEFT JOIN ?_keyword K ON K.ID=S_CLICK.KEYWORD_ID
        LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=S_LOG.VISITOR_ID AND CV.COMPANY_ID=?cp

        LEFT JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
        LEFT JOIN ?_referer R ON R.ID=RS.REFERER_ID
        LEFT JOIN ?_keyword K1 ON K1.ID=RS.NATURAL_KEY

        LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID

		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'CAMP_NAME', 'CLICK_SOURCE', 'PAID_KEYWROD', 'NATURAL_KEYWORD'));
    $R->AddColumn('PATH', $Lang['LandingPage'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('CAMP_NAME', $Lang['Camp'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('CLICK_SOURCE', $Lang['RefSource'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('PAID_KEYWROD', $Lang['PaidKey'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('NATURAL_KEYWORD', $Lang['NaturalKey'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['CLICK_CAMP_NAME']=$Lang['ByCampName'];
    $FilterNames['CLICK_HOST']=$Lang['BySource'];
    $FilterNames['CLICK_KEYWORD']=$Lang['ByKey'];
}

if ($Mode=="Fraud") {
    $CntQuery = "SELECT COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.ID
        $JoinStr
        $WhereStr AND S_CLICK.FRAUD='1'
        GROUP BY S_LOG.VISITOR_ID
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
		S_LOG.ID, S_LOG.VISITOR_ID, 	I.IP AS LAST_IP, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.SITE_ID, 	COUNT(S_LOG.ID) AS FRAUD

		FROM ?_{$CpId}_stat_log S_LOG
		INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.ID
		INNER JOIN ?_camp_piece CP ON CP.ID=S_CLICK.CAMP_ID
		INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_ip I  ON I.ID=V.LAST_IP_ID
		$WhereStr 	AND S_CLICK.FRAUD='1'

		GROUP BY S_LOG.VISITOR_ID
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('CAMP_NAME', 'FRAUD', 'TOTAL_CLICK'));
    $R->AddColumn('CAMP_NAME', $Lang['Camp'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('FRAUD', $Lang['FraudCount'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('TOTAL_CLICK', $Lang['TotalClicks'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['CLICK_CAMP_NAME']=$Lang['ByCampName'];
}

if ($Mode=="Actions") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_{$CpId}_stat_action S_ACTION ON S_ACTION.LOG_ID=S_LOG.ID
            $JoinStr $WhereStr
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
		S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, VA.NAME AS ACTION_NAME, AI.NAME AS ACTION_ITEM,
		SH.HOST AS SITE_HOST, S_ACTION.ID AS DELETE_ID, SP.PATH AS PATH, PT.TITLE AS PTITLE

		FROM ?_{$CpId}_stat_log S_LOG

		INNER JOIN ?_{$CpId}_stat_action S_ACTION 	ON S_ACTION.LOG_ID=S_LOG.ID
		INNER JOIN ?_site_page SP 	ON SP.ID=S_LOG.PAGE_ID
        INNER JOIN ?_page_query PQ
            ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID
        LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID
		INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_visitor_action VA 	ON VA.ID=S_ACTION.ACTION_ID
		LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID
		LEFT JOIN ?_action_set ACS ON ACS.STAT_ACTION_ID=S_ACTION.ID AND ACS.COMPANY_ID=?cp
		LEFT JOIN ?_action_item AI ON AI.ID=ACS.ACTION_ITEM_ID AND AI.COMPANY_ID=?cp
		LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID

		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'ACTION_NAME', 'ACTION_ITEM'));
    $R->AddColumn('PATH', $Lang['Page'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('ACTION_NAME', $Lang['Action'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('ACTION_ITEM', $Lang['ActionItem'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['ACTION_NAME']=$Lang['ByActionName'];
    $FilterNames['ACTION_ITEM']=$Lang['ByActionTarget'];
}

if ($Mode=="Sales") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
                INNER JOIN ?_{$CpId}_stat_sale S_SALE ON S_SALE.LOG_ID=S_LOG.ID
                $CntJoinStr
                $JoinStr $WhereStr
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
			S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
			S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, S_SALE.COST AS SALE_COST,
			SS.QUANT, (SS.COST*SS.QUANT) AS COST, SI.NAME AS PRODUCT_NAME, SH.HOST AS SITE_HOST, S_SALE.ID AS DELETE_ID, S_SALE.CUSTOM_ORDER_ID,
			S_SALE.ADDITIONAL, S_SALE.ID AS SALE_ID,
            K.KEYWORD AS NATURAL_KEYWORD, K2.KEYWORD AS PAID_KEYWORD,
            H.HOST AS NATURAL_HOST, HG.NAME AS NATURAL_HOST_NAME,
            H2.HOST AS PAID_HOST, HG2.NAME AS PAID_HOST_NAME

			FROM ?_{$CpId}_stat_log S_LOG
			INNER JOIN ?_{$CpId}_stat_sale S_SALE ON S_SALE.LOG_ID=S_LOG.ID
			INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
			LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID
			LEFT JOIN ?_sale_set SS ON SS.SALE_ID=S_SALE.ID AND SS.COMPANY_ID=?cp
			LEFT JOIN ?_sale_item SI 	ON SI.ID=SS.ITEM_ID AND SI.COMPANY_ID=?cp
			LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID

            LEFT JOIN ?_{$CpId}_stat_log S_PARENT ON S_PARENT.ID=S_LOG.COOKIE_LOG

            LEFT JOIN ?_referer_set RS ON RS.ID=S_PARENT.REFERER_SET
            LEFT JOIN ?_host H ON H.ID=RS.HOST_ID
            LEFT JOIN ?_referer R ON R.ID=RS.REFERER_ID
            LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
            LEFT JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY

            LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_PARENT.ID
            LEFT JOIN ?_camp_piece CP ON CP.ID = S_CLICK.CAMP_ID
            LEFT JOIN ?_keyword K2 ON K2.ID=S_CLICK.KEYWORD_ID
            LEFT JOIN ?_host H2 ON H2.ID = S_CLICK.SOURCE_HOST_ID
            LEFT JOIN ?_host_grp HG2 ON HG2.ID=H2.GRP_ID

            LEFT JOIN ?_{$CpId}_stat_split S_SPLIT ON S_SPLIT.LOG_ID=S_PARENT.ID
            LEFT JOIN ?_camp_piece CP2 ON CP2.ID=S_SPLIT.SPLIT_ID
            ".($FilterFor=='TAGS'?$JoinStr:'')."
			$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('SITE_HOST', 'CUSTOM_ORDER_ID', 'PRODUCT_NAME',
                                                                                                             'COST','ADDITIONAL','TAGS','SALE_SOURCE', 'SALE_KEYWORD'));
    $R->AddColumn('SITE_HOST', $Lang['Site'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('CUSTOM_ORDER_ID', $Lang['CustomId'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('PRODUCT_NAME', $Lang['Item'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('COST', $Lang['Cost'], false, false, array('FormatFunc'=>'ShowCost', 'Money'=>true));
    $R->AddColumn('ADDITIONAL', $Lang['AddInfo'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('TAGS', $Lang['Tags'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('SALE_SOURCE', $Lang['RefSource'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('SALE_KEYWORD', $Lang['Key'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['SALE_NAME']=$Lang['ByItem'];
    $FilterNames['SALE_CUSTOM']=$Lang['ByCustomId'];
    $FilterNames['SALE_SOURCE']=$Lang['BySaleSource'];
    $FilterNames['SALE_KEYWORD']=$Lang['BySaleKeyword'];
    $FilterNames['TAGS']=$Lang['ByTag'];
}

if ($Mode=="Split") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_{$CpId}_stat_split S_SPLIT ON S_SPLIT.LOG_ID=S_LOG.ID
            $JoinStr $WhereStr
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
		S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, S_SPLIT.SPLIT_ID, S_LOG.PAGE_ID,
		CP.NAME AS SPLIT_NAME, SP.PATH, Q.QUERY_STRING, SH.HOST AS SITE_HOST, S_SPLIT.ID AS DELETE_ID, PT.TITLE AS PTITLE

		FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_{$CpId}_stat_split S_SPLIT ON S_SPLIT.LOG_ID=S_LOG.ID
		INNER JOIN ?_camp_piece CP ON CP.ID=S_SPLIT.SPLIT_ID
		INNER JOIN ?_site_page SP 	ON SP.ID=S_LOG.PAGE_ID
        INNER JOIN ?_page_query PQ
            ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID
        LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID
		INNER JOIN ?_split_test ST 	ON ST.SUB_ID=S_SPLIT.SPLIT_ID
		INNER JOIN ?_split_page SPP 	ON SPP.SPLIT_ID=ST.ID AND SPP.PAGE_ID=S_LOG.PAGE_ID

		LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID
		LEFT JOIN ?_query Q ON Q.ID=SPP.QUERY_ID
		LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'SPLIT_NAME'));
    $R->AddColumn('PATH', $Lang['LandingPage'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('SPLIT_NAME', $Lang['SplitName'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['SPLIT_PATH']=$Lang['ByPage'];
    $FilterNames['SPLIT_NAME']=$Lang['BySplitName'];
}

if ($Mode=="Ref") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
            $JoinStr $WhereStr AND S_LOG.REFERER_SET>0
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
		S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, K.KEYWORD, R.REFERER,
		SH.HOST AS SITE_HOST, SP.PATH, PT.TITLE AS PTITLE,
        H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME

		FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
        LEFT JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY
		INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID
		INNER JOIN ?_site_page SP 	ON SP.ID=S_LOG.PAGE_ID
        INNER JOIN ?_host H ON H.ID=RS.HOST_ID
        LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
        INNER JOIN ?_page_query PQ
            ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID
        LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID
		LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID
		LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'REFERER', 'CLICK_SOURCE', 'KEYWORD'));
    $R->AddColumn('PATH', $Lang['LandingPage'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('REFERER', $Lang['Ref'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('CLICK_SOURCE', $Lang['RefSource'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('KEYWORD', $Lang['Key'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['REF_REFERER']=$Lang['ByRef'];
}

if ($Mode=="Key") {
    $CntQuery = "SELECT COUNT(S_LOG.ID) FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
            $JoinStr $WhereStr AND S_LOG.REFERER_SET>0 AND RS.NATURAL_KEY>0
    ";
    $Pages=new PageNums($Db->ReturnValue($CntQuery, $Args),$Limit);
    $Pages->Calculate();

	$Query = "
		SELECT
		S_LOG.ID, UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL ?tz HOUR_MINUTE)) AS STAMP,
		S_LOG.VISITOR_ID, S_LOG.SITE_ID, I.IP AS LAST_IP, H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME,
        K.KEYWORD, 	SP.PATH AS PATH, Q.QUERY_STRING, SH.HOST AS SITE_HOST, PT.TITLE AS PTITLE, R.REFERER AS SOURCE_REFERER

		FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
		INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
        INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID
		INNER JOIN ?_host H ON H.ID=RS.HOST_ID
        LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
		INNER JOIN ?_keyword K ON K.ID=RS.NATURAL_KEY
		INNER JOIN ?_site_page SP 	ON SP.ID=S_LOG.PAGE_ID
		LEFT JOIN ?_ip I ON I.ID=S_LOG.IP_ID LEFT JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID
		LEFT JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
        INNER JOIN ?_page_query PQ
            ON PQ.SITE_HOST_ID=S_LOG.SITE_HOST_ID AND PQ.PAGE_ID=S_LOG.PAGE_ID AND PQ.QUERY_ID=S_LOG.QUERY_ID
        LEFT JOIN ?_page_title PT ON PT.ID=PQ.TITLE_ID
		$WhereStr
		ORDER BY S_LOG.STAMP $UserOrder
		LIMIT {$Pages->PageStart}, {$Pages->Limit}
	";

    $R->ColumnOrder = array_merge($R->ColumnOrder, array('PATH', 'CLICK_SOURCE', 'KEYWORD'));
    $R->AddColumn('PATH', $Lang['LandingPage'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('CLICK_SOURCE', $Lang['RefSource'], false, false, array('NoFormat'=>true, 'String'=>true));
    $R->AddColumn('KEYWORD', $Lang['Key'], false, false, array('NoFormat'=>true, 'String'=>true));

    $FilterNames['KEY_WORD']=$Lang['ByKey'];
}

$Sql = new Query($Query, 'ARR', $Args);
$Arr = array();
$VisId = array();
$SaleIds = array();
$LastRssRow = false;

while ($Row = $Sql->Row()) {
    if ($UserOrder=='DESC' && !$LastRssRow) $LastRssRow = $Row;
    if ($UserOrder=='ASC') $LastRssRow = $Row;
    $Row['CLICK_SOURCE']='';
    $Row['SALE_SOURCE']='';
    $Row['FRAUD_CAMP'] = array();
    if (@$Row['PATH']) {
        $Row['PATH']=$Row['SITE_HOST'].$Row['PATH'];
        if (@$Row['QUERY_STRING']) $Row['PATH']=$Row['PATH']."?".$Row['QUERY_STRING'];
        $Row['Link_PATH'] = "http://".$Row['PATH'];
        if ($ShowPageTitles[$Row['SITE_ID']]==0) $Row['PTITLE']=false;
        if ($ShowPageTitles[$Row['SITE_ID']]==1 && @$Row['PTITLE']) $Row['PATH'].=" (".$Row['PTITLE'].")";
        if ($ShowPageTitles[$Row['SITE_ID']]==2 && @$Row['PTITLE']) $Row['PATH']=$Row['PTITLE'];
        $Row['PATH']=RefCut(htmlspecialchars($Row['PATH']), 70);
    }
    if (@$Row['REFERER']) {
        $Row['Link_REFERER']=$Row['REFERER'];
        $Row['REFERER']=RefCut(_htmlspecialchars(urldecode($Row['REFERER'])));
    }
    $Row['Link_LAST_IP']=getURL("visitor_path",
        "&CpId=$CpId&AllSites=$AllSites&VisId=".$Row['VISITOR_ID']."&SiteId=".$Row['SITE_ID']."&ViewDate=$ViewDate", "report");
    $Row['Link_STAMP']=getURL("visitor_path", "&CpId=$CpId&&SiteId=".$Row['SITE_ID']."&ViewDate=".date('Y-m-d',$Row['STAMP']), "report");

    if (@$Row['SOURCE_HOST']) {
        $Row['CLICK_SOURCE'] = @$Row['HOST_GRP_NAME'] ? $Row['HOST_GRP_NAME'] : $Row['SOURCE_HOST'];
        if (@$Row['SOURCE_REFERER']) $Row['Link_CLICK_SOURCE'] = $Row['SOURCE_REFERER'];
    }

    if (@$Row['SALE_ID']) {
        if (@$Row['NATURAL_HOST']) {
            $Row['SALE_SOURCE'] = @$Row['NATURAL_HOST_NAME'] ? $Row['NATURAL_HOST_NAME'] : $Row['NATURAL_HOST'];
        }
        if (@$Row['PAID_HOST']) {
            $Row['SALE_SOURCE'] = @$Row['PAID_HOST_NAME'] ? $Row['PAID_HOST_NAME'] : $Row['PAID_HOST'];
        }
        $Row['SALE_KEYWORD'] = @$Row['PAID_KEYWORD'] ? $Row['PAID_KEYWORD'] : $Row['NATURAL_KEYWORD'];
        if ($Row['QUANT']>1) $Row['PRODUCT_NAME'].=" ({$Row['QUANT']})";
    }

    if (@$Row['SALE_COST']) $Row['COST']=$Row['SALE_COST'];

    if ($Mode=='Clicks') {
        $Row['RSS_NAME']=$Row['CAMP_NAME'];
        if ($Row['CLICK_SOURCE']) $Row['RSS_NAME'] .= " : ".$Row['CLICK_SOURCE'];
    }
    if ($Mode=='Actions') {
        $Row['RSS_NAME']=$Row['ACTION_NAME'];
        if ($Row['ACTION_ITEM']) $Row['RSS_NAME'] .= " : ".$Row['ACTION_ITEM'];
    }
    if ($Mode=='Ref') {
        $Row['RSS_NAME']=$Row['CLICK_SOURCE'];
        if ($Row['KEYWORD']) $Row['RSS_NAME'] .= " : ".$Row['KEYWORD'];
    }
    if ($Mode=='Key') {
        $Row['RSS_NAME']=$Row['KEYWORD'];
        if ($Row['CLICK_SOURCE']) $Row['RSS_NAME'] .= " : ".$Row['CLICK_SOURCE'];
    }
    if ($Mode=='Sales') {
        if ($Row['CUSTOM_ORDER_ID']) $Row['RSS_NAME']=$Row['CUSTOM_ORDER_ID'];
        if ($Row['COST']) $Row['RSS_NAME']=ShowCost($Row['COST']);
        if ($Row['PRODUCT_NAME']) $Row['RSS_NAME']=$Row['PRODUCT_NAME'];
    }
    if ($Mode=='Split') {
        $Row['RSS_NAME']=$Row['SPLIT_NAME'];
    }
    if ($Mode=='Fraud') {
        $Row['RSS_NAME']=$Row['CAMP_NAME'];
    }

    $Row['TAGS']='';
    $VisId[$Row['VISITOR_ID']]=$Row['ID'];
    if (@$Row['SALE_ID']) {
        $SaleIds[$Row['SALE_ID']] = $Row['ID'];
        if (isset($Arr[$Row['ID']])) {
            if (!@$Row['SALE_COST']) $Arr[$Row['ID']]['COST'] += $Row['COST'];
            if ($Row['PRODUCT_NAME']) {
                $Arr[$Row['ID']]['PRODUCT_NAME'] .= ', '.$Row['PRODUCT_NAME'];
                $Row['RSS_NAME']=$Arr[$Row['ID']]['PRODUCT_NAME'];
            }
        }
        else $Arr[$Row['ID']]=$Row;
    }
    else $Arr[$Row['ID']]=$Row;
}

if ($UserRss && $LastRssRow) {
    $Query = "UPDATE ?_user_rss SET LAST_REC_DATE = ? WHERE ID=?";
    $Db->Query($Query, date('Y-m-d H:i:s', $LastRssRow['STAMP']), $UserRss->ID);
}

$VisNames = array();
if (!empty($VisId)) {
    $Query = "SELECT * FROM ?_client_visitor WHERE COMPANY_ID = ? AND VISITOR_ID IN (?)";
    $Sql = new Query($Query, false, $CpId, array_keys($VisId));
    while ($Row=$Sql->Row()) $VisNames[$Row->VISITOR_ID]=$Row;
    foreach ($Arr as $k=>$Row) {
        if (@$VisNames[$Row['VISITOR_ID']]) {
            $Row['LAST_IP'] = $VisNames[$Row['VISITOR_ID']]->NAME . " ({$Row['LAST_IP']})";
            $Arr[$k] = $Row;
        }
    }
}

if ($Mode=='Sales' && !empty($Arr)) {
        $SaleTags=array();
        $Query = "SELECT SR.SALE_ID, SR.TAG_ID, T.TAG
            FROM ?_sale_tag_rel SR
            INNER JOIN ?_tag T ON T.ID=SR.TAG_ID
            WHERE SR.COMPANY_ID=? AND SR.SALE_ID IN (?)
        ";
        $Sql = new Query($Query,false,$CpId,array_keys($SaleIds));
        while ($Row=$Sql->Row()) $SaleTags[$Row->SALE_ID][]=$Row->TAG;
        foreach ($SaleTags as $SaleId => $TArr) {
            if (!isset( $Arr[$SaleIds[$SaleId]] )) continue;
            $Arr[$SaleIds[$SaleId]]['TAGS']=implode(", ",$TArr);
        }
    }

if ($Mode=='Fraud' && !empty($Arr)) {
        $Args['visid'] = array_keys($VisId);
        $Query = "SELECT CP.ID, CP.NAME, S_LOG.VISITOR_ID
            FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.ID
            INNER JOIN ?_camp_piece CP ON CP.ID=S_CLICK.CAMP_ID
            $JoinStr
            $WhereStr   AND S_CLICK.FRAUD='1' AND S_LOG.VISITOR_ID IN (?visid)
        ";
        $Sql=new Query($Query, false, $Args);
        while ($Row=$Sql->Row()) {
            if (!isset($Arr[ $VisId[$Row->VISITOR_ID] ])) continue;
            $ARow =& $Arr[ $VisId[$Row->VISITOR_ID] ];
            if (in_array($Row->ID, $ARow['FRAUD_CAMP'])) continue;
            if (!@$ARow['CAMP_NAME']) $ARow['CAMP_NAME'] = '';
            if (@$ARow['CAMP_NAME']) $ARow['CAMP_NAME'].=", ";
            $ARow['CAMP_NAME'].=$Row->NAME;
            $ARow['FRAUD_CAMP'][]=$Row->ID;
        }
        $Query = "SELECT S_LOG.VISITOR_ID, COUNT(S_LOG.ID) AS CNT
            FROM ?_{$CpId}_stat_log S_LOG
            INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.ID
            $JoinStr
            $WhereStr   AND S_LOG.VISITOR_ID IN (?visid)
            GROUP BY S_LOG.VISITOR_ID
        ";
        $Sql=new Query($Query, false, $Args);
        while ($Row=$Sql->Row()) {
            if (!isset($Arr[ $VisId[$Row->VISITOR_ID] ])) continue;
            $Arr[ $VisId[$Row->VISITOR_ID] ]['TOTAL_CLICK'] = $Row->CNT;
        }
}

if( ($nsUser->ADMIN||$nsUser->SUPER_USER) && in_array($Mode,$ModesWDel)) {
    $R->ColumnOrder[]='DELETE';
    $R->AddColumn('DELETE', '', false, false, array('CustomColumn'=>true, 'Width'=>1, 'NoWrap'=>1, 'Align'=>'right',
                                                                                       'CheckBox'=>array('CheckName'=>'DeleteArr', 'ValueKey'=>'DELETE_ID',
                                                                                                                         'CheckedCallback'=>'toggleDeleteBtn'),
                                                                                       'Icons'=>array(0=>array('Img'=>FileLink('images/icon_edit.gif'), 'w'=>11, 'h'=>11,
                                                                                                                                   'Link'=>getURL("sale", 'EditId={KEY}', "admin"),
                                                                                                                                   'Key'=>'DELETE_ID',
                                                                                                                                   'style'=>'vertical-align:2px;'))
    ));
}

$R->AddRows($Arr);
$R->EmailMode=$Mode;
$Params = array();
if ($SiteId) $Params['SiteId']=$SiteId;
if ($Filter) {   $Params['FilterFor']=$FilterFor; $Params['Filter']=$Filter; }
if (!empty($Params)) $ParamStr =  base64_encode(@gzcompress(serialize($Params), 9));
else $ParamStr = '';
if ($Mode!='Hits') {

    $R->RssLink = getURL('logs', "CpId=$CpId&Mode=$Mode&Rss=1&Params=$ParamStr&CLineAuth=".$nsUser->GetClientAuth(), 'report');

    $AdditionalHead = V($AdditionalHead);
    $AdditionalHead .= '<link rel="alternate" type="application/rss+xml" title="'.$PageTitle.'" ';
    $AdditionalHead .= 'href="'.$R->RssLink.'">';

}
$FilterNames['IP']=$Lang['ByIp'];
$Pages->Args = $Get."&Mode=$Mode";

$R->ExportParams = ExportParams(array(
        'Mode'=>$Mode,
        'StartDate'=>$StartDay,
        'EndDate'=>$EndDay,
        'Filter'=>$Filter,
        'SiteId'=>$SiteId
));

if (@$ReturnMode!='DATAOBJ') {

    if ($Rss) {
        $R->ExportRss($CurrentCompany->NAME.' - '.$PageTitle,
                                   $R->RssLink,
                                   $nsTemplate->Inc('rss/logs.rss'));
        exit;
    }

    $R->CheckExport( $R->ExportParams );
    include $nsTemplate->Inc("inc/".($Print?'print_':'')."header");
    include $nsTemplate->Inc();
    include $nsTemplate->Inc("inc/".($Print?'print_':'')."footer");
} else {
    //     

}
?>