<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");


/////////////////////////////////////////////
///////// require libraries here
require_once SELF."/lib/company.func.php";
require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sql.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/graph.class.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/class/report_data.class.php";
require_once SELF."/lib/call_card.func.php";

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("constructor/report_description");
$nsLang->TplInc("inc/getuserhost");
$nsLang->TplInc("inc/menu");
require_once SELF."/lib/reports/const_groups.arr.php";

/////////////////////////////////////////////
///////// prepare any variables

$PageTitle=$Lang['Title'];
$MetaTitle=$Lang['Title'];
$SaveMode="NATURAL";

$CpId=ValidVar($_GP['CpId']);
if (!$CpId) $nsProduct->Redir("default", "", "admin");

UserColumns(); // ,     

//////////////////  
require_once SELF."/lib/reports/reports_list.inc.php";
require_once SELF."/lib/reports/prepare_vars.inc.php";

//////////////////   
$Report= new Constructor($CpId);
$Report->ReportId=$ReportId;
$Report->GroupBy=$GroupBy;
$Report->NewVsRet=$NewVsRet;
$Report->MakeSum=true;
if ($StartDate) $Report->StartDate=$StartDate;
if ($ViewDate) $Report->ViewDate=$ViewDate;
if ($EndDate) $Report->EndDate=$EndDate;
$Report->SiteId=$SiteId;


if ($DynamicPeriod!="-1" && $DynamicPeriod!=="" ) {
    $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
    $Report->StartDate=$DynamicDate['StartDate'];
    $Report->EndDate=$DynamicDate['EndDate'];
    $Report->ViewDate="";
}

///////////////////   
require_once SELF."/lib/reports/const_where.inc.php";

///////////////////   
require_once SELF."/lib/reports/prepare_groups.inc.php";

///////////////////  
require_once SELF."/lib/reports/const_groupby.inc.php";

///////////////////  CACHE
$Report->Additional['OrderBy']=$OrderBy;
$Report->Additional['OrderTo']=$OrderTo;
$Report->Additional['FormLimit']=$Limit;

$Report->PageLimit=$Limit;
$Report->OrderBy=$OrderBy;
$Report->OrderTo=$OrderTo;

if ($nsUser->Columns->VISITS) $PrevReport->SessVisits=$Report->SessVisits=true;
if ($ExportCsv&&$ExportNoLimit) $Report->PageLimit=false;

if ($OrderBy == "ACTCONV"||$OrderBy == "SALECONV") {
        $Report->PageLimit=false;
        if (function_exists("ini_set")) @ini_set("memory_limit","20M");
}

$PrevReport->TrafficMode = $Report->TrafficMode=$TrafficMode;
if (array_intersect($SessionGroups,$UsedGroupsArr)) {
    $PrevReport->CookieJoin = $Report->CookieJoin=false;
    $PrevReport->SessVisits = $Report->SessVisits=false;
}
if ($Report->_OnlyAction||$Report->_OnlySale) $PrevReport->SessVisits = $Report->SessVisits=false;
if (array_intersect($DateGroups,$UsedGroupsArr) && 
    $GroupBy != $UsedGroupsArr[ count($UsedGroupsArr)-1 ] ) $Report->DisableDatesFill=true;

if (!$TotalsOnly) {
    if (!$ArchiveMode) $Report->CacheJob();
    else $Report->StatArr=$Arch->FULL_DATA;
}

///////////////////   
require_once SELF."/lib/reports/const_path.inc.php";

///////////////////    

if (!$ArchiveMode && $PrevConvReport && $nsUser->Columns->CONVERSIONS && !$Report->TakenFromCache &&
    !$TotalsOnly) {
    $PrevConvReport->TrafficMode=$TrafficMode;
	$PrevConvReport->Calculate();
	$Report->PrevLevelUni=V($PrevConvReport->StatArr[$Report->ConversionUni]);
}

/////////////////////  TOTALS

if ($TotalsOnly && $PrevReport) {
    $PrevReport->_GetActionConv = false;
    $PrevReport->_GetSaleConv = false;
    $PrevReport->_GetCost = false;    
    $PrevReport->JoinArr = array_merge($PrevReport->JoinArr, $PrevReport->tlsJoinArr);
    $PrevReport->WhereArr = array_merge($PrevReport->WhereArr, $PrevReport->tlsWhereArr);
    $PrevReport->CacheEnable = false;
    $PrevReport->CacheSmart = false;
    $PrevReport->Calculate();
    require_once SELF."/lib/reports/prepare_table.inc.php";
    $RData->ColumnsRealSum = $PrevReport->StatArr;
    $RData->ShowSubSum = $TotalsOnly == 2 ? true : false;
    include_once $nsTemplate->Inc('constructor/totals.inc');
    exit;
}

/////////////////////    
if (!$ArchiveMode && !$Report->TakenFromCache && !$Report->NonRealTime) {
    $Report->PageLimit++;
    $Report->Calculate();
    $Report->PageLimit--;
}

$Report->FillDates();

if (!empty($Report->StatArr)) require_once SELF."/lib/reports/process_data.inc.php";
else {
	include $nsTemplate->Inc("inc/".(($Print)?"print_":"")."header");
	if (!$Print) include $nsTemplate->Inc("inc/submenu");
	if (!$ArchiveMode && !$Print && !$CurrentCompany->DISABLE_CONSTRUCTOR) include $nsTemplate->Inc("constructor/natural_form");
    if (!$ArchiveMode && !$Print && $StaticMode) include $nsTemplate->Inc("constructor/static_report_form");
    if (!$Print && $ArchiveMode) include $nsTemplate->Inc("constructor/archive_report_form");    
    if (!$Print && !$ArchiveMode) include $nsTemplate->Inc("constructor/cache_update");
    if (!$Print && !$ArchiveMode && ($Report->ToCache || $Report->TakenFromCache || $Report->NonRealTime)) {
        include $nsTemplate->Inc("constructor/cache_check");
        CacheCheck(array('CacheId'=>$Report->CacheId,
                                      'CacheAjax'=>$Report->CacheUpdateMode,
                                      'AdditionalHash'=>$Report->AdditionalHash,
                                      'EnableChecking'=>($Report->ToCache||$Report->NonRealTime),
                                      'Additional'=>$Report->AdditionalTask(),
                                      'ReportId'=>$ReportId));
    }
	if (!$Report->NonRealTime && !$Report->ToCache) include $nsTemplate->Inc("inc/no_records");
}



include $nsTemplate->Inc("inc/".(($Print)?"print_":"")."footer");


?>