<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==4) $nsProduct->Redir("default", "", "admin"); 

/////////////////////////////////////////////
///////// require libraries here
require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sql.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/split_v2.class.php";
require_once SELF."/class/report_data.class.php";
require_once SELF."/lib/reports/misc.func.php";
$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("constructor/constructor_form");


/////////////////////////////////////////////
///////// prepare any variables
$SplitId=(ValidId($_GP['SplitId'])) ?$_GP['SplitId']:false;
$ViewDate= (ValidDate($_GP['ViewDate'])) ?($_GP['ViewDate']):false;
$StartDate= (ValidDate($_GP['StartDate'])) ?($_GP['StartDate']):false;
$EndDate= (ValidDate($_GP['EndDate'])) ?($_GP['EndDate']):false;
$DynamicPeriod= V($_GP['DynamicPeriod'],"-1");
if($DynamicPeriod=='0-a-0') $DynamicPeriod="-1";

UserColumns(); // ,     

$nsLang->TplInc("constructor/periods");
//    
$FormPeriodsArr=array();
$Query = "SELECT * FROM ?_periods WHERE COMPANY_ID IN (0, $CpId) AND DELETED != '1' ORDER BY TEMPLATE";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
    $FormPeriodsArr[$Row->TEMPLATE]=$Row;
}
$PArr=array_keys($FormPeriodsArr);
usort($PArr,"SortPeriods");
$FormPeriodsArr=SyncKeysWValues($FormPeriodsArr,$PArr);    

if (!ValidId($SplitId)) $nsProduct->Redir("default", "", "admin");
$SplitTest=$Db->Select("SELECT * FROM ?_camp_piece WHERE ID=$SplitId");
if (!ValidId($SplitTest->ID)) $nsProduct->Redir("default", "", "admin");

$PageTitle=$SplitTest->NAME;
$MenuSection="split_test";

$ProgPath[0]['Name']=$Lang['MSplits'];
$ProgPath[0]['Url']=getURL("incampaign", "CampId=".$SplitTest->CAMPAIGN_ID, "admin");
$ProgPath[1]['Name']=$SplitTest->NAME;
$ProgPath[1]['Url']=getURL("split_test", "EditId=$SplitId", "admin");
$ProgPath[2]['Name']=$Lang['SplitStat'];
$ProgPath[2]['Url']=getURL("split_test", "SplitId=$SplitId", "report");


$SubMenu[0]['Name']=$Lang['BackToList'];
if ($SplitTest->CAMPAIGN_ID) $SubMenu[0]['Link']=getURL("incampaign", "CampId=".$SplitTest->CAMPAIGN_ID, "admin");
else $SubMenu[0]['Link']=getURL("split_list", "", "admin");
$SubMenu[1]['Name']=$Lang['SplitEdit'];
$SubMenu[1]['Link']=getURL("split_test", "EditId=$SplitId", "admin");


/////////////////////////////////////////////
///////// call any process functions


/////////////////////////////////////////////
///////// display section here




$Report=new SplitStat_v2($SplitTest->COMPANY_ID);
$Report->SplitId=$SplitId;

if ($nsUser->Columns->CLICKS) $Report->_GetVisits=true;
if ($nsUser->Columns->ACTIONS) $Report->_GetActions=true;
if ($nsUser->Columns->SALES) $Report->_GetSales=true;
if ($nsUser->Columns->CONVERSIONS) $Report->_GetActionConv=true;
if ($nsUser->Columns->CONVERSIONS) $Report->_GetSaleConv=true;

$RData = new ReportData("PAID");
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->AddColumn('Name',$Lang['SplitStat']);
$RData->TopCaption = $SplitTest->NAME;
$RData->EmailMode='SPLIT';
$RData->Report =& $Report;

if ($nsUser->Columns->HITS) {  
    $RData->AddColumn("CntClick",$Lang['RHeaderTotal'],false,"Click");
    $RData->AddColumn("UniClick",$Lang['RHeaderUni'],false,"Click");
}
if ($nsUser->Columns->SALES) {  
    $RData->AddColumn("CntSale",$Lang['RHeaderTotal'],false,"Sale");
    $RData->AddColumn("UniSale",$Lang['RHeaderUni'],false,"Sale");
    $RData->AddColumn("Income",$Lang['RHeaderIncome'],false,"Sale");
}
if ($nsUser->Columns->ACTIONS) {  
    $RData->AddColumn("CntAction",$Lang['RHeaderTotal'],false,"Action");
    $RData->AddColumn("UniAction",$Lang['RHeaderUni'],false,"Action");
}
if ($nsUser->Columns->CONVERSIONS) {  
    $RData->AddColumn("ActionConv",$Lang['RHeaderAction'],false,false,1);
    $RData->AddColumn("SaleConv",$Lang['RHeaderSale'],false,false,1);
}

$Report->ShowPages=true;
if ($StartDate) $Report->StartDate=$StartDate;
if ($EndDate) $Report->EndDate=$EndDate;
if ($ViewDate) $Report->ViewDate=$ViewDate;
if ($DynamicPeriod!="-1" && $DynamicPeriod!==""  && $DynamicPeriod!=="0-a-0") {
    $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
    $Report->StartDate=$DynamicDate['StartDate'];
    $Report->EndDate=$DynamicDate['EndDate'];
    $Report->ViewDate="";
}



$Report->CacheJob();
if (!$Report->TakenFromCache && !$Report->NonRealTime) $Report->Calculate();


$GroupBy='Page';
$SplitStat=&$Report->SplitStat;
$Report->SplitStat['Name']=$Lang['General'];
$RData->AddRow($Report->SplitStat);
if (!empty($Report->PageStat)) {
foreach ($Report->PageStat as $k=>$v) {
    $v['Name']=$v['Obj']->HOST.$v['Obj']->PATH;
    $RData->AddRow($v);    
}
}

$RData->CheckExport();
include $nsTemplate->Inc();

/////////////////////////////////////////////
///////// process functions here


/////////////////////////////////////////////
///////// library section


?>