<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!defined("NS_PHP_TRACKING")) {
	$nsSelf=SELF;
	$nsSys=SYS;
    if (!defined("NS_DB_PFX")) define("NS_DB_PFX", PFX);
    if (!defined("NS_COOKIE_PFX")) define("NS_COOKIE_PFX", COOKIE_PFX);
    if (!defined("NS_TRACKING")) define("NS_TRACKING", true);
	$_NS_TRACK_VARS['QueryClass']="Query";
	$_NS_TRACK_VARS['Version']=$nsProduct->VERSION;
    $_NS_TRACK_VARS['Mode']='sale';
}
if (!defined("NS_TRACKER_DELAYED")) define("NS_TRACKER_DELAYED",false);

require_once $nsSelf."/lib/track/misc.func.php";
require_once $nsSelf."/lib/track/delayed.func.php";
require_once $nsSelf."/lib/track/general.func.php";
require_once $nsSelf."/lib/track/campaign.func.php";
require_once $nsSelf."/lib/track/visitor.func.php";
require_once $nsSelf."/lib/track/page.func.php";
require_once $nsSelf."/lib/track/query.func.php";
require_once $nsSelf."/lib/track/sale.func.php";
require_once $nsSys."/system/class/convertcharset/convert_charset.class.php";
require $nsSelf."/lib/track/define.vars.php";

if ($Version!=$TrackerVersion) return NS_TRACK_GENERAL::FinishTracking('Wrong tracker version');

$NoTmpSkip=true;
$_NS_TRACK_VARS['Db']=&$Db;
$RequestType=3;

$TimeDblSale=&$_NS_TRACK_VARS['TimeDblSale'];
$PresetIP=&$_NS_TRACK_VARS['PresetIP'];
$PresetID=&$_NS_TRACK_VARS['PresetID'];
$Cost=&$_NS_TRACK_VARS['Cost'];
$CustomId=&$_NS_TRACK_VARS['CustomId'];
$AddInfo=&$_NS_TRACK_VARS['AddInfo'];
$Items=&$_NS_TRACK_VARS['Items'];


$Item=&$_NS_TRACK_VARS['Item']; //  
$KeepVisPath=true; //     ,     
$UpdateVisPath=$KeepVisPath; //     .   ,   stat_path
$Cur= NS_TRACK_MISC::V($_GP['cur']);
$ScrRes= NS_TRACK_MISC::V($_GP['wr']);
$FlVer= NS_TRACK_MISC::V($_GP['fl']);
$PxD= NS_TRACK_MISC::V($_GP['px']);
$Frame= NS_TRACK_MISC::V($_GP['frame']);
$PageTitle= NS_TRACK_MISC::V($_GP['title']);
$PageCharset= NS_TRACK_MISC::V($_GP['charset']);
$CurrentCharset=$LangConfig;

$Current=false;
if (NS_TRACK_MISC::V($_SERVER['HTTP_REFERER'])) $Current=$_SERVER['HTTP_REFERER'];
if (NS_TRACK_MISC::V($Cur)) $Current=$Cur;
$StId= (NS_TRACK_MISC::ValidId($_GP['st']))?$_GP['st']:false;
$StTextId=NS_TRACK_MISC::V($_GP['stext']); //   

$Cost=NS_TRACK_MISC::V($_GP['cs'], 0);
$CustomId= NS_TRACK_MISC::V($_GP['oid']);
$AddInfo= NS_TRACK_MISC::V($_GP['oinfo']);

$Site=NS_TRACK_GENERAL::GetCurrentSite($StId,$StTextId);
$CompanyId=$Site->COMPANY_ID;
if (NS_TRACK_GENERAL::CheckStopTracking()) return NS_TRACK_GENERAL::FinishTracking('Tracking stopped');

$Settings=NS_TRACK_MISC::GetSettings($CompanyId, $StId);

if (NS_TRACK_DELAYED::DelayedNeeded()) return NS_TRACK_DELAYED::WriteTempLog();

$VisId=NS_TRACK_VISITOR::GetVisitorId();
if (NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'skip'])) $Skip=true;
if ($Skip||!NS_TRACK_MISC::ValidId($StId)) return NS_TRACK_GENERAL::FinishTracking('No site id or ns_skip cookie');

$KeepNoRef=NS_TRACK_MISC::SetsByPrior($Settings, "KEEP_NO_REF");
$NoDblSale=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_SALE"); 
$TimeDblSale=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_SALE", "TIME_DBL_SALE"); 

//if(!$KeepNoRef&&!NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'log'])) $Skip=true;
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Cookie ns_skip');


$HostsArr=NS_TRACK_GENERAL::GetSiteHosts($StId, $Site);
$CurrentPageArr=NS_TRACK_GENERAL::PreparePathAddr($Current);
$SiteHostId=NS_TRACK_GENERAL::CurrentSiteHost($HostsArr, $CurrentPageArr, $Site);
if (!$SiteHostId) $Skip=true;
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Unknown host');

$RefSet=0;
$QueryId=NS_TRACK_QUERY::GetQueryId($CurrentPageArr['query']);
$PageId=NS_TRACK_PAGE::GetPageId($CurrentPageArr, $StId);
$PqId=NS_TRACK_PAGE::SetPage2QueryRelation();

$Items=(NS_TRACK_MISC::ValidArr($_GP['itm']))?NS_TRACK_SALE::PrepareSaleItems($_GP['itm']):false;


if ($NoDblSale) NS_TRACK_GENERAL::CheckSaleDblClick();
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Double click protection');


NS_TRACK_GENERAL::UpdateVisitorPath();
NS_TRACK_GENERAL::UpdateVisitorSale();
if (!NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'log'])) NS_TRACK_VISITOR::FindLastNode($VisId, true);


if (defined("TRACK_ERRORS")&&TRACK_ERRORS &&  !defined("NS_PHP_TRACKING") && !NS_TRACKER_DELAYED) {
	for ($i=0;$i<count($Logs->Errors);$i++) {
		$Db->Query("INSERT INTO track_error (ERROR) VALUES ('".addslashes($Logs->Errors[$i])."')");
	}
}


return NS_TRACK_GENERAL::FinishTracking('We are watching you :)');

?>