<?

if (!defined("NS_TRACKER_INDEX")) exit;
if (!defined("NS_PHP_TRACKING")) {
    if (!defined("NS_DB_PFX")) define("NS_DB_PFX", PFX);
    if (!defined("NS_COOKIE_PFX")) define("NS_COOKIE_PFX", COOKIE_PFX);
    if (!defined("NS_TRACKING")) define("NS_TRACKING", true);
	$_NS_TRACK_VARS['QueryClass']="Query";
	$_NS_TRACK_VARS['Version']=$nsProduct->VERSION;
}
if (!defined("NS_TRACKER_DELAYED")) define("NS_TRACKER_DELAYED",false);

require_once SELF."/lib/track/misc.func.php";
require_once SELF."/lib/track/delayed.func.php";
require_once SELF."/lib/track/general.func.php";
require_once SELF."/lib/track/campaign.func.php";
require_once SELF."/lib/track/visitor.func.php";
require_once SELF."/lib/track/page.func.php";
require_once SELF."/lib/track/referer.func.php";
require_once SELF."/lib/track/action.func.php";
require_once SELF."/lib/track/query.func.php";
require SELF."/lib/track/define.vars.php";
require_once SYS."/system/class/convertcharset/convert_charset.class.php";

$_NS_TRACK_VARS['Db']=&$Db;
$RequestType=5;

if (isset($_GP['RequestParam'])) {
	$ReqArr=explode("/",$_GP['RequestParam']);
	foreach($ReqArr as $i=>$Val) {
		if (substr($Val, 0, 1)=="s") $_GP['s']=substr($Val, 1);
	}
}

$SplitId=(NS_TRACK_MISC::ValidId($_GP['s']))?$_GP['s']:0;
$CurrentCharset=$LangConfig;
$TitleUpdate=false;
$RememberPage=false;

$Ref=NS_TRACK_MISC::ValidVar($_GP['ref'],NS_TRACK_MISC::ValidVar($_SERVER['HTTP_REFERER']));


if (!$Db->ID) {
    Header("X-ST-DB: No database");
	@clearstatcache();
	$f=@fopen(SELF."/store/split_test.nodb", "r");
	if (!$f) return NS_TRACK_MISC::Redir($_SERVER['HTTP_REFERER']);
	$Data=fread($f, filesize(SELF."/store/split_test.nodb"));
	if (!$Data) return NS_TRACK_MISC::Redir($_SERVER['HTTP_REFERER']);
	$DataArr=@unserialize($Data);
	if(!ValidArr($DataArr)) return NS_TRACK_MISC::Redir($_SERVER['HTTP_REFERER']);
	if(!ValidArr($DataArr[$SplitId])) return NS_TRACK_MISC::Redir($_SERVER['HTTP_REFERER']);
	return NS_TRACK_MISC::Redir($DataArr[$SplitId][0]);
	exit;
}

$SplitSettings = $Db->Select("SELECT * FROM ?_split_test WHERE ID = ?", false, $SplitId);
$FirstSplitPage = false;
$Page=false;
$UpdateNextSplitPage = false;
$PrevPageId=NS_TRACK_MISC::CookieStorageGet("split$SplitId"."_page");
$PrevQueryId=NS_TRACK_MISC::CookieStorageGet("split$SplitId"."_query");
$Query = "
        SELECT 
            TSP.*, TS.COMPANY_ID, TS.HOST, 
            SP.PATH, TQ.QUERY_STRING, TS.ID AS SITE_ID, ST.SUB_ID, 
            TSP.FULL_PATH AS PAGE_PATH
        FROM ?_split_page TSP
        INNER JOIN ?_split_test ST
            ON ST.ID=TSP.SPLIT_ID
        INNER JOIN ?_site_page SP
            ON SP.ID = TSP.PAGE_ID
        INNER JOIN ?_site TS
            ON TS.ID = SP.SITE_ID
        LEFT JOIN ?_query TQ
            ON TQ.ID=TSP.QUERY_ID
        WHERE TSP.SPLIT_ID=?
        ORDER BY TSP.ID
";
$Sql = new Query($Query, false, $SplitId);
while ($Row=$Sql->Row()) {
    if (!$FirstSplitPage) $FirstSplitPage = $Row->ID;
    $SplitPages[$Row->ID]=$Row;
}

//     
if ($PrevPageId && $SplitSettings->REMEMBER_PAGE) {
    
    foreach ($SplitPages as $PId=>$Row) {
        if ($PrevQueryId && $Row->PAGE_ID == $PrevPageId && $Row->QUERY_ID==$PrevQueryId) {
            $Page = $Row;
            break;
        }
        if (!$PrevQueryId && $Row->PAGE_ID == $PrevPageId) {
            $Page = $Row;
            break;
        }
    }
}
else {
    //    
    if ($SplitSettings->DISTR_METHOD==1) {
        $StopSingal = false;
        foreach ($SplitPages as $PId=>$Row) {
            if ($StopSingal) {
                $Page = $Row;
                $UpdateNextSplitPage=$Row->ID;
                break;
            }
            if ($Row->ID==$SplitSettings->NEXT_DISTR_ID) $StopSingal = true;
        }
        if (!$UpdateNextSplitPage) {
            $Page = @$SplitPages[$FirstSplitPage];
            $UpdateNextSplitPage=$FirstSplitPage;
        }
    }
    //    
    else {
        $Ids = array_keys($SplitPages);
        $RandKey = rand(0, count($Ids)-1);
        $Page = @$SplitPages[ $Ids[$RandKey] ];
    }
}

if (!$Page) return NS_TRACK_MISC::Redir($Ref);

if ($UpdateNextSplitPage) {
    $Query = "UPDATE ?_split_test SET NEXT_DISTR_ID = ? WHERE ID = ?";
    $Db->Query($Query,$UpdateNextSplitPage,$SplitId);
}

if ($Page->PAGE_PATH) {
    $Current=$Page->PAGE_PATH;
    //if (V($Page->PATH)&&$Page->PATH=='/' && substr($Page->PAGE_PATH,-1)!='/') $Current.='/';    
}
else {
	$Current="http://".$Page->HOST.$Page->PATH;
	if ($Page->QUERY_STRING) $Current.="?".$Page->QUERY_STRING;
}

$Redir=$Current;

$StId=$Page->SITE_ID;
$KeepVisPath=true;
$CompanyId=$Page->COMPANY_ID; 
if ($Version!=$TrackerVersion) return NS_TRACK_MISC::Redir($Redir);
if (NS_TRACK_GENERAL::CheckStopTracking()) return NS_TRACK_MISC::Redir($Redir);

$UpdateVisPath=$KeepVisPath; 
$Item=&$_NS_TRACK_VARS['Item']; 
$Actions=&$_NS_TRACK_VARS['Actions'];
$Fraud=&$_NS_TRACK_VARS['Fraud'];
$TimeDblPageLoad=&$_NS_TRACK_VARS['TimeDblPageLoad'];
$TimeDblAdvClick=&$_NS_TRACK_VARS['TimeDblAdvClick'];

$Site=NS_TRACK_GENERAL::GetCurrentSite($StId);


if (NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'skip'])) $Skip=true;
if ($Skip) return NS_TRACK_MISC::Redir($Redir);

$Settings=NS_TRACK_MISC::GetSettings($CompanyId, $StId);

if (NS_TRACK_DELAYED::DelayedNeeded()) return NS_TRACK_DELAYED::WriteTempLog($Current);

$VarCamp=NS_TRACK_MISC::V($Settings['All']->VAR_CAMPAIGN, "c");
$VarCampSource=NS_TRACK_MISC::V($Settings['All']->VAR_CAMPAIGN_SOURCE, false);
$VarKw=NS_TRACK_MISC::V($Settings['All']->VAR_KW, "kw");
$VarKeyword=NS_TRACK_MISC::V($Settings['All']->VAR_KEYWORD, "k");

if (isset($_GP['RequestParam'])) {
	$ReqArr=explode("/",$_GP['RequestParam']);
	foreach($ReqArr as $i=>$Val) {
		if (substr($Val, 0, strlen($VarCamp))==$VarCamp) $_GP[$VarCamp]=substr($Val,strlen($VarCamp));
		if (substr($Val, 0, strlen($VarKeyword))==$VarKeyword) $_GP[$VarKeyword]=substr($Val, strlen($VarKeyword));
	}
}


$CurrentPageArr=NS_TRACK_GENERAL::PreparePathAddr($Current);
if (!$CurrentPageArr)  return NS_TRACK_GENERAL::FinishTracking('Unable to parse current page');
$GetVars=NS_TRACK_QUERY::ParseTemplate(NS_TRACK_MISC::V($CurrentPageArr['query']));

$ReqArr=NS_TRACK_GENERAL::PreparePathAddr('http://'.$_SERVER['HTTP_HOST'].@$_SERVER['REQUEST_URI']);
$ReqVars=NS_TRACK_QUERY::ParseTemplate(NS_TRACK_MISC::V(@$ReqArr['query']));

$ClickSubId=(NS_TRACK_MISC::ValidId($_GP[$VarCamp]))?$_GP[$VarCamp]:0;
if (!$ClickSubId && $VarCampSource) $ClickSubId=NS_TRACK_CAMPAIGN::GetCampaignBySrc(NS_TRACK_MISC::V($ReqVars[$VarCampSource]));
if (!$ClickSubId && $VarCampSource) $ClickSubId=NS_TRACK_CAMPAIGN::GetCampaignBySrc(NS_TRACK_MISC::V($GetVars[$VarCampSource]));
$KeyId=(NS_TRACK_MISC::ValidId($_GP[$VarKeyword]))?$_GP[$VarKeyword]:0;
$Keyword=NS_TRACK_REFERER::FindReqKeyword($ReqVars,$VarKw);
if (!$Keyword) $Keyword=NS_TRACK_REFERER::FindReqKeyword($GetVars,$VarKw); 
if ($Keyword) $KeyId=NS_TRACK_REFERER::GetKeywordId($Keyword);

$VisId=NS_TRACK_VISITOR::GetVisitorId();
if ($Skip) return NS_TRACK_MISC::Redir($Redir);
$PageId=$Page->PAGE_ID;
$StId=$SiteId=$Page->SITE_ID;
$SplitCamp=$Page->SUB_ID;

$KeepNoRef=NS_TRACK_MISC::SetsByPrior($Settings, "KEEP_NO_REF"); 
$NoDblPageLoad=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_PAGE_LOAD"); 
$TimeDblPageLoad=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_PAGE_LOAD", "TIME_DBL_PAGE_LOAD"); 
$NoDblAdvClick=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_ADV_CLICK");
$TimeDblAdvClick=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_ADV_CLICK", "TIME_DBL_ADV_CLICK"); 


//      
$RefPageArr=NS_TRACK_GENERAL::PreparePathAddr($Ref,'ref');
$HostsArr=NS_TRACK_GENERAL::GetSiteHosts($StId);
$SiteHostId=NS_TRACK_GENERAL::CurrentSiteHost($HostsArr, $CurrentPageArr);
if (!$SiteHostId) $Skip=true;
if ($Skip) return NS_TRACK_MISC::Redir($Redir);

//     referer_set
$RefSet=NS_TRACK_REFERER::GetRefererSet($RefPageArr, $Ref);

if ($Skip) return NS_TRACK_MISC::Redir($Redir);


// ,    - 
$Actions=NS_TRACK_ACTION::GetActionIds($PageId, $CurrentPageArr);
$QueryId=NS_TRACK_QUERY::GetQueryId(NS_TRACK_MISC::V($CurrentPageArr['query']));
$PqId=NS_TRACK_PAGE::SetPage2QueryRelation();

if ($NoDblPageLoad) NS_TRACK_GENERAL::CheckPathDblClick();
if ($NoDblAdvClick) NS_TRACK_GENERAL::CheckAdvDblClick();
if ($Skip) return NS_TRACK_MISC::Redir($Redir);
$Fraud=NS_TRACK_GENERAL::CheckClickFraud($Settings, $VisId, $ClickSubId);

//    
NS_TRACK_GENERAL::UpdateVisitorPath();
NS_TRACK_GENERAL::TrackingCookie(NS_COOKIE_PFX.'tmp_skip', md5(NS_TRACK_GENERAL::TmpCurrentPath($Redir)), 0, '/', $_NS_TRACK_VARS['COOKIE_DOMAIN']);
//      ( )
NS_TRACK_GENERAL::UpdateVisitorAction();

//    ,    
if (NS_TRACK_MISC::ValidId($ClickSubId)&&$ClickSubId>0) NS_TRACK_GENERAL::UpdateVisitorClick();

//     
NS_TRACK_GENERAL::UpdateVisitorSplit($SplitCamp);
if ($SplitSettings->REMEMBER_PAGE) {
	$Arr["split$SplitId"."_page"]=$Page->PAGE_ID;
	$Arr["split$SplitId"."_query"]=$Page->QUERY_ID;	
	NS_TRACK_MISC::CookieStorageSet($Arr, false, time()+60*60*24*365*10, '/', $_NS_TRACK_VARS['COOKIE_DOMAIN']);
}

NS_TRACK_GENERAL::SetCookieLog();
return NS_TRACK_MISC::Redir($Redir);
?>