<?

class Button {
    function Button($Options=array()) {
        $this->Title = @$Options['Title'];
        $this->Href = @$Options['Href'];
        $this->Js = @$Options['Js'];
        $this->Id = @$Options['Id'];
        $this->Icons = array();
        
        if (@$Options['Icon']) $this->AddIcon($Options['Icon']);
        if (@$Options['Icons']) foreach ($Options['Icons'] as $Icon) $this->AddIcon($Icon); 
    }

    function AddIcon($Icon=array()) {
        $this->Icons[] = array(
            'URL'=> (is_array($Icon)? @$Icon['URL'] : @$Icon),
            'W'=>@$Icon['W'],
            'H'=>@$Icon['H'],
            'Style'=>@$Icon['Style'],
            'Title'=> (@$Icon['Title'] ? $Icon['Title'] : $this->Title),
            'Js'=> @$Icon['Js'],
            'Id'=>@$Icon['Id']
        );
    }

    function HTML() {
        if (empty($this->Icons)) return false;
        if ($this->Href) {
            echo "<a href=\"{$this->Href}\" id=\"$this->Id\"";
            if ($this->Js) echo " onclick=\"{$this->Js}\"";
            echo " title=\"".htmlspecialchars($this->Title)."\"";
            echo ">";
        }
        foreach ($this->Icons as $Icon) {
            echo "<img src=\"{$Icon['URL']}\" alt=\"{$Icon['Title']}\" id=\"{$Icon['Id']}\"";
            echo " width=\"{$Icon['W']}\" height=\"{$Icon['H']}\" border=0";
            if ($this->Js && !$this->Href && !$Icon['Js']) echo " onclick=\"{$this->Js}\"";
            if ($Icon['Js']) echo " onclick=\"{$Icon['Js']}\"";
            echo " style=\"{$Icon['Style']}\"";
            echo ">";
        }
        if ($this->Href) echo "</a>";
    }
}
?>