<?

require_once SELF."/class/report_parent_v2.class.php";

class Constructor extends ReportParent {

    function Constructor($CpId=0, $ConstMode='NATURAL') {
        
        $this->ReportParent($CpId);
        $this->CpId=$CpId;
        $this->GetSettings();
        $this->SiteId=0;
        $this->StartDate=false;
        $this->EndDate=false;
        $this->ViewDate=false;
        $this->StartStamp=false;
        $this->EndStamp=false;

        $this->SelectArr=array();
        $this->JoinArr=$this->VisitsJoin=$this->ActionsJoin=$this->SalesJoin=array();
        $this->GroupArr=array();
        $this->WhereArr=array();
        $this->OrderArr=array();
        $this->HavingArr=array();

        $this->tlsJoinArr = array();
        $this->tlsWhereArr = array();

        $this->PageLimit=0; //  
        $this->GrpFld=''; //   
        $this->GrpName=''; //     
        $this->NullGrpName=''; //   ""
        $this->OrderBy='CNT'; //        getStat
        $this->OrderTo='ASC'; //     FillDates()
        $this->GroupBy=''; //   

        //$this->NoRef=false; // 1 -      ; 0 - 
        //$this->OnlyNoRef=false; // 1 -     (     )
        $this->ByPage=false; // 1 -    , 0 - 
        $this->TrafficMode=0; // 0 - all, 1 - paid, 2 - referrers, 3 - direct

        $this->KeyId=false; //     
        $this->NatKeyId=false; //      
        $this->HostId=false; //    
        $this->HostGrp=false; //     
        $this->SiteId=false; //    
        $this->CampId=false; //  
        $this->GrpId=false; //  
        $this->CampIds=array(); //  
        $this->ShowPerClick=false; //    
        $this->ShowTotalCost=false; //    
        
        $this->RsNeeded=false; //     referer set
        $this->CookieJoin=false; //  .      NODE
        $this->MakeSum=false; //     
        $this->CookieOnly=false; //       .   

        $this->LoggerFunc=false; //    (nsConsole)

        $this->ProcessTime=0;
        $this->StatArr=array(); //   
    
        //     
        $this->ColSum=array("CntClickSum"=>0,"UniClickSum"=>0,"VisitsSum"=>0,"CntActionSum"=>0,"UniActionSum"=>0,"CntSaleSum"=>0,"UniSaleSum"=>0);

        $this->ShowPrevActionConv=false; //    
        $this->PrevLevelUni=0; //     -  .   
        $this->ConversionUni="UniClick"; //    ,       
        $this->Mode=$ConstMode;

        $this->FromUseIndex="";//   USE INDEX  FROM 
        $this->NewVsRet=false; //       
        $this->SessVisits=false; //       
        $this->DisableDatesFill=false; //     

        $this->_GetVisits=$this->_GetActions=$this->_GetSales=$this->_GetCost=true;
        $this->_GetActionConv=$this->_GetSaleConv=true;
        $this->_OnlyAction=$this->_OnlySale=false;
        $this->_SessionUsed=false; //      ,       
        $this->_HitsUseNode=false; //       
        
        $this->_NoNodeReplace=false; //     ConvLength. 
                                                          //   NODE.STAMP  S_LOG.STAMP
        $this->CountType = 'COUNT';
        $this->CountIfNoCache = false; //    ,    
        
        $this->_OrderChanged = false; //   ,  ,           order by
    }

    //   - - 
    function Calculate($Mode="")
    {
        global $nsUser, $CurrentCompany, $nsProduct;
        if (!in_array($Mode, array("EXPLAIN", "QUERY")) && $this->CacheEnable && $this->CacheJob()) {
            if ($this->TakenFromCache || !$this->CountIfNoCache) return false;
        }

        if (ValidId($CurrentCompany->ID)&&$CurrentCompany->SITE_CNT==0&&$this->CpId==$CurrentCompany->ID) return false;
        $this->StartTime=$this->GetMicrotime();

        if ($this->SiteId==-1) $this->SiteId=false;

        $this->Where();

        //     
        $this->JoinArr=array_unique($this->JoinArr);
        $this->SelectArr=array_unique($this->SelectArr);
        $this->WhereArr=array_unique($this->WhereArr);
        $this->GroupArr=array_unique($this->GroupArr);
        $this->OrderArr=array_unique($this->OrderArr);

        $Return=$this->GetStat($Mode);
        
        if ($Mode=='QUERY') return $Return;
        if ($Mode=="EXPLAIN") return false;

        $this->EndTime=$this->GetMicrotime();
        $this->ProcessTime=$this->EndTime-$this->StartTime;
        $this->QuerySetLog($this->ProcessTime);
    }
    
    function WhereDates()
    {
        global $nsUser;
        //    
        $StartStamp=($this->StartStamp)?$this->StartStamp:false;
        $EndStamp=($this->EndStamp)?$this->EndStamp:false;
        if (strpos($this->StartDate, " ")!==false) { $StartStamp=$this->StartDate; $this->StartDate=""; }
        if (strpos($this->EndDate, " ")!==false) { $EndStamp=$this->EndDate; $this->EndDate=""; }
        if (ValidDate($this->ViewDate)) { $StartStamp=$this->ViewDate." 00:00:00"; $EndStamp=$this->ViewDate." 23:59:59"; }
        if (ValidDate($this->StartDate)) $StartStamp=$this->StartDate." 00:00:00";
        if (ValidDate($this->EndDate)) $EndStamp=$this->EndDate." 23:59:59";
        if ($StartStamp&&$EndStamp) $this->WhereArr[]="S_LOG.STAMP BETWEEN DATE_ADD('$StartStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) AND DATE_ADD('$EndStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
        if ($StartStamp&&!$EndStamp) $this->WhereArr[]="S_LOG.STAMP >= DATE_ADD('$StartStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
        if (!$StartStamp&&$EndStamp) $this->WhereArr[]="S_LOG.STAMP <= DATE_ADD('$EndStamp', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)";
        $this->StartStamp=$StartStamp;
        $this->EndStamp=$EndStamp;
        $this->_SqlStartStamp=$StartStamp?" DATE_ADD('$StartStamp',INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE) ":false;
        $this->_SqlEndStamp=$EndStamp?" DATE_ADD('$EndStamp',INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE) ":false;        
    }

    function Where()
    {
        global $nsUser, $nsProduct;
        //   
        if ($this->SiteId) $this->WhereArr[]="S_LOG.SITE_ID = {$this->SiteId}";
        
        $this->WhereDates();

        if ($this->Mode=='NATURAL') {

            if ($this->TrafficMode==1 && @$nsProduct->LICENSE!=4) { //  
                $this->JoinArr[]="INNER JOIN ?_{$this->CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.COOKIE_LOG";
            }

            if ($this->TrafficMode==2) { //  
                $this->JoinArr[]="LEFT JOIN ?_{$this->CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.COOKIE_LOG";
                $this->JoinArr[]="LEFT JOIN ?_{$this->CpId}_stat_split S_SPLIT_CHECK ON S_SPLIT_CHECK.LOG_ID = S_LOG.COOKIE_LOG";
                $this->WhereArr[]="(S_CLICK.ID < 1 OR S_CLICK.ID IS NULL)"; 
                $this->WhereArr[]="(S_SPLIT_CHECK.ID < 1 OR S_SPLIT_CHECK.ID IS NULL)";
                $this->WhereArr[]="S_LOG.COOKIE_LOG!=0";               
            }

            if ($this->TrafficMode==3) { //  
                $this->WhereArr[]=" S_LOG.COOKIE_LOG=0";
                //$this->WhereArr[]="S_LOG.REFERER_SET=0";
                $this->CookieJoin=false;
            }

            //    
            if (ValidId($this->KeyId)) $this->WhereArr[]="RS.NATURAL_KEY=".$this->KeyId;
            //   
            if (ValidId($this->HostId)) $this->WhereArr[]="RS.HOST_ID=".$this->HostId;
            //    
            if (ValidId($this->HostGrp)&&!ValidId($this->HostId)) {
                $this->JoinArr[]="INNER JOIN ?_host TH ON TH.ID=RS.HOST_ID";
                $this->WhereArr[]="TH.GRP_ID=".$this->HostGrp;
            }

            //   referer set
            if ($this->RsNeeded||$this->KeyId!==false||$this->HostId!==false||$this->HostGrp!==false) {
                array_unshift($this->JoinArr, "INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET");
            }
        }

        if ($this->Mode=='PAID') {
            if ((ValidId($this->GrpId)||ValidId($this->CpId))&&!ValidId($this->CampId)) {
                $this->CampIds=$this->GetCampIds();
                $this->WhereArr[]="S_CLICK.CAMP_ID IN (".implode(",",$this->CampIds).")";
            }
            //  
            if (ValidId($this->CampId)) {
                $this->WhereArr[]="S_CLICK.CAMP_ID = ".$this->CampId;
                $this->CampIds[]=$this->CampId;
            }
            //  
            if (ValidId($this->KeyId)) $this->WhereArr[]="S_CLICK.KEYWORD_ID = ".$this->KeyId;
            //   
            if (ValidId($this->NatKeyId)) {
                array_unshift($this->JoinArr, "INNER JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET");
                $this->WhereArr[]="RS.NATURAL_KEY=".$this->NatKeyId;
            }
            // 
            if (ValidId($this->HostId)) $this->WhereArr[]="S_CLICK.SOURCE_HOST_ID = ".$this->HostId;

            if (!$this->ByPage) $this->CookieJoin=true;
        }

        //if (in_array($this->GroupBy,array("VisLen"))) $this->CookieJoin=false; //   ?
        if ($this->SessVisits) {
            $this->JoinArr[]="LEFT JOIN ?_{$this->CpId}_stat_session_log VISITS ON VISITS.LOG_ID=".($this->CookieJoin?"NODE":"S_LOG").".ID";
            $this->SelectArr[]="COUNT(DISTINCT VISITS.SESSION_ID) AS VISITS";
        }
    }

    function GetStat($Mode='')
    {
        // SQL_CALC_FOUND_ROWS is a temp hack to fix a problem with LIMIT on 
        // MySQL 4.1.21 (it is only supported from MySQL 4.0)
        //if (count($this->SelectArr)>0) $this->_SelectStr="SQL_CALC_FOUND_ROWS\n".implode(", \n", $this->SelectArr).", \n";     
        global $nsProduct;
        if (@$nsProduct->LICENSE == 4) {
            $this->_GetSales = false;
            $this->_GetCost = false;           
            $this->_GetSaleConv = false;                      
        }
        $this->_SelectStr=(!empty($this->SelectArr))?implode(", \n", $this->SelectArr).", \n":"";
        $this->_JoinStr=(!empty($this->JoinArr))?implode(" \n", $this->JoinArr):"";
        $this->_OrderStr=(!empty($this->OrderArr))?"ORDER BY ".implode(", ", $this->OrderArr):"";
        $this->_GroupStr=(!empty($this->GroupArr))?"GROUP BY ".implode(", ", $this->GroupArr):"";
        $this->_WhereStr=(!empty($this->WhereArr))?"WHERE ".implode(" AND ", $this->WhereArr):"";
        $this->_LimitStr=($this->PageLimit>0)?"LIMIT ".$this->PageLimit:"";
        $this->_NewVsRetStr='';
        $this->_NewVsRetJoinStr='';
        if ($this->NewVsRet>0&&!$this->_SessionUsed) {
            $this->_NewVsRetJoinStr="\nLEFT JOIN ?_{$this->CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID";
            $this->_NewVsRetJoinStr.="\nLEFT JOIN ?_{$this->CpId}_stat_session SESS ON SESS.ID=SESS_LOG.SESSION_ID AND SESS.FIRST_SESSION=0 ";
            $this->_NewVsRetStr=", COUNT(DISTINCT SESS.VISITOR_ID) AS RETURNING";
            $this->_NewVsRetStr.=", COUNT(DISTINCT S_LOG.VISITOR_ID)-COUNT(DISTINCT SESS.VISITOR_ID) AS NEW";
        }
        if ($this->NewVsRet>0&&$this->_SessionUsed) {
            $this->_NewVsRetJoinStr.="\nLEFT JOIN ?_{$this->CpId}_stat_session SESS2 ON SESS2.ID=SESS.ID AND SESS2.FIRST_SESSION=0 ";
            $this->_NewVsRetStr=", COUNT(DISTINCT SESS2.VISITOR_ID) AS RETURNING";
            $this->_NewVsRetStr.=", COUNT(DISTINCT S_LOG.VISITOR_ID)-COUNT(DISTINCT SESS2.VISITOR_ID) AS NEW";
        }

        $this->_GetIndex=0;

        $FuncOrder=array();
        if (in_array($this->OrderBy,array("DEFAULT", "NAME","CNT","UNI","ACTCONV","SALECONV","ROI","NEW","RETURNING","VISITS"))) {$FuncOrder=array("GetVisits","GetCampCost","GetActions","GetSales");}
        if (in_array($this->OrderBy,array("SALECNT","SALEUNI","INCOME"))) {$FuncOrder=array("GetSales", "GetVisits","GetCampCost","GetActions");}
        if (in_array($this->OrderBy,array("ACTIONCNT","ACTIONUNI"))) {$FuncOrder=array("GetActions","GetVisits","GetCampCost","GetSales");}
        if ($this->OrderBy=='COST') {$FuncOrder=array("GetCampCost","GetVisits","GetActions","GetSales");}

        foreach ($FuncOrder as $Func) {
            $Return=$this->$Func($Mode);
            if ($Mode=='QUERY') return $Return;
        }

        foreach ($this->StatArr as $i => $Row) {
            if (isset($Row['Obj']->USTAMP) && in_array($this->GroupBy,array("Date", "Month"))) $this->StatArr[$i]['Stamp']=$Row['Obj']->USTAMP;
            if (in_array($this->GroupBy,array("Time", "WeekDay", "Year"))) $this->StatArr[$i]['Stamp']=intval($Row['Obj']->NAME);
            if (in_array($this->GroupBy,array("WeekDay"))) $this->StatArr[$i]['Stamp']=$this->StatArr[$i]['Stamp']==0?7:$this->StatArr[$i]['Stamp'];

            $Uni=$this->StatArr[$i]['UniClick']=($this->StatArr[$i]['UniClick'])?$this->StatArr[$i]['UniClick']:$this->PrevLevelUni;

            if ($this->_GetActionConv) $this->StatArr[$i]['ActionConv']=$this->GetRatio($Uni, $Row['UniAction']);
            if ($this->_GetSaleConv) $this->StatArr[$i]['SaleConv']=$this->GetRatio($Uni, $Row['UniSale']);

            if ($this->NewVsRet) {
                if (!V($this->StatArr[$i]['Returning'])) $this->StatArr[$i]['Returning']=V($Row['Obj']->RETURNING);
                if (!V($this->StatArr[$i]['New'])) $this->StatArr[$i]['New']=V($Row['Obj']->NEW);
                if ($this->StatArr[$i]['New']<0) $this->StatArr[$i]['New']=0;
            }

            if ($this->Mode=='PAID') $this->StatArr[$i]['ROI']=$this->GetROI($this->StatArr[$i]['CampCost'], $this->StatArr[$i]['TotalIncome']);
        }

        if (empty($this->StatArr)) return false;
        if (empty($this->GroupArr)) $this->StatArr=V($this->StatArr[0],array());
    }


    function GetVisits($Mode='')
    {
        if (!$this->_GetVisits) return false;
        $HitSelectStr=$this->_NoNodeReplace?$this->_SelectStr:
                                preg_replace("/NODE\.STAMP/", "S_LOG.STAMP", $this->_SelectStr);
        $NewVsRetStr=$this->_NewVsRetStr; 
        $OrderStr=$this->_OrderStr;

        if ($this->Mode=='PAID') $HitSelectStr.="COUNT(DISTINCT S_CLICK.CAMP_ID) AS CAMP_UNI, ";

        $PaidJoin=($this->Mode=='PAID')?"INNER JOIN ?_{$this->CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID":"";
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='NEW')?str_replace("CNT","NEW",str_replace("UNI","NEW",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='RETURNING')?str_replace("CNT","RETURNING",str_replace("UNI","RETURNING",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='VISITS')?str_replace("CNT","VISITS",str_replace("UNI","VISITS",$OrderStr)):$OrderStr;

        $WhereStr=($this->_HitsUseNode)?preg_replace("/S_LOG\.STAMP/", "NODE.STAMP", $this->_WhereStr):$this->_WhereStr;
        
        $JoinStr=$this->_JoinStr;
        if (!$this->_HitsUseNode) $JoinStr=str_replace("VISITS.LOG_ID=NODE.ID", "VISITS.LOG_ID=S_LOG.ID", $JoinStr);
        
        $VisitsJoinStr = (!empty($this->VisitsJoin)) ? implode("\n", array_unique($this->VisitsJoin)) : '';

        $Query = "
                SELECT
                    $HitSelectStr
                    COUNT(S_LOG.ID) CNT,
                    COUNT(DISTINCT S_LOG.VISITOR_ID) UNI
                    $NewVsRetStr
                    FROM ?_{$this->CpId}_stat_log S_LOG {$this->FromUseIndex}
                    $PaidJoin
                $VisitsJoinStr
                $JoinStr
                $this->_NewVsRetJoinStr
                $WhereStr
                $this->_GroupStr
                $OrderStr
                $this->_LimitStr
        ";
        return $this->GetRows($Mode,$Query,array("CNT"=>"CntClick","UNI"=>"UniClick","CAMP_UNI"=>"Camp","VISITS"=>"Visits"),'VISITS');
    }

    function GetActions($Mode)
    {
        if (!$this->_GetActions) return false;
        $NewVsRetStr=(!$this->_GetVisits)?$this->_NewVsRetStr:''; 
        $OrderStr=$this->_OrderStr;
        $WhereStr=(($this->CookieJoin||$this->_HitsUseNode)&&!$this->_NoNodeReplace)?preg_replace("/S_LOG\.STAMP/", "NODE.STAMP", $this->_WhereStr):$this->_WhereStr;
        $SelectStr=(($this->CookieJoin||$this->_HitsUseNode)&&!$this->_NoNodeReplace)?preg_replace("/S_LOG\.STAMP/", "NODE.STAMP", $this->_SelectStr):$this->_SelectStr;
        $ActionWhereAdd=($this->SiteId)?"AND S_ACTION.SITE_ID = $this->SiteId":"";
        $ActionJoin=($this->CookieJoin&&!$this->_HitsUseNode)?"
                    INNER JOIN ?_{$this->CpId}_stat_log NODE
                        ON NODE.COOKIE_LOG=S_LOG.ID
                    INNER JOIN ?_{$this->CpId}_stat_action S_ACTION
                        ON S_ACTION.LOG_ID=NODE.ID":

                    "INNER JOIN ?_{$this->CpId}_stat_action S_ACTION
                        ON S_ACTION.LOG_ID=".(($this->_HitsUseNode)?"NODE":"S_LOG").".ID";

        $PaidJoin=($this->Mode=='PAID')?"INNER JOIN ?_{$this->CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID":"";
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='NEW')?str_replace("CNT","NEW",str_replace("UNI","NEW",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='RETURNING')?str_replace("CNT","RETURNING",str_replace("UNI","RETURNING",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='VISITS')?str_replace("CNT","VISITS",str_replace("UNI","VISITS",$OrderStr)):$OrderStr;

        $ActionsJoinStr = (!empty($this->ActionsJoin)) ? implode("\n", array_unique($this->ActionsJoin)) : '';

        $Query = "
                SELECT 
                    $SelectStr
                    COUNT(S_LOG.ID) CNT,
                    COUNT(DISTINCT S_LOG.VISITOR_ID) UNI,
                    COUNT(DISTINCT S_ACTION.ACTION_ID) ACTION_UNI
                    $NewVsRetStr
                    FROM ?_{$this->CpId}_stat_log S_LOG $this->FromUseIndex
                    $ActionsJoinStr
                    $PaidJoin
                    $ActionJoin
                $this->_JoinStr
                $this->_NewVsRetJoinStr
                $WhereStr
                $ActionWhereAdd
                $this->_GroupStr
                $OrderStr
                $this->_LimitStr
        ";
        return $this->GetRows($Mode,$Query,array("CNT"=>"CntAction","UNI"=>"UniAction", "ACTION_UNI"=>"Actions"));
    }


    function GetSales($Mode)
    {
        if (!$this->_GetSales) return false;
        $NewVsRetStr=(!$this->_GetVisits&&!$this->_GetActions)?$this->_NewVsRetStr:''; 
        $OrderStr=$this->_OrderStr;
        $WhereStr=(($this->CookieJoin||$this->_HitsUseNode)&&!$this->_NoNodeReplace)?preg_replace("/S_LOG\.STAMP/", "NODE.STAMP", $this->_WhereStr):$this->_WhereStr;
        $SelectStr=(($this->CookieJoin||$this->_HitsUseNode)&&!$this->_NoNodeReplace)?preg_replace("/S_LOG\.STAMP/", "NODE.STAMP", $this->_SelectStr):$this->_SelectStr;
        $SaleWhereAdd=($this->SiteId)?"AND S_SALE.SITE_ID = $this->SiteId":"";
        $SaleJoin=($this->CookieJoin&&!$this->_HitsUseNode)?"
                    INNER JOIN ?_{$this->CpId}_stat_log NODE
                        ON NODE.COOKIE_LOG=S_LOG.ID
                    INNER JOIN ?_{$this->CpId}_stat_sale S_SALE
                        ON S_SALE.LOG_ID=NODE.ID":
                    
                    "INNER JOIN ?_{$this->CpId}_stat_sale S_SALE
                        ON S_SALE.LOG_ID=".(($this->_HitsUseNode)?"NODE":"S_LOG").".ID";

        $PaidJoin=($this->Mode=='PAID')?"INNER JOIN ?_{$this->CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID=S_LOG.ID":"";
        $OrderStr=($this->OrderBy=='INCOME')?str_replace("CNT","SALE_SUM",str_replace("UNI","SALE_SUM",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='NEW')?str_replace("CNT","NEW",str_replace("UNI","NEW",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='RETURNING')?str_replace("CNT","RETURNING",str_replace("UNI","RETURNING",$OrderStr)):$OrderStr;
        $OrderStr=($this->_GetIndex==0&&$this->OrderBy=='VISITS')?str_replace("CNT","VISITS",str_replace("UNI","VISITS",$OrderStr)):$OrderStr;        

        $Query = "
                SELECT
                    $SelectStr
                    COUNT(S_LOG.ID) CNT,
                    COUNT(DISTINCT S_LOG.VISITOR_ID) UNI,
                    SUM(S_SALE.COST) AS SALE_SUM
                    ".($this->_GroupStr ? ", S_SALE.COST " : "")."
                    $NewVsRetStr
                    FROM ?_{$this->CpId}_stat_log S_LOG $this->FromUseIndex
                    $PaidJoin
                    $SaleJoin
                $this->_JoinStr
                $this->_NewVsRetJoinStr
                $WhereStr
                $SaleWhereAdd
                $this->_GroupStr
                $OrderStr
                $this->_LimitStr
        ";
        return $this->GetRows($Mode,$Query,array("CNT"=>"CntSale","UNI"=>"UniSale","SALE_SUM"=>($this->Mode=='PAID')?"TotalIncome":"Income"));
    }

    function GetCampCost($Mode)
    {
        if (!$this->_GetCost) return false;
        if ($this->Mode=='NATURAL') return false;
        $CostSelectStr=preg_replace("/NODE\.STAMP/", "S_LOG.STAMP", $this->_SelectStr);
        $GroupStr=($this->_GroupStr)?$this->_GroupStr.", CC.ID":"GROUP BY CC.ID";
        $Now=gmdate("Y-m-d H:i:s", time());
        $CostWhere="";
        if ($this->_SqlStartStamp && $this->_SqlEndStamp) {
            $CostWhere="  {$this->_SqlEndStamp} > CC.START_DATE 
                                    AND ( (CC.END_DATE IS NULL OR CC.END_DATE = '0000-00-00') 
                                            OR {$this->_SqlStartStamp} < CC.END_DATE) ";
        }
        if ($this->_SqlStartStamp && !$this->_SqlEndStamp) {
            $CostWhere="  {$this->_SqlStartStamp} >= CC.START_DATE
                                    AND ( (CC.END_DATE IS NULL OR CC.END_DATE = '0000-00-00') 
                                            OR {$this->_SqlStartStamp} <= CC.END_DATE) ";
        }
        if (!$this->_SqlStartStamp && $this->_SqlEndStamp) {
            $CostWhere="  {$this->_SqlEndStamp} > CC.START_DATE
                                    AND ( (CC.END_DATE IS NULL OR CC.END_DATE = '0000-00-00') 
                                            OR {$this->_SqlEndStamp} <= CC.END_DATE) ";            
        }
        if (!$CostWhere) $CostWhere="1=1";
        if ($this->_SqlStartStamp) $CostSelectStr.="\nTO_DAYS({$this->_SqlStartStamp}) AS START_DAYS, ";
        if ($this->_SqlEndStamp) $CostSelectStr.="\nTO_DAYS({$this->_SqlEndStamp}) AS END_DAYS, ";
        $CostSelectStr.="\nTO_DAYS('$Now') AS NOW_DAYS,";
        global $nsUser;

        //        
        $JoinStr=($this->SessVisits)?str_replace("VISITS.LOG_ID=NODE.","VISITS.LOG_ID=S_LOG.",$this->_JoinStr):$this->_JoinStr;

        $Query = "
                    SELECT
                    $CostSelectStr
                    CC.ID AS COST_ID,
                    SC.TYPE,
                    CC.MODE,
                    COUNT(S_CLICK.ID)*CC.COST AS COST,
                    CC.COST AS CAMP_COST,
                    TO_DAYS(CC.START_DATE) AS DIFF_START,
                    TO_DAYS(CC.END_DATE) AS DIFF_END,
                    (TO_DAYS(CC.END_DATE)-TO_DAYS(CC.START_DATE)) AS DIFF

                    FROM ?_{$this->CpId}_stat_log S_LOG $this->FromUseIndex
                         INNER JOIN ?_{$this->CpId}_stat_click S_CLICK
                              ON S_CLICK.LOG_ID=S_LOG.ID
                         INNER JOIN ?_sub_campaign SC
                              ON SC.SUB_ID=S_CLICK.CAMP_ID
                         INNER JOIN ?_camp_cost CC
                              ON CC.SUB_CAMPAIGN=S_CLICK.CAMP_ID
                    $JoinStr
                    $this->_WhereStr
                    AND CC.SUM_THIS='1'

                    AND (
                        (SC.TYPE='0' AND CC.MODE='1'AND (
                          ((CC.END_DATE !='0000-00-00' AND CC.END_DATE IS NOT NULL) AND S_LOG.STAMP BETWEEN CC.START_DATE AND CC.END_DATE)
                          OR
                          ((CC.END_DATE ='0000-00-00' OR CC.END_DATE IS NULL) AND S_LOG.STAMP>=CC.START_DATE)
                          )
                        )
                        OR
                        (SC.TYPE='1' AND CC.MODE='0' AND($CostWhere))
                    )
                    $GroupStr
        ";
        return $this->GetRows($Mode,$Query,array(),'COST');
    }

    function GetRows($Mode, $Query, $KeyArr,$QueryMode='')
    {
        if ($Mode=="EXPLAIN") return $this->GetQueryExplain($Query,  $this->_GetIndex);
        if ($Mode=="QUERY") return $Query;       
        global $Logs; 
        $Sql = new Query($Query);
        $GrpItems=array();
        if ($this->LoggerFunc) { $Sql->LoggerFunc=$this->LoggerFunc; $Sql->GetTime=true; }
        $Sql->GetTime=true;
        while ($Row=$Sql->Row()) {
            //    ,   
            if ($this->GrpFld) {$Tmp=$this->GrpFld;$Grp=$Row->$Tmp;}
            else $Grp=$Sql->Position; // ,   
            $Row->ID=$Grp;
            if ($QueryMode == 'COST' && (!$this->CampId && !$this->GrpId) &&(!isset($this->StatArr[$Grp]) || !$Grp) && $this->_GetIndex > 0) continue;
            //if ($QueryMode=='COST') echo $Grp."<br>";
            if (!isset($this->StatArr[$Grp])) {
                if ($QueryMode=='VISITS' || $this->_GetIndex==0) $this->StatArr[$Grp]=$this->StatRow();
                else continue;
            }

            //  ,    ,    
            if (($this->_GetIndex==0||empty($this->StatArr[$Grp]['Name']))&&$this->GrpName) {
                $Name=$this->GrpName; 
                $Row->$Name=trim($Row->$Name);
                $this->StatArr[$Grp]['Name']=$Row->$Name;
                if ($this->NullGrpName&&!$Grp) {
                    $Row->$Name=$this->NullGrpName;
                    $this->StatArr[$Grp]['Name']=$this->NullGrpName;
                }
            }
            if (isset($Row->SPECIAL_CNT)) $Row->CNT=$Row->SPECIAL_CNT;
            if (isset($Row->SPECIAL_UNI)) $Row->UNI=$Row->SPECIAL_UNI;
            if (V($Row->UNI)==0) $Row->CNT=0;
            if ($QueryMode=='COST') { 
                
                if ( ($this->GrpId || $this->CampId) && !$this->GroupBy) $CostRow = &$this->StatArr[0];
                else {
                    if (!isset($this->StatArr[$Grp])) continue;
                    $CostRow = &$this->StatArr[$Grp];
                }

                if ($this->ShowPerClick&&$Row->MODE==1&&$Row->TYPE==0) {
                    $CostRow['CampCost']+=$Row->COST;
                }
                if ($this->ShowTotalCost&&$Row->MODE==0&&$Row->TYPE==1) {
                    $Row->CUSTOM_COST=false;
                    if ($this->_SqlStartStamp || $this->_SqlEndStamp) {
                        if ($this->_SqlStartStamp&&$this->_SqlEndStamp)
                            $Row->DAYS= ($Row->DIFF_END)?$Row->DIFF_END-$Row->START_DAYS:$Row->END_DAYS-$Row->START_DAYS;
                        if ($this->_SqlStartStamp&&!$this->_SqlEndStamp) 
                            $Row->DAYS= ($Row->DIFF_END)?$Row->DIFF_END-$Row->START_DAYS:$Row->NOW_DAYS-$Row->START_DAYS;
                        if (!$this->_SqlStartStamp&&$this->_SqlEndStamp) $Row->DAYS= $Row->END_DAYS-DIFF_START;
                        if ($Row->DAYS<0) continue;
                        $Row->COST_DAYS=($Row->DIFF_END)?$Row->DIFF_END-$Row->DIFF_START:$Row->NOW_DAYS-$Row->DIFF_START;
                        $Row->CUSTOM_COST=($Row->CAMP_COST*$Row->DAYS)/$Row->COST_DAYS;
                    }
                    $CostRow['CampCost']+=($Row->CUSTOM_COST)?$Row->CUSTOM_COST:$Row->CAMP_COST;
                }
            }
            foreach ($KeyArr as $ObjKey=>$ArrKey) {
                if (!$ObjKey||!$ArrKey||!isset($Row->$ObjKey)) continue;
                $this->StatArr[$Grp][$ArrKey]=V($Row->$ObjKey,0);
                if ($this->MakeSum&&isset($this->ColSum[$ArrKey.'Sum'])) $this->ColSum[$ArrKey.'Sum']+=$Row->$ObjKey;
            }
            if (!isset($this->StatArr[$Grp]['Obj'])||($this->NewVsRet&&$QueryMode=='VISITS')) $this->StatArr[$Grp]['Obj']=$Row;

            //  ID ,   
            //         
            if (!$this->_OrderChanged&&!empty($this->GroupArr)) $GrpItems[]=" '$Grp' ";
        }
        $this->QuerySetLog($Sql->ResTime, false,$Query, $this->_GetIndex);
        if (!$this->_OrderChanged&&!empty($GrpItems)&&!ValidId($this->GroupArr[0])) {
            $this->_OrderStr=str_replace("ORDER BY", "ORDER BY ".$this->GroupArr[0]." IN (".implode(",",$GrpItems).") DESC, ", $this->_OrderStr);
            $this->_OrderChanged = true;
        }
        $this->_GetIndex++;
    }

    ///////////////////////////////////////
    ////       ,  
    //          
    //     
    function GetCampIds($GrpId=false, $CpId=false)
    {
        $Grp=($GrpId)?$GrpId:$this->GrpId;
        $Cp=($CpId)?$CpId:$this->CpId;
        if (!ValidId($Grp)&&!ValidId($Cp)) return false;
        if ($Cp) {$Fld="COMPANY_ID";$Value=$Cp;}
        if ($Grp) {$Fld="CAMPAIGN_ID";$Value=$Grp;}
        $CampArr=array();
        $SubArr=array();
        $Query = "SELECT CP.ID FROM ?_camp_piece CP WHERE CP.$Fld=?";
        $Sql = new Query($Query,false,$Value);
        while ($Row=$Sql->Row()) $CampArr[]=$Row->ID;
        if ($Grp) {
            $Query = "SELECT ID FROM ?_campaign WHERE PARENT_ID=?";
            $Sql = new Query($Query,false,$Grp);
            while ($Row=$Sql->Row()) {$SubArr=$this->GetCampIds($Row->ID); $CampArr=array_merge($CampArr,$SubArr);}
        }
        return empty($CampArr)?array(0=>0):array_unique($CampArr);
    }

    function StatRow() 
    {
        return array("Name"=>0,
                    "CntClick"=>0,"UniClick"=>0, "Visits"=>0, "New"=>0, "Returning"=>0,
                    "CntCamp"=>0, "UniCamp"=>0, "Camp"=>0,
                    "CntSale"=>0,"UniSale"=>0,"Income"=>0,
                    "CntAction"=>0,"UniAction"=>0,
                    "ROI"=>0,"CampCost"=>0,"TotalIncome"=>0,
                    "ActionConv"=>0,"SaleConv"=>0);
    }

    function FillDates($Mode='')
    {
        global $Db, $ArchiveMode;
        if ($this->DisableDatesFill) return false;
        if (empty($this->StatArr)) return false;
        if (!in_array($this->GroupBy,array('Date','Month','Year')) || $this->OrderBy!='NAME') return false;
        $WhereArr = $this->WhereArr;
        $this->WhereArr=array();
        $this->WhereDates();
        $WhereStr=(!empty($this->WhereArr))?" WHERE ".implode(" AND ",$this->WhereArr):"";
        $Fill=array();
        $Total = isset($this->StatArr['__total'])?$this->StatArr['__total']:false;
        if (@$this->StatArr['__total']) unset($this->StatArr['__total']);

        $Limits=array();
        settype($Limits,'object');
        if (!$this->StartStamp || !$this->EndStamp) {
            $Query = "
                SELECT UNIX_TIMESTAMP(MIN(STAMP)) AS MIN_STAMP, UNIX_TIMESTAMP(MAX(STAMP)) AS MAX_STAMP
                FROM ?_{$this->CpId}_stat_log S_LOG
                {$WhereStr}
            ";
            if ($Mode=='bot') {
                $Query = str_replace("S_LOG","B_LOG",$Query);
                $Query = str_replace("_stat_log","_bot_log",$Query);
            }
            $Limits=$Db->Select($Query);
            $Limits->MY=date("Y",$Limits->MIN_STAMP);
            $Limits->MAY=date("Y",$Limits->MAX_STAMP);
            $Limits->MM=date("n",$Limits->MIN_STAMP);
            $Limits->MAM=date("n",$Limits->MAX_STAMP);
            $Limits->MD= date("j",$Limits->MIN_STAMP);
            $Limits->MAD= date("j",$Limits->MAX_STAMP);
        }
        if ($this->StartStamp) {
            $Arr=explode(" ",$this->StartStamp);
            $Arr2=explode("-",$Arr[0]);
            $Limits->MY=$Arr2[0]; $Limits->MM=$Arr2[1]; $Limits->MD=$Arr2[2];
        }
        if ($this->EndStamp) {
            $Arr=explode(" ",$this->EndStamp);
            $Arr2=explode("-",$Arr[0]);
            $Limits->MAY=$Arr2[0]; $Limits->MAM=$Arr2[1]; $Limits->MAD=$Arr2[2];
        }

        if ($this->GroupBy=='Year') {
            for($Year=$Limits->MY; $Year<=$Limits->MAY; $Year++) {
                $Fill[]=array("Format"=>$Year,"Stamp"=>mktime(0,0,0,1,1,$Year));
            }
        }

        if (in_array($this->GroupBy,array('Date','Month'))) {
            $Months=array();
            for($Year=$Limits->MY; $Year<=$Limits->MAY; $Year++) {
                $Start=1; $End=12;
                if ($Year==$Limits->MY) {$Start=$Limits->MM; $End=12;}
                if ($Year==$Limits->MAY) {$Start=1; $End=$Limits->MAM;}
                if ($Limits->MY==$Limits->MAY) {$Start=$Limits->MM; $End=$Limits->MAM;}

                for ($Month=$Start; $Month<=$End; $Month++) {
                    $Stamp=mktime(0,0,0,$Month,1,$Year);
                    $Months[]=array("Format"=>"$Year-".sprintf("%02d",$Month),
                                                "Stamp"=>$Stamp, "Year"=>$Year, "Month"=>$Month,
                                                "DayCnt"=>date('t',$Stamp));
                }
            }
            if ($this->GroupBy=='Month') $Fill=$Months;
            if ($this->GroupBy=='Date') {
                foreach ($Months as $j=>$Month) {
                    $Start=1; $End=$Month['DayCnt'];
                    if ($Month['Year']==$Limits->MY) {$Start=$Limits->MD; $End=$Month['DayCnt'];}
                    if ($Month['Year']==$Limits->MAY) {$Start=$j>0?1:$Limits->MD; $End=$Limits->MAD;}
                    for ($d=$Start; $d<=$End; $d++) {
                        $Fill[]=array("Format"=>$Month['Format']."-".sprintf("%02d",$d),
                                            "Stamp"=>mktime(0,0,0,$Month['Month'],$d,$Month['Year']));
                    }
                }
            }
        }

        if ($this->OrderTo=='DESC') $Fill=array_reverse($Fill);
        array_splice($Fill,$this->PageLimit);
        $Added=0;
        foreach ($Fill as $Row) {
            if (!isset($this->StatArr[$Row['Format']])) {
                $NewStat = $this->StatRow();
                $NewStat['Name']=$Row['Format'];
                $NewStat['Stamp']=$Row['Stamp'];
                $NewStat['Obj']=array("ID"=>$Row['Format'],
                                                     "NAME"=>$Row['Format'],
                                                     "USTAMP"=>$Row['Stamp']);
                settype($NewStat['Obj'],'object');
                $this->StatArr[$Row['Format']]=$NewStat;
                $Added++;
            }
        }

        $this->WhereArr = $WhereArr;
        if ($Added>0) usort($this->StatArr, array("Constructor","SortAfterFill"));
        if ($Total) $this->StatArr['__total'] = $Total;
        return $Added;
    }

    function SortAfterFill($a, $b)
    {
        global $GroupBy,$OrderTo;
        if ($GroupBy=="Time") $Key="NAME";
        else $Key="USTAMP";
        
        $KeyA=intval($a['Obj']->$Key);
        $KeyB=intval($b['Obj']->$Key);

        if ($KeyA < $KeyB) {
            return ($OrderTo == 'ASC' ? -1 : 1);
        } else if ($KeyA > $KeyB) {
            return ($OrderTo == 'ASC' ? 1 : -1);
        } else {
            return 0;
        }
    }    
}
?>