var currentSearchQuery = ''
var prevSearchValue = ''
var currentResultBox = ''
var sectionSearchPerformed=false

function showSearchLoadingImg() { $('#SLoading1').show() }
function hideSearchLoadingImg() { $('#SLoading1').hide() }

function clearSearchField() {
    if (currentSearchQuery == '') {
        $('#GlobalSearch').val('')
        prevSearchValue = ''
    }
}

function restoreSearchField() {
    if (currentSearchQuery == '') {
        $('#GlobalSearch').val(srchText)
        prevSearchValue = srchText
    }
}

function showSearchForm(close) {
    if (close) return aSearch.close( (close == 1 ? true : false), false, function() {
                        aSearch.currentAjaxDivURL = false
                        aSearch.initialLoading = showSearchLoadingImg
                        aSearch.initialLoadingStop = hideSearchLoadingImg
                        if(close != 2) {
                            aSearch._working = false
                        }
                        $('#GlobalSearch').val(srchText)
                        prevSearchValue = srchText
                        $('#SearchClose').hide()
                        currentSearchQuery = ''
                    })
    $('#GlobalSearch').focus()
}

function globalSearch(value) {
    if (value.length < 3 && value.length > 0) {
        currentSearchQuery = false
        prevSearchValue = value 
        return showSearchForm(2)
    }
    if (value.length == 0) {
        currentSearchQuery = false
        prevSearchValue = value 
        return showSearchForm(3)
    }
    if (currentSearchQuery == value) return false
    if (prevSearchValue == value) return false
    prevSearchValue = value 
    aSearch.clearTimeout()
    currentResultBox = ''
    currentSearchQuery = value
    aSearch.wrapperDiv = 'GlobalSearchResults'
    aSearch._working = false
    aSearch.show(SResultsURL+value,function() { $('#SearchClose').show() }, 
                function() {
                    aSearch.initialLoading = false
                    aSearch.initialLoadingStop = false
                    aSearch.loadingObj = $('#'+aSearch.loadingDiv)
                })
}

function switchResultBox(key) {
    if (sectionSearchPerformed) return false
    if (currentResultBox==key) return false
    if (currentResultBox!='' && currentResultBox!=key) {
        $('#Header_'+currentResultBox).toggle()
        $('#Res_'+currentResultBox).toggle()
    }

    if (!currentResultBox) {
        var oColl = $('#ResultTd > div')
        if (oColl.length>0) currentResultBox=oColl[0].id.replace('Res_','')
        if (currentResultBox) return switchResultBox(key)
    }
    if (!currentResultBox) return false
    currentResultBox=key
    if (!jQuery.trim($('#Res_'+key).html())) return runSectionSearch(key)
    $('#Header_'+key).toggle()
    $('#Res_'+key).toggle()
}

function runSectionSearch(boxKey) {
    sectionSearchPerformed=true
    aSearch.wrapperDiv='Res_'+boxKey
    aSearch.load(SResultsURL+currentSearchQuery+"&ResType="+boxKey, function () {
            $('#Header_'+boxKey).toggle()
            $('#Res_'+boxKey).toggle()
            sectionSearchPerformed=false
    })
}
