<?
$Lang['Title']="Statistics removal settings";

$Lang['RemovalSettings']="Removal settings";

$Lang['DeleteEnable']="Enable automatic removal";

$Lang['DeleteDescr']="Below you can specify what data should be automatically 
deleted and when. Please note that if you have archiving also turned on then the archiving
settings might influence the minimal period that will never be deleted. For example,
if you have enabled Previous year for at least some of the reports in the archive
then the removal functionality will not delete any statistics for the current year 
because this data will be required for the archiving when the current year will 
finally end (it will be required in order to add a previous year report to the 
archive).";

$Lang['DeleteParams']="What types of data to delete";
$Lang['DeleteParamsDescr']="The removal functionality can delete all the logged 
visitors activity for the period that you've requested. Optionally, it can delete
only ordinary page views for the specified period (and keep all the logged
clicks, actions, sales, etc).<br><br>

After the removal process some unused data might remain in the database. With 
these settings you can specify the types of unused data which you want to delete 
from the database as well during the removal process.";

$Lang['LaunchPeriod']="Launch period";
$Lang['LaunchPeriodDescr']="With these settings you control when the removal 
process will actually run. It is recommended to choose a period with the 
minimal tracking load. Please also note that during the removal process,
the tracking is automatically stopped, and it is automatically resumed when 
the removal process is complete.";

$Lang['KeepPeriod']="Delete all statistics except this period";
$Lang['KeepPeriodDescr']="";

$Lang['SpecifyForClient']="Specify different periods for different companies";

$Lang['RunNow']="Run removal process as soon as possible";
$Lang['Running']="The removal process is running right now";
$Lang['Waiting']="Waiting for the next cron process launch";

$Lang['Referrers']="Referrers";
$Lang['HostGrp']="Delete hosts in domain groups";
$Lang['Keywords']="Keywords";
$Lang['Visitors']="Visitors";
$Lang['SavedVisitors']="Delete saved visitors";
$Lang['BrowserGrp']="   Delete browers in groups";
$Lang['Pages']="Pages";
$Lang['PagesGrp']="Delete pages in groups";
$Lang['Products']="Products";
$Lang['ActionItems']="Action items";
$Lang['VisitorsActivity']="All logged visitors activity";
$Lang['PageViews']="Ordinary page views only";
$Lang['DeleteStat']="Delete statistics";

$Lang['Day']="Day(s)";
$Lang['Week']="Week(s)";
$Lang['Month']="Month(s)";
$Lang['Year']="Year(s)";

$Lang['Night']="night (00:00 - 06:00)";
$Lang['Morning']="morning (06:00 - 12:00)";
$Lang['Day1']="day (12:00 - 18:00)";
$Lang['Evening']="evening (18:00 - 00:00)";

$Lang['Every']="Every";
$Lang['At']="at";
$Lang['Using']="using";
$Lang['Timezone']="timezone";

$Lang['Last']="Last";

$Lang['Inherit']="Inherit";

$Lang['NoReport']="No report found";

$Lang['MinRemovalDate']="Based on your archiving settings, statistics could be deleted only for the period before <b>{DATE}</b>";

$Lang['AllCompanies']="All companies";

$Lang['FirstWeekDay']="at first week day";
$Lang['FirstMonthDay']="at first month day";
$Lang['FirstYearDay']="at first year day";

$Lang['Enable']="Enable automatic removal";
$Lang['Disable']="Disable automatic removal";
$Lang['EnableDates']="Enable removal for a date range";

$Lang['AreYouSure']="Are you sure?";

$Lang['AlsoDelete']="Also delete unused:";

$Lang['DeleteRange'] = "Remove statistics for a specific date range";
$Lang['DateRangeDescr'] = "The automatic removal will be turned off right after deletion of this date range";
?>