<?
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/map.class.php";
require_once SELF."/lib/reports/misc.func.php";

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("constructor/report_description");

define('NO_SESSION_DATES', true);
UserColumns();

$GroupBy=$_REQUEST['GroupBy']='City';
$_REQUEST['DynamicPeriod']='0-d-0';
$_REQUEST['OrderBy']='CNT';
$_REQUEST['OrderTo']='DESC';
$_REQUEST['WhereArr'] = array(0=>array('Mode'=>'City','Id'=>''));
$SaveMode = 'NATURAL';

require_once SELF."/lib/reports/const_groups.arr.php";
require_once SELF."/lib/reports/prepare_vars.inc.php";

$Report = new Constructor($CpId,'NATURAL');
$Report->GroupBy=$GroupBy;
$Report->NewVsRet=false;
$Report->MakeSum=false;

$DynamicDate=GetDateFromPeriod('0-d-0',true);
$Report->StartDate=$DynamicDate['StartDate'];
$Report->EndDate=$DynamicDate['EndDate'];
$Report->ViewDate="";

require_once SELF."/lib/reports/const_where.inc.php";
require_once SELF."/lib/reports/prepare_groups.inc.php";
require_once SELF."/lib/reports/const_groupby.inc.php";

$Report->PageLimit=false;
$Report->OrderBy=$OrderBy;
$Report->OrderTo=$OrderTo;
$Report->SessVisits=false;
$Report->DisableDatesFill=true;
$Report->CacheType = 2;
$Report->CountIfNoCache = true;
$Report->NoCacheUpdate = true;


$Report->Calculate();
$Report->SetCacheType(2);
$Report->SetUpdateInterval(60);

if (isset($Report->StatArr['__total'])) unset($Report->StatArr['__total']);

$z=0;
if (!$Report->TakenFromCache) foreach ($Report->StatArr as $i=>$Row) {
    include SELF."/lib/reports/prepare_names.inc.php";
    $Row['Position']=$z;
    $Row['ActionConvOneOf']=$Report->OneOf(V($Row['UniAction'],0),V($Row['UniClick'],0));
    $Row['SaleConvOneOf']=$Report->OneOf(V($Row['UniSale'],0),V($Row['UniClick'],0));
    $Report->StatArr[$i]=$Row;     
    $z++;
}

if  (empty($Report->StatArr)) {
    include $nsTemplate->Inc('inc/no_records');
    exit;
}

$Map = new TrackerMap();
$Map->ID='TodayC';
$Map->Zoom='4';
$Map->Align = 'left';
foreach ($Report->StatArr as $Row) {
    $Map->AddDot(array('latitude'=>$Row['Obj']->LATITUDE, 'longitude'=>$Row['Obj']->LONGITUDE,
                                      'lable'=>$Row['Obj']->COUNTRY_NAME.', '.$Row['Name'], 
                                      'clickable'=>1, 'size'=>0, 'id'=>$Row['Obj']->ID,
                                      'life'=>0, 'info'=>'Visitors: '.$Row['UniClick']));
}
if ($Report->TakenFromCache) include $nsTemplate->Inc("constructor/cache_update");
else echo '<div id=SpacerLarge></div>';

$Map->PrintFlash();
exit;
?>