<?
if (!defined("NS_TRACKER_INDEX")) exit;
if ($nsProduct->LICENSE!=3) exit;
if (!$nsUser->SUPER_ADMIN) exit;

$DynamicPeriod = V($_REQUEST['DynamicPeriod'], '0-m-0');

require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/lib/reports/misc.func.php";
define('NO_SESSION_DATES', true);
UserColumns(); // ,     

$FormPeriodsArr=GetPeriodsList($CpId);
$DynamicDate=GetDateFromPeriod($DynamicPeriod,true);

$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->CssIncluded = true;

$RData->AddColumn("Name",$Lang['CompanyName']);

if ($nsUser->Columns->HITS) {  
    $RData->AddColumn("CntClick",$Lang['RHeaderPV'],"CNT");
    $RData->AddColumn("UniClick",$Lang['RHeaderUni'],"UNI","Visitor");
    if ($nsUser->Columns->VISITS) $RData->AddColumn("Visits",$Lang['RHeaderVisits'],"VISITS","Visitor");
    if ($nsUser->Columns->NEWRET) $RData->AddColumn("New",$Lang['RHeaderNew'],"NEW","Visitor");
    if ($nsUser->Columns->NEWRET) $RData->AddColumn("Returning",$Lang['RHeaderReturn'],"RETURNING","Visitor");    
}
if ($nsUser->Columns->CLICKS) {  
    $RData->AddColumn("CntCamp",$Lang['RHeaderTotal'],"CNT","Camp");
    $RData->AddColumn("UniCamp",$Lang['RHeaderUni'],"UNI","Camp");
}
if ($nsUser->Columns->SALES) {  
    $RData->AddColumn("CntSale",$Lang['RHeaderTotal'],"SALECNT","Sale");
    $RData->AddColumn("UniSale",$Lang['RHeaderUni'],"SALEUNI","Sale");
}
if ($nsUser->Columns->ACTIONS) {  
    $RData->AddColumn("CntAction",$Lang['RHeaderTotal'],"ACTIONCNT","Action");
    $RData->AddColumn("UniAction",$Lang['RHeaderUni'],"ACTIONUNI","Action");
}

$R = new Constructor($CpId, 'NATURAL');
$R->CacheAgeLimit=2400;
$R->CountIfNoCache = true;
$R->StartDate=$DynamicDate['StartDate'];
$R->EndDate=$DynamicDate['EndDate'];
$R->ViewDate="";
$R->NoRef=true;
$R->NewVsRet = true;
$R->SessVisits = true;
$R->SelectArr[]="CL.ID";
$R->SelectArr[]="CL.NAME";
$R->JoinArr[]="INNER JOIN ?_site TS ON TS.ID=S_LOG.SITE_ID";
$R->JoinArr[]="INNER JOIN ?_client CL ON CL.ID=TS.COMPANY_ID";
$R->GroupArr[]="CL.ID";
$R->GrpFld="ID";
$R->GrpName="NAME";
$R->OrderArr[]="CL.NAME ASC";
$R->QueryParams=array('GroupBy'=>'Cmp', "DynamicPeriod"=>"0-m-0");

$R->Calculate();

if ($nsUser->Columns->CLICKS) {
    $R2 = new Constructor($CpId, 'PAID');
    $R2->CacheAgeLimit=2400;
    $R2->CountIfNoCache = true;
    $R2->StartDate=$DynamicDate['StartDate'];
    $R2->EndDate=$DynamicDate['EndDate'];
    $R2->ViewDate="";
    $R2->NoRef=true;
    $R2->DisableAll();
    $R2->_GetVisits = true;
    $R2->SelectArr[]="CL.ID";
    $R2->SelectArr[]="CL.NAME";
    $R2->JoinArr[]="INNER JOIN ?_site TS ON TS.ID=S_LOG.SITE_ID";
    $R2->JoinArr[]="INNER JOIN ?_client CL ON CL.ID=TS.COMPANY_ID";
    $R2->GroupArr[]="CL.ID";
    $R2->GrpFld="ID";
    $R2->GrpName="NAME";
    $R2->OrderArr[]="CL.NAME ASC";
    $R2->QueryParams=array('GroupBy'=>'Cmp', "DynamicPeriod"=>"0-m-0");
    $R2->Calculate();
}

if ($R->TakenFromCache) {
    $RData->BottomCaption .= $Lang['CacheUpdated'].' '._date($R->CacheStamp,'datetime');
    if (@$R->CacheTZ)  $RData->BottomCaption .= " ".str_replace("{TZ}", ($R->CacheTZ>0?"+":"").$R->CacheTZ, $Lang['CacheTimezone']);
}

/*
 *       .     , 
 *      .
 * 
$R->GetCacheId();
if ($R->CacheType != 2) {
    $R->SetCacheType(2);
    $R->SetUpdateInterval(2400);
}
$R2->GetCacheId();
if ($R2->CacheType != 2) {
    $R2->SetCacheType(2);
    $R2->SetUpdateInterval(2400);
}
*/

foreach ($CompArr as $Cmp) {
    if (!isset($R->StatArr[$Cmp->ID])) continue;  
    $StatArr = $R->StatArr[$Cmp->ID];
    $StatArr['Name'] = $Cmp->NAME;
    if (@$R2 && @$R2->StatArr[$Cmp->ID]) {
        $StatArr['CntCamp']=V($R2->StatArr[$Cmp->ID]['CntClick'], 0);
        $StatArr['UniCamp']=V($R2->StatArr[$Cmp->ID]['UniClick'], 0);        
    }
    else $StatArr['CntCamp'] = $StatArr['UniCamp'] = 0;    
    $RData->AddRow($StatArr);    
}

$RData->Id = 'dashcompanies';
$RData->TopCaption = $Lang['CompaniesComparsion'].' - '.$FormPeriodsArr[$DynamicPeriod]->NAME;

$RData->CaptionButtonsLeft[] = new Button(array(
    'Icon'=>array('URL'=>FileLink('images/circle_02.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align: -5px; display:none;', 'Id'=>'CmpRefresh')
));
$RData->CaptionButtonsLeft[] = new Button(array(
    'Href'=>'javascript:;', 'Js'=>' showCmpPeriod(); ', 'Id'=>'CmpPeriod',
    'Icon'=>array('URL'=>FileLink('images/block_option.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align: -5px')
));
$RData->CaptionButtonsLeft[] = new Button(array(
    'Href'=>'javascript:;', 'Js'=>"\$('#AllCmp').hide(); \$('#close{$RData->Id}').hide();",
    'Icon'=>array('URL'=>FileLink('images/close_block.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align: -5px')
));

$RData->CheckExport();

$RData->HtmlDump();
if (empty($RData->Rows)) include $nsTemplate->Inc('inc/no_records');

echo "<span id='CmpPeriodBlock' class=DashPeriodSelect style='display:none;'>";
echo "<select name=DynamicPeriod onchange=\" updateCmpBlock(this.value, '".getURL('client_page', 'Mode=companies&ax=1&DynamicPeriod=')."'); \">";
foreach ($FormPeriodsArr as $k => $Row) {
    if ($k=='0-a-0') continue;
    echo "<option value='$k' ";
    if ($k==$DynamicPeriod) echo "selected";
    echo ">{$Row->NAME}</option>";
}
echo "</select>";
echo "</span>";
echo '<div id=SpacerLarge></div>';
exit;
?>