<?

function ExtendUser()
{
	global $nsUser, $Db, $nsProduct, $CpId, $TrackerVersion;
	global $_COOKIE;
	$nsUser->ADMIN=false; //      ,    
	$nsUser->MERCHANT=false; //      ,     
	$nsUser->SUPER_USER=false; //         
	$nsUser->SUPER_ADMIN=false; //      
	$nsUser->DEMO=false;
    $nsUser->REPORTS_DONE=false;
    $nsUser->TRAFFIC_MODE=false;
    $nsUser->ADMIN_ID=false;
    $nsUser->MERCH_ID=false;
	$nsUser->UserInfo['NAME']=stripslashes(V($nsUser->UserInfo['NAME']));

	$Query = "SELECT * FROM ?_user_settings WHERE USER_ID=?";
	$Check=$Db->Select($Query, false, $nsUser->UserId());
	$nsUser->HELP_MODE=@$Check->HELP_MODE;
	$nsUser->TZ=@$Check->TIMEZONE;
	$nsUser->DEF_LOGS_ORDER=@$Check->DEF_PATH_ORDER;
    $nsUser->HIDE_PATH_STEPS=@$Check->HIDE_PATH_STEPS;
	$nsUser->AUTO_TZ=false;
	$nsUser->ENC=@$Check->PAGE_ENCODING;
    $nsUser->DISABLE_SMART=@$Check->DISABLE_SMART;
    $nsUser->CACHE_UPDATE_MODE=@$Check->CACHE_UPDATE_MODE;
    $nsUser->GRAPH_PLACE=@$Check->GRAPH_PLACE;
    $nsUser->TRAFFIC_MODE=@$Check->TRAFFIC_MODE;
    $nsUser->CAN_CHANGE_SKIN=@$Check->CAN_CHANGE_SKIN;
    $nsUser->ACTIVITY_ORDER=@$Check->ACTIVITY_ORDER;
    $nsUser->ALLOW_SCHEDULE_EMAILS=@$Check->ALLOW_SCHEDULE_EMAILS;
    $nsUser->PERCENT_CALC=@$Check->PERCENT_CALC;

    if (!$nsUser->CAN_CHANGE_SKIN) $nsProduct->SKIN = $nsProduct->DEFAULT_SKIN;

	//    ,     ,   
	if ($nsUser->TZ!="a"&&V($_COOKIE[COOKIE_PFX.'auto_tz'])) {
		$nsUser->SetCookie(COOKIE_PFX.'auto_tz', '0', time()-1000, '/');
		unset($_COOKIE[COOKIE_PFX.'auto_tz']);
	}

	//    ,    
	if ($nsUser->TZ=="a")  {
		$nsUser->TZ=V($_COOKIE[COOKIE_PFX.'auto_tz']);
		$nsUser->AUTO_TZ=true;
	}

	if (!$nsUser->TZ) $nsUser->TZ="0";
	$nsUser->_TZ=-$nsUser->TZ;

    $nsUser->SQL_TZ=SqlTZ($nsUser->TZ);
    $nsUser->_SQL_TZ=SqlTZ($nsUser->TZ,$nsUser->SQL_TZ);

    if ($TrackerVersion==$nsProduct->VERSION) {
        $Query = "SELECT CACHE_ID FROM ?_user_cache WHERE USER_ID=? AND DONE=1";
        $Arr=array();
        $Sql = new Query($Query, false, $nsUser->UserId());
        while ($Row=$Sql->Row()) $Arr[$Row->CACHE_ID]=1;
        $nsUser->REPORTS_DONE=count($Arr);
        $nsUser->CacheArr=$Arr;
    }

	$Query = "SELECT * FROM ?_user WHERE USER_ID = ?";
	$Check=$Db->Select($Query, false, $nsUser->UserId());
	if ($Check) {
		$nsUser->SUPER_USER=$Check->SUPER_USER;
		$nsUser->COMPANY_ID=$Check->COMPANY_ID;
		$nsUser->MERCHANT=true;
		$nsUser->DEMO=V($Check->DEMO);
		$CpId=$nsUser->COMPANY_ID;
        $nsUser->MERCH_ID=$Check->ID;
        if ($nsProduct->LICENSE==3) $nsUser->USER_LEVEL=($nsUser->SUPER_USER)?2:3;
        else $nsUser->USER_LEVEL=($nsUser->SUPER_USER)?1:2;
		return;
	}

	$Query = "SELECT * FROM ?_admin WHERE USER_ID = ?";
	$Check=$Db->Select($Query, false, $nsUser->UserId());
	if ($Check) {
		$nsUser->SUPER_ADMIN=$Check->SUPER_ADMIN;
		$nsUser->DEMO=$Check->DEMO;
		$nsUser->ADMIN=true;
        $nsUser->USER_LEVEL=($nsUser->SUPER_ADMIN)?0:1;
        $nsUser->ADMIN_ID=$Check->ID;
        $nsUser->COMPANY_ID=false;
        $nsUser->ALLOW_SCHEDULE_EMAILS=true;

		if ($nsProduct->LICENSE!=3) {
			$nsUser->ADMIN=false;
			$nsUser->SUPER_ADMIN=false;
			$nsUser->MERCHANT=true;
			$nsUser->SUPER_USER=true;
            $nsUser->USER_LEVEL=0;
			$nsUser->COMPANY_ID=$Db->ReturnValue("SELECT ID FROM ?_client");
		}
		return;
	}
}


function PrepareUserOrder($Str='', $UserValue=false, $Mode=false)
{
	global $Db, $nsUser;
	$Mode=strtoupper($Mode);
	if (!$Str && !$UserValue) $UserValue="DESC";
    if ($UserValue!="ASC" && $UserValue != "DESC" && $UserValue != "-1") $UserValue="DESC";
	$Arr=explode(";", $Str);
	$ReturnArr=array();
	foreach ($Arr as $i=>$Val) {
		$Arr2=explode(":",$Val);
		if (isset($Arr2[0]) && ($Arr2[0]=="ASC" || $Arr2[0]=="DESC")) continue;
		if (isset($Arr2[0]) && $Arr2[0]==$Mode) {
			if ($UserValue!="-1") $Arr2[1]=$UserValue;
			if ($UserValue=="-1" && isset($Arr2[1])) $UserValue=$Arr2[1];
		}
		if (isset($Arr2[0]) && isset($Arr2[1])) $ReturnArr[$Arr2[0]]=$Arr2[1];
	}
	if (!isset($ReturnArr[$Mode]) || !$ReturnArr[$Mode]) $ReturnArr[$Mode]="DESC";

	$Str="";
	$i=0;
	foreach ($ReturnArr as $K=>$V) {
		if ($i>0) $Str.=";";
		$Str.="$K:$V";
		$i++;
	}

	$Query = "UPDATE ?_user_settings SET DEF_PATH_ORDER = ? WHERE USER_ID = ?";
	$Db->Query($Query, $Str, $nsUser->UserId());

	return $ReturnArr[$Mode];
}


function CookieStorageSet($Name=false, $Value=false, $Expire=false, $Path=false, $Domain=false, $Secure=false) {
	if (!$Name) return false;
	global $nsUser, $_COOKIE;
	$CookieArr=ValidVar($_COOKIE[COOKIE_PFX.'storage']);
	if (!ValidVar($CookieArr)) $CookieArr=array();
	else $CookieArr=@unserialize($CookieArr);
	if (!is_array($Name)) $Arr[$Name]=$Value;
	else $Arr=$Name;
	foreach($Arr as $Name=>$Value) $CookieArr[$Name]=$Value;
	$CookieArr=serialize($CookieArr);
	$_COOKIE[COOKIE_PFX.'storage']=$CookieArr;
	$nsUser->SetCookie(COOKIE_PFX.'storage', $CookieArr, $Expire, $Path, $Domain, $Secure);
}

function CookieStorageGet($Name=false) {
	if (!$Name) return false;
	global $_COOKIE;
	$CookieArr=ValidVar($_COOKIE[COOKIE_PFX.'storage']);
	if (!ValidVar($CookieArr)) return false;
	else $CookieArr=@unserialize($CookieArr);
	return ValidVar($CookieArr[$Name]);
}

function TimeArr($RawSec)
{
    $Hour=0;
    $Minute=0;
    $Secs=0;
    $Hour=intval($RawSec/3600);
    $Minute=intval(($RawSec-$Hour*3600)/60);
    $Secs=number_format($RawSec-($Hour*3600)-($Minute*60), 3, '.', '');
    if ($Secs>=1 || $Hour || $Minute) $Secs=intval($Secs);
    if ($Secs < 1 && !$Hour && !$Minute) $Secs = '< 1';
    if ($Secs < 1 && ($Hour || $Minute)) $Secs=false;
    if ($Hour>=1) $Secs=false;
    return array('h'=>$Hour,'m'=>$Minute,'s'=>$Secs);
}

function CookieStorageRemove($Name=false, $Expire=false, $Path=false, $Domain=false, $Secure=false) {
	if (!$Name) return false;
	global $nsUser, $_COOKIE;
	$CookieArr=ValidVar($_COOKIE[COOKIE_PFX.'storage']);
	if (!ValidVar($CookieArr)) $CookieArr=array();
	else $CookieArr=@unserialize($CookieArr);
	unset($CookieArr[$Name]);
	$CookieArr=serialize($CookieArr);
	$_COOKIE[COOKIE_PFX.'storage']=$CookieArr;
	$nsUser->SetCookie(COOKIE_PFX.'storage', $CookieArr, $Expire, $Path, $Domain, $Secure);
}

function UserColumns()
{
	global $Db, $nsUser, $nsProduct;
	$Query = "SELECT * FROM ?_user_column WHERE USER_ID=?";
	$nsUser->Columns=$Db->Select($Query, false, $nsUser->UserId());
    if ($nsProduct->LICENSE==4) {
        $nsUser->Columns->CLICKS=false;
        $nsUser->Columns->SALES=false;
        $nsUser->Columns->ROI=false;
    }
}


function ShowCost($Value=0, $Arr=false, $NoFormat=false)
{
	global $CurrentCompany;
	if (!$Arr) $Arr=V($CurrentCompany->CUR);
    if ($NoFormat) {
        if (!$Arr||!$Arr[0]||!$Value) return $Value;
        if ($Arr[1]==0) return $Arr[0].$Value;
        if ($Arr[1]==1) return $Value.$Arr[0];
    }
	if (!$Arr||!$Arr[0]||!$Value) return number_format($Value, 2, '.', ',');
	if ($Arr[1]==0) return $Arr[0].number_format($Value, 2, '.', ',');
	if ($Arr[1]==1) return number_format($Value, 2, '.', ',').$Arr[0];
}




//       
// -  
function GetSettings($CompId=false, $SiteId=false)
{
	$Where=array();
	$Where[]="(COMPANY_ID=0 AND SITE_ID=0)";
	if (ValidId($CompId)) $Where[]="(COMPANY_ID=$CompId AND SITE_ID=0)";
	if (ValidId($SiteId)) $Where[]="SITE_ID=$SiteId";
	$WhereStr="WHERE ".implode(" OR ", $Where);
	$Pfx=(defined("NS_DB_PFX") )?NS_DB_PFX:PFX;
	global $_NS_TRACK_VARS;
	$QueryClass=(isset($_NS_TRACK_VARS['QueryClass']))?$_NS_TRACK_VARS['QueryClass']:"Query";
	$Query = "SELECT * FROM {$Pfx}_tracker_config $WhereStr";
	$Sql = new $QueryClass($Query);
	$Sets=array();
	while ($Row=$Sql->Row()) {
		if ($Row->COMPANY_ID==0) $Sets['All']=$Row;
		if ($Row->COMPANY_ID>0&&$Row->SITE_ID==0) $Sets['Client']=$Row;
		if ($Row->COMPANY_ID>0&&$Row->SITE_ID>0) $Sets['Site']=$Row;
	}
	return $Sets;
}

function SetsByPrior($Arr, $Var)
{
	if (isset($Arr['Site']->$Var)&&$Arr['Site']->$Var!=2) return $Arr['Site']->$Var;
	if (isset($Arr['Client']->$Var)&&$Arr['Client']->$Var!=2) return $Arr['Client']->$Var;
	if (isset($Arr['All']->$Var)) return $Arr['All']->$Var;
	return false;
}

function CacheEnabled($Settings=array())
{
    //if (!isset($Settings['All']->CRON_ENABLE) || !$Settings['All']->CRON_ENABLE) return false;
    if (!isset($Settings['All']->CACHE_DYNAMIC_ENABLE) || !$Settings['All']->CACHE_DYNAMIC_ENABLE) return false;
    if (!isset($Settings['Client']->CACHE_DYNAMIC_ENABLE) || !$Settings['Client']->CACHE_DYNAMIC_ENABLE) return false;
    return true;
}

function TimeDblSettings($Arr, $Var, $Time)
{
	if (isset($Arr['Site']->$Var)&&$Arr['Site']->$Var!=2) return $Arr['Site']->$Time;
	if (isset($Arr['Client']->$Var)&&$Arr['Client']->$Var!=2) return $Arr['Client']->$Time;
	if (isset($Arr['All']->$Var)) return $Arr['All']->$Time;
	return false;
}

function GetCurrentCompany($Id=false)
{
	if (!ValidId($Id)) return false;
	global $Db, $nsUser, $nsProduct;
	$Company = $Db->Select("SELECT * FROM ?_client WHERE ID = ?", false, $Id);
	if (!$Company) {
		$nsUser->SetCookie("CompId", '', time()-1000, "/");
		$nsProduct->Redir("default", "", "admin");
	}
	$Company->SITE_CNT=$Db->ReturnValue("SELECT COUNT(*) FROM ?_site WHERE COMPANY_ID=?", $Id);
	$Company->CUR[0]=$Company->CURRENCY;
	$Company->CUR[1]=$Company->CURRENCY_POSITION;
	return $Company;
}



function ValidIp($IP) {
	$Num="([0-9]|[0-9]{2}|1\d\d|2[0-4]\d|25[0-5])";
	return preg_match("/^$Num\.$Num\.$Num\.$Num$/", $IP);
}

function ValidIpTempl($IP) {
	$Num="([0-9]|[0-9]{2}|1\d\d|2[0-4]\d|25[0-5]|\*)";
	return preg_match("/^$Num\.$Num\.$Num\.$Num$/", $IP);
}


function UpdatesAvailable()
{
	global $nsProduct, $TrackerVersion, $Lang, $Logs;
	$Avail=0;
	$Necessary=true;
	if (CompareVersions($TrackerVersion, $nsProduct->VERSION)<1) $Necessary = false;

	$D=@opendir(SELF."/update");
	while (($Row=@readdir($D))!==false) {
		if ($Row==".."||$Row=="."||$Row=="CVS") continue;
		if (CompareVersions($Row, $nsProduct->VERSION)<1) continue;
		$Avail++;
	}
	@closedir($D);
	if ($Necessary && !$Avail) $Logs->Error("TRIAL_UPDATE");
	if ($Necessary) $nsProduct->Redir("update", "", "admin");
	return $Avail;
}

function GeoAvailable() {
    $Arr = array('GeoIp'=>false, 'GeoCity'=>false);
    $d = @opendir(SELF.'/store');
    if ($d) while ( ($Row = @readdir($d)) !== false) {
        if ( preg_match('/geoip\.dat/i', $Row) ) $Arr['GeoIp']=$Row;
        if ( preg_match('/geocity\.dat/i', $Row) ) $Arr['GeoCity']=$Row;
    }
    if ($d) @closedir($d);
    else {
        if ( file_exists( SELF.'/store/GeoIp.dat' ) ) $Arr['GeoIp']='GeoIp.dat';
        if ( file_exists( SELF.'/store/GeoCity.dat' ) ) $Arr['GeoCity']='GeoCity.dat';
    }
    return $Arr;
}

function UserDate($Format=false, $TZ=false)
{
	global $Db;
    if ($TZ===false) {
        global $nsUser;
        $TZ=$nsUser->TZ;
    }
	$GmTime = gmdate("Y-m-d H:i:s");
	if (!$Format) return $Db->ReturnValue("SELECT DATE_FORMAT(DATE_ADD('$GmTime', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE), '%Y-%m-%d')");
	elseif ($Format=="stamp") return $Db->ReturnValue("SELECT UNIX_TIMESTAMP(DATE_ADD('$GmTime', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE))");
    else return date($Format, $Db->ReturnValue("SELECT UNIX_TIMESTAMP(DATE_ADD('$GmTime', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE))"));
}

function _date($Stamp=false,$Mode='date')
{
    if (!$Stamp) $Stamp=time();
    global $Db,$Settings;
    if (strval(intval($Stamp))!=strval($Stamp)) $Stamp=$Db->ReturnValue("SELECT UNIX_TIMESTAMP(?)",$Stamp);

    $FormatDate=V($Settings['All']->FORMAT_DATE,'d.m.Y');
    $FormatTime=V($Settings['All']->FORMAT_TIME,'H:i');

    if ($Mode=='date') return  date($FormatDate,$Stamp);
    if ($Mode=='time') return date($FormatTime,$Stamp);
    if ($Mode=='datetime') return date($FormatDate." ".$FormatTime,$Stamp);
}


function GetMicrotime()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

function GetResTime(){ global $StartTime; return GetMicrotime()-$StartTime; }
function PrintResTime($line=0){ echo ($line!=0?'line '.$line:'').": ".GetResTime().'<br>'; }

function cmdDump(&$Var, $Level=0)
{
	if(is_array($Var)) $Type = "Array[".count($Var)."]";
	else if (is_object($Var)) $Type = "Object";
	else $Type = "";

	if ($Type)
	{
		echo "$Type\n";
		for (Reset($Var), $Level++; list($k, $v) = each($Var);)
		{
			if (is_array($v) && $k === "GLOBALS") continue;
			for ($i = 0; $i < $Level*3; $i++) echo " ";
			echo "[".htmlspecialchars($k)."] => ", cmdDump($v, $Level);
		}
	}
	else echo "'".htmlspecialchars($Var)."'\n";
}

function SyncKeysWValues($ArrKeys=array(),$ArrValues=array())
{
    $Return=array();
    foreach ($ArrValues as $v) $Return[$v]=$ArrKeys[$v];
    return $Return;
}

function SqlTZ($TZ,$SQL_TZ='')
{
    if (!$SQL_TZ) return (($TZ*10)%10)?intval($TZ)." 30":"$TZ 00";
    else return (intval($TZ)<0)?str_replace("-","",$SQL_TZ):"-".$SQL_TZ;
}


function ToFloat($Var, $Cnt=1)
{
    $Arr=explode(".", $Var);
    for ($i=0;$i<count($Arr);$i++) {
        $Arr[$i]=intval($Arr[$i]);
    }
    $Var="";
    for ($i=0;$i<=$Cnt;$i++) {
        if ($i>0) $Var.=".";
        $Var.=$Arr[$i];
    }
    return $Var;
}

function is__writable($path) {
    //will work in despite of Windows ACLs bug
    //NOTE: use a trailing slash for folders!!!
    //see http://bugs.php.net/bug.php?id=27609
    //see http://bugs.php.net/bug.php?id=30931
    if ($path{strlen($path)-1}=='/') // recursively return a temporary file path
        return is__writable($path.uniqid(mt_rand()).'.tmp');
    else if (is_dir($path))
        return is__writable($path.'/'.uniqid(mt_rand()).'.tmp');
    // check tmp file for read/write capabilities
    $rm = file_exists($path);
    $f = @fopen($path, 'a');
    if ($f===false) return false;
    fclose($f);
    if (!$rm) unlink($path);
    return true;
}


?>