<?

require_once (@$nsSelf ? $nsSelf : SELF)."/class/ua_tracker.class.php";
$tmp = NS_TRACK_MISC::GeoAvailable(@$nsSelf);
$_NS_TRACK_VARS['GeoIp']=$tmp['GeoIp'] ? (@$nsSelf?$nsSelf:SELF)."/store/{$tmp['GeoIp']}":false;
$_NS_TRACK_VARS['GeoCity']=$tmp['GeoCity'] ? (@$nsSelf?$nsSelf:SELF)."/store/{$tmp['GeoCity']}":false;
if (!function_exists("geoip_open")) require_once (@$nsSelf?$nsSelf:SELF).'/lib/geo/geoipcity.php';


class NS_TRACK_VISITOR {


function GetVisitorId()
{
	global $_NS_TRACK_VARS, $_COOKIE;
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$IpId=&$_NS_TRACK_VARS['IpId'];
	$AgentId=&$_NS_TRACK_VARS['AgentId'];
	$PresetID=&$_NS_TRACK_VARS['PresetID'];
	$PresetIP=&$_NS_TRACK_VARS['PresetIP'];
	$Settings=&$_NS_TRACK_VARS['Settings'];
	$ScrRes=&$_NS_TRACK_VARS['ScrRes'];
	$PxD=&$_NS_TRACK_VARS['PxD'];
	$FlVer=&$_NS_TRACK_VARS['FlVer'];
	$CheckCookieId=&$_NS_TRACK_VARS['CheckCookieId'];
	$Db=&$_NS_TRACK_VARS['Db'];
	$FindLastNode=&$_NS_TRACK_VARS['FindLastNode'];
    $Current=&$_NS_TRACK_VARS['Current'];
    $NoTmpSkip=&$_NS_TRACK_VARS['NoTmpSkip'];
    $UseBotLog=&$_NS_TRACK_VARS['UseBotLog'];

	$UserAgent=NS_TRACK_MISC::V($_SERVER['HTTP_USER_AGENT']);
	if ( (defined("NS_PHP_TRACKING")&&!trim($UserAgent)&&!$PresetIP&&!$PresetID) || 	
			(!defined("NS_PHP_TRACKING")&&!trim($UserAgent)) ) {
		$Skip=true;
		return 0;
	}

    //        
	if (isset($_COOKIE[NS_COOKIE_PFX.'tmp_skip'])) {
        if ($_COOKIE[NS_COOKIE_PFX.'tmp_skip']==md5(NS_TRACK_GENERAL::TmpCurrentPath($Current))&&!$NoTmpSkip) $Skip=true;
		NS_TRACK_GENERAL::TrackingCookie(NS_COOKIE_PFX.'tmp_skip', '0',time()-(60*60*24), '/', $_NS_TRACK_VARS['COOKIE_DOMAIN']);
	}
	if ($Skip) return 0;

    $AgentId=NS_TRACK_VISITOR::GetUserAgentId(trim($UserAgent));
    if ($UseBotLog) return 0;
    if ($Skip) return 0;
    $Visitor=false;
    $CookieId=false;
    $CountryId=0;
    $ScrRes=addslashes($ScrRes);
    $PxD=addslashes($PxD);
    $FlVer=addslashes($FlVer);
    if (strpos($FlVer, "<")!==false) $FlVer=substr($FlVer, 0, strpos($FlVer, "<"));
    if (!$FlVer) $FlVer="-1";
    if ($FlVer!="-1") $FlVer=substr($FlVer, 0, 1);
    if (!$ScrRes || $ScrRes == "x" || $ScrRes==0) $ScrRes="-1";
    if (!$PxD) $PxD="-1";

	$Stamp=$_NS_TRACK_VARS['PresetStamp']?$_NS_TRACK_VARS['PresetStamp']:gmdate("Y-m-d H:i:s", time());
	$UserIp=NS_TRACK_VISITOR::GetUserIp();
	$IpId=NS_TRACK_VISITOR::GetIpId($UserIp);
	if ($Skip) return 0;

	//   ID 
	if (NS_TRACK_MISC::V($PresetID)&&!NS_TRACK_MISC::ValidId($PresetID)) {
        $Query = "SELECT ID FROM ?_visitor WHERE COOKIE_ID=?";
        $PresetID=$Db->ReturnValue($Query, $PresetID);
    }

	if (NS_TRACK_MISC::V($PresetID)&&NS_TRACK_MISC::ValidId($PresetID)) {
		$Visitor=$Db->Select("SELECT * FROM ?_visitor WHERE ID = ?",false,$PresetID);
		if (NS_TRACK_MISC::ValidId($Visitor->ID)) {
			$AgentId=($Visitor->LAST_AGENT_ID)?$Visitor->LAST_AGENT_ID:$AgentId;
			return $PresetID;
		}
	}

	//   
	if (!NS_TRACK_MISC::V($PresetID)||!NS_TRACK_MISC::V($Visitor->ID)) {

		//      
		if (defined("NS_PHP_TRACKING") 
			&& $Settings['All']->IP_TRACKING 
			&& $Settings['All']->IP_NO_COOKIE
			&& count($_COOKIE) > 0 ) {

			$Settings['All']->IP_TRACKING=false;
		}

		// ,   ,    
		if (!defined("NS_PHP_TRACKING") && !NS_TRACKER_DELAYED) {
			//   ,       ip
			if (!$CheckCookieId && !isset($_COOKIE[NS_COOKIE_PFX.'visitor']) && 
				$Settings['All']->IP_TRACKING && $Settings['All']->IP_NO_COOKIE) {
				$CookieId=NS_TRACK_VISITOR::TrackingVisitorCookie();
				NS_TRACK_MISC::Redir(NS_TRACK_MISC::ns_my_url()."&CheckCookieId=$CookieId");
			}

			//    ,   ip tracking
			if ($CheckCookieId && isset($_COOKIE[NS_COOKIE_PFX.'visitor'])) {
				$Settings['All']->IP_TRACKING=false;
			}
		}

		//   ,    IP
		if (!isset($_COOKIE[NS_COOKIE_PFX.'visitor']) && $Settings['All']->IP_TRACKING) {
			$Visitor=NS_TRACK_VISITOR::FindByIp($IpId, $AgentId, $Settings['All']->IP_PERIOD);
			if ($Visitor) {
				$AgentId=($Visitor->LAST_AGENT_ID)?$Visitor->LAST_AGENT_ID:$AgentId;
				$CookieId=NS_TRACK_VISITOR::TrackingVisitorCookie($Visitor->COOKIE_ID);
				NS_TRACK_VISITOR::FindLastNode($Visitor->ID);
				$FindLastNode=false;
			}
		}
		//     ,  
		if (!$CookieId) $CookieId=NS_TRACK_VISITOR::TrackingVisitorCookie();
		//      ,    
		if (!$Visitor) {
			$Query = "SELECT * FROM ?_visitor WHERE COOKIE_ID=?";
			$Visitor=$Db->Select($Query, false, $CookieId);
		}
	}

    if (!$Visitor && NS_TRACK_MISC::V($_NS_TRACK_VARS['Mode'])=='sale' && $Settings['All']->SALE_ONLY_EXISTING) {
        NS_TRACK_GENERAL::FinishTracking('Sale for unknown visitor');
    }

	//     
	if ($Visitor && NS_TRACK_MISC::ValidId($Visitor->ID) ) {
		//       , 
		$Location=NS_TRACK_VISITOR::GetLocationInfo($UserIp);
        $CountryId=@$Location['CountryId'];
        $CityId=@$Location['CityId'];
		if ((!$ScrRes || $ScrRes=="-1") && $Visitor->LAST_RESOLUTION) $ScrRes=$Visitor->LAST_RESOLUTION;
		if ((!$PxD || $PxD=="-1") && $Visitor->PIXEL_DEPTH) $PxD=$Visitor->PIXEL_DEPTH;
		if ((!$FlVer || $FlVer=="-1") && $Visitor->FLASH_VERSION) $FlVer=$Visitor->FLASH_VERSION;
		$Query = "UPDATE ?_visitor SET 
            LAST_IP_ID = ?, LAST_AGENT_ID=?, LAST_STAMP=?, LAST_COUNTRY_ID=?, LAST_CITY_ID=?, 
            LAST_RESOLUTION = ?, PIXEL_DEPTH=?, FLASH_VERSION=? WHERE ID = ?";
		$Db->Query($Query, $IpId, $AgentId, $Stamp, $CountryId, $CityId, $ScrRes, $PxD, $FlVer, $Visitor->ID);
		NS_TRACK_VISITOR::TrackingVisitorCookie($Visitor->COOKIE_ID);
		//   
		return NS_TRACK_VISITOR::UpdateVisitorInfo($Visitor->ID);
	}

	//     
	$Location=NS_TRACK_VISITOR::GetLocationInfo($UserIp);
	$Query ="INSERT INTO ?_visitor 
        (COOKIE_ID, LAST_IP_ID, LAST_AGENT_ID, FIRST_STAMP, LAST_STAMP, LAST_COUNTRY_ID, LAST_CITY_ID,  
        LAST_RESOLUTION, PIXEL_DEPTH, FLASH_VERSION) 
        VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
	$Db->Query($Query, $CookieId, $IpId, $AgentId, $Stamp, $Stamp, @$Location['CountryId'], @$Location['CityId'], 
                            $ScrRes, $PxD, $FlVer);
	$FindLastNode=false;
    $_NS_TRACK_VARS['CookieId']=$CookieId;
	return NS_TRACK_VISITOR::UpdateVisitorInfo($Db->LastInsertId);
}

function UpdateVisitorInfo($VisId=false)
{
    if (!$VisId) return false;
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    $VisitorName=&$_NS_TRACK_VARS['VisitorName'];
    $VisitorTag=&$_NS_TRACK_VARS['VisitorTag'];
    $OverwriteTags=&$_NS_TRACK_VARS['OverwriteTags'];
    $StId=&$_NS_TRACK_VARS['StId'];

    if (($VisitorName||$VisitorTag||$OverwriteTags) && $StId) {
        $CpId=$Db->ReturnValue("SELECT COMPANY_ID FROM ?_site WHERE ID=?", $StId);

        if ($VisitorName) {
            $CheckId=$Db->ReturnValue("SELECT ID FROM ?_client_visitor WHERE COMPANY_ID=? AND VISITOR_ID=?", $CpId, $VisId);
            if ($CheckId) $Db->Query("UPDATE ?_client_visitor SET NAME=? WHERE ID=?",$VisitorName,$CheckId);
            else $Db->Query("INSERT INTO ?_client_visitor (COMPANY_ID,VISITOR_ID,NAME) VALUES (?,?,?)",$CpId,$VisId,$VisitorName);
        }

        if ($VisitorTag) {
            $TmpArr=explode(";",$VisitorTag);
            $TagIds=$TagArr=$ExTags=array();
            foreach ($TmpArr as $Tag) {
                $Tag=trim($Tag);
                if (!$Tag) continue;
                $TagArr[ md5($Tag) ]=$Tag;
            }
            $TagIds=NS_TRACK_GENERAL::GetTagId($TagArr);
            $Query = "SELECT TAG_ID FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=?";
            $Sql = new Query($Query,false,$CpId,$VisId);
            while ($Row=$Sql->Row()) $ExTags[]=$Row->TAG_ID;
            if ($OverwriteTags) {
                $RemArr=array_diff($ExTags,$TagIds);
                $Query = "DELETE FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=? AND TAG_ID IN (?)";
                if (!empty($RemArr)) $Db->Query($Query,$CpId,$VisId,$RemArr);
            }
            foreach ($TagIds as $TagId) {
                if (in_array($TagId,$ExTags)) continue;
                $Query = "INSERT INTO ?_visitor_tag_rel (COMPANY_ID,VISITOR_ID,TAG_ID) VALUES (?,?,?)";
                $Db->Query($Query,$CpId,$VisId,$TagId);
            }
        }
        if (!$VisitorTag && $OverwriteTags) {
            $Query = "DELETE FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=?";
            $Db->Query($Query,$CpId,$VisId);
        }
    }

    return $VisId;
}


function TrackingVisitorCookie($Cookie=false)
{
	global $_NS_TRACK_VARS, $_COOKIE;
	$Domain=false;
	if (defined("COOKIE_DOMAIN")) $Domain=COOKIE_DOMAIN;
	if (isset($_NS_TRACK_VARS['COOKIE_DOMAIN'])) $Domain=$_NS_TRACK_VARS['COOKIE_DOMAIN'];
	if ($Cookie) {
		if (!isset($_COOKIE[NS_COOKIE_PFX.'visitor']) || $_COOKIE[NS_COOKIE_PFX.'visitor']!=$Cookie) 
               NS_TRACK_GENERAL::TrackingCookie(NS_COOKIE_PFX.'visitor', $Cookie, time()+60*60*24*10*365, "/", $Domain);
		return $Cookie;
	}
	if (isset($_COOKIE[NS_COOKIE_PFX.'visitor'])) return $_COOKIE[NS_COOKIE_PFX.'visitor'];
	else {
		$Cookie=substr(md5(uniqid(rand())), 0, 32);
		NS_TRACK_GENERAL::TrackingCookie(NS_COOKIE_PFX.'visitor', $Cookie, time()+60*60*24*10*365, "/", $Domain);
		return $Cookie;
	}
}


function GetUserAgentId($Agent=false)
{
	if (!$Agent) return 0;
	global $_NS_TRACK_VARS;
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$Db=&$_NS_TRACK_VARS['Db'];
    $UseBotLog=&$_NS_TRACK_VARS['UseBotLog'];
    $Settings=&$_NS_TRACK_VARS['Settings'];

	$Query = "
		SELECT 
			VA.ID, VA.BAN, AB.BAN AS AB_BAN, AR.BAN AS AR_BAN, 
            AR.ID AS ROBOT_ID
			FROM ?_visitor_agent VA
			LEFT JOIN ?_visitor_agent_browser AB
				ON AB.ID=VA.BROWSER_ID
            LEFT JOIN ?_visitor_agent_robot AR
                ON AR.ID=VA.ROBOT_ID
			WHERE VA.MD5_SEARCH=?
	";
	$Check=$Db->Select($Query, false, md5($Agent));
	if ($Check && ($Check->BAN||$Check->AB_BAN||$Check->AR_BAN)) {
        header('X-ST-USER_AGENT: Skip'); 
        $Skip=true; 
        return 0; 
    }
    if (@$Check->ROBOT_ID) $UseBotLog=true;
	if (@$Check->ID) return $Check->ID;
    $UAParser = new UATrackerParser();
    $UA=$UAParser->ParseUA($Agent);
    if ((@$UA['Other'] || @$UA['PotentialBot']) && @$Settings['All']->IGNORE_ALL_BOTS) {
        header('X-ST-USER_AGENT: Bots are ignored'); 
        $Skip=true;
        return 0;
    }
    if (!$UA['Other']&&$UA['PotentialBot']) {
        header('X-ST-USER_AGENT: Potential bot'); 
        $Skip=true;
    }
    $Query ="INSERT INTO ?_visitor_agent (USER_AGENT, MD5_SEARCH, BAN) VALUES (?,?,?)";
    $Db->Query($Query,$Agent,md5($Agent),($Skip?1:0));
    $Id=$Db->LastInsertId;
    if ($Skip) return $Id;

    $Browser=$Engine=$OS=$Robot=false;
    if ($UA['Browser']) $Browser=$Db->Select("SELECT * FROM ?_visitor_agent_browser WHERE NAME_KEY=?",
                                                                        false,$UA['Data']['browser']['key']);
    if ($UA['Engine']) $Engine=$Db->Select("SELECT * FROM ?_visitor_agent_engine WHERE NAME_KEY=?",
                                                                        false,$UA['Data']['engine']['key']);
    if ($UA['OS']) $OS=$Db->Select("SELECT * FROM ?_visitor_agent_os WHERE NAME_KEY=?",
                                                                        false,$UA['Data']['os']['key']);
    if ($UA['Other']) $Robot=$Db->Select("SELECT * FROM ?_visitor_agent_robot WHERE NAME_KEY=?",
                                                                        false,$UA['Data']['other']['key']);

    $Query = "UPDATE ?_visitor_agent SET BROWSER_ID=?, ENGINE_ID=?, OS_ID=?, ROBOT_ID=?, 
                            BROWSER_VERSION=?, ENGINE_VERSION=?, OS_VERSION=?, ROBOT_VERSION=? WHERE ID=?";
    $Db->Query($Query,($Browser?$Browser->ID:0),($Engine?$Engine->ID:0),($OS?$OS->ID:0),($Robot?$Robot->ID:0),
                                    $UA['BrowserVersion'], $UA['EngineVersion'], $UA['OSVersion'], $UA['OtherVersion'], $Id);
    if ($Browser && $Browser->BAN) $Skip=true;
    if ($Robot && $Robot->BAN) $Skip=true;
    if ($Robot && !$Skip) $UseBotLog=true;
	return $Id;
}

function GetUserIp()
{
	global $_NS_TRACK_VARS;
	$PresetIP=&$_NS_TRACK_VARS['PresetIP'];	
	
	if (NS_TRACK_MISC::V($PresetIP)&&NS_TRACK_MISC::ValidIp($PresetIP)) return $PresetIP;
	$UserIp=false;
	if (NS_TRACK_MISC::V($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		$UserIp=$_SERVER['HTTP_X_FORWARDED_FOR'];
		if (strpos($UserIp, ",")!==false) {
			$Arr=explode(",",$UserIp);
			$UserIp=$Arr[0];
		}
	}
	if (NS_TRACK_MISC::ValidIp($UserIp)) return $UserIp;
	else  return $_SERVER['REMOTE_ADDR'];
}

function GetIpId($IP)
{
    global $_NS_TRACK_VARS;
    $Skip=&$_NS_TRACK_VARS['Skip'];
    $Db=&$_NS_TRACK_VARS['Db'];
    $QueryClass=&$_NS_TRACK_VARS['QueryClass'];    
    $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
            
    $Query = "SELECT ID, IGNORED FROM ?_ip WHERE IP=?";
    $Check=$Db->Select($Query, false, $IP);
    if ($Check && $Check->IGNORED) {
        $Skip=true;
        return false;
    }

    $IpArr=explode(".",$IP);
    $Query = "SELECT ID, TEMPLATE, IP FROM ?_ip_ignore 
        WHERE COMPANY_ID = 0 OR (COMPANY_ID = ? AND IP = ?)
        ORDER BY IF (COMPANY_ID > 0, 1, 0) DESC";
    $Sql = new $QueryClass($Query, false, $CompanyId, $IP);
    while ($Row=$Sql->Row()) {
        if ($Row->IP == $IP) {$Skip = true; return false; }
        $Match=0;
        $Arr=explode(".",$Row->TEMPLATE);
        foreach ($Arr as $i=>$T) {
            if ($T=="*") $Match++;
            if ($T!="*" && $T==$IpArr[$i]) $Match++; 
        }
        if ($Match==4) { $Skip=true; return false; }
    }

    if ($Check && $Check->ID>0) return $Check->ID;
    $Query = "INSERT INTO ?_ip (IP) VALUES (?)";
    $Db->Query($Query, $IP);
    return $Db->LastInsertId;
}

function UpdateByRegs()
{
    return false;

	
}


function FindByIp($IpId, $AgentId, $Days=0)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
    
    $Stamp=$_NS_TRACK_VARS['PresetStamp']?" '{$_NS_TRACK_VARS['PresetStamp']}' ":'NOW()';
	$WhereArr[]="LAST_IP_ID=$IpId";
	if (!$_NS_TRACK_VARS['PresetIP']) $WhereArr[]="LAST_AGENT_ID=$AgentId";
	$WhereStr=implode(" AND ", $WhereArr);
	$Query = "
		SELECT * 
		FROM ?_visitor 
		WHERE 
			$WhereStr
			AND LAST_STAMP >= DATE_ADD($Stamp, INTERVAL -$Days DAY)
		ORDER BY LAST_STAMP DESC
	";
	$Visitor=$Db->Select($Query);
	return $Visitor;
}

function GetLocationInfo($IP=false) {
    global $_NS_TRACK_VARS;
    $Db=&$_NS_TRACK_VARS['Db'];
    $GeoIp=&$_NS_TRACK_VARS['GeoIp'];
    $GeoCity=&$_NS_TRACK_VARS['GeoCity'];
    $QueryClass=&$_NS_TRACK_VARS['QueryClass'];    

    if (!$GeoIp && !$GeoCity && !@$_SERVER['GEOIP_LATITUDE']&& !@$_SERVER['GEOIP_COUNTRY_CODE']) 
        return array('CountryId'=>0, 'CityId'=>0);

    if (!@$_SERVER['GEOIP_LATITUDE']&&!@$_SERVER['GEOIP_COUNTRY_CODE']) {
        $gi = geoip_open($GeoCity?$GeoCity:$GeoIp,GEOIP_STANDARD);
        if ($GeoCity) $Rec=GeoIP_record_by_addr($gi,$IP);
        else {
            $CId=geoip_country_id_by_addr($gi,$IP);
            $Rec= (object) array();
            $Rec->country_code=@$gi->GEOIP_COUNTRY_CODES[$CId];
            $Rec->country_name=@$gi->GEOIP_COUNTRY_NAMES[$CId];
        }
        if (!@$Rec->area_code) $Rec->area_code = null;
        if (!@$Rec->dma_code) $Rec->dma_code = null;
        if (!@$Rec->postal_code) $Rec->postal_code = null;        
    } else {
        $Rec = (object) array('country_code'=>@$_SERVER['GEOIP_COUNTRY_CODE'], 
                             'country_name'=>@$_SERVER['GEOIP_COUNTRY_NAME'], 
                             'latitude'=>@$_SERVER['GEOIP_LATITUDE'], 
                             'longitude'=>@$_SERVER['GEOIP_LONGITUDE'], 
                             'city'=>@$_SERVER['GEOIP_CITY'],
                             'area_code'=>null, 'dma_code'=>null, 'postal_code'=>null);
    }

    if (@$Rec->country_code) {
        $Query = "SELECT ID FROM ?_country WHERE CODE = ?";
        $CountryId=$Db->ReturnValue($Query,$Rec->country_code);
        if (!$CountryId) {
            $Query = "INSERT INTO ?_country (CODE,NAME) VALUES (?,?)";
            $Db->Query($Query,$Rec->country_code,$Rec->country_name);
            $CountryId=$Db->LastInsertId;
        }
    } else $CountryId=0;

    if (isset($Rec->latitude) && isset($Rec->longitude) && @$Rec->city) {
        $CityId = false;
        if ($Rec->country_code == 'US') {
            $Query = "SELECT * FROM ?_city WHERE (LATITUDE=? AND LONGITUDE=?) OR AREA_CODE = ? OR DMA_CODE=?";
            $Sql = new $QueryClass($Query,false,$Rec->latitude,$Rec->longitude,$Rec->area_code, $Rec->dma_code);
                $ByCode = array();
                while ( ($City = $Sql->Row()) && !$CityId) {
                    if ($City->LATITUDE == $Rec->latitude && $City->LONGITUDE==$Rec->longitude) $CityId = $City->ID;
                    elseif ($Rec->city == $City->NAME && 
                               ((double)$Rec->latitude > (double)$City->LATITUDE-1 && (double)$Rec->latitude < (double)$City->LATITUDE+1) &&
                               ((double)$Rec->longitude > (double)$City->LONGITUDE-1 && (double)$Rec->longitude < (double)$City->LONGITUDE+1) && 
                               ($Rec->area_code == $City->AREA_CODE && $Rec->dma_code == $City->DMA_CODE)
                               ) {
                                    $City->LaDiff = abs( $City->LATITUDE - $Rec->latitude );
                                    $City->LoDiff = abs( $City->LONGITUDE - $Rec->longitude );
                                    $ByCode[$City->ID]=$City;
                    }
                }
                if (!$CityId) foreach ($ByCode as $k=>$v) {
                    if ($CityId && $v->LaDiff <= $ByCode[$CityId]->LaDiff && $v->LoDiff <= $ByCode[$CityId]->LoDiff)  $CityId=$k;
                    else $CityId=$k;
                }
        }
        else {
            $Query = "SELECT ID FROM ?_city WHERE LATITUDE=? AND LONGITUDE=?";
            $CityId=$Db->ReturnValue($Query,$Rec->latitude,$Rec->longitude);
        }
        if (!$CityId) {
            $Query = "INSERT INTO ?_city (COUNTRY_ID,NAME,LATITUDE,LONGITUDE,AREA_CODE,DMA_CODE) VALUES (?,?,?,?,?,?)";
            $Db->Query($Query,$CountryId,$Rec->city,$Rec->latitude,$Rec->longitude, $Rec->area_code, $Rec->dma_code);
            $CityId=$Db->LastInsertId;
        }
    } else $CityId=0;

    geoip_close($gi);

    return array('CountryId'=>$CountryId,'CityId'=>$CityId);
}

function GetCountryId($IP=false)
{
	if (!$IP) return 0;
	$IpLong=sprintf("%u\n", ip2long($IP));
	if (!$IpLong) return 0;
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	
	$Query = "
		SELECT C.ID
			FROM ?_country_ip CI
			INNER JOIN ?_country C
				ON C.CODE=CI.COUNTRY_CODE
			WHERE $IpLong BETWEEN CI.IP_START AND CI.IP_END
	";
	$CId=$Db->ReturnValue($Query);
	return ($CId)?$CId:0;
}


function FindLastNode($VisId=0, $AndSet=true) 
{
	global $_NS_TRACK_VARS, $_COOKIE;
	$Db=&$_NS_TRACK_VARS['Db'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$LogId=&$_NS_TRACK_VARS['LogId'];
	$CompanyId=&$_NS_TRACK_VARS['CompanyId'];

	$Query = "SELECT ID FROM ?_".$CompanyId."_stat_log WHERE ID=COOKIE_LOG AND VISITOR_ID=? AND SITE_ID=? ORDER BY STAMP DESC";
	$CheckId=$Db->ReturnValue($Query, $VisId, $StId);
	if (!$CheckId) return;
	if (!$AndSet) return $CheckId;

	if ($LogId) NS_TRACK_GENERAL::SetCookieLog(false, $CheckId);

}


}


?>