<?include $nsTemplate->Inc("inc/header");?>
<?include $nsTemplate->Inc("inc/submenu");?>

<script>
var ReportDetailsURL='<?=getURL('ajax','Mode=report_arch&ReportId=','pub')?>';
</script>
<script language="JavaScript" src="<?=FileLink("js/archiving.js");?>"></script>

<style>
.ParamsTd2 { padding:0px 0px 2px 0px; border-bottom:0px solid #E1E1E1; }
.ParamsTd { padding: 4px 0px 0px 0px; border-bottom:0px solid #E1E1E1; }
.SubParamsTd { padding: 0px 0px 2px 0px; }
.SubDet { margin-top:2px; }
.SettingDescr {
    font-weight:normal;
    border:1px solid #f0f0f0;
    background:#fcfcfc;
    padding:10px;
    margin:10px;
    color:#666;
}
</style>




<div id=SpacerMedium></div>
<div class=SectionCaption><?=$Lang['ArchivingSettings']?></div>
<?PostFORM()?>
<input type=hidden name="EditArr[void]" value=1>
<table  class=FormTable>

<tbody>


<tr><td class=FormLeftTd>
<?=$Lang['ArchivingEnable']?><br>
</td><td class=FormRightTd>
<input type=checkbox name="EditArr[ArchiveEnable]" value=1 <?=((ValidVar($EditArr['ArchiveEnable'])=='1')?"checked":"")?>>
</td></tr>

<tr><td class=FormLeftTd>
<?=$Lang['ArchiveRows']?><br>
</td><td class=FormRightTd>
<input type=text name="EditArr[ArchiveRows]" value="<?=$EditArr['ArchiveRows']?>" style="width:100px;">
</td></tr>


<tr><td class=FormLeftTd colspan=2>
<div class="ImportantNotice"><?=$Lang['ArchDescr']?></div>
</td></tr>

<tr><td colspan=2 class=FormLeftTd>
<?$i=0; foreach ($PeriodStat as $Row) {?>
    <?if ($i>0) echo ", "?>
    <nobr><?=$Row->NAME?> &mdash; <span style="font-weight:normal;"><?=$Row->STATUS?></span></nobr>
<?$i++;}?>
</td></tr>

<tr><td colspan=2 class=FormLeftTd>
<select name="ToAll">
<option></option>
<?foreach ($PeriodStat as $Row) {?>
    <option value="<?=$Row->TEMPLATE?>"><?=$Row->NAME?></option>
<?}?>
</select>

<input type=submit name="EnableForAll" value="<?=$Lang['EnableForAll']?>">
<input type=submit name="DisableForAll" value="<?=$Lang['DisableForAll']?>">
</td></tr>


<?foreach ($RGroups as $GrpId=>$Grp) {
    if (!isset($ReportArr[$GrpId])) continue;?>
<tr><td colspan=2 class=FormLeftTd>
<a href="javascript:;" onclick="ShowReports(<?=$GrpId?>)">
<img id="Plus_<?=$GrpId?>" src="<?=FileLink("images/icon_plus.gif")?>" width=9 height=9 border=0>
<img id="Minus_<?=$GrpId?>" src="<?=FileLink("images/icon_minus.gif")?>" width=9 height=9 border=0 style="display:none;">
&nbsp;<?=$Grp->NAME?></a>
</td></tr>

<tbody id="Reports_<?=$GrpId?>" style="display:none;">
<?foreach ($ReportArr[$GrpId] as $ReportId=>$Report) {?>
    <tr><td class=FormLeftTd style="font-weight:normal;padding-left:25px;">
    <a href="javascript:;" onclick="ShowReportDetails(<?=$ReportId?>)">
    <img id="RPlus_<?=$ReportId?>" src="<?=FileLink("images/icon_plus.gif")?>" width=9 height=9 border=0>
    <img id="RMinus_<?=$ReportId?>" src="<?=FileLink("images/icon_minus.gif")?>" width=9 height=9 border=0 style="display:none;">
    &nbsp;<?=$Report->NAME?></a>
    <?if ($Report->COMPANY_ID>0 && $nsProduct->LICENSE==3) {?>(<?=$Report->CLIENT_NAME?>)<?}?>
    <?if ($Report->COMPANY_ID==0 && $nsProduct->LICENSE==3) {?>(<?=$Lang['AllCompanies']?>)<?}?>
    </td><td class=FormRightTd>
    
    <input type=hidden name="DoArchive[<?=$ReportId?>]" value=0>
    <table cellpadding=0 cellspacing=0 border=0><tr>
    <td><input onclick="SetArchive(<?=$ReportId?>, this.checked);" id="DoArchive_<?=$ReportId?>" type=checkbox name="DoArchive[<?=$ReportId?>]" value=1 <?=$Report->ARCH?"checked":""?>></td>
    <td><label for="DoArchive_<?=$ReportId?>"><?=$Lang['DoArchive']?></label></td>
    </tr></table>

    </td></tr>
    
    <tr id="RDetails_<?=$ReportId?>" style="display:none;"><td colspan=2 class=FormLeftTd style="padding-left:50px;font-weight:normal;"></td></tr>
<?}?>
</tbody>

<?}?>

<tr><td></td><td class=FormSubmit><input type=submit value="<?=$Lang['Save']?>"></td></tr>
</table>

</form>


<div id="Loading" style="display:none;">
<img src="<?=FileLink("images/circle_02.gif")?>" width=18 height=18 border=0 style="vertical-align:-4px;"> <?=$Lang['Loading']?>
</div>

<?include $nsTemplate->Inc("inc/footer");?>