
function showGrpShort(oA, callBack) {
    var grpId = $(oA).attr('grpid')
    var URL = shortStatURL+'&amode=grp&ax=1&GrpId='+grpId
    loadURL('GrpShort_'+grpId, URL, showGlobalLoading, function() {
        $('#GrpShort_'+grpId).show()
        $(oA).hide()
        hideGlobalLoading()
        checkMoreLinks()
        if (callBack) callBack()
    })
}

function showCampShort(oA, callBack) {
    var campId = $(oA).attr('campid')
    var URL = shortStatURL+'&amode=camp&ax=1&CampId='+campId
    loadURL('CampShort_'+campId, URL, showGlobalLoading, function() {
        $('#CampShort_'+campId).show()
        $(oA).hide()
        hideGlobalLoading()
        checkMoreLinks()
        if (callBack) callBack()
    })
}

function showSplitShort(oA, callBack) {
    var splitId = $(oA).attr('splitid')
    var URL = shortStatURL+'&amode=split&ax=1&SplitId='+splitId
    loadURL('SplitShort_'+splitId, URL, showGlobalLoading, function() {
        $('#SplitShort_'+splitId).show()
        $(oA).hide()
        hideGlobalLoading()
        checkMoreLinks()
        if (callBack) callBack()
    })
}

function checkMoreLinks() {
    var oColl = $('a[run=quickstat]:visible')
    if (oColl.length == 0) $('#quickStatAllContainer').hide()
}

function quickStatAll() {
    var oColl = $('a[run=quickstat]:visible')
    if (oColl.length == 0) return false
    for (var i=0; i < oColl.length; i++) {
        var o = $(oColl[i])
        if (o.attr('mode')=='grp') return showGrpShort(oColl[i],quickStatAll)
        if (o.attr('mode')=='camp') return showCampShort(oColl[i],quickStatAll)
        if (o.attr('mode')=='split') return showSplitShort(oColl[i],quickStatAll)
    }
}