function ShowValues(Position,Type,ValueObj) {
    var d = $('#Step_'+Position);
    var s =  $('#Select_'+Position);
    
    $('#FStep_'+Position).attr('disabled', (Type=='entry'?true:false));
    d[Type?'show':'hide']();
    if (!Type) return false;

    s.attr('disabled', true);
    d.html(CircleImg);

    var URL=ShowValueURL;
    URL+='&Type='+Type;
    URL+='&Position='+Position;
    for (var i in ValueObj) URL+='&'+i+'='+ValueObj[i];

    loadURL( 'Step_'+Position , URL,
            function(){ d.html(CircleImg) },
            function(){ 
                s.attr('disabled',false);
                if ( Type=='page' && !ValueObj.PageId && ValueObj.Page)  _pageReqOnChange(Position, $('#StepPage_'+Position).get(0), ValueObj.SiteId);
            }
    )

    if (Type!='action') ShowActionItems(Position,-1);
    ShowKeyword(Position,(Type=='click'||Type=='ref')?0:1,ValueObj.KeyId);
    ShowRefHost(Position,(Type=='ref')?ValueObj.RefGrpId:-1,ValueObj.RefHostId);
}

function ShowKeyword(Position,Close,KeyId)
{
    var DivName="Keyword_"+Position;
    var SelName="Select_"+Position;
    if (!KeyId) KeyId=0;
    _(DivName).style.display=(Close==0)?'':'none';    
    if (Close) return false;
    if (_(DivName).innerHTML!='') return false;
    _(SelName).disabled=true;
    _(DivName).innerHTML=CircleImg;    
    var URL=KeywordURL;
    URL+='&Position='+Position;
    URL+='&KeyId='+KeyId;
    
    loadURL(DivName,URL,function(){ $('#'+DivName).html(CircleImg) },
                        function(){ $('#Select_'+Position).attr('disabled',false) })    
}


function ShowRefHost(Position,GrpId,HostId)
{
    var DivName="RefHost_"+Position;
    var SelName="Select_"+Position;
    if (!GrpId) GrpId=0;
    if (!HostId) HostId=0;    
    _(DivName).style.display=(GrpId==-1)?'none':'';    
    if (GrpId==-1) return false;
    _(SelName).disabled=true;
    _(DivName).innerHTML=CircleImg;    
    var URL=RefHostURL;
    URL+='&Position='+Position;
    URL+='&GrpId='+GrpId;
    URL+='&HostId='+HostId;
    
    loadURL(DivName,URL,function(){ $('#'+DivName).html(CircleImg) },
                        function(){ $('#Select_'+Position).attr('disabled',false) })           
}

function ShowActionItems(Position,ActionId,ActionItemId)
{
    var DivName="ActionItem_"+Position;
    var SelName="Select_"+Position;
    _(DivName).style.display=(ActionId>0)?'':'none';
    if (_(DivName).innerHTML!='') return false;
    if (ActionId==-1) return false;
   
    _(SelName).disabled=true;
    _(DivName).innerHTML=CircleImg;
    
    var URL=ActionItemURL;
    URL+='&Position='+Position;
    URL+='&ActionId='+ActionId;
    URL+='&ActionItemId='+ActionItemId;
    
    loadURL(DivName,URL,function(){ $('#'+DivName).html(CircleImg) },
                        function(){ $('#Select_'+Position).attr('disabled',false) })        
}


function AddStep(AfterPosition)
{
    var NewPosition=AfterPosition+1;
    var HTML=_('StepSample').innerHTML;
    HTML=HTML.replace(/{STEP_NO}/g,NewPosition);
    for (var i = NewPosition; i <= StepNo; i++) RenameStep(i,i+1);
    var oDiv=document.createElement('div');
    oDiv.id='DivStep_'+NewPosition;
    oDiv.innerHTML=HTML;
    if (NewPosition<=StepNo) _('Steps').insertBefore(oDiv,_('DivStep_'+(NewPosition+1)));
    else _('Steps').appendChild(oDiv);
    StepNo++;
    SetOptions();
}

function RemoveStep(Position)
{
    _('Steps').removeChild(_('DivStep_'+Position));
    for (var i = Position+1; i <= StepNo; i++) RenameStep(i,i-1); 
    StepNo--;
    if (StepNo==0) AddStep(0);
    SetOptions();
}

function RenameStep(Position,ToPosition)
{
    var oDiv=_('DivStep_'+Position);
    var HTML=oDiv.innerHTML;
    HTML=HTML.replace(RegExp("\\["+Position+"\\]",'g'),"["+ToPosition+"]");
    HTML=HTML.replace(RegExp("_"+Position,'g'),"_"+ToPosition);
    HTML=HTML.replace(RegExp("\\("+Position+"\\)",'g'),"("+ToPosition+")");
    HTML=HTML.replace(RegExp(","+Position,'g'),","+ToPosition);
    HTML=HTML.replace(RegExp(Position+",",'g'),ToPosition+",");
    HTML=HTML.replace(RegExp("<script>[^<]+<\/script>",'g'),'');
    oDiv.innerHTML=HTML;
    oDiv.getElementsByTagName('span')[0].innerHTML=ToPosition;
    oDiv.id='DivStep_'+ToPosition;
}

function SetOptions()
{
    for (var i = 1; i <= StepNo; i++) {
        var oColl=_('StepOptions_'+i).getElementsByTagName('tr');
        oColl[0].style.display=(i==1)?'':'none';
        oColl[1].style.display=(i==1)?'':'none';
        oColl[2].style.display=(i==1)?'none':'';
    }
}

function ClearPageId(Position)
{
    _('PageId_'+Position).value='';
}

function _pageReqOnChange(Pos, oInput, SelectSiteId) {
    $('#PageId_'+Pos).val('');
    var i = $(oInput);
    var s = $('#PageSite_'+Pos);
    var a = $('#Additional_'+Pos);
    var SiteId = s.length ? s.val() : 0;
    requestURL(CheckPageURL+i.val()+'&Position='+Pos+'&SiteId='+SiteId+'&SelectSiteId='+SelectSiteId, 
        function() { if (!a.html()) a.html(CircleImg).show(); }, 
        function(data){
            if (data) a.html(data).show();
            else if (a.find('img').length) a.html('');
    });
}