<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#

// class "Session". It is a simple bulkhead on the core PHP sessions. 

//------------------------------------------------------------------------------------
class nsSession  extends nsBase{
	//------------------------------------------------------------------------------------
	//   ,   ID    ID
	function nsSession($sid = FALSE){
        $this->started=false;
		if (defined("COMMAND_LINE")) return false;
        $this->sid=$sid;
        if (!defined("NO_SESSION")||!NO_SESSION) $this->start();
	}
    
    function start()
    {
        if ($this->started) return false;
        if (defined("COMMAND_LINE")||defined("NO_SESSION")) return false;
        if($this->sid){ session_id($this->sid); }
        session_start();
        $this->started=true;
        return session_id();        
    }
    
	//------------------------------------------------------------------------------------
	//  .  $value   -  t   
	function set($name, $value=false){
       if (!$this->started) $this->start();
	   if ($value)	$this->__set_session_var($name, $value);
	   else 	$this->__destroy_session_var($name);
	}
	function remove($name){  $this->set($name);  }
	//------------------------------------------------------------------------------------
	/**
	* @return mixed
	* @param string $name
	* @desc returns the session variable. If this variable does not exist
	* in the current session - returns false.
	*/
	function get($name){
        if (!$this->started) $this->start();
		return isset($_SESSION[$name]) ? $_SESSION[$name] : false;
	}
	//------------------------------------------------------------------------------------
	//  id 
	function id(){
        if (!$this->started) $this->start();
		return session_id();
	}
	//------------------------------------------------------------------------------------
	//  - 
	function destroy(){
		$_SESSION = array();
		session_destroy();		
	}
	//------------------------------------------------------------------------------------
	//------------------------------------------------------------------------------------
	//   :
	//------------------------------------------------------------------------------------
	//   
	function __set_session_var($name, $val){
        if (!$this->started) $this->start();
		$_SESSION[$name] = $val;
	}
	//------------------------------------------------------------------------------------
	//   
	function __destroy_session_var($name){
        if (!$this->started) $this->start();
		unset($_SESSION[$name]);
	}
}



?>